IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[pjm6UserActivityDetailBrowse]') AND type in (N'P', N'PC'))
BEGIN
	PRINT 'Dropping procedure [pjm6UserActivityDetailBrowse]'
	DROP PROCEDURE [pjm6UserActivityDetailBrowse]
END
GO

PRINT 'Creating procedure [pjm6UserActivityDetailBrowse]'
GO

CREATE PROCEDURE [dbo].[pjm6UserActivityDetailBrowse] 
	@Date datetime,
	@UserID int
AS
	SET NOCOUNT ON
	SELECT
		ISNULL([Module].[Description], [Module].[Name]) as [Name], 
		[Created],
		[Closed],
		CAST(DATEDIFF(second, [Created], [Closed]) / CAST(60 as decimal(18,4)) as decimal(18,2)) as [Duration],
		ISNULL([Module].[Description], [Module].[Name]) as [Module]
	FROM 
		[pjmams].[Session] 
		INNER JOIN [pjmams].[Process] 
			ON ([Session].[ID] = [Process].[SessionID])
		INNER JOIN [UserNTLoginMapping]
			ON [UserNTLoginMapping].[NTLogin] = [Process].[UserName]
		INNER JOIN [pjmams].[Module]
			ON [Process].[ModuleID] = [Module].[ID]
	WHERE
		CONVERT(datetime, CONVERT(varchar(8), [Created], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		CONVERT(datetime, CONVERT(varchar(8), [Closed], 112)) = CONVERT(datetime, CONVERT(varchar(8), @Date, 112))
	AND
		[UserNTLoginMapping].[UserID] = @UserID
	ORDER BY 
		 3 DESC	
	
	RETURN 0
GO


GRANT EXECUTE ON [pjm6UserActivityDetailBrowse] TO PUBLIC
GO 