IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfBankAccountGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfBankAccountGet'
		DROP PROCEDURE [dbo].[adfBankAccountGet]
	END
GO

PRINT 'Creating procedure adfBankAccountGet'
GO

/******************************************************************************
**		File: adfBankAccountGet.sql
**		Name: adfBankAccountGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/04/2004 15:04:36
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfBankAccountGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT DISTINCT
		[BankAccount].[ID],
		[BankAccount].[CompanyID],
		[BankAccount].[Class],
		[BankAccount].[State],
		[BankAccount].[Flag],
		[BankAccount].[FileAs],
		[BankAccount].[CurrencyCode],
		[BankAccount].[BankName],
		[BankAccount].[BankCode],
		[BankAccount].[Country],
		[BankAccount].[City],
		[BankAccount].[Address],
		[BankAccount].[SWIFT],
		[BankAccount].[ABA],
		[BankAccount].[IBAN],
		[BankAccount].[Account],
		[BankAccount].[IntermediaryBank],
		[BankAccount].[IntermediaryAddress],
		[BankAccount].[IntermediarySWIFT],
		[BankAccount].[IntermediaryABA],
		[BankAccount].[IntermediaryAccount],
		[BankAccount].[AdditionalAccounts],
		[BankAccount].[Created],
		[BankAccount].[CreatedBy],
		[BankAccount].[Modified],
		[BankAccount].[ModifiedBy],
		[BankAccount].[Timestamp],
		(CASE WHEN [Invoice].[SupplierBankAccountID] IS NULL THEN 0
		 ELSE 1 END) AS [SupplierBankAccount]
	FROM
		[BankAccount] LEFT OUTER JOIN [Invoice] ON [BankAccount].[ID] = [Invoice].[SupplierBankAccountID] 		
	WHERE
		[BankAccount].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [adfBankAccountGet] TO PUBLIC
GO

 