IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfCategoryBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfCategoryBrowse'
		DROP  Procedure  adfCategoryBrowse
	END

GO

PRINT 'Creating Procedure adfCategoryBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfCategoryBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfCategoryBrowse
	@DocumentGuid TGuid,
	@ReferenceID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE @DocumentClass TClass
	
	SELECT @DocumentClass = [Class] FROM [Class] WHERE [Guid] = @DocumentGuid

	SELECT
		[ID],
		[FileAs] as [Name]
	FROM
		[Category]
	WHERE
		[State] = 1
	AND
		([DocumentClass] = @DocumentClass)
	AND
		(@ReferenceID IS NULL OR (@ReferenceID IS NOT NULL AND [ReferenceID] = @ReferenceID))
		
	RETURN 0
GO

GRANT EXEC ON adfCategoryBrowse TO PUBLIC
GO
