IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'adftrNoteDelete')
	BEGIN
		PRINT 'Dropping Trigger adftrNoteDelete'
		DROP  Trigger adftrNoteDelete
	END
GO

/******************************************************************************
**		File: 
**		Name: adftrNoteDelete
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger adftrNoteDelete'
GO
CREATE Trigger adftrNoteDelete ON [Note] FOR DELETE
AS
	SET NOCOUNT ON
	
	UPDATE [Document]
	SET
		[NoteCount] = [NoteCount] - [I].[Count]
	FROM
		[Document] INNER JOIN (SELECT [DocumentClass], [DocumentID], COUNT(*) as [Count] FROM deleted GROUP BY [DocumentClass], [DocumentID]) as [I]
			ON ([Document].[ID] = [I].[DocumentID] AND [Document].[Class] = [I].[DocumentClass])

GO

