IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanyInsertDefaultPlanningValues]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanyInsertDefaultPlanningValues'
		DROP PROCEDURE [dbo].[adfCompanyInsertDefaultPlanningValues]
	END
GO

PRINT 'Creating procedure adfCompanyInsertDefaultPlanningValues'
GO

/******************************************************************************
**		File: adfCompanyInsertDefaultPlanningValues.sql
**		Name: adfCompanyInsertDefaultPlanningValues
**		Desc:        
**		  
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Sergey Pelevin
**		Date: 20/02/2013 16:11
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**
*******************************************************************************/
CREATE PROCEDURE [adfCompanyInsertDefaultPlanningValues]
	@CompanyID int = NULL
AS
SET NOCOUNT ON

	DECLARE
		@PlanProfitability decimal(18,2),
		@PlanPurchases bit

	SELECT
		@PlanProfitability = CONVERT(decimal(18,2),[Value])
	FROM 
		[F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53]
	WHERE 
		[Name] = 'PlanProfitability' AND [Group] = 'Pjm7'
			
	SELECT
		@PlanPurchases = CONVERT(bit,[Value])
	FROM
		[F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53]
	WHERE
		[Name] = 'PlanPurchases' AND [Group] = 'Pjm7'
	
	IF @CompanyID IS NULL
	BEGIN
		UPDATE [Company]
		SET 
			[PlanProfitability] = 	@PlanProfitability,
			[PlanPurchases] = ISNULL(@PlanPurchases,0)
		WHERE
			[Own] = 0
	END
	ELSE
	BEGIN
		UPDATE [Company]
		SET 
			[PlanProfitability] = 	@PlanProfitability,
			[PlanPurchases] = ISNULL(@PlanPurchases,0)
		WHERE
			[ID] = @CompanyID
	END
	
	RETURN 0
GO

GRANT EXECUTE ON adfCompanyInsertDefaultPlanningValues TO PUBLIC
GO