IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfEmployeeCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfEmployeeCreate'
		DROP PROCEDURE [dbo].[adfEmployeeCreate]
	END
GO

PRINT 'Creating procedure adfEmployeeCreate'
GO

/******************************************************************************
**		File: adfEmployeeCreate.sql
**		Name: adfEmployeeCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/05/2004 18:09:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		11.02.10	syv				   pjm6AutoTransitionParametersSet 
**		30.11.11	PAM				  ""    
**		25.12.12	SOV				        
**		15.01.13	SOV				    ProjectManager
**		07.02.13	SOV				      ""  
**		06.03.13	SAP				  OPENXML
*******************************************************************************/
CREATE PROCEDURE [adfEmployeeCreate]
	@Xml XML,
	@ExtendedProperties XML,
	@RunningFromMaster bit = 0 --    ?
AS
	DECLARE @result						INT,
			@State						TState,
			@ID							TIdentifier,
			@Title						TCode,
			@FirstName					TPersonName,
			@MiddleName					TPersonName,
			@LastName					TPersonName,
			@Suffix						TCode,
			@FileAs						TName,
			@BirthDate					TDate,
			@BirthPlace					TName,
			@LegalCode					TCode,
			@CompanyID					TIdentifier,
			@PositionID					TIdentifier,
			@DivisionID					TIdentifier,
			@HireDate					TDate,
			@FireDate					TDate,
			@UserID						TIdentifier,
			@CurrentUserID				TIdentifier,
			@Comments					TNotes,
			@Initials					TCode,
			@XPathRoot					nvarchar(256),
			@Class						TClass,
			@QualificationID			TIdentifier,
			@ExternalID					TExternalIdentifier,
			@Flag						TFlag,
			@Private					TBool,
			@WindowsLogin				TSysName,
			@SqlLogin					TSysName,
			@Number						TCode,
			@CongratulateWithBirthday	TBool,
			@value						TVariant,
			@ExchangeSync				TBool
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('219e9b7e-153a-4e93-ab63-0b3785d67c8a')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SELECT
		@FileAs = T.c.value('FileAs[1]','nvarchar(256)'),
		@Title = T.c.value('Title[1]','varchar(32)'),
		@FirstName = T.c.value('FirstName[1]','nvarchar(50)'),
		@MiddleName = T.c.value('MiddleName[1]','nvarchar(50)'),
		@LastName = T.c.value('LastName[1]','nvarchar(50)'),
		@Suffix = T.c.value('Suffix[1]','varchar(32)'),
		@BirthDate = CONVERT(datetime, T.c.value('BirthDate[1]','varchar(19)'), 126),
		@BirthPlace = T.c.value('BirthPlace[1]','nvarchar(256)'),
		@LegalCode = T.c.value('LegalCode[1]','varchar(32)'),
		@Comments = T.c.value('Comments[1]','nvarchar(max)'),
		@CompanyID = T.c.value('CompanyID[1]','int'),
		@PositionID = T.c.value('PositionID[1]','int'),
		@HireDate = CONVERT(datetime, T.c.value('HireDate[1]','varchar(19)'), 126),
		@FireDate = CONVERT(datetime, T.c.value('FireDate[1]','varchar(19)'), 126),
		@WindowsLogin = T.c.value('WindowsLogin[1]','nvarchar(128)'),
		@SqlLogin = T.c.value('SqlLogin[1]','nvarchar(128)'),
		@Initials = T.c.value('Initials[1]','varchar(32)'),
		@QualificationID = T.c.value('QualificationID[1]','int'),
		@DivisionID = T.c.value('DivisionID[1]','int'),
		@ExternalID = T.c.value('ExternalID[1]','varchar(256)'),
		@Flag = T.c.value('Flag[1]','int'),
		@Number = T.c.value('Number[1]','varchar(32)'),
		@CongratulateWithBirthday = T.c.value('CongratulateWithBirthday[1]','bit')
	FROM
		@Xml.nodes('/adfEmployeeGet/Employee') AS T(c)


	DECLARE @Own TBool, @HasAccess TBool
	SELECT @Own = [Own] FROM [Company] WHERE [ID] = @CompanyID

	IF @Own = 1 AND dbo.adfHasAccessRightByName('ManageEmployees') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF @Own = 0 AND dbo.adfHasAccessRightByName('ManageContacts') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @Flag IS NULL
	BEGIN
		SET @Flag = 0
	END
	
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	SELECT @value = [Value] FROM [UserParameter] WHERE [Name] = 'SetPrivatePropertyOnCreate' AND [UserID] = @CurrentUserID
	SET @Private = ISNULL(CAST(@value as bit), 1)

	SELECT @value = [Value] FROM [UserParameter] WHERE [Name] = 'SetContactSyncPropertyOnCreate' AND [UserID] = @CurrentUserID
	SET @ExchangeSync = ISNULL(CAST(@value AS BIT), 0)

	BEGIN TRANSACTION
	
	DECLARE @OwnCompany TBool
	
	SELECT @OwnCompany = [Own] FROM [Company] WHERE [ID] = @CompanyID
	
	IF @OwnCompany = 1
	BEGIN
		SELECT @UserID = [User].[ID] FROM [User] INNER JOIN [Trustee] ON [User].[ID]=[Trustee].[ID] WHERE [Trustee].[Name] = @FileAs
		IF @UserID IS NOT NULL
		BEGIN
			IF EXISTS(SELECT * FROM [Employee] WHERE [UserID] = @UserID)
			BEGIN
				RAISERROR('#UserNameMustBeUnique', 16, -1)
				ROLLBACK TRANSACTION
				RETURN 1
			END
			ELSE
			BEGIN
				UPDATE [User] 
				SET 
					[Locked] = 0, 
					[SQLLogin]=@SqlLogin, 
					[NTLogin]=@WindowsLogin 
				WHERE 
					[ID] = @UserID
				IF @@ERROR != 0
				BEGIN
					ROLLBACK TRANSACTION
					RETURN 1
				END
			END
		END
		ELSE
		BEGIN
			EXEC @result = adfUserCreate @FileAs, @FileAs, @SqlLogin, @WindowsLogin, @UserID OUTPUT
			IF @result != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END
		
	INSERT INTO [Employee]
		([Flag], [State], [FileAs], [CompanyID], [PositionID], [HireDate], [FireDate], [UserID], [Comments],
		[QualificationID], [DivisionID],
		[Title], [FirstName], [MiddleName], [LastName], [Suffix], [BirthDate], [BirthPlace], [LegalCode], [Initials], [Number])
	VALUES
		(@Flag, @State, @FileAs, @CompanyID, @PositionID, @HireDate, @FireDate, @UserID, @Comments,
		@QualificationID, @DivisionID,
		@Title, @FirstName, @MiddleName, @LastName, @Suffix, @BirthDate, @BirthPlace, @LegalCode, @Initials, @Number)
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()
	
	SELECT @Class = [Class] FROM [Employee] WHERE [ID] = @ID
	
	INSERT INTO [ExtendedProperties] 
		([ID], [Class], [ExtendedProperties])
	VALUES
		(@ID, @Class, @ExtendedProperties)	

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	--          
	IF @RunningFromMaster = 1 BEGIN
		DECLARE @IsManager					TBool,
				@IsChiefAccountant			TBool,
				@IsAdministrator			TBool
				
		SELECT 
			@IsManager = T.c.value('IsManager[1]','bit'),
			@IsChiefAccountant = T.c.value('IsChiefAccountant[1]','bit'),
			@IsAdministrator = T.c.value('IsAdministrator[1]','bit')
		FROM
		@Xml.nodes('/adfEmployeeGet') AS T(c)
		
		--      
		EXEC adfRoleMemberCreate @RoleName = 'Employee', @UserName = NULL, @UserID = @UserID
		EXEC adfRoleMemberCreate @RoleName = 'SalesManager', @UserName = NULL, @UserID = @UserID
				
		--   ,     ,   -
		IF @IsChiefAccountant = 1 OR @IsManager = 1 OR @IsAdministrator = 1
			EXEC adfRoleMemberCreate @RoleName = 'HRManager', @UserName = NULL, @UserID = @UserID
		IF @IsChiefAccountant = 1 OR @IsManager = 1
			EXEC adfRoleMemberCreate @RoleName = 'FinancialManager', @UserName = NULL, @UserID = @UserID
		IF @IsAdministrator = 1 OR @IsManager = 1
		BEGIN
			EXEC adfRoleMemberCreate @RoleName = 'Administrator', @UserName = NULL, @UserID = @UserID
			EXEC adfRoleMemberCreate @RoleName = 'ProjectManager', @UserName = NULL, @UserID = @UserID		
		END	
		
		--      
		IF @IsManager = 1 BEGIN				
			EXEC adfRoleMemberCreate @RoleName = 'Executive', @UserName = NULL, @UserID = @UserID
			EXEC adfRoleMemberCreate @RoleName = 'ChiefSalesManager', @UserName = NULL, @UserID = @UserID
			EXEC adfRoleMemberCreate @RoleName = 'ResourceManager', @UserName = NULL, @UserID = @UserID			
		END
		
		--     - 
		IF @IsAdministrator = 1
			EXEC adfRoleMemberCreate @RoleName = 'FileClerkManager', @UserName = NULL, @UserID = @UserID
	END

	
		
	EXEC @result = adfBusinessCardCreate @doc = @xml, @XPathRoot = '/adfEmployeeGet', @ID = @ID, 
		@Class = @Class, @State = @State, @FileAs = @FileAs, @Comments = @Comments,
		@CompanyID = @CompanyID, @PositionID = @PositionID, @ExternalID = @ExternalID
	
	IF @@error != 0 OR @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF @Private = 1
	BEGIN
		INSERT INTO UserContact ([UserID], [BusinessCardClass], [BusinessCardID])
			VALUES(dbo.adfGetCurrentUserID(), @Class, @ID)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	IF @ExchangeSync = 1
	BEGIN
		EXEC @result = pjm7ExchangeSyncStateUpdate @ID, @Class, @ExchangeSync
		IF @result != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	EXEC @result = adfPersonIdentityCardUpdate @doc = @Xml, @EmployeeID = @ID
	
	IF @@error != 0 OR @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DECLARE		
	@RuleID	TIdentifier

	IF @OwnCompany = 1
	BEGIN
		INSERT INTO	[SubscriptionRule] ([State], [FileAs], [UserID], [Created], [Modified])	
		VALUES (1, '     ', @UserID, GETDATE(), GETDATE())
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		SET @RuleID = SCOPE_IDENTITY()

		INSERT INTO [Subscription] ([SubscriptionTypeID], [SubscriptionRuleID])
		VALUES (2, @RuleID), (3, @RuleID)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		INSERT INTO [SubscriptionRuleNotificationWay] ([NotificationWayID], [SubscriptionRecurrencePatternID], [SubscriptionRuleID])
		VALUES (1, NULL, @RuleID)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		INSERT INTO	[SubscriptionRule] ([State], [FileAs], [UserID], [Created], [Modified])	
		VALUES (1, '     ', @UserID, GETDATE(), GETDATE())
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		SET @RuleID = SCOPE_IDENTITY()

		INSERT INTO [Subscription] ([SubscriptionTypeID], [SubscriptionRuleID])
		VALUES (5, @RuleID), (6, @RuleID)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		INSERT INTO [SubscriptionRuleNotificationWay] ([NotificationWayID], [SubscriptionRecurrencePatternID], [SubscriptionRuleID])
		VALUES (1, NULL, @RuleID)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	COMMIT TRANSACTION	
	

	EXEC adfEmployeeGet @ID

	IF @OwnCompany = 1
	BEGIN	
		EXEC pjm6AutoTransitionParametersSet @UserID
	END

	RETURN 0
GO

GRANT EXECUTE ON adfEmployeeCreate TO PUBLIC
GO
