IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfEmployeeGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfEmployeeGet'
		DROP PROCEDURE [dbo].[adfEmployeeGet]
	END
GO

PRINT 'Creating procedure adfEmployeeGet'
GO

/******************************************************************************
**		File: adfEmployeeGet.sql
**		Name: adfEmployeeGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/05/2004 18:09:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
**		23.04.10	KOV				    , 
**									  
**
**		29.04.10	KOV				 ,      
**									 
**		11.12.13	SAP				   /    
*******************************************************************************/
CREATE PROCEDURE [adfEmployeeGet]
	@ID TIdentifier
AS
	DECLARE 
		@Class TClass, 
		@UserID TIdentifier, 
		@Private BIT,
		@HasRights BIT = 0,
		@ExcnangeSync TBool,
		@EnableContactExcnangeSync TBool,
		@value TVariant
	SET NOCOUNT ON
	
	SET @Class = dbo.adfGetClassByName('Adf.Employee')
	SET @UserID = dbo.adfGetCurrentUserID()

	IF EXISTS(SELECT * FROM [UserContact] WHERE [UserID] = @UserID AND [BusinessCardClass]=@Class AND [BusinessCardID]=@ID)
		SET @Private = 1
	ELSE
		SET @Private = 0
	--   
	SELECT @value = [Value] FROM [UserParameter] WHERE [Name] = 'SyncExchangeContacts' AND [UserID] = @UserID
	SET @EnableContactExcnangeSync = ISNULL(CAST(@value AS BIT), 0)
	IF EXISTS(SELECT *FROM [ExchangeDocumentSync] WHERE [DocumentClass] = @Class AND
		[DocumentID] = @ID AND [UserID] = @UserID) AND @EnableContactExcnangeSync = 1
		SET @ExcnangeSync = 1
	ELSE
		SET @ExcnangeSync = 0

	DECLARE @ViewRight TBool
	SET @ViewRight = dbo.adfHasAccessRightByName('ManageContacts') | dbo.adfHasAccessRightByName('ViewAllContacts')

	DECLARE @Own TBool = 0, @HasAccess INT
	SELECT @Own = [Own] FROM [Employee] INNER JOIN [Company] ON [Employee].[CompanyID] = [Company].[ID] WHERE [Employee].[ID] = @ID
	IF @Own = 1
	BEGIN
		IF dbo.adfHasAccessRightByName('ViewEmployee') = 0
		BEGIN 
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END
	ELSE
	BEGIN
		IF @ViewRight = 0
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END	
	END

	IF dbo.adfHasAccessRightByName('ViewEmployeeDetails') = 1 AND @Own = 1
		SET @HasRights = 1

	IF dbo.adfHasAccessRightByName('ViewContactDetails') = 1 AND @Own = 0
		SET @HasRights = 1
	
	--  ReminderInterval
	DECLARE
		@ReminderState bit,
		@ReminderTotalInterval int,
		@ReminderIntervalFromSettings int,
		@ReminderInterval int,
		@BirthDateCurrentYear TDate,
		@BirthDateNextYear TDate,
		@CurrentDate TDate = CAST(GETDATE() AS date),		
		@BirthDate TDate,		
		@ReminderDate TDate,
		@ReminderDateWithTime TDate,
		@BirthdayInFuture bit = 0,
		@ReminderTimeMinutes int

	SELECT
		@BirthDate = 
		CASE
			WHEN @HasRights = 0 THEN NULL
			ELSE [Employee].[BirthDate]
		END,
		@ReminderState = [UserReminder].[State],
		@ReminderTotalInterval = [UserReminder].[OriginalInterval],
		@ReminderIntervalFromSettings = dbo.fnPjm5GetReminderInterval([Employee].[Class], 'CB', @UserID)
	FROM
		[Employee]
		LEFT OUTER JOIN [Reminder]
			ON ([Reminder].[DocumentClass] = [Employee].[Class] AND
				[Reminder].[DocumentID] = [Employee].[ID] AND
				[Reminder].[Subtype] = 'CB')
		LEFT OUTER JOIN [UserReminder]
			ON ([Reminder].[ID] = [UserReminder].[ReminderID] AND
				[UserReminder].[UserID] = @UserID)
	WHERE
		[Employee].[ID] = @ID

	--  
	SET @BirthDate = CAST(@BirthDate AS date)

	SET @BirthDateCurrentYear = DATEADD(Year,DATEDIFF(Year,@BirthDate,@CurrentDate),@BirthDate)
	SET @BirthDateNextYear = DATEADD(Year,1,@BirthDateCurrentYear)	
	SET @ReminderDate = CAST(DATEADD(Minute,-@ReminderTotalInterval,@BirthDate) AS date)
	SET @ReminderDateWithTime = DATEADD(Minute,-@ReminderTotalInterval,@BirthDate)
	SET @ReminderTimeMinutes = ABS(DATEDIFF(Minute,@ReminderDateWithTime,@ReminderDate))
	
	IF @BirthDate > @CurrentDate
		SET @BirthdayInFuture = 1

	IF @ReminderDate > @BirthDateCurrentYear
		SET @ReminderInterval = ABS(DATEDIFF(Minute,@BirthDateNextYear,(DATEADD(Minute,ABS(@ReminderTotalInterval+@ReminderTimeMinutes),@BirthDate))))
	ELSE IF @BirthdayInFuture = 1
		SET @ReminderInterval = ABS(DATEDIFF(Minute,@BirthDate,(DATEADD(Minute,ABS(@ReminderTotalInterval+@ReminderTimeMinutes),@BirthDate))))
	ELSE
		SET @ReminderInterval = ABS(DATEDIFF(Minute,@BirthDateCurrentYear,(DATEADD(Minute,ABS(@ReminderTotalInterval+@ReminderTimeMinutes),@BirthDate))))


	IF @ReminderState <> 1
		SET @ReminderInterval = -1

	
	SELECT
		[Employee].[ID],
		[Employee].[Class],
		[Employee].[State],
		[Employee].[Flag],
		[Employee].[FileAs],
		[Employee].[CompanyID],
		[Employee].[PositionID],
		[Employee].[QualificationID],
		[Employee].[DivisionID],
		CASE
			WHEN @HasRights = 0 THEN NULL
			ELSE [Employee].[HireDate]
		END AS [HireDate],
		CASE
			WHEN @HasRights = 0 THEN NULL
			ELSE [Employee].[FireDate]
		END AS [FireDate],
		CASE
			WHEN @HasRights = 0 THEN NULL
			WHEN @Own = 0 THEN NULL
			ELSE (SELECT dbo.Pjm6GetExperienceFormatted([Employee].[HireDate],[Employee].[FireDate]))
		END as [Experience],
		[Employee].[UserID],
		[User].[NtLogin] as [WindowsLogin],
		[User].[SQLLogin] as [SqlLogin],
		[Employee].[Comments],
		[Employee].[Created],
		[Employee].[CreatedBy],
		[Employee].[Modified],
		[Employee].[ModifiedBy],
		[Employee].[Timestamp],
		[Employee].[Title],
		[Employee].[FirstName],
		[Employee].[MiddleName],
		[Employee].[LastName],
		[Employee].[Suffix],
		CASE
			WHEN @HasRights = 0 THEN NULL
			ELSE [Employee].[BirthDate]
		END AS [BirthDate],
		CASE
			WHEN @HasRights = 0 THEN NULL
			ELSE [Employee].[BirthPlace]
		END AS [BirthPlace],
		[Employee].[LegalCode],
		[Employee].[Initials],
		[Employee].[Number],
		[Employee].[CongratulateWithBirthday],
		[ExtendedProperties].[ExtendedProperties],
		ISNULL((SELECT [Own] FROM [Company] WHERE [ID] = [Employee].[CompanyID]),0) AS [Own],
		@Private as [Private],
		@ExcnangeSync AS [ExchangeSync],
		[exch].[ExchangeLink].[SyncTime] AS [ExchangeLastSyncDate],		
		ISNULL(@ReminderInterval, -1) AS [ReminderInterval]
	FROM
		[Employee]
		INNER JOIN [ExtendedProperties]
			ON ([Employee].[Class] = [ExtendedProperties].[Class] AND
				[Employee].[ID] = [ExtendedProperties].[ID])
		LEFT OUTER JOIN [exch].[ExchangeLink]
			ON [exch].[ExchangeLink].[DocumentClass] = [Employee].[Class] AND
				[exch].[ExchangeLink].[DocumentID] = [Employee].[ID] AND
				[exch].[ExchangeLink].[UserID] = @UserID
		LEFT OUTER JOIN [User]
			ON ([Employee].[UserID] = [User].[ID])
		LEFT OUTER JOIN [Reminder]
			ON ([Reminder].[DocumentClass] = [Employee].[Class] AND
				[Reminder].[DocumentID] = [Employee].[ID] AND
				[Reminder].[Subtype] = 'CB')
		LEFT OUTER JOIN [UserReminder]
			ON ([Reminder].[ID] = [UserReminder].[ReminderID] AND
				[UserReminder].[UserID] = @UserID)
	WHERE
		[Employee].[ID] = @ID

	EXEC adfBusinessCardExtraInfoGet @Class, @ID

	IF @HasRights = 1
		EXEC adfPersonExtraInfoGet @ID

	RETURN 0
GO

GRANT EXECUTE ON [adfEmployeeGet] TO PUBLIC
GO

 
