﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfEmployeeRegistrationDataRemove]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfEmployeeRegistrationDataRemove'
		DROP PROCEDURE [dbo].[adfEmployeeRegistrationDataRemove]
	END
GO

PRINT 'Creating procedure adfEmployeeRegistrationDataRemove'
GO

/******************************************************************************
**		File: adfEmployeeRegistrationDataRemove.sql
**		Name: adfEmployeeRegistrationDataRemove
**		Desc: Процедура удаляет учетные данные для сотрудника
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 22.06.2012 12:12:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfEmployeeRegistrationDataRemove]
	@EmployeeID TIdentifier
AS
	DECLARE
		@UserID		TIdentifier,
		@rv			int

	SELECT @UserID = [UserID] FROM [Employee] WHERE [ID] = @EmployeeID
	
	BEGIN TRANSACTION

	IF @UserID IS NOT NULL
	BEGIN
		EXEC @rv = adfUserDeleteByID @UserID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON [adfEmployeeRegistrationDataRemove] TO PUBLIC
GO
 