IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfEmployeeUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfEmployeeUpdate'
		DROP PROCEDURE [dbo].[adfEmployeeUpdate]
	END
GO

PRINT 'Creating procedure adfEmployeeUpdate'
GO

/******************************************************************************
**		File: adfEmployeeUpdate.sql
**		Name: adfEmployeeUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/05/2004 18:09:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		28.11.11	PAM				   ""
**		16.03.12	PAM				 /  
**		06.03.13	SAP				  OPENXML
**		07.08.13	SAP				     /, 
**									      .. ,
**									      ,  
**									.
**		27.09.13	SAP				    / 
**		11.12.13	SAP				    /
*******************************************************************************/
CREATE PROCEDURE adfEmployeeUpdate
	@Xml XML,
	@ExtendedProperties XML
AS
	SET NOCOUNT ON
	DECLARE 
		@result								INT,
		@ID									TIdentifier,
		@FileAs								TName,
		@CompanyID							TIdentifier,
		@PositionID							TIdentifier,
		@DivisionID							TIdentifier,
		@HireDate							TDate,
		@FireDate							TDate,
		@UserID								TIdentifier,
		@Comments							TNotes,
		@Title								TCode,
		@FirstName							TPersonName,
		@MiddleName							TPersonName,
		@LastName							TPersonName,
		@Suffix								TCode,
		@BirthDate							TDate,
		@BirthPlace							TName,
		@LegalCode							TCode,
		@Class								TClass,
		@Initials							TCode,		
		@QualificationID					int,
		@WindowsLogin						TSysName,
		@SqlLogin							TSysName,
		@Number								TCode,
		@CongratulateWithBirthday			TBool,
		@OwnCompany							TBool,
		@HasAccess							TBool,		
		@ReminderInterval					TTimeSpan,
		@rv									int

	SELECT
		@ID = T.c.value('ID[1]','int'),
		@FileAs = T.c.value('FileAs[1]','nvarchar(256)'),
		@Title = T.c.value('Title[1]','varchar(32)'),
		@FirstName = T.c.value('FirstName[1]','nvarchar(50)'),
		@MiddleName = T.c.value('MiddleName[1]','nvarchar(50)'),
		@LastName = T.c.value('LastName[1]','nvarchar(50)'),
		@Suffix = T.c.value('Suffix[1]','varchar(32)'),
		@BirthDate = CONVERT(datetime, T.c.value('BirthDate[1]','varchar(19)'), 126),
		@BirthPlace = T.c.value('BirthPlace[1]','nvarchar(256)'),
		@LegalCode = T.c.value('LegalCode[1]','varchar(32)'),
		@Comments = T.c.value('Comments[1]','nvarchar(max)'),
		@CompanyID = T.c.value('CompanyID[1]','int'),
		@PositionID = T.c.value('PositionID[1]','int'),
		@DivisionID = T.c.value('DivisionID[1]','int'),
		@WindowsLogin = T.c.value('WindowsLogin[1]','nvarchar(128)'),
		@SqlLogin = T.c.value('SqlLogin[1]','nvarchar(128)'),
		@HireDate = CONVERT(datetime, T.c.value('HireDate[1]','varchar(19)'), 126),
		@FireDate = CONVERT(datetime, T.c.value('FireDate[1]','varchar(19)'), 126),
		@Initials = T.c.value('Initials[1]','varchar(32)'),
		@QualificationID = T.c.value('QualificationID[1]','int'),
		@Number = T.c.value('Number[1]','varchar(32)'),
		@CongratulateWithBirthday = T.c.value('CongratulateWithBirthday[1]','bit'),
		@ReminderInterval		= T.c.value('ReminderInterval[1]','int')

	FROM
		@Xml.nodes('/adfEmployeeGet/Employee') AS T(c)


	SELECT @OwnCompany = [Own] FROM [Company] WHERE [ID] = @CompanyID

	IF @OwnCompany = 1 AND dbo.adfHasAccessRightByName('ManageEmployees') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF @OwnCompany = 0 AND dbo.adfHasAccessRightByName('ManageContacts') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION
	
	DECLARE @OldCompanyID int

	SELECT
		@OldCompanyID = [CompanyID]
	FROM
		[Employee]
	WHERE
		[Employee].[ID] = @ID

	--     /,   
	--   ..       
	--,   
	IF (@OldCompanyID IS NOT NULL AND @CompanyID IS NULL)
	BEGIN
		DECLARE
			@ExecutiveEmployeeID int,
			@AccountantEmployeeID int

		SELECT
			@ExecutiveEmployeeID = [ExecutiveEmployeeID],
			@AccountantEmployeeID = [AccountantEmployeeID]
		FROM
			[Company]
		WHERE
			[Company].[ID] = @OldCompanyID

		IF(@ExecutiveEmployeeID = @ID)
		BEGIN
			UPDATE [Company]
			SET
				[ExecutiveEmployeeID] = NULL
			WHERE
				[Company].[ID] = @OldCompanyID
		END

		IF(@AccountantEmployeeID = @ID)
		BEGIN
			UPDATE [Company]
			SET
				[AccountantEmployeeID] = NULL
			WHERE
				[Company].[ID] = @OldCompanyID
		END

		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	UPDATE [Employee]
	SET
		@UserID = [Employee].[UserID],
		@Class = [Employee].[Class],
		[Employee].[FileAs] = @FileAs,
		[Employee].[Title] = @Title,
		[Employee].[FirstName] = @FirstName,
		[Employee].[MiddleName] = @MiddleName,
		[Employee].[LastName] = @LastName,
		[Employee].[Suffix] = @Suffix,
		[Employee].[BirthDate] = @BirthDate,
		[Employee].[BirthPlace] = @BirthPlace,
		[Employee].[LegalCode] = @LegalCode,
		[Employee].[Initials] = @Initials,
		[Employee].[CompanyID] = @CompanyID,
		[Employee].[PositionID] = @PositionID,
		[Employee].[DivisionID] = @DivisionID,
		[Employee].[HireDate] = @HireDate,
		[Employee].[FireDate] = @FireDate,
		[Employee].[QualificationID] = @QualificationID,
		[Employee].[Comments] = @Comments,
		[Employee].[Modified] = DEFAULT,
		[Employee].[ModifiedBy] = DEFAULT,
		[Employee].[Number] = @Number,
		[Employee].[CongratulateWithBirthday] = @CongratulateWithBirthday
	WHERE
		[Employee].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	--***************************************
	--  /
	DECLARE
		@ReminderTotalInterval TTimeSpan,
		@CurrentReminderTotalInterval TTimeSpan,
		@CurrentReminderNextInterval TTimeSpan,
		@ReminderIntervalFromSettings TTimeSpan,				
		@CurentUserID TIdentifier = dbo.adfGetCurrentUserID(),
		@ReminderState bit = 1,
		@ReminderIsPostponed bit = 0

	--      
	SELECT
		@ReminderIntervalFromSettings = [InitialInterval] 
	FROM
		[ReminderSetting]
	WHERE
		[UserID] = @CurentUserID
		AND
		[Subtype] = 'CB'
	
	--    ,     
	IF @ReminderIntervalFromSettings IS NULL
	BEGIN
		SELECT
			@ReminderIntervalFromSettings = [DefaultInterval] 
		FROM
			[ReminderType]
		WHERE
			[Class] = dbo.adfGetClassByName('Adf.Employee')
			AND
			[Subtype] = 'CB'
	END

	--  
	SET @BirthDate = CAST(@BirthDate AS date)

	--   
	SELECT
		@CurrentReminderTotalInterval = [OriginalInterval],
		@CurrentReminderNextInterval = [NextInterval]
	FROM
		[Reminder]
		INNER JOIN [UserReminder]
			ON [UserReminder].[ReminderID] = [Reminder].[ID]			
	WHERE
		[Reminder].[DocumentClass] = dbo.adfGetClassByName('Adf.Employee')
		AND
		[Reminder].[DocumentID] = @ID
		AND
		[Reminder].[Subtype] = 'CB'
		AND 
		[UserReminder].[UserID] = @CurentUserID
	
	-- ,   
	IF @CurrentReminderTotalInterval <> @CurrentReminderNextInterval
		SET @ReminderIsPostponed = 1


	--    	
	SET @ReminderTotalInterval = @ReminderIntervalFromSettings + @ReminderInterval

	IF @BirthDate IS NULL OR @ReminderInterval = -1
	BEGIN
		SET @ReminderState = 0		
	END
	ELSE
	BEGIN
		--  
		DECLARE
			@BirthDateCurrentYear TDate,
			@BirthDateNextYear TDate,
			@CurrentDate TDate = CAST(GETDATE() AS date),
			@CurrentDateWithTime TDateTime = GETDATE(),
			@Difference int,
			@Year int = 525600
			

		SET @ReminderState = 1
		
		SET @BirthDateCurrentYear = CAST(DATEADD(Year,DATEDIFF(Year,@BirthDate,@CurrentDate),@BirthDate) AS Date)
		SET @Difference = DATEDIFF(Minute,@BirthDate,@BirthDateCurrentYear)
		SET @BirthDateNextYear = CAST(DATEADD(Year,1,@BirthDateCurrentYear) AS Date)			
		
		IF  (
				DATEADD(Minute,-@ReminderIntervalFromSettings,@BirthDateCurrentYear) <= @CurrentDateWithTime
				OR
				DATEADD(Minute, -@ReminderInterval - @ReminderIntervalFromSettings, @BirthDateCurrentYear) <= @CurrentDateWithTime
			)
			AND
				@ReminderIsPostponed = 0
			SET @ReminderTotalInterval = @ReminderTotalInterval - @Difference - @Year
		ELSE
			SET @ReminderTotalInterval = @ReminderTotalInterval - @Difference		
	END



	EXEC @rv = pjm7ContactBirthdayReminderCreate @ID,
		@BirthDate, @ReminderState, @ReminderTotalInterval

	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END


	--/    
	IF @UserID IS NOT NULL
	BEGIN
		EXEC @result = adfUserUpdate @UserID, @FileAs, @FileAs, @SqlLogin, @WindowsLogin, NULL
		IF @@ERROR != 0 OR @result != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	DECLARE @CurrentUserID TIdentifier
	
	SET @CurrentUserID = dbo.adfGetCurrentUserID()

	UPDATE [ExtendedProperties]
	SET
		[ExtendedProperties]=@ExtendedProperties
	WHERE
		[Class] = @Class AND [ID] = @ID
	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	
	EXEC @result = adfBusinessCardUpdate @doc = @Xml, @XPathRoot = '/adfEmployeeGet', 
		@ID = @ID, @Class = @Class, @FileAs = @FileAs, @Comments = @Comments,
		@CompanyID = @CompanyID, @PositionID = @PositionID
	IF @@error != 0 OR @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	EXEC @result = adfPersonIdentityCardUpdate @doc = @Xml, @EmployeeID = @ID
	IF @@error != 0 OR @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION	
	

	EXEC adfEmployeeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfEmployeeUpdate TO PUBLIC
GO
 
