IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfEmployeeList')
	BEGIN
		PRINT 'Dropping Procedure adfEmployeeList'
		DROP  Procedure  adfEmployeeList
	END

GO

PRINT 'Creating Procedure adfEmployeeList'
GO
/******************************************************************************
**		File: 
**		Name: adfEmployeeList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfEmployeeList
AS
	SET NOCOUNT ON
		
	SELECT
		[Employee].[ID],
		[Employee].[FileAs] as [Name],
		[Employee].[CompanyID],
		(CASE WHEN [Employee].[State] = 1 AND [Company].[State] = 1 THEN 1 ELSE 2 END) as [State],
		[Employee].[UserID],
		[Company].[Own],
		[Employee].[Initials] as [Code],
		[Employee].[DivisionID]
	FROM
		[Employee] LEFT JOIN [Company]
			ON ([Employee].[CompanyID] = [Company].[ID]) 

	RETURN 0
GO

GRANT EXEC ON adfEmployeeList TO PUBLIC
GO
