IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfIdentityCardTypeList')
	BEGIN
		PRINT 'Dropping Procedure adfIdentityCardTypeList'
		DROP  Procedure  adfIdentityCardTypeList
	END

GO

PRINT 'Creating Procedure adfIdentityCardTypeList'
GO
/******************************************************************************
**		File: 
**		Name: adfIdentityCardTypeList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfIdentityCardTypeList
AS
	SET NOCOUNT ON
		
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	
	SELECT
		[IdentityCardType].[ID],
		ISNULL([DocumentGlobal].[FileAs], [IdentityCardType].[FileAs]) as [Name],
		[IdentityCardType].[State]
	FROM
		[IdentityCardType] LEFT OUTER JOIN [DocumentGlobal]
			ON ([IdentityCardType].[Class] = [DocumentGlobal].[Class] AND
				[IdentityCardType].[ID] = [DocumentGlobal].[ID] AND
				[DocumentGlobal].[Language] = @Lang)
	
	RETURN 0
GO

GRANT EXEC ON adfIdentityCardTypeList TO PUBLIC
GO
