IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfPhoneTypeList')
	BEGIN
		PRINT 'Dropping Procedure adfPhoneTypeList'
		DROP  Procedure  adfPhoneTypeList
	END

GO

PRINT 'Creating Procedure adfPhoneTypeList'
GO
/******************************************************************************
**		File: 
**		Name: adfPhoneTypeList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfPhoneTypeList
AS
	SET NOCOUNT ON

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[PhoneType].[ID],
		ISNULL([DocumentGlobal].[FileAs], PhoneType.FileAs) as [Name]
	FROM
		[PhoneType] LEFT OUTER JOIN [DocumentGlobal]
			ON ([PhoneType].[Class] = [DocumentGlobal].[Class] AND
				[PhoneType].[ID] = [DocumentGlobal].[ID] AND
				[DocumentGlobal].[Language] = @Lang)
	RETURN 0
GO

GRANT EXEC ON adfPhoneTypeList TO PUBLIC
GO
