IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfGetDocumentIdentity]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function adfGetDocumentIdentity'
		DROP FUNCTION [dbo].[adfGetDocumentIdentity]
	END

GO

PRINT 'Creating function adfGetDocumentIdentity'
GO
/******************************************************************************
**		File: 
**		Name: adfGetDocumentIdentity
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: nikita.alexandrov
**		Date: 09/07/2009
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		29.03.10	KOV				  @DocumentClass  
**									 dbo.adfGetClassByName('...')
**    
*******************************************************************************/
CREATE FUNCTION adfGetDocumentIdentity
	(@DocumentID TIdentifier, @DocumentClass TIdentifier)
RETURNS @document TABLE ([DocumentClassName] TName, [DocumentName] TName)
AS
BEGIN
	DECLARE
		@Lang TLanguage,
		@DocumentTable TSysname,
		@DocumentName TName,
		@DocumentClassName TName
	
	SET @Lang = dbo.adfGetLanguage()

	IF @Lang = 'en'
		BEGIN
			SELECT
				@DocumentClassName = [ClassGlobal].[Name]
			FROM
				[ClassGlobal]
			WHERE
				[ClassGlobal].[Class] = @DocumentClass
				AND
				[ClassGlobal].[Language] = @Lang
		END
	ELSE IF @Lang = 'ru'
		BEGIN
			SELECT
				@DocumentClassName = [Class].[Name]
			FROM
				[Class]
			WHERE
				[Class].[Class] = @DocumentClass
		END 
	
	--
	--IF @DocumentClass = 32
	IF @DocumentClass = dbo.adfGetClassByName('Pjm5.Task')
		SELECT @DocumentName = [Task].[FileAs] FROM [Task] WHERE [Task].[ID] = @DocumentID
	--
	--IF @DocumentClass = 38
	IF @DocumentClass = dbo.adfGetClassByName('Pjm5.ServiceAssignment')
	BEGIN
		SELECT @DocumentName = [ServiceAssignment].[FileAs] FROM [ServiceAssignment] WHERE [ServiceAssignment].[ID] = @DocumentID
	--   " -"  ""
	IF @Lang = 'en'
		SET @DocumentClassName = 'Service'
	ELSE IF @Lang = 'ru'
		SET @DocumentClassName = ''
	END
	--
	--IF @DocumentClass = 47
	IF @DocumentClass = dbo.adfGetClassByName('Pjm5.Issue')
		SELECT @DocumentName = [Issue].[FileAs] FROM [Issue] WHERE [Issue].[ID] = @DocumentID
	--
	--IF @DocumentClass = 52
	IF @DocumentClass = dbo.adfGetClassByName('Pjm5.ServiceRequest')
		SELECT @DocumentName = [ServiceRequest].[FileAs] FROM [ServiceRequest] WHERE [ServiceRequest].[ID] = @DocumentID
	--
	--IF @DocumentClass = 65
	IF @DocumentClass = dbo.adfGetClassByName('Pjm5.TaskRequest')
		SELECT @DocumentName = [TaskRequest].[FileAs] FROM [TaskRequest] WHERE [TaskRequest].[ID] = @DocumentID	

	INSERT INTO @document VALUES(@DocumentClassName, @DocumentName)
	RETURN
END
GO

GRANT SELECT ON adfGetDocumentIdentity TO PUBLIC
GO