IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfTransitionBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfTransitionBrowse'
		DROP  Procedure  adfTransitionBrowse
	END

GO

PRINT 'Creating Procedure adfTransitionBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfTransitionBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfTransitionBrowse
	@ID TIdentifier,
	@Guid TGuid
AS
	SET NOCOUNT ON

	DECLARE @Class TClass
	SET @Class = dbo.adfGetClassByGuid(@Guid)

	SELECT
		[TransitionTemplate].[Name]	AS [TransitionName],
		[FromState].[Name]			AS [FromStateName],
		[ToState].[Name]			AS [ToStateName],
		[Transition].[Created]		AS [Time],
		[Action].[Name]				AS [ActionName],
		[Trustee].[DisplayName]		AS [TrusteeName]
	FROM
		[Transition]
		INNER JOIN [adfvwTransitionTemplate] as [TransitionTemplate]
			ON	[TransitionTemplate].[ID] = [Transition].[TransitionTemplateID]
		LEFT OUTER JOIN [adfvwState] AS [FromState]
			ON	[FromState].[State] = [TransitionTemplate].[FromState] AND [FromState].[Class] = [Transition].[Class]
		LEFT OUTER JOIN [adfvwState] AS [ToState]
			ON	[ToState].[State] = [TransitionTemplate].[ToState] AND [ToState].[Class] = [Transition].[Class]
		INNER JOIN [adfvwAction] as [Action]
			ON	[Action].[ID] = [TransitionTemplate].[ActionID]
		INNER JOIN [Trustee]
			ON	[Trustee].[ID] = [Transition].[UserID]
	WHERE
		[Transition].[Class] = @Class AND
		[Transition].[DocumentID] = @ID
	ORDER BY
		[Transition].[Created]

	RETURN 0
GO

GRANT EXEC ON adfTransitionBrowse TO PUBLIC
GO
