IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].fnPjm7GetFormattedDaysBeforeEvent') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm7GetFormattedDaysBeforeEvent'
		DROP FUNCTION [dbo].fnPjm7GetFormattedDaysBeforeEvent
	END

GO

PRINT 'Creating Function fnPjm7GetFormattedDaysBeforeEvent'
GO
/******************************************************************************
**		File:	fnPjm7GetFormattedDaysBeforeEvent.sql
**		Name: 	fnPjm7GetFormattedDaysBeforeEvent
**		Desc:	returns 
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	29.11.11		ASA		first version
**    	06.12.11		ASA		second version, within date functions
*******************************************************************************/

CREATE FUNCTION fnPjm7GetFormattedDaysBeforeEvent(@Days int, @EventDate datetime)
RETURNS varchar(20)
BEGIN
	DECLARE
		@Result varchar(20),
		@ThisYearDate datetime,
		@eventDay datetime,
		@Language TCode,
		@today datetime,
		@nextYear datetime,
		@daysUntil int,
		@monthsUntil int,
		@daysString varchar(10),
		@monthsString varchar(10),
		@oneMonthInDays int,
		@twoMonthsInDays int

	SET @today = GetDate()
	SET @nextYear = DATEADD(YEAR,1,@today)
	SET @Language = dbo.adfGetLanguage()

	--    (    )
		--     
	IF((DATEPART(MONTH,@EventDate) < DATEPART(MONTH,@today)) OR ((DATEPART(MONTH,@EventDate) = DATEPART(MONTH,@today)) AND (DATEPART(DAY,@EventDate) < DATEPART(DAY,@today))))
		IF(Datepart(month, @EventDate) > 2)					--    
		BEGIN
			IF(isdate(datename(year,@EventDate)+'0229') = 1)	--  
			BEGIN
				IF(isdate(datename(year,@nextYear)+'0229') = 1)		--   
				BEGIN
					SET @eventDay = dateadd(year,1,Dateadd(day,datepart(dayofyear,@EventDate) - 1 - 1, datename(year,@today)))
				END
				ELSE												--    	
				BEGIN
					SET @eventDay = dateadd(year,1,Dateadd(day,datepart(dayofyear,@EventDate) - 1, datename(year,@today))) -- +1
				END
			END													--   
			ELSE IF(isdate(datename(year,@EventDate)+'0229') = 0)
			BEGIN
				IF(isdate(datename(year,@nextYear)+'0229') = 1)		--   
				BEGIN
					SET @eventDay = dateadd(year,1,Dateadd(day,datepart(dayofyear,@EventDate) - 1, datename(year,@today)))
				END
				ELSE												--    	
				BEGIN
					SET @eventDay = dateadd(year,1,Dateadd(day,datepart(dayofyear,@EventDate) - 1 + 1, datename(year,@today))) -- +1
				END
			END
		END
		ELSE														--   
		BEGIN
			SET @eventDay = dateadd(year,1,Dateadd(day,datepart(dayofyear,@EventDate) - 1, datename(year,@today)))
		END
	ELSE	--     
	BEGIN
		IF(Datepart(month, @EventDate) > 2)					--    
		BEGIN
			IF(isdate(datename(year,@EventDate)+'0229') = 1)	--  
			BEGIN
				IF(isdate(datename(year,@today)+'0229') = 1)		--  
				BEGIN
					SET @eventDay = Dateadd(day,datepart(dayofyear,@EventDate) - 1, datename(year,@today))
				END
				ELSE												--   	
				BEGIN
					SET @eventDay = Dateadd(day,datepart(dayofyear,@EventDate) - 1 - 1, datename(year,@today))
				END
			END													--   
			ELSE IF(isdate(datename(year,@EventDate)+'0229') = 0)
			BEGIN
				IF(isdate(datename(year,@today)+'0229') = 1)		--  
				BEGIN
					SET @eventDay = Dateadd(day,datepart(dayofyear,@EventDate) - 1 + 1, datename(year,@today))
				END
				ELSE												--   	
				BEGIN
					SET @eventDay = Dateadd(day,datepart(dayofyear,@EventDate) - 1 , datename(year,@today))
				END
			END
		END
		ELSE													--   
		BEGIN
			SET @eventDay = Dateadd(day,datepart(dayofyear,@EventDate) - 1, datename(year,@today))
		END
	END

	SET @monthsUntil = DATEDIFF(month,@today,@eventDay)
	SET @daysUntil = DATEDIFF(DAY,@today,@eventDay)
	SET @oneMonthInDays = DATEDIFF(DAY,@today,DATEADD(month,1,@today))
	SET @twoMonthsInDays = DATEDIFF(DAY,@today,DATEDIFF(month,2,@today))

	IF(@Language = 'ru')
	BEGIN
			IF ( (datepart(month,@Eventdate) = datepart(month,@today) AND (DATEPART(DAY,@EventDate) >= DATEPART(DAY,@today))) OR (datepart(month,@Eventdate) = datepart(month,dateadd(month,1,@today))))
		BEGIN
			IF (@daysUntil = 0)
			BEGIN
				SET @Result = ''
			END
			ELSE IF(@daysUntil < @oneMonthInDays)
			BEGIN
				IF(@daysUntil IN (2,3,4,22,23,24))
				BEGIN
					SET @Result = CAST(@daysUntil as varchar(10)) + ' '
				END
				ELSE IF(@daysUntil IN (1,21))
				BEGIN
					SET @Result = CAST(@daysUntil as varchar(10)) + ' '
				END
				ELSE
				BEGIN
					SET @Result = CAST(@daysUntil as varchar(10)) + ' '
				END
			END
			ELSE IF(@daysUntil = @oneMonthInDays)
			BEGIN
				SET @Result = '1 '
			END
			ELSE IF(@daysUntil > @oneMonthInDays)
			BEGIN
				IF((@daysUntil - @oneMonthInDays) IN (2,3,4,22,23,24))
				BEGIN
					SET @Result = '1 . ' + CAST((@daysUntil - @oneMonthInDays) as varchar(10)) + ' '
				END
				ELSE IF((@daysUntil - @oneMonthInDays) IN (1,21))
				BEGIN
					SET @Result = '1 . ' + CAST((@daysUntil - @oneMonthInDays) as varchar(10)) + ' '
				END
				ELSE
				BEGIN
					SET @Result = '1 . ' + CAST((@daysUntil - @oneMonthInDays) as varchar(10)) + ' '
				END
			END
		END
		ELSE
		BEGIN
			IF(@monthsUntil IN (2,3,4))
			BEGIN
				SET @Result = CAST(@monthsUntil as varchar(10)) + ' '
			END
			ELSE
			BEGIN
				SET @Result = CAST(@monthsUntil as varchar(10)) + ' '
			END
		END
	END
	ELSE IF(@Language = 'en')
	BEGIN
		IF ( (datepart(month,@Eventdate) = datepart(month,@today) AND (DATEPART(DAY,@EventDate) >= DATEPART(DAY,@today))) OR (datepart(month,@Eventdate) = datepart(month,dateadd(month,1,@today))))
		BEGIN
			IF (@daysUntil = 0)
			BEGIN
				SET @Result = 'today'
			END
			ELSE IF(@daysUntil < @oneMonthInDays)
			BEGIN
				IF(@daysUntil = 1)
				BEGIN
					SET @Result = CAST(@daysUntil as varchar(10)) + ' day'
				END
				ELSE
				BEGIN
					SET @Result = CAST(@daysUntil as varchar(10)) + ' days'
				END
			END
			ELSE IF(@daysUntil = @oneMonthInDays)
			BEGIN
				SET @Result = '1 month'
			END
			ELSE IF(@daysUntil > @oneMonthInDays)
			BEGIN
				IF((@daysUntil - @oneMonthInDays) = 1)
				BEGIN
					SET @Result = '1 month ' + CAST((@daysUntil - @oneMonthInDays) as varchar(10)) + ' day'
				END
				ELSE
				BEGIN
					SET @Result = '1 month ' + CAST((@daysUntil - @oneMonthInDays) as varchar(10)) + ' days'
				END
			END
		END
		ELSE
		BEGIN
			SET @Result = CAST(@monthsUntil as varchar(10)) + ' months'
		END
	END

	RETURN @Result
END
GO

GRANT EXEC ON fnPjm7GetFormattedDaysBeforeEvent TO PUBLIC
GO
