IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfSqlUserList')
	BEGIN
		PRINT 'Dropping Procedure adfSqlUserList'
		DROP  Procedure  adfSqlUserList
	END

GO

PRINT 'Creating Procedure adfSqlUserList'
GO
/******************************************************************************
**		File: 
**		Name: adfSqlUserList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		26.02.13	SOV				 ,     
**									   SQL-
**		22.08.13	SOV				    Azure SQL
*******************************************************************************/
CREATE Procedure adfSqlUserList
	@OnlyUnused TBool = 0
AS
	SET NOCOUNT ON

	DECLARE @EngineEdition SQL_VARIANT = SERVERPROPERTY('EngineEdition')

	IF (@EngineEdition != 5)
	BEGIN
		SELECT 
			u.[uid] as [ID], u.[name] as [Name]
		FROM
			sys.sysusers as u LEFT OUTER JOIN sys.syslogins  l 
				ON (u.[sid] = l.[sid])
			LEFT JOIN [User]
				ON [User].[SQLLogin] = u.[name]
		WHERE 
			u.[uid] != u.[gid] and u.[issqlrole]=0 and u.[isapprole]=0 AND u.[uid] > 2
		AND
			[l].[name] IS NOT NULL
		AND
			CHARINDEX('\', [l].[name]) = 0
		AND
			(@OnlyUnused = 0 OR [User].[SQLLogin] IS NULL)
	END
	ELSE
	BEGIN
		SELECT 
			u.[uid] as [ID], u.[name] as [Name]
		FROM
			sys.sysusers as u LEFT OUTER JOIN sys.database_principals  l 
				ON (u.[sid] = l.[sid])
			LEFT JOIN [User]
				ON [User].[SQLLogin] = u.[name] COLLATE SQL_Latin1_General_CP1_CI_AS
		WHERE 
			u.[uid] != u.[gid] and u.[issqlrole]=0 and u.[isapprole]=0 AND u.[uid] > 2
		AND
			[l].[name] IS NOT NULL
		AND
			CHARINDEX('\', [l].[name]) = 0
		AND
			(@OnlyUnused = 0 OR [User].[SQLLogin] IS NULL)
	END
	
	RETURN 0
GO

GRANT EXEC ON adfSqlUserList TO PUBLIC
GO
