IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfAccessRightCreate')
	BEGIN
		PRINT 'Dropping Procedure adfAccessRightCreate'
		DROP  Procedure  adfAccessRightCreate
	END

GO

PRINT 'Creating Procedure adfAccessRightCreate'
GO
/******************************************************************************
**		File: 
**		Name: adfAccessRightCreate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfAccessRightCreate
	@RightName TSysname,
	@TrusteeName TSysname
AS
	DECLARE @result INT
	
	SET NOCOUNT ON

	EXEC @result = adfAccessRightCheck 'ManageRights'
	IF @result != 0
		RETURN @result

	INSERT INTO [AccessRight] 
		([RightID], [TrusteeID], [Allow])
	VALUES
		(dbo.adfGetRightID(@RightName), dbo.adfGetTrusteeID(@TrusteeName), 1)
		
	RETURN 0
GO

GRANT EXEC ON adfAccessRightCreate TO PUBLIC
GO
