IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfRightGet')
	BEGIN
		PRINT 'Dropping Procedure adfRightGet'
		DROP  Procedure  adfRightGet
	END

GO

PRINT 'Creating Procedure adfRightGet'
GO
/******************************************************************************
**		File: 
**		Name: adfRightGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfRightGet
	@Name TSysname
AS
	DECLARE @ID TIdentifier
	
	SET NOCOUNT ON

	SET @ID = dbo.adfGetRightID(@Name)

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[Right].[ID],
		[Right].[Name],
		ISNULL([RightGlobal].[DisplayName], [Right].[DisplayName]) as [DisplayName],
		[Right].[Group],
		ISNULL([RightGlobal].[Comments], [Right].[Comments]) as [Comments],
		1 as [State],
		CAST('2004-06-04 13:00' as datetime) as Created,
		CAST('2004-06-04 13:00' as datetime) as Modified,
		1 as CreatedBy,
		1 as ModifiedBy
	FROM
		[Right] LEFT OUTER JOIN [RightGlobal]
			ON ([Right].[ID] = [RightGlobal].[ID] AND [RightGlobal].[Language] = @Lang)
	WHERE
		[Right].[ID] = @ID
		
	SELECT
		[Trustee].[Name],
		ISNULL([TrusteeGlobal].[DisplayName], [Trustee].[DisplayName]) as [DisplayName],
		dbo.adfGetTrusteeType([Trustee].[Name]) as [TrusteeType]
	FROM
		[AccessRight] INNER JOIN [Trustee]
			ON ([AccessRight].[TrusteeID] = [Trustee].[ID])
		LEFT OUTER JOIN [TrusteeGlobal]
			ON ([Trustee].[ID] = [TrusteeGlobal].[ID] AND [TrusteeGlobal].[Language] = @Lang)
	WHERE
		[AccessRight].[RightID] = @ID
	ORDER BY
		ISNULL([TrusteeGlobal].[DisplayName], [Trustee].[DisplayName])

	RETURN 0
GO

GRANT EXEC ON adfRightGet TO PUBLIC
GO
