IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfStateGet')
	BEGIN
		PRINT 'Dropping Procedure adfStateGet'
		DROP  Procedure  adfStateGet
	END

GO

PRINT 'Creating Procedure adfStateGet'
GO
/******************************************************************************
**		File: 
**		Name: adfStateGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfStateGet
	@Class TClass,
	@State TState
AS
	DECLARE @C TClass, @Lang TLanguage
	SET NOCOUNT ON
	
	SET @Lang = dbo.adfGetLanguage()

	SET @C = dbo.adfGetClassByName('Adf.State')
	
	SELECT
		[State].[Class] as [ClassID],
		[State].[State] as [ClassState],
		@C as [Class],
		ISNULL([StateGlobal].[Name], [State].[Name]) as [Name],
		ISNULL([StateGlobal].[Comments], [State].[Comments]) as [Comments],
		ISNULL([StateGlobal].[UIText], [State].[UIText]) as [UIText],
		[State].[Image],
		CAST(1 as INT) as [State]
	FROM
		[State] LEFT OUTER JOIN [StateGlobal]
			ON ([State].[Class] = [StateGlobal].[Class] AND [State].[State]=[StateGlobal].[State] AND
				[StateGlobal].[Language] = @Lang)
	WHERE
		[State].[Class] = @Class
	AND
		[State].[State] = @State

	RETURN 0
GO

GRANT EXEC ON adfStateGet TO PUBLIC
GO
