IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfwfDocumentDelete')
	BEGIN
		PRINT 'Dropping Procedure adfwfDocumentDelete'
		DROP  Procedure  adfwfDocumentDelete
	END

GO

PRINT 'Creating Procedure adfwfDocumentDelete'
GO
/******************************************************************************
**		File: 
**		Name: adfwfDocumentDelete
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfwfDocumentDelete
	@Class TClass,
	@ID TIdentifier
AS
	DECLARE @result INT, @State TState, @TransitionTemplateID TIdentifier
	
	SET NOCOUNT ON

	SELECT 
		@State = [State]
	FROM
		[Document]
	WHERE
		[Class] = @Class AND [ID] = @ID
		
	SELECT
		@TransitionTemplateID = [ID] 
	FROM
		[TransitionTemplate]
	WHERE
		[FromState] = @State AND [ToState] IS NULL AND [Class] = @Class

	BEGIN TRANSACTION
	
	EXEC adfwfDocumentDeleteInternal @ID, @TransitionTemplateID
	
	IF @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @result
	END
	
	COMMIT TRANSACTION
	
	RETURN 0
GO

GRANT EXEC ON adfwfDocumentDelete TO PUBLIC
GO
