IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'Case') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	IF EXISTS (SELECT * FROM [Case] WHERE CAST([AllowInternal] AS int) + CAST([AllowIncoming] AS int) + CAST([AllowOutgoing] AS int) != 1)
	BEGIN
		SELECT * FROM [Case] WHERE CAST([AllowInternal] AS int) + CAST([AllowIncoming] AS int) + CAST([AllowOutgoing] AS int) != 1
		RAISERROR ('   " ".      ', 18, -1)
		RETURN
	END

	IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'IncomingDocument') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
	BEGIN
		IF EXISTS(
			SELECT 
				* 
			FROM 
				[IncomingDocument]
				LEFT OUTER JOIN [Case]
					ON [IncomingDocument].[CaseID] = [Case].[ID]
			WHERE
				[IncomingDocument].[CaseID] IS NULL OR
				[Case].[AllowIncoming] != 1
			)
		BEGIN
			SELECT 
				* 
			FROM 
				[IncomingDocument]
				LEFT OUTER JOIN [Case]
					ON [IncomingDocument].[CaseID] = [Case].[ID]
			WHERE
				[IncomingDocument].[CaseID] IS NULL OR
				[Case].[AllowIncoming] != 1
			RAISERROR ('      " ".   ""   ', 18, -1)
			RETURN
		END
	END

	IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'OutgoingDocument') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
	BEGIN
		IF EXISTS(
			SELECT 
				* 
			FROM 
				[OutgoingDocument]
				LEFT OUTER JOIN [Case]
					ON [OutgoingDocument].[CaseID] = [Case].[ID]
			WHERE
				[OutgoingDocument].[CaseID] IS NULL OR
				[Case].[AllowOutgoing] != 1
			)
		BEGIN
			SELECT 
				* 
			FROM 
				[OutgoingDocument]
				LEFT OUTER JOIN [Case]
					ON [OutgoingDocument].[CaseID] = [Case].[ID]
			WHERE
				[OutgoingDocument].[CaseID] IS NULL OR
				[Case].[AllowOutgoing] != 1
			RAISERROR ('      " ".   ""   ', 18, -1)
			RETURN
		END

		IF EXISTS(
			SELECT 
				* 
			FROM 
				[DocumentCard]
				INNER JOIN [Case]
					ON [DocumentCard].[CaseID] = [Case].[ID]
			WHERE
				[Case].[AllowInternal] != 1)
				AND
		EXISTS(SELECT * FROM [IncomingDocument])
				AND
		EXISTS(SELECT * FROM [OutgoingDocument])
			
		BEGIN
			SELECT 
				* 
			FROM 
				[DocumentCard]
				INNER JOIN [Case]
					ON [DocumentCard].[CaseID] = [Case].[ID]
			WHERE
				[Case].[AllowInternal] != 1
			RAISERROR ('      " ".   ""   ', 18, -1)
			RETURN
		END
		IF EXISTS (SELECT * FROM syscolumns WHERE [name] = 'DocumentItemID' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='DocumentCard')
		BEGIN
			IF EXISTS(
				SELECT 
					* 
				FROM 
					[DocumentCard]
					LEFT OUTER JOIN [Case]
						ON [DocumentCard].[CaseID] = [Case].[ID]
				WHERE
					[DocumentCard].[DocumentCardClassID] IS NOT NULL AND [Case].[ID] IS NULL
				)
			BEGIN
				SELECT 
					* 
				FROM 
					[DocumentCard]
					LEFT OUTER JOIN [Case]
						ON [DocumentCard].[CaseID] = [Case].[ID]
				WHERE
					[DocumentCard].[DocumentCardClassID] IS NOT NULL AND [Case].[ID] IS NULL
				RAISERROR ('   " ".   ""  ""   ', 18, -1)
				RETURN
			END
		END
	END
END
ELSE
BEGIN
	IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'IncomingDocument') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
	BEGIN
		IF EXISTS(
			SELECT 
				* 
			FROM 
				[IncomingDocument]
			WHERE
				[IncomingDocument].[CompanyID] IS NULL
			)
		BEGIN
			SELECT 
				* 
			FROM 
				[IncomingDocument]
			WHERE
				[IncomingDocument].[CompanyID] IS NULL
			RAISERROR ('   " ".  ""   ', 18, -1)
			RETURN
		END
	END

	IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'OutgoingDocument') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
	BEGIN
		IF EXISTS(
			SELECT 
				* 
			FROM 
				[OutgoingDocument]
			WHERE
				[OutgoingDocument].[CompanyID] IS NULL
			)
		BEGIN
			SELECT 
				* 
			FROM 
				[OutgoingDocument]
			WHERE
				[OutgoingDocument].[CompanyID] IS NULL
			RAISERROR ('   " ".  ""   ', 18, -1)
			RETURN
		END
		
		IF EXISTS(
			SELECT 
				* 
			FROM 
				[DocumentCard]
			WHERE
				[DocumentCard].[DocumentCardClassID] IS NOT NULL AND [DocumentCard].[CompanyID] IS NULL
			)
		BEGIN
			SELECT 
				* 
			FROM 
				[DocumentCard]
			WHERE
				[DocumentCard].[DocumentCardClassID] IS NOT NULL AND [DocumentCard].[CompanyID] IS NULL
			RAISERROR ('   " ".  ""      ', 18, -1)
			RETURN
		END
	END

END
GO

--   ,     
IF EXISTS (SELECT * FROM syscolumns WHERE [name] = 'SubprojectID' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Task')
BEGIN
	EXEC sp_executesql N'
				IF EXISTS(SELECT
							[SubprojectID]
						FROM [Task]
						WHERE
							[SubprojectID] IS NOT NULL
						GROUP BY [SubprojectID]
						HAVING count(*) > 1	)
				BEGIN
					RAISERROR('' ,     .'', 18, -1)
					RETURN
				END
			'
END
GO

--       
DECLARE @value TVariant,
		@Param TVariant,		
		@xml XML,
		@major int,
		@minor int,
		@build int

EXEC adfParameterGet 'DatabaseVersion', 'VersionInfo', @Param OUTPUT

SET @xml = CAST(@Param as varchar(8000))

SELECT 
	@major = T.c.value('major[1]','int'),
	@minor = T.c.value('minor[1]','int'),
	@build = T.c.value('build[1]','int')
FROM 
	@xml.nodes('/version') AS T(c)	

IF(@major * 100000 + @minor * 10000 + @build < 602428)
BEGIN
	exec adfAccessRightDelete @RightName=N'ViewFinance',@TrusteeName=N'ProjectManager'
END
GO
