﻿IF EXISTS(SELECT *FROM [ReminderType] WHERE [Subtype] = 'NC')
BEGIN
	IF EXISTS(Select *from sys.key_constraints where [name] = 'ReminderTypePK')
	ALTER TABLE [ReminderType]
		DROP CONSTRAINT ReminderTypePK
	
	
	ALTER TABLE [ReminderType]
		ALTER COLUMN [Class] TClass NULL
	
	ALTER TABLE [ReminderType]
		ALTER COLUMN [View] TSysName NULL

	IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'IsTimeFormat' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='ReminderType')
	ALTER TABLE [ReminderType]
		ADD [IsTimeFormat] TBool NOT NULL DEFAULT 0
	
	IF EXISTS(Select *from sys.key_constraints where [name] = 'ReminderSettingPK')
	ALTER TABLE [ReminderSetting]
		DROP CONSTRAINT ReminderSettingPK

	IF EXISTS (SELECT * FROM syscolumns WHERE [name] = 'Class' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='ReminderSetting')
	ALTER TABLE [ReminderSetting]
		DROP COLUMN [Class]	

	IF EXISTS (SELECT * FROM syscolumns WHERE [name] = 'UserDefined' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='UserReminder')
	ALTER TABLE [UserReminder]
		DROP COLUMN [UserDefined]
	
	IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'Description' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='UserReminder')
	ALTER TABLE [UserReminder]
		ADD [Description] TName NULL
	
	IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'Modified' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='UserReminder')
	ALTER TABLE [UserReminder]
		ADD Modified TSysDateTime not null default GETDATE()

	IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'Modified' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Reminder')
	ALTER TABLE [Reminder]
		ADD Modified TSysDateTime not null default GETDATE()

	IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'ReminderDescription') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
	/*==============================================================*/
	/* Table: ReminderDescription                                   */
	/*==============================================================*/
	create table ReminderDescription (
	   Subtype              TCode2               not null,
	   Class				TClass				 null,
	   Language             TLanguage            not null,
	   Description          TName                not null
	)

	IF EXISTS (SELECT * FROM syscolumns WHERE [name] = 'LastContact' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Employee')
	ALTER TABLE [Employee]
		DROP COLUMN [LastContact]
	IF EXISTS (SELECT * FROM syscolumns WHERE [name] = 'NextContact' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Employee')
	ALTER TABLE [Employee]
		DROP COLUMN [NextContact]
	IF EXISTS (SELECT * FROM syscolumns WHERE [name] = 'LastContact' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Company')
	ALTER TABLE [Company]
		DROP COLUMN [LastContact]

	IF EXISTS (SELECT * FROM syscolumns WHERE [name] = 'NextContact' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Company')
	ALTER TABLE [Company]
		DROP COLUMN [NextContact]

	IF EXISTS (SELECT * FROM syscolumns WHERE [name] = 'LastContact' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='BusinessCard')
	ALTER TABLE [BusinessCard]
		DROP COLUMN [LastContact]

	IF EXISTS (SELECT * FROM syscolumns WHERE [name] = 'NextContact' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='BusinessCard')
	ALTER TABLE [BusinessCard]
		DROP COLUMN [NextContact]
END
GO


IF EXISTS(SELECT *FROM [ReminderType] WHERE [Subtype] = 'NC')
BEGIN
	IF NOT EXISTS(SELECT *FROM [ReminderType] WHERE [Subtype] = 'UR')
		INSERT INTO [ReminderType] (Subtype, Name, DefaultState, DefaultInterval, IsTimeFormat)
		VALUES('UR', 'Пользовательское напоминание', 1, -600, 1)

	


	UPDATE [ReminderType] SET [IsTimeFormat] = 0 WHERE [Subtype] = 'ES'
	UPDATE [ReminderType] SET [IsTimeFormat] = 0 WHERE [Subtype] = 'ID'
	UPDATE [ReminderType] SET [IsTimeFormat] = 1 WHERE [Subtype] = 'TD'
	UPDATE [ReminderType] SET [IsTimeFormat] = 0 WHERE [Subtype] = 'SD'
	UPDATE [ReminderType] SET [IsTimeFormat] = 0 WHERE [Subtype] = 'RD'
	UPDATE [ReminderType] SET [IsTimeFormat] = 0 WHERE [Subtype] = 'MS'
	UPDATE [ReminderType] SET [IsTimeFormat] = 1 WHERE [Subtype] = 'BC'
	UPDATE [ReminderType] SET [IsTimeFormat] = 1 WHERE [Subtype] = 'VA'
	UPDATE [ReminderType] SET [IsTimeFormat] = 1 WHERE [Subtype] = 'VP'
	UPDATE [ReminderType] SET [IsTimeFormat] = 1 WHERE [Subtype] = 'MD'
	UPDATE [ReminderType] SET [IsTimeFormat] = 1 WHERE [Subtype] = 'UR'


	DELETE FROM [UserReminder] FROM [UserReminder] u
		LEFT JOIN Reminder r
			ON u.[ReminderID] = r.[ID]
		WHERE [Subtype] = 'NC'
			
	DELETE FROM [Reminder] WHERE [Subtype] = 'NC'
	DELETE FROM [ReminderType] WHERE [Subtype] = 'NC'
	DELETE FROM [ReminderSetting] WHERE [Subtype] = 'NC'

	IF NOT EXISTS(Select *from sys.key_constraints where [name] = 'ReminderSettingPK')
		ALTER TABLE [ReminderSetting]
			ADD CONSTRAINT ReminderSettingPK PRIMARY KEY  (UserID, Subtype)
	IF NOT EXISTS(Select *from sys.key_constraints where [name] = 'ReminderTypePK')
		ALTER TABLE [ReminderType]
			ADD CONSTRAINT ReminderTypePK PRIMARY KEY  (Subtype)
	--Общие напоминания
	INSERT INTO [ReminderDescription] VALUES('UR', NULL, 'ru', 'К исполнению')
	INSERT INTO [ReminderDescription] VALUES('UR', NULL, 'ru', 'Для сведения')
	INSERT INTO [ReminderDescription] VALUES('UR', NULL, 'ru', 'Позвонить')
	INSERT INTO [ReminderDescription] VALUES('UR', NULL, 'ru', 'Отправить письмо')
	INSERT INTO [ReminderDescription] VALUES('UR', NULL, 'ru', 'Контроль исполнения')
	INSERT INTO [ReminderDescription] VALUES('UR', NULL, 'en', 'To execution')
	INSERT INTO [ReminderDescription] VALUES('UR', NULL, 'en', 'For information')
	INSERT INTO [ReminderDescription] VALUES('UR', NULL, 'en', 'Call')
	INSERT INTO [ReminderDescription] VALUES('UR', NULL, 'en', 'Send email')
	INSERT INTO [ReminderDescription] VALUES('UR', NULL, 'en', 'Execution control')

	--Счет
	INSERT INTO [ReminderDescription] VALUES('VA', dbo.adfGetClassByName('Pjm5.Invoice'), 'ru', 'Напомнить о дате выставления счета')
	INSERT INTO [ReminderDescription] VALUES('VP', dbo.adfGetClassByName('Pjm5.Invoice'), 'ru', 'Напомнить о сроке оплаты счета')
	INSERT INTO [ReminderDescription] VALUES('VA', dbo.adfGetClassByName('Pjm5.Invoice'), 'en', 'To remind of the billing date')
	INSERT INTO [ReminderDescription] VALUES('VP', dbo.adfGetClassByName('Pjm5.Invoice'), 'en', 'To remind of the invoice due date')

	--Акт
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.Statement'), 'ru', 'Утвердить акт')
	INSERT INTO [ReminderDescription] VALUES('MD', dbo.adfGetClassByName('Pjm5.Statement'), 'ru', 'Напомнить о сроке возвращения акта')
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.Statement'), 'en', 'Approve statement')
	INSERT INTO [ReminderDescription] VALUES('MD', dbo.adfGetClassByName('Pjm5.Statement'), 'en', 'To remind of the term of statement return')

	--Калькуляция
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.Calculation'), 'ru', 'Утвердить калькуляцию')
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.Calculation'), 'ru', 'Включить в счет/акт')
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.Calculation'), 'en', 'Approve calculation')
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.Calculation'), 'en', 'Include in invoice/statement')

	--Счет-фактура
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.Facture'), 'ru', 'Утвердить счет-фактуру')
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.Facture'), 'en', 'Approve facture')

	--Документы в ДО
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.DocumentCard'), 'ru', 'Отправить контрагенту')
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.DocumentCard'), 'ru', 'Контроль возврата документа')
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.DocumentCard'), 'ru', 'Ознакомиться с документом')
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.DocumentCard'), 'en', 'Send to the client')
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.DocumentCard'), 'en', 'Control of document return')
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.DocumentCard'), 'en', 'Familiarize with the document')

	--Проекты
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.Project'), 'ru', 'Подготовить документы')
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.Project'), 'en', 'Prepare documents')

	--Бюджет
	--INSERT INTO [ReminderDescription] VALUES('BC', dbo.adfGetClassByName('Pjm6.Budget'), 'ru', 'Напомнить о пересчете бюджета')
	--INSERT INTO [ReminderDescription] VALUES('BC', dbo.adfGetClassByName('Pjm6.Budget'), 'en', 'To remind of the budget recalculation')

	--Контакт
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Adf.Employee'), 'ru', 'Назначить встречу')
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Adf.Employee'), 'en', 'Make an appointment')

	--Встречи
	INSERT INTO [ReminderDescription] VALUES('MS', dbo.adfGetClassByName('Pjm5.MeetingRequest'), 'ru', 'Напомнить о начале встречи')
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.MeetingRequest'), 'ru', 'Подготовиться к встрече')
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.MeetingRequest'), 'ru', 'Подготовить документы к встрече')
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.MeetingRequest'), 'ru', 'Изучить документы к встрече')
	INSERT INTO [ReminderDescription] VALUES('MS', dbo.adfGetClassByName('Pjm5.MeetingRequest'), 'en', 'To remind of the meeting beginning')
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.MeetingRequest'), 'en', 'Prepare for a meeting')
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.MeetingRequest'), 'en', 'Prepare documents for a meeting')
	INSERT INTO [ReminderDescription] VALUES('UR', dbo.adfGetClassByName('Pjm5.MeetingRequest'), 'en', 'Familiarize with the document for a meeting')

	--Запись о времени
	INSERT INTO [ReminderDescription] VALUES('ES', dbo.adfGetClassByName('Pjm5.TimeEntry'), 'ru', 'Напомнить о начале записи о времени')
	INSERT INTO [ReminderDescription] VALUES('ES', dbo.adfGetClassByName('Pjm5.TimeEntry'), 'en', 'To remind of the time entry beginning')

	--Запрос
	INSERT INTO [ReminderDescription] VALUES('ID', dbo.adfGetClassByName('Pjm5.Issue'), 'ru', 'Напомнить о сроке исполнения запроса')
	INSERT INTO [ReminderDescription] VALUES('ID', dbo.adfGetClassByName('Pjm5.Issue'), 'en', 'To remind of the issue due date')

	--Поручение
	INSERT INTO [ReminderDescription] VALUES('RD', dbo.adfGetClassByName('Pjm5.TaskRequest'), 'ru', 'Напомнить о сроке исполнения поручения')
	INSERT INTO [ReminderDescription] VALUES('RD', dbo.adfGetClassByName('Pjm5.TaskRequest'), 'en', 'To remind of the task request due date')

	--Заявка
	INSERT INTO [ReminderDescription] VALUES('SD', dbo.adfGetClassByName('Pjm5.ServiceRequest'), 'ru', 'Напомнить о сроке исполнения заявки')
	INSERT INTO [ReminderDescription] VALUES('SD', dbo.adfGetClassByName('Pjm5.ServiceRequest'), 'en', 'To remind of the service request due date')

	--Задача
	INSERT INTO [ReminderDescription] VALUES('TD', dbo.adfGetClassByName('Pjm5.Task'), 'ru', 'Напомнить о сроке исполнения задачи')
	INSERT INTO [ReminderDescription] VALUES('TD', dbo.adfGetClassByName('Pjm5.Task'), 'en', 'To remind of the task due date')

	--Удаление старых напоминаний по счету
	UPDATE ur
	SET ur.[State] = 0
	FROM [UserReminder] ur
		INNER JOIN [Reminder] r
		 ON	r.[ID] = ur.[ReminderID]
		INNER JOIN [Invoice] i
		ON i.[ID] = r.[DocumentID] AND
			i.[Class] = r.[DocumentClass]
	WHERE
		i.[State] NOT IN (1, 6)	

	--Заполнение описаний старых напоминаний
	UPDATE ur
	SET
		UR.[Description] = rd.[Description]
	FROM [UserReminder] ur
		INNER JOIN [Reminder] r
			ON r.[ID] = ur.[ReminderID]
		INNER JOIN [ReminderDescription] rd
			ON rd.[Subtype] = r.[Subtype]
	WHERE dbo.adfGetLanguage() = rd.[Language]
END
GO

IF NOT EXISTS (SELECT * FROM [ReminderType] WHERE [Class] = dbo.adfGetClassByName('Adf.Employee') AND  [Subtype] = 'CB')
BEGIN
	insert into [ReminderType] ([Class], [Subtype], [Name], [View], [DefaultState], [DefaultInterval], [IsTimeFormat])
	values (dbo.adfGetClassByName('Adf.Employee'), 'CB', 'День рождения контакта', NULL, 1, -600, 1)
END

IF NOT EXISTS (SELECT * FROM [ReminderDescription] WHERE [Class] = dbo.adfGetClassByName('Adf.Employee') AND [Subtype] = 'CB')
BEGIN
	INSERT INTO [ReminderDescription] VALUES('CB', dbo.adfGetClassByName('Adf.Employee'), 'ru', 'Поздравить с днем рождения')
	INSERT INTO [ReminderDescription] VALUES('CB', dbo.adfGetClassByName('Adf.Employee'), 'en', 'Congratulate with birthday')
END

IF EXISTS(Select *from sys.indexes where [name] = 'Reminder_IX_DocumentID_DocumentClass_Subtype')
	DROP INDEX Reminder_IX_DocumentID_DocumentClass_Subtype ON Reminder
GO



