--  /    


DECLARE @DBVersion TVariant
EXEC adfParameterGet 'DatabaseVersion', 'VersionInfo', @Value = @DBVersion OUTPUT

DECLARE @RightName TName
DECLARE @ParameterName TName = 'DeleteRight_AssignManagers'
IF NOT EXISTS (SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = @ParameterName)
BEGIN
	SET @RightName = 'AssignManagers'

	DELETE [AccessRight] 
	WHERE [RightID] IN (SELECT [ID] FROM [Right] WHERE [Name] = @RightName)
		
	DELETE [Right] WHERE [Name] = @RightName

	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES (@ParameterName, @DBVersion, 'upgrade-rights.sql')
END

SET @ParameterName = 'DeleteRight_ViewRevenueAnalysisByProjectReport'
IF NOT EXISTS (SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = @ParameterName)
BEGIN
	SET @RightName = 'ViewRevenueAnalysisByProjectReport'

	DELETE [AccessRight] 
	WHERE [RightID] IN (SELECT [ID] FROM [Right] WHERE [Name] = @RightName)
		
	DELETE [Right] WHERE [Name] = @RightName

	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES (@ParameterName, @DBVersion, 'upgrade-rights.sql')
END


DECLARE 
		@Name TSysname,
		@RightID TIdentifier,
		@TrusteeID TIdentifier


SET @ParameterName = 'AddRight_ManageActivityMonitor'
IF NOT EXISTS (SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = @ParameterName)
BEGIN

	SELECT @Name = [Name] 
		FROM [Right] 
		WHERE [Name] = 'ManageActivityMonitor'
	
	IF (@Name IS NULL)
	BEGIN --   
	-- 
		INSERT INTO [Right]([Name], [DisplayName], [Comments], [Group]) 
			VALUES(
			'ManageActivityMonitor', 
			'   ',
			',        ',
			' ')
	
		SELECT @RightID = [ID] FROM [Right] WHERE [Name] = 'ManageActivityMonitor'

		IF NOT EXISTS (SELECT * FROM [RightGlobal] WHERE [ID] = @RightID AND [Language] = 'ru')
		BEGIN
		INSERT INTO [RightGlobal]([ID], [Language], [DisplayName], [Comments]) 
			VALUES(
			@RightID,
			'ru',
			'   ',
			',        ')
		END

		IF NOT EXISTS (SELECT * FROM [RightGlobal] WHERE [ID] = @RightID AND [Language] = 'en')
		BEGIN
		INSERT INTO [RightGlobal]([ID], [Language], [DisplayName], [Comments]) 
			VALUES(
			@RightID,
			'en',
			'Manage Activity Monitor parameters',
			NULL)
		END	
	END

	

	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES (@ParameterName, @DBVersion, 'upgrade-rights.sql')
END


SET @ParameterName = 'AddRight_ViewApplicationTimeAllocationByEmployeeReport'
IF NOT EXISTS (SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = @ParameterName)
BEGIN
	
	SELECT @Name = [Name] 
		FROM [Right] 
		WHERE [Name] = 'ViewApplicationTimeAllocationByEmployeeReport'
	
	IF (@Name IS NULL)
	BEGIN --   
	-- 
		INSERT INTO [Right]([Name], [DisplayName], [Comments], [Group]) 
			VALUES(
			'ViewApplicationTimeAllocationByEmployeeReport', 
			'  "     "',
			',   ,     "     "',
			' ')
	
		SELECT @RightID = [ID] FROM [Right] WHERE [Name] = 'ViewApplicationTimeAllocationByEmployeeReport'

		IF NOT EXISTS (SELECT * FROM [RightGlobal] WHERE [ID] = @RightID AND [Language] = 'ru')
		BEGIN
		INSERT INTO [RightGlobal]([ID], [Language], [DisplayName], [Comments]) 
			VALUES(
			@RightID,
			'ru',
			'  "     "',
			',   ,     "     "')
		END

		IF NOT EXISTS (SELECT * FROM [RightGlobal] WHERE [ID] = @RightID AND [Language] = 'en')
		BEGIN
		INSERT INTO [RightGlobal]([ID], [Language], [DisplayName], [Comments]) 
			VALUES(
			@RightID,
			'en',
			'View report "Employee working time distribution by applications"',
			'User with this right gets access to the report "Employee working time distribution by applications"')
		END	
	END

	

	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES (@ParameterName, @DBVersion, 'upgrade-rights.sql')
END


SET @ParameterName = 'AddRight_ViewApplicationTimeAllocationByEmployeesReport'
IF NOT EXISTS (SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = @ParameterName)
BEGIN
	
	SELECT @Name = [Name] 
		FROM [Right] 
		WHERE [Name] = 'ViewApplicationTimeAllocationByEmployeesReport'
	
	IF (@Name IS NULL)
	BEGIN --   
	-- 
		INSERT INTO [Right]([Name], [DisplayName], [Comments], [Group]) 
			VALUES(
			'ViewApplicationTimeAllocationByEmployeesReport', 
			'  "    "',
			',   ,     "    "',
			' ')
	
		SELECT @RightID = [ID] FROM [Right] WHERE [Name] = 'ViewApplicationTimeAllocationByEmployeesReport'

		IF NOT EXISTS (SELECT * FROM [RightGlobal] WHERE [ID] = @RightID AND [Language] = 'ru')
		BEGIN
		INSERT INTO [RightGlobal]([ID], [Language], [DisplayName], [Comments]) 
			VALUES(
			@RightID,
			'ru',
			'  "    "',
			',   ,     "    "')
		END

		IF NOT EXISTS (SELECT * FROM [RightGlobal] WHERE [ID] = @RightID AND [Language] = 'en')
		BEGIN
		INSERT INTO [RightGlobal]([ID], [Language], [DisplayName], [Comments]) 
			VALUES(
			@RightID,
			'en',
			'View report "Department employees working time for period"',
			'User with this right gets access to the report "Department employees working time for period"')
		END	
	END

	

	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES (@ParameterName, @DBVersion, 'upgrade-rights.sql')
END


SET @ParameterName = 'AddRight_ViewFuturePeriodsRealizationReport'
IF NOT EXISTS (SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = @ParameterName)
BEGIN
	
	SELECT @Name = [Name] 
		FROM [Right] 
		WHERE [Name] = 'ViewFuturePeriodsRealizationReport'
	
	IF (@Name IS NULL)
	BEGIN --   
	-- 
		INSERT INTO [Right]([Name], [DisplayName], [Comments], [Group]) 
		VALUES('ViewFuturePeriodsRealizationReport',
		'  "  "',
		',   ,     "  ".',
		'')
	
		SELECT @RightID = [ID] FROM [Right] WHERE [Name] = 'ViewFuturePeriodsRealizationReport'

		IF NOT EXISTS (SELECT * FROM [RightGlobal] WHERE [ID] = @RightID AND [Language] = 'ru')
		BEGIN
		INSERT INTO [RightGlobal]([ID], [Language], [DisplayName], [Comments]) 
			VALUES(
			@RightID,
			'ru',
			'  "  "',
			',   ,     "  "')
		END

		IF NOT EXISTS (SELECT * FROM [RightGlobal] WHERE [ID] = @RightID AND [Language] = 'en')
		BEGIN
		INSERT INTO [RightGlobal]([ID], [Language], [DisplayName], [Comments]) 
			VALUES(
			@RightID,
			'en',
			'View report "Future periods realization"',
			'User with this right gets access to the report "Future periods realization"')
		END
		
		
		SELECT
			@TrusteeID = [ID]
		FROM
			[Trustee]
		WHERE
			[Name] = 'Executive'

		INSERT INTO [AccessRight]
		SELECT
			@RightID,
			@TrusteeID,
			1

		SELECT
			@TrusteeID = [ID]
		FROM
			[Trustee]
		WHERE
			[Name] = 'FinancialManager'

		INSERT INTO [AccessRight]
		SELECT
			@RightID,
			@TrusteeID,
			1
			
	END
	
	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES (@ParameterName, @DBVersion, 'upgrade-rights.sql')
END
GO

DELETE FROM [Right]
WHERE [Name] IN ('ViewResourceReport', 
				 'ViewLoadOfEmployeeReport', 
				 'ViewEmploymentReport', 
				 'ViewLoadOfProjectsReport',
				 'ViewLoadOfEmployeesReport', 
				 'ViewResourcePlanPeriodReport', 
				 'ViewResourcePlanReport',
				 'ViewResourcePlanHolidayReport', 
				 'ViewResourcePlanEducateReport',
				 'ViewRateByEmployeeReportGroup', 
				 'ViewRateByEmployeeReport',
				 'ViewRateByProjectReport', 
				 'ViewRateByQualificationReport',
				 'ViewBillOfProjectReport')
GO

UPDATE [Right]
SET [Group] = ' '
WHERE [Name] in ('ViewAllActivity', 'ViewOwnActivity')
