--          
DECLARE @DBVersion TVariant
EXEC adfParameterGet 'DatabaseVersion', 'VersionInfo', @Value = @DBVersion OUTPUT

DECLARE @TrusteeID INT,
		@ScriptName TName = 'upgrade-role-step2.sql'

DECLARE @ParameterName TName = 'DeleteRightsFromRole_BillingPerson'
IF NOT EXISTS (SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = @ParameterName)
BEGIN
	SELECT @TrusteeID = [ID] FROM [Trustee] WHERE [Name] = 'BillingPerson'
	
	DELETE [AccessRight] 
	WHERE 
		[TrusteeID] = @TrusteeID AND [RightID] IN (
		SELECT [ID] FROM [Right] WHERE [Name] IN ('ViewFinanceResultsReport', 'ViewRevenueByServiceReport',
		'ViewRevenueDynamicsReport', 'ViewRevenueByClientReport', 'ViewRevenueByCostCenterReport'))
	
	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES (@ParameterName, @DBVersion, @ScriptName)
END

SET @ParameterName = 'DeleteRightsFromRole_ChiefSalesManager'
IF NOT EXISTS (SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = @ParameterName)
BEGIN
	SELECT @TrusteeID = [ID] FROM [Trustee] WHERE [Name] = 'ChiefSalesManager'
	
	DELETE [AccessRight] 
	WHERE 
		[TrusteeID] = @TrusteeID AND [RightID] IN (
		SELECT [ID] FROM [Right] WHERE [Name] = 'ViewAllFinance')

	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES (@ParameterName, @DBVersion, @ScriptName)
END

SET @ParameterName = 'DeleteRightsFromStandardRoles_RightsForReports'
IF NOT EXISTS (SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = @ParameterName)
BEGIN
	DELETE [AccessRight] 
	WHERE 
		[RightID] IN (SELECT [ID] FROM [Right] WHERE [Name] IN ('ViewEmploymentReport', 'ViewLoadOfEmployeeReport', 
			'ViewLoadOfEmployeesReport', 'ViewLoadOfProjectsReport', 'ViewRateByEmployeeReport', 
			'ViewRateByEmployeeReportGroup', 'ViewRateByProjectReport', 'ViewRateByQualificationReport', 
			'ViewResourcePlanEducateReport', 'ViewResourcePlanPeriodReport', 'ViewResourcePlanReport',
			'ViewResourceReport', 'ViewRevenueDynamicsReport', 'ViewRevenueAnalysisByProjectReport'))

	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES (@ParameterName, @DBVersion, @ScriptName)
END

--       ""
--    ,    ManageProject,   ". - "
SET @ParameterName = 'AddRightsForRolesWithManageProject_RightsForViewVisibility'
IF NOT EXISTS (SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = @ParameterName)
BEGIN
	DECLARE @RightID int
	SELECT @RightID = [ID] FROM [Right] WHERE [Name] = 'ViewBilling'

	IF (@RightID IS NOT NULL)
	BEGIN
		INSERT INTO [AccessRight]
		SELECT @RightID, [Trustee].[ID], 1
		FROM [Trustee]
			INNER JOIN [AccessRight]
				ON [AccessRight].[TrusteeID] = [Trustee].[ID] AND [Trustee].[Standard] = 0
			INNER JOIN [Right]
				ON [RightID] = [Right].[ID]
		WHERE [Right].[Name] = 'ManageProject'

	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES (@ParameterName, @DBVersion, @ScriptName)
	END
END
GO

--          "Everyone"
IF EXISTS(SELECT * FROM [Trustee] WHERE [ID]=0 AND [Standard]=0)
BEGIN
	--    ?
	DECLARE @HasTrigger bit = 0

	IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'adftrTrusteeIU')
		SET @HasTrigger = 1

	-- , ..       
	IF @HasTrigger = 1
		DISABLE TRIGGER [adftrTrusteeIU] ON [Trustee]

	UPDATE [Trustee] SET [Standard]=1 WHERE [ID]=0 AND [Standard]=0 

	IF @HasTrigger = 1
		ENABLE TRIGGER [adftrTrusteeIU] ON [Trustee]
END
GO