IF  EXISTS (SELECT * FROM systypes WHERE name = N'TXml')
	EXEC dbo.sp_droptype @typename=N'TXml'
go

IF  EXISTS (SELECT * FROM systypes WHERE name = N'TNotesOld')
	EXEC dbo.sp_droptype @typename=N'TNotesOld'
go

IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Name] = 'DocumentLineSeparator1')
BEGIN
	EXEC adfParameterSet 'DocumentLineSeparator1', 'Pjm5', '.'
	EXEC adfParameterSet 'DocumentLineSeparator2', 'Pjm5', '.'
	EXEC adfParameterSet 'DocumentLineSeparator3', 'Pjm5', '.'
end
GO

IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Name] = 'IssueSeparator')
BEGIN
	EXEC adfParameterSet 'IssueSeparator', 'Pjm5', '.'
	EXEC adfParameterSet 'TaskRequestSeparator', 'Pjm5', '.'
	EXEC adfParameterSet 'ServiceRequestSeparator', 'Pjm5', '.'
end
GO

IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Name] = 'StatementPrintCurrency')
BEGIN
	EXEC adfParameterSet 'StatementPrintCurrency', 'Pjm5', 0
	EXEC adfParameterSet 'InvoicePrintCurrency', 'Pjm5', 0
	EXEC adfParameterSet 'FacturePrintCurrency', 'Pjm5', 0
end
GO

IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Name] = 'InvoiceExpirationPeriodType')
BEGIN
	EXEC adfParameterSet 'InvoiceExpirationPeriodType', 'Pjm5', 1
end
GO

DECLARE @Class TClass
SET @Class = dbo.adfGetClassByName('Adf.PhoneType')
UPDATE [DocumentGlobal] SET [FileAs] = '' WHERE [FileAs] = ''
GO

EXEC adfParameterSet 'DefaultMoneyScale', 'CommonBusiness', 2
GO

/*==============================================================*/
/* Init Reminders                                               */
/*==============================================================*/
DECLARE @Class TClass
SET @Class = dbo.adfGetClassByName('Pjm5.MeetingRequest')
IF NOT EXISTS(SELECT *FROM [ReminderType] WHERE [Class] = @Class AND [Subtype] = 'MS' AND [Name] = ' ' AND [View] = 'pjm5vwReminderMeetingRequest')
	insert into [ReminderType] ([Class], [Subtype], [Name], [View], [DefaultState], [DefaultInterval])
	values (@Class, 'MS', ' ', 'pjm5vwReminderMeetingRequest', 1, 15)

SET @Class = dbo.adfGetClassByName('Pjm6.Budget')
IF NOT EXISTS(SELECT *FROM [ReminderType] WHERE [Class] = @Class AND [Subtype] = 'BC' AND [Name] = ' ' AND [View] = 'pjm6vwReminderBudgetBC')
	insert into [ReminderType] ([Class], [Subtype], [Name], [View], [DefaultState], [DefaultInterval], [IsTimeFormat])
	values (@Class, 'BC', ' ', 'pjm6vwReminderBudgetBC', 1, -600,1)
go

IF NOT EXISTS(SELECT *FROM [ReminderDescription] WHERE [Subtype] = 'BC')
BEGIN
INSERT INTO [ReminderDescription] VALUES('BC', dbo.adfGetClassByName('Pjm6.Budget'), 'ru', '   ')
INSERT INTO [ReminderDescription] VALUES('BC', dbo.adfGetClassByName('Pjm6.Budget'), 'en', 'To remind of the budget recalculation')
END
go

IF NOT EXISTS(SELECT * FROM [ResourceType])
BEGIN
	EXEC sp_executesql N'
	SET IDENTITY_INSERT [ResourceType] ON
	INSERT INTO [ResourceType] ([ID], [State], [FileAs], [Flag]) VALUES(1, 1, '' '', 0)
	SET IDENTITY_INSERT [ResourceType] OFF

	DECLARE @Class TClass
	SET @Class = dbo.adfGetClassByName(''Pjm5.ResourceType'')
	INSERT INTO [DocumentGlobal] ([Class], [ID], [Language], [FileAs]) VALUES (@Class, 1, ''ru'', '' '')
	INSERT INTO [DocumentGlobal] ([Class], [ID], [Language], [FileAs]) VALUES (@Class, 1, ''en'', ''Meeting Room'')
	'
END
GO

IF NOT EXISTS (SELECT * FROM [Folder])
BEGIN
	EXEC sp_executesql N'
	SET IDENTITY_INSERT [Folder] ON
	INSERT INTO [Folder] 
		([ID], [State], [Flag], [FileAs]) 
	VALUES
		(1, 1, 0, '' '')
	SET IDENTITY_INSERT [Folder] OFF
	
	INSERT INTO [FolderAccessControl] 
		([TrusteeID], [FolderID], [AccessRights])
	VALUES
		(0, 1, 0xFFFF)
	'
END
GO

IF NOT EXISTS (SELECT * FROM [DocumentType])
BEGIN
	EXEC sp_executesql N'
	SET IDENTITY_INSERT [DocumentType] ON
	INSERT INTO [DocumentType] ([ID], [State], [Flag], [Code], [FileAs]) VALUES(1, 1, 0, ''In'', '''')
	INSERT INTO [DocumentType] ([ID], [State], [Flag], [Code], [FileAs]) VALUES(2, 1, 0, ''Internal'', '''')
	INSERT INTO [DocumentType] ([ID], [State], [Flag], [Code], [FileAs]) VALUES(3, 1, 0, ''Out'', '''')
	SET IDENTITY_INSERT [DocumentType] OFF
	'
END
GO

DECLARE @Class TClass
SET @Class = dbo.adfGetClassByName('Pjm5.DocumentType')
IF NOT EXISTS(SELECT * FROM [DocumentGlobal] WHERE [Class] = @Class)
BEGIN
	EXEC sp_executesql N'
	DECLARE @Class TClass
	SET @Class = dbo.adfGetClassByName(''Pjm5.DocumentType'')
	
	INSERT INTO [DocumentGlobal] ([Class], [ID], [Language], [FileAs])
	VALUES	(@Class, 1, ''ru'', '''')
	INSERT INTO [DocumentGlobal] ([Class], [ID], [Language], [FileAs])
	VALUES	(@Class, 2, ''ru'', '''')
	INSERT INTO [DocumentGlobal] ([Class], [ID], [Language], [FileAs])
	VALUES	(@Class, 3, ''ru'', '''')

	INSERT INTO [DocumentGlobal] ([Class], [ID], [Language], [FileAs])
	VALUES	(@Class, 1, ''en'', ''Incoming'')
	INSERT INTO [DocumentGlobal] ([Class], [ID], [Language], [FileAs])
	VALUES	(@Class, 2, ''en'', ''Internal'')
	INSERT INTO [DocumentGlobal] ([Class], [ID], [Language], [FileAs])
	VALUES	(@Class, 3, ''en'', ''Outgoing'')
	'
END
GO

EXEC sp_executesql N'
	ALTER TABLE [Task] DISABLE TRIGGER ALL
	UPDATE
		[Task]
	SET
		[EndDate] = CAST(CONVERT(varchar(8), [EndDate], 112) as datetime)
	WHERE
		[EndDate] IS NOT NULL
	ALTER TABLE [Task] ENABLE TRIGGER ALL
	'
GO
--      . 
INSERT INTO [ReminderSetting]
	([UserID], [Subtype], [InitialState], [InitialInterval])
SELECT 
	[UserID], 
	'MS',
	[InitialState],
	[InitialInterval]
FROM 
	[ReminderSetting] as [RS]
WHERE 
	[Subtype]='ES'
AND
	NOT EXISTS(SELECT * FROM [ReminderSetting] WHERE [UserID] = [RS].[UserID] AND [Subtype]='MS')
GO

IF EXISTS (SELECT * FROM [Severity] WHERE [ID] = 1 AND [FileAs] = ' ')
BEGIN
	EXEC sp_executesql N'
		DECLARE @Class TClass
		
		ALTER TABLE [Severity] DISABLE TRIGGER ALL
		UPDATE [Severity] 
		SET 
			@Class = [Class],
			[FileAs] = '''' 
		WHERE [ID] = 1
		ALTER TABLE [Severity] ENABLE TRIGGER ALL

		ALTER TABLE [Document] DISABLE TRIGGER ALL
		UPDATE [Document] 
		SET 
			[FileAs] = '''' 
		WHERE [Class] = @Class AND [ID] = 1
		ALTER TABLE [Document] ENABLE TRIGGER ALL
		
		ALTER TABLE [DocumentGlobal] DISABLE TRIGGER ALL
		UPDATE 
			[DocumentGlobal] 
		SET
			[FileAs] = ''''
		WHERE
			[Class] = @Class AND [ID] = 1 AND [Language] = ''ru''
		ALTER TABLE [DocumentGlobal] ENABLE TRIGGER ALL
		'
END
GO

IF EXISTS(SELECT * FROM [DocumentVersion] WHERE [DocumentVersion].[DataLength] = 1)
BEGIN
	UPDATE
		[DocumentVersion]
	SET
		[Data] = NULL
	FROM 
		[DocumentVersion]
		INNER JOIN [DocumentItem]
			ON [DocumentItem].[ID] = [DocumentVersion].[DocumentItemID]
	WHERE
		[DocumentItem].[State] = 3 AND
		[DocumentItem].[LatestVersion] < [DocumentVersion].[Version] AND
		[DocumentVersion].[DataLength] = 1 AND
		CAST([DocumentVersion].[Data] AS binary) = 0x0
END
GO


IF NOT EXISTS(SELECT * FROM [MailItemEventType] WHERE [EventType] = 'KickMail')
BEGIN
	INSERT INTO [MailItemEventType] ([EventType], [FileAs])
		VALUES ('KickMail', '')
	INSERT INTO [MailItemEventTypeGlobal] ([EventType], [Language], [FileAs])
		VALUES ('KickMail', 'en', 'Message')
END
GO