/******************************************************************************
**		File: AddDefaultRight_ManageChangeServicesPricesWizard.sql
**		Name: 
**		Desc:          
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Sergey.Pelevin
**		Date: 17.12.12 10:45
*****************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/


DECLARE 
	@Name TSysname,
	@RightID TIdentifier,
	@TrusteeID TIdentifier

SELECT @Name = [Name] 
	FROM [Right] 
	WHERE [Name] = 'ManageChangeServicesPricesWizard'
	
IF (@Name IS NULL)
BEGIN --   
-- 
	INSERT INTO [Right]([Name], [DisplayName], [Comments], [Group]) 
		VALUES(
		'ManageChangeServicesPricesWizard', 
		'    ',
		',          (     :  ,   ,    )',
		'')
	
	SELECT @RightID = [ID] FROM [Right] WHERE [Name] = 'ManageChangeServicesPricesWizard'
	
	--    
	SELECT @TrusteeID = [ID] FROM [Trustee] WHERE [Name] = 'Executive'
	INSERT INTO [AccessRight]
		SELECT
			@RightID,
			@TrusteeID,
			1
	
	--     
	SELECT @TrusteeID = [ID] FROM [Trustee] WHERE [Name] = 'FinancialManager'
	INSERT INTO [AccessRight]
		SELECT
			@RightID,
			@TrusteeID,
			1
	
END
ELSE--  
BEGIN
--   
	UPDATE [Right] SET	[DisplayName] = '    ',
		[Comments] = ',          (     :  ,   ,    )',
		[Group] = ''
		WHERE
		[Name] = 'ManageChangeServicesPricesWizard'
	
	SELECT @RightID = [ID] FROM [Right] WHERE [Name] = 'ManageChangeServicesPricesWizard'
		
	--    
	SELECT @TrusteeID = [ID] FROM [Trustee] WHERE [Name] = 'Executive'
	IF EXISTS (SELECT * FROM [AccessRight] WHERE [RightID] = @RightID AND [TrusteeID] = @TrusteeID)
	BEGIN
		UPDATE [AccessRight]
		SET [Allow] = 1
		WHERE [RightID] = @RightID AND [TrusteeID] = @TrusteeID
	END
	ELSE
	BEGIN
		INSERT INTO [AccessRight]
		SELECT
			@RightID,
			@TrusteeID,
			1
	END
			
	
	--     
	SELECT @TrusteeID = [ID] FROM [Trustee] WHERE [Name] = 'FinancialManager'
	IF EXISTS (SELECT * FROM [AccessRight] WHERE [RightID] = @RightID AND [TrusteeID] = @TrusteeID)
	BEGIN
		UPDATE [AccessRight]
		SET [Allow] = 1
		WHERE [RightID] = @RightID AND [TrusteeID] = @TrusteeID
	END
	ELSE
	BEGIN
		INSERT INTO [AccessRight]
		SELECT
			@RightID,
			@TrusteeID,
			1
	END
END