﻿if exists (select * from dbo.sysobjects where id = object_id(N'[exch].[EmployeeFind]') and objectproperty(id, N'IsProcedure') = 1)
begin
	print 'Dropping procedure EmployeeFind'
	drop procedure [exch].[EmployeeFind]
end
go

print 'Creating procedure EmployeeFind'
go

create procedure [exch].[EmployeeFind] @UserID TIdentifier, @XContact xml, @ID TIdentifier output
with execute as 'pjmexchangesync'
as
begin	
	declare @Class TClass, @FirstName TName, @LastName TName, @MiddleName TName, @Count int;

	set nocount on;

	set @Class = dbo.adfGetClassByName('Adf.Employee');

	declare @phone table ([Phone] nvarchar(32) not null);
	declare @email table ([Email] nvarchar(256) not null);
	declare @employee table ([ID] int not null);
	declare @result table ([ID] int not null);
	declare @result1 table ([ID] int not null);

	select
		@FirstName = T.C.value('@FirstName', 'TName'),
		@LastName = T.C.value('@LastName', 'TName'),
		@MiddleName = T.C.value('@MiddleName', 'TName')
	FROM
		@XContact.nodes('Contact') T(C)	

	insert into @employee
	select
		[ID]
	from
		[Employee]
	where
		[FirstName] = @FirstName and [LastName] = @LastName and (@MiddleName is null or [MiddleName] is null or [MiddleName] = @MiddleName);

	insert into @email
		([Email])
	select distinct
		T.C.value('(@Email)[1]', 'nvarchar(256)')
	from
		@XContact.nodes('Contact/Email') as T(C);

	insert into @phone
		([Phone])
	select distinct
		[exch].[fnGetPhoneDigits](T.C.value('(@Phone)[1]', 'nvarchar(32)'))
	from
		@XContact.nodes('Contact/Phone') as T(C);

	insert into @result
		([ID])
	select distinct
		[BusinessCardID]
	from
		[Email] as [P1] inner join @email as [P2]
			on ([BusinessCardClass] = @class and [P1].[Email] = [P2].[Email])
	where
		[BusinessCardID] in (select [ID] from @employee);

	select @Count = count(*) from @result;
	if @Count = 1
	begin
		select @ID = [ID] from @result;
		exec [exch].[ContactGet] @UserID, @ID;
		return 0;
	end
	else if @Count > 1
	begin
		insert into @result1
			([ID])
		select distinct
			[BusinessCardID]
		from
			[Phone] as [P1] inner join @phone as [P2]
				on ([BusinessCardClass] = @class and [exch].[fnGetPhoneDigits]([P1].[Phone]) = [P2].[Phone])
		where
			[BusinessCardID] in (select [ID] from @result);
	end
	else
	begin
		insert into @result1
			([ID])
		select distinct
			[BusinessCardID]
		from
			[Phone] as [P1] inner join @phone as [P2]
				on ([BusinessCardClass] = @class and [exch].[fnGetPhoneDigits]([P1].[Phone]) = [P2].[Phone])
		where
			[BusinessCardID] in (select [ID] from @employee);
	end

	select @Count = count(*) from @result1;

	if @Count > 0
	begin
		select @ID = min([ID]) from @result1;
		exec [exch].[ContactGet] @UserID, @ID;
		return 0;
	end
	else 
	begin
		declare @xml xml;
		set @xml = N'<Contact />';
		select @xml;
		return 1;
	end
end
go


grant execute on [exch].[EmployeeFind] to [projectmateservice];
go
