﻿if exists (select * from dbo.sysobjects where id = object_id(N'[exch].[SyncStateUpdate]') and objectproperty(id, N'IsProcedure') = 1)
begin
	print 'Dropping procedure SyncStateUpdate'
	drop procedure [exch].[SyncStateUpdate]
end
go

print 'Creating procedure SyncStateUpdate'
go

create procedure [exch].[SyncStateUpdate] @UserID TIdentifier, @TypeName varchar(10), @MseSyncState varchar(max), @PjmSyncState bigint
with execute as 'pjmexchangesync'
as
begin
	set nocount on;
	if exists(select * from [exch].[SyncState] where [UserID] = @UserID and [TypeName] = @TypeName)
	begin
		update [exch].[SyncState]
		set
			[MseSyncState] = @MseSyncState,
			[PjmSyncState] = @PjmSyncState
		where
			[UserID] = @UserID and [TypeName] = @TypeName;
	end
	else
	begin
		insert into [exch].[SyncState]
			([UserID], [TypeName], [MseSyncState], [PjmSyncState])
		values
			(@UserID, @TypeName, @MseSyncState, @PjmSyncState);
	end

	return 0;
end
GO


grant execute on [exch].[SyncStateUpdate] to [projectmateservice];
go
