﻿ IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6ExchangeSyncActivityTypeEntry]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6ExchangeSyncActivityTypeEntry'
		DROP FUNCTION [dbo].[fnPjm6ExchangeSyncActivityTypeEntry]
	END

GO

PRINT 'Creating function fnPjm6ExchangeSyncActivityTypeEntry'
GO
/******************************************************************************
**		File: fnPjm6ExchangeSyncActivityTypeEntry.sql
**		Name: fnPjm6ExchangeSyncActivityTypeEntry
**		Desc: Функция проверяет нужно ли устанавливать флаг "Синхронизация" 
**			для заданного вида деятельности
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: anton.paramonov
**		Date: 24.02.2012
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm6ExchangeSyncActivityTypeEntry(
	@ActivityTypeID TIdentifier, 
	@UserID TIdentifier
	)
RETURNS BIT
AS
BEGIN
	
	DECLARE
		@Class	TClass

	SET @Class = dbo.adfGetClassByName('Adf.ActivityType')

	IF EXISTS(SELECT *FROM [ExchangeAttributesForSync] 
				WHERE
				[ExchangeAttributesForSync].[DocumentID] = @ActivityTypeID
				AND
				[ExchangeAttributesForSync].[DocumentClass] = @Class
				AND
				[ExchangeAttributesForSync].[UserID] = @UserID)
		RETURN 1

	RETURN 0
END
GO
