﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm7ExchangeGetModifiedDateForContact]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm7ExchangeGetModifiedDateForContact'
		DROP FUNCTION [dbo].[fnPjm7ExchangeGetModifiedDateForContact]
	END

GO

PRINT 'Creating function fnPjm7ExchangeGetModifiedDateForContact'
GO
/******************************************************************************
**		File: fnPjm7ExchangeGetModifiedDateForContact.sql
**		Name: fnPjm7ExchangeGetModifiedDateForContact
**		Desc: Функция возвращает
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: anton.paramonov	
**		Date: 20.04.12 15:45
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm7ExchangeGetModifiedDateForContact
	(@ContactID TIdentifier, @ContactModifiedDate TDate, @UserID TIdentifier)
RETURNS TDate
AS
BEGIN
	DECLARE 
		@ContactClass TClass,
		@ReminderModifiedDate	TDate,
		@UserReminderModifiedDate	TDate

	SET @ContactClass = dbo.adfGetClassByName('Adf.Employee')

	SET @ReminderModifiedDate = 
		(SELECT MAX(r.[Modified])
			FROM
				[Reminder] r
				INNER JOIN [UserReminder] ur
					ON ur.[ReminderID] = r.[ID] AND ur.[UserID] = @UserID
			WHERE
				r.[DocumentID] = @ContactID AND r.[DocumentClass] = @ContactClass
		)
	SET @UserReminderModifiedDate = 
		(SELECT MAX(ur.[Modified])
			FROM
				[Reminder] r
				INNER JOIN [UserReminder] ur
					ON ur.[ReminderID] = r.[ID] AND ur.[UserID] = @UserID
			WHERE
				r.[DocumentID] = @ContactID AND r.[DocumentClass] = @ContactClass
		)

	RETURN dbo.fnPjm7MaxDate3(@ContactModifiedDate, @ReminderModifiedDate, @UserReminderModifiedDate)
END
GO

GRANT EXEC ON fnPjm7ExchangeGetModifiedDateForContact TO PUBLIC
GO

