IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5AddWorkingDays]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5AddWorkingDays'
		DROP FUNCTION [dbo].[fnPjm5AddWorkingDays]
	END

GO

PRINT 'Creating function fnPjm5AddWorkingDays'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5AddWorkingDays
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5AddWorkingDays(@start TDateTime, @days TAmount)
RETURNS datetime
AS
BEGIN
	DECLARE @end datetime,
			@curdate datetime,
			@add int,
			@value TVariant, @daymask int
	
	SET @curdate = CAST(CONVERT(varchar(8), @start, 112) AS DATETIME)

	IF (@days != 0)
	BEGIN
		IF (@days > 0)
		BEGIN
			SET @add = 1
		END
		ELSE
		BEGIN
			SET @add = -1
			SET @days = -@days
		END
	
		SELECT @value = Value FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Name]='WorkDaysOfWeek' AND [Group]='Pjm5'
		SET @daymask = CAST(@value as int)

		WHILE 1 = 1
		BEGIN
			IF (dbo.fnPjm5IsWorkingDayByMask(@curdate, @daymask) = 1)
			BEGIN
				SET @days = @days - 1
				IF @days <= 0
					BREAK
			END

			SET @curdate = DATEADD(day, @add, @curdate)
		END
	END

	RETURN @curdate
END
GO

GRANT EXEC ON fnPjm5AddWorkingDays TO PUBLIC
GO
 