IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetDefaultActivity]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetDefaultActivity'
		DROP FUNCTION [dbo].[fnPjm5GetDefaultActivity]
	END

GO

PRINT 'Creating function fnPjm5GetDefaultActivity'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetDefaultActivity
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		13.01.10	PAM				    
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetDefaultActivity
	(@ProjectID TIdentifier, @EmployeeID TIdentifier)
RETURNS TIdentifier
AS
BEGIN
	DECLARE @ActivityTypeID TIdentifier
	IF @EmployeeID IS NULL
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SELECT 
		@ActivityTypeID = [Qualification].[ActivityTypeID]
	FROM
		[Qualification] 
		INNER JOIN [vwAssignment] AS [Assignment]
			ON ([Qualification].[ID] = [Assignment].[QualificationID])
		INNER JOIN [ActivityType]
			ON ([ActivityType].[ID] = [Qualification].[ActivityTypeID])
		INNER JOIN [ProjectActivityType]
			ON ([ProjectActivityType].[ProjectID] = @ProjectID AND
				[ProjectActivityType].[ActivityTypeID] = [Qualification].[ActivityTypeID])
	WHERE
		[Assignment].[EmployeeID] = @EmployeeID AND [Assignment].[State] = 1 AND [ProjectActivityType].[Actively] = 1
		AND [ActivityType].[State] = 1  
	
	RETURN @ActivityTypeID
END
GO

 