IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetExpireDaysProject]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetExpireDaysProject'
		DROP FUNCTION [dbo].[fnPjm5GetExpireDaysProject]
	END

GO

PRINT 'Creating function fnPjm5GetExpireDaysProject'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetExpireDaysProject
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetExpireDaysProject(@ProjectID int, @TodayDate datetime)
RETURNS decimal(18,2)
AS
BEGIN
	DECLARE	@res decimal(18,2)
		
	SELECT
	@res = ISNULL(SUM(dbo.fnPjm5GetDeviationByTask([Task].[ID], @TodayDate)), 0)
	FROM 
		[Project] LEFT JOIN [Task]
			ON [Task].[ProjectID] = [Project].[ID] AND [Task].[State] IN (1,2)
	WHERE 
		[Project].[ID] = @ProjectID
	GROUP BY
		[Project].[EndDate]
				
	RETURN(@res)
END
GO

GRANT EXEC ON fnPjm5GetExpireDaysProject TO PUBLIC
GO
 