IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5ThreeDigitName]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5ThreeDigitName'
		DROP FUNCTION [dbo].[fnPjm5ThreeDigitName]
	END

GO

PRINT 'Creating function fnPjm5ThreeDigitName'
GO
/******************************************************************************
**		File: 
**		Name: ThreeDigitName
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5ThreeDigitName(
	@Value	BIGINT,
	@Name1	TName,				--	
	@Name2	TName,				--	
	@Name3	TName				--	
	)
RETURNS TName
AS
BEGIN
	DECLARE @Result			AS TName
	
	SET @Value = @Value % 100
	SET @Result = CASE
		WHEN (@Value % 10 = 1) AND @Value <> 11
			THEN @Name1
		WHEN (@Value % 10 IN (2, 3, 4) AND @Value / 10 <> 1)
			THEN @Name2
		ELSE @Name3
	END

	RETURN LTRIM(RTRIM(@Result))
END
GO

GRANT EXEC ON fnPjm5ThreeDigitName TO PUBLIC
GO
   