IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5ThreeDigitToString]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5ThreeDigitToString'
		DROP FUNCTION [dbo].[fnPjm5ThreeDigitToString]
	END

GO

PRINT 'Creating function fnPjm5ThreeDigitToString'
GO
/******************************************************************************
**		File: 
**		Name: ThreeDigitToString
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5ThreeDigitToString(
	@Value	BIGINT,
	@Gender	TAmount		-- 0 - , 1 - , 2 - 
	)
RETURNS TName
AS
BEGIN
	DECLARE @Result			AS TName
	DECLARE @Converting		AS BIGINT
	SET @Result	= ''
	SET @Value = @Value % 1000
	
	IF @Value = 0 
		SET @Result	= ''
		
	WHILE @Value > 0
	BEGIN
		SET @Converting = @Value
		SET @Result	= @Result + ' '
		IF @Converting < 20
		BEGIN
			IF @Gender IN (1, 2) AND @Converting IN (1, 2)
				SET @Result	= @Result + 
					CASE 
						WHEN @Converting = 1 AND @Gender = 1 THEN ''
						WHEN @Converting = 1 AND @Gender = 2 THEN ''
						WHEN @Converting = 2 AND @Gender = 1 THEN ''
					END
			ELSE
			SET @Result	= @Result + 
				CASE @Converting
					WHEN 1 THEN ''
					WHEN 2 THEN ''
					WHEN 3 THEN ''
					WHEN 4 THEN ''
					WHEN 5 THEN ''
					WHEN 6 THEN ''
					WHEN 7 THEN ''
					WHEN 8 THEN ''
					WHEN 9 THEN ''

					WHEN 10 THEN ''
					WHEN 11 THEN ''
					WHEN 12 THEN ''
					WHEN 13 THEN ''
					WHEN 14 THEN ''
					WHEN 15 THEN ''
					WHEN 16 THEN ''
					WHEN 17 THEN ''
					WHEN 18 THEN ''
					WHEN 19 THEN ''
				END
			SET @Value = @Value - @Converting
		END
		ELSE IF @Converting BETWEEN 20 AND 99
		BEGIN
			SET @Converting = (@Converting / 10) * 10
			
			SET @Result	= @Result + 
				CASE @Converting
					WHEN 20 THEN ''
					WHEN 30 THEN ''
					WHEN 40 THEN ''
					WHEN 50 THEN ''
					WHEN 60 THEN ''
					WHEN 70 THEN ''
					WHEN 80 THEN ''
					WHEN 90 THEN ''
				END
			SET @Value = @Value - @Converting		
		END
		ELSE IF @Converting BETWEEN 100 AND 999
		BEGIN
			SET @Converting = (@Converting / 100) * 100
			SET @Result	= @Result + 
				CASE @Converting
					WHEN 100 THEN ''
					WHEN 200 THEN ''
					WHEN 300 THEN ''
					WHEN 400 THEN ''
					WHEN 500 THEN ''
					WHEN 600 THEN ''
					WHEN 700 THEN ''
					WHEN 800 THEN ''
					WHEN 900 THEN ''
				END
			SET @Value = @Value - @Converting		
		END
	END	

	RETURN LTRIM(RTRIM(@Result))
END
GO

GRANT EXEC ON fnPjm5ThreeDigitToString TO PUBLIC
GO
  