IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6DayTypeNameGet]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6DayTypeNameGet'
		DROP FUNCTION [dbo].[fnPjm6DayTypeNameGet]
	END

GO

PRINT 'Creating function fnPjm6DayTypeNameGet'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm6DayTypeNameGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm6DayTypeNameGet(@Type TCode)
RETURNS TName
AS
BEGIN
	IF @Type IS NULL
		RETURN NULL
		
	DECLARE @language TLanguage
	SET @language = dbo.adfGetLanguage()
	IF @language = 'en'
	BEGIN
		IF @Type = 'FIRST_CALENDAR'
			RETURN 'First period day'
		ELSE IF @Type = 'FIRST_WORKING'
			RETURN 'First working day'
		ELSE IF @Type = 'LAST_CALENDAR'
			RETURN 'Last period day'
		ELSE IF @Type = 'LAST_WORKING'
			RETURN 'Last working day'
	END
	ELSE
	BEGIN
		IF @Type = 'FIRST_CALENDAR'
			RETURN '  '
		ELSE IF @Type = 'FIRST_WORKING'
			RETURN '  '
		ELSE IF @Type = 'LAST_CALENDAR'
			RETURN '  '
		ELSE IF @Type = 'LAST_WORKING'
			RETURN '  '
	END
	RETURN NULL
END
GO

GRANT EXEC ON fnPjm6DayTypeNameGet TO PUBLIC
GO
  