IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6GetDocumentIdentity]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetDocumentIdentity'
		DROP FUNCTION [dbo].[fnPjm6GetDocumentIdentity]
	END

GO

PRINT 'Creating function fnPjm6GetDocumentIdentity'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm6GetDocumentIdentity
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: nikita.alexandrov
**		Date: 09/07/2009
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm6GetDocumentIdentity
	(@DocumentID TIdentifier, @DocumentClass TIdentifier)
RETURNS @document TABLE ([DocumentClassName] TName, [DocumentName] TName)
AS
BEGIN
	DECLARE
		@Lang TLanguage,
		@DocumentTable TSysname,
		@DocumentName TName,
		@DocumentClassName TName
	
	--,     	
	IF @DocumentID IS NULL AND @DocumentClass IS NULL
		BEGIN
			INSERT INTO @document VALUES(NULL, NULL)
			RETURN
		END
	
	SET @Lang = dbo.adfGetLanguage()

	IF @Lang = 'en'
		BEGIN
			SELECT
				@DocumentClassName = [ClassGlobal].[Name]
			FROM
				[ClassGlobal]
			WHERE
				[ClassGlobal].[Class] = @DocumentClass
				AND
				[ClassGlobal].[Language] = @Lang
		END
	ELSE IF @Lang = 'ru'
		BEGIN
			SELECT
				@DocumentClassName = [Class].[Name]
			FROM
				[Class]
			WHERE
				[Class].[Class] = @DocumentClass
		END 
	
	--
	IF @DocumentClass = 38
	BEGIN
		SELECT @DocumentName = [ServiceAssignment].[FileAs] FROM [ServiceAssignment] WHERE [ServiceAssignment].[ID] = @DocumentID
	--   " -"  ""
	IF @Lang = 'en'
		SET @DocumentClassName = 'Service'
	ELSE IF @Lang = 'ru'
		SET @DocumentClassName = ''
	END
	--
	IF @DocumentClass = 47
		SELECT @DocumentName = [Issue].[FileAs] FROM [Issue] WHERE [Issue].[ID] = @DocumentID
	--
	IF @DocumentClass = 52
		SELECT @DocumentName = [ServiceRequest].[FileAs] FROM [ServiceRequest] WHERE [ServiceRequest].[ID] = @DocumentID
	--
	IF @DocumentClass = 65
		SELECT @DocumentName = [TaskRequest].[FileAs] FROM [TaskRequest] WHERE [TaskRequest].[ID] = @DocumentID	

	INSERT INTO @document VALUES(@DocumentClassName, @DocumentName)
	RETURN
END
GO

GRANT SELECT ON fnPjm6GetDocumentIdentity TO PUBLIC
GO