IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6GetLastTransitionDate]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetLastTransitionDate'
		DROP FUNCTION [dbo].[fnPjm6GetLastTransitionDate]
	END
GO
PRINT 'Creating function fnPjm6GetLastTransitionDate'
GO
/******************************************************************************
**		File: fnPjm6GetLastTransitionDate.sql
**		Name: fnPjm6GetLastTransitionDate
**		Desc:       
**		Called by:     1 
**		Auth: pavel.svintsov
**		Date: 18.05.2011
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		18.05.11	SPV				First version
*******************************************************************************/
CREATE FUNCTION fnPjm6GetLastTransitionDate(@ID TIdentifier, @Class TClass, @ToState TState)
RETURNS TDate
AS
BEGIN
	DECLARE @Modified TDate
	
	SET @Modified =
		(
			SELECT TOP(1) [Transition].[Created]
			FROM [Transition]
			WHERE 
				[Transition].[DocumentID] = @ID AND
				[Transition].[TransitionTemplateID] IN
				(
					SELECT [ID]
					FROM [TransitionTemplate]
					WHERE [Class] = @Class AND [ToState] = @ToState
				)
			ORDER BY [Created] DESC
		)
	
	RETURN(@Modified)
END
GO

GRANT EXEC ON fnPjm6GetLastTransitionDate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6GetLastEditDate]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetLastEditDate'
		DROP FUNCTION [dbo].[fnPjm6GetLastEditDate]
	END
GO
PRINT 'Creating function fnPjm6GetLastEditDate'
GO
/******************************************************************************
**		Name: fnPjm6GetLastEditDate
**		Desc:      
**			   (      )
**		Called by:     1 
**		Auth: pavel.svintsov
**		Date: 18.05.2011
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		23.05.11	SPV				First version
*******************************************************************************/
CREATE FUNCTION fnPjm6GetLastEditDate(@ID TIdentifier, @Class TClass)
RETURNS TDate
AS
BEGIN
	DECLARE @Modified TDate
	
	SET @Modified =
		(
			SELECT TOP(1) [Transition].[Created]
			FROM [Transition]
			WHERE 
				[Transition].[DocumentID] = @ID AND
				[Transition].[TransitionTemplateID] IN
				(
					SELECT [ID]
					FROM [TransitionTemplate]
					WHERE [Class] = @Class AND [ToState] = [FromState] AND [ToState] <> 2
				)
			ORDER BY [Created] DESC
		)
	
	RETURN(@Modified)
END
GO

GRANT EXEC ON fnPjm6GetLastEditDate TO PUBLIC
GO
