IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6GetServiceAssignmentRate]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetServiceAssignmentRate'
		DROP FUNCTION [dbo].[fnPjm6GetServiceAssignmentRate]
	END
GO

PRINT 'Creating function fnPjm6GetServiceAssignmentRate'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm6GetServiceAssignmentRate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: yuriy.soldatkin
**		Date: 25.10.10
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE FUNCTION fnPjm6GetServiceAssignmentRate(@AssignmentID TIdentifier, @ServiceAssignmentID TIdentifier, @Rate TMoney)
RETURNS TMoney
AS
BEGIN
	
	IF @ServiceAssignmentID IS NOT NULL
	BEGIN
		DECLARE @AlwaysUseRate TBool,
				@Price TMoney,
				@RateMultiplier TAmount
			
		SELECT
			@AlwaysUseRate = [AlwaysUseRate]
		FROM
			[Assignment]
		WHERE
			[ID] = @AssignmentID
				
		SELECT
			@Price = [Price],
			@RateMultiplier = [RateMultiplier]
		FROM 
			[ServiceAssignment]		
		WHERE
			[ID] = @ServiceAssignmentID
		AND
			[PaymentTermID] = 3
		
		IF @AlwaysUseRate = 0
		BEGIN	
			IF @Price IS NOT NULL	
				SET @Rate = @Price
		END
		IF @RateMultiplier IS NOT NULL
			SET @Rate = ROUND(@Rate * @RateMultiplier, 2)
	END
	
	RETURN @Rate
END
GO