﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm7MaxDate3]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm7MaxDate3'
		DROP FUNCTION [dbo].[fnPjm7MaxDate3]
	END

GO

PRINT 'Creating function fnPjm7MaxDate3'
GO
/******************************************************************************
**		File: fnPjm7MaxDate3
**		Name: fnPjm7MaxDate3
**		Desc: Функция возвращает максимальную дату
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: anton.paramonov
**		Date: 04.06.2012 17:40:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm7MaxDate3
	(
	@Num1	TDate,
	@Num2	TDate,
	@Num3	TDate
	)
RETURNS TDate
AS
BEGIN
	
	DECLARE @result	TDate

	DECLARE @Temp TABLE
	(
		[Date]	TDate
	)


	INSERT INTO @Temp VALUES(@Num1)
	INSERT INTO @Temp VALUES(@Num2)
	INSERT INTO @Temp VALUES(@Num3)	

	SELECT @result = MAX([Date]) FROM @Temp

	RETURN @result
END
GO

GRANT EXEC ON fnPjm7MaxDate3 TO PUBLIC
GO
