IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'pjm6TaskBookingAccessRoleGet')
	BEGIN
		PRINT 'Dropping Procedure pjm6TaskBookingAccessRoleGet'
		DROP  Procedure  pjm6TaskBookingAccessRoleGet
	END

GO

PRINT 'Creating Procedure pjm6TaskBookingAccessRoleGet'
GO
/******************************************************************************
**		File: 
**		Name: pjm6TaskBookingAccessRoleGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		01.04.13	SOV				 ,    . -
*******************************************************************************/
CREATE Procedure pjm6TaskBookingAccessRoleGet
	@AssignmentID TIdentifier,
	@TaskID TIdentifier = 0
AS
	
	SET NOCOUNT ON

	DECLARE 
		@EmployeeID TIdentifier,
		@ProjectID TIdentifier,
		@Permission int,
		@ProjectState TState,
		@CreatedBy int,
		@State int
	
	SELECT
		@State = [Task].[State],
		@CreatedBy = [Task].[CreatedBy]
	FROM
		[Task]
	WHERE
		[Task].[ID] = @TaskID
		
	
	SELECT
		@Permission = 0,
		@EmployeeID = [Assignment].[EmployeeID],
		@ProjectID = [Assignment].[ProjectID],
		@ProjectState = [Project].[State]
	FROM
		[vwAssignment] as [Assignment]
			INNER JOIN [Project]
				ON [Project].[ID] = [Assignment].[ProjectID]
	WHERE
		[Assignment].[ID] = @AssignmentID

	IF (@State NOT IN (2, 8))
		SET @Permission = 0
	ELSE IF(dbo.fnPjm5IsProjectManager(@ProjectID, NULL) = 1 
		OR dbo.fnPjm5IsProjectAdministrator (@ProjectID, NULL) = 1
		OR dbo.fnPjm7IsManagerAssistant(@ProjectID, NULL) = 1)
		OR (@ProjectState = 5 AND dbo.adfIsRoleMember('ProjectManager') = 1)
		OR(ISNULL(@State, 0) = 8 AND ISNULL(@CreatedBy, 0) = dbo.adfGetCurrentUserID())
		SET @Permission = 2
	ELSE
		IF(@EmployeeID = dbo.adfGetCurrentEmployeeID())
			SET @Permission = 1
	
	SELECT @Permission
	
	RETURN 0
GO

GRANT EXEC ON pjm6TaskBookingAccessRoleGet TO PUBLIC
GO
 