IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineGroupGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineGroupGet'
		DROP PROCEDURE [dbo].[pjm6BudgetLineGroupGet]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineGroupGet'
GO

/******************************************************************************
**		File: pjm6BudgetLineGroupGet.sql
**		Name: pjm6BudgetLineGroupGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 10/10/2010 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		02.12.13	SAP				  [PlanPurchases]
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineGroupGet
	@ID	TIdentifier
	
AS
	SET NOCOUNT ON

	DECLARE
		@Lang			TLanguage

	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[BudgetLineGroup].[ID],
		[BudgetLineGroup].[Class],
		[BudgetLineGroup].[State],
		[BudgetLineGroup].[Flag],
		[BudgetLineGroup].[BudgetID],
		ISNULL([BudgetLineGroupGlobal].[FileAs], [BudgetLineGroup].[FileAs]) AS [FileAs],
		[BudgetLineGroup].[StartDate],
		[BudgetLineGroup].[EndDate],
		[BudgetLineGroup].[GroupTypeID],
		(CASE WHEN [Budget].[State] NOT IN (4,5) THEN [Budget].[Class] ELSE dbo.adfGetClassByName('Pjm6.BudgetTemplate') END) AS [BudgetClass],
		[Budget].[DocumentID],
		[Budget].[VATIsIncluded],
		[Budget].[VATRate],
		[Budget].[CurrencyCode],
		[Budget].[PlanningActivityForWork],
		[Budget].[PlanningEmployeeForWork],
		[Budget].[PlanningQualificationForWork],
		[Budget].[PlanningDateForWork],
		[Budget].[PlanningExpenseTypeForExpense],
		[Budget].[PlanningEmployeeForExpense],
		[Budget].[PlanningDateForExpense],
		[Budget].[PlanPurchases],
		[BudgetLineGroup].[Comments],
		[BudgetLineGroup].[Created],
		[BudgetLineGroup].[CreatedBy],
		[BudgetLineGroup].[Modified],
		[BudgetLineGroup].[ModifiedBy],
		[BudgetLineGroup].[Timestamp]
	FROM
		[BudgetLineGroup]
		LEFT OUTER JOIN [BudgetLineGroupGlobal] 
			ON ([BudgetLineGroup].[ID] = [BudgetLineGroupGlobal].[ID]
				AND [BudgetLineGroupGlobal].[Language] = @Lang)
		INNER JOIN [Budget]
			ON [BudgetLineGroup].[BudgetID] = [Budget].[ID]
	WHERE
		[BudgetLineGroup].[ID] = @ID AND
		(dbo.fnPjm6CanEditBudget([Budget].[ID]) = 1 OR dbo.fnPjm6CanViewBudget([Budget].[ID]) = 1)

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineGroupGet TO PUBLIC
GO