IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineGroupUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineGroupUpdate'
		DROP PROCEDURE [dbo].[pjm6BudgetLineGroupUpdate]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineGroupUpdate'
GO

/******************************************************************************
**		File: pjm6BudgetLineGroupUpdate.sql
**		Name: pjm6BudgetLineGroupUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 10/10/2010 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		28.02.13	MAB				  OPENXML
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineGroupUpdate
	@Xml	XML
	
AS
	DECLARE
		@State	TState,
		@Class		TClass,
		@ID			TIdentifier,
		@FileAs		TName,
		@BudgetID	TIdentifier,
		@StartDate	TDate,
		@EndDate	TDate,
		@Order		TCount,
		@Comments	TNotes,
		@GroupType	TIdentifier

	SET NOCOUNT ON

	SELECT
		@ID			= @Xml.value('(/pjm6BudgetLineGroupGet/BudgetLineGroup/ID)[1]','int'),
		@FileAs		= @Xml.value('(/pjm6BudgetLineGroupGet/BudgetLineGroup/FileAs)[1]','nvarchar(256)'),
		@BudgetID	= @Xml.value('(/pjm6BudgetLineGroupGet/BudgetLineGroup/BudgetID)[1]','int'),
		@StartDate	= CAST(@Xml.value('(/pjm6BudgetLineGroupGet/BudgetLineGroup/StartDate)[1]','varchar(19)') as datetime),
		@EndDate	= CAST(@Xml.value('(/pjm6BudgetLineGroupGet/BudgetLineGroup/EndDate)[1]','varchar(19)') as datetime),
		@GroupType	= @Xml.value('(/pjm6BudgetLineGroupGet/BudgetLineGroup/GroupType)[1]','int'),
		@Comments	= @Xml.value('(/pjm6BudgetLineGroupGet/BudgetLineGroup/Comments)[1]','nvarchar(max)')

	IF dbo.fnPjm6CanEditBudget(@BudgetID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	BEGIN TRANSACTION

	UPDATE BudgetLineGroup
	SET
		[FileAs] = @FileAs,
		[StartDate] = @StartDate,
		[EndDate] = @EndDate,
		[Comments] = @Comments
	WHERE
		[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION

	EXEC pjm6BudgetLineGroupGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineGroupUpdate TO PUBLIC
GO