﻿IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm6trBudgetLineGroupInsert')
	BEGIN
		PRINT 'Dropping Trigger pjm6trBudgetLineGroupInsert'
		DROP  Trigger pjm6trBudgetLineGroupInsert
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm6trBudgetLineWorkInsert
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm6trBudgetLineGroupInsert'
GO
CREATE Trigger pjm6trBudgetLineGroupInsert 
ON [BudgetLineGroup] FOR INSERT
AS
BEGIN
	IF @@ROWCOUNT = 0
		RETURN

	DECLARE
		@ID				TIdentifier,
		@BudgetID		TIdentifier,
		@State			TState,
		@GroupTypeID	TIdentifier

	DECLARE BudgetGroups CURSOR FAST_FORWARD FOR SELECT [ID], [BudgetID], [State], [GroupTypeID] FROM [inserted]

	OPEN BudgetGroups
	FETCH NEXT FROM BudgetGroups INTO @ID, @BudgetID, @State, @GroupTypeID
	WHILE @@FETCH_STATUS = 0
	BEGIN
		
		IF @State = 1
		BEGIN
			UPDATE [BudgetLineGroup]
			SET
				[Order] = [Order] + 1
			WHERE
				[BudgetID] = @BudgetID AND
				[State] = 2 AND
				[GroupTypeID] = @GroupTypeID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN
			END
		END
		FETCH NEXT FROM BudgetGroups INTO @ID, @BudgetID, @State, @GroupTypeID
	END
	CLOSE BudgetGroups
	DEALLOCATE BudgetGroups
END

GO

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm6trBudgetLineGroupDelete')
	BEGIN
		PRINT 'Dropping Trigger pjm6trBudgetLineGroupDelete'
		DROP  Trigger pjm6trBudgetLineGroupDelete
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm6trBudgetLineGroupDelete
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm6trBudgetLineGroupDelete'
GO
CREATE Trigger pjm6trBudgetLineGroupDelete 
ON [BudgetLineGroup] FOR DELETE
AS
BEGIN
	IF @@ROWCOUNT = 0
		RETURN

	DECLARE
		@Order			TCount,
		@BudgetID		TIdentifier,
		@State			TState,
		@GroupTypeID	TIdentifier

	DECLARE BudgetGroups CURSOR FAST_FORWARD FOR SELECT [Order], [BudgetID], [State], [GroupTypeID] FROM [deleted]

	OPEN BudgetGroups
	FETCH NEXT FROM BudgetGroups INTO @Order, @BudgetID, @State, @GroupTypeID
	WHILE @@FETCH_STATUS = 0
	BEGIN

		UPDATE [BudgetLineGroup]
		SET [Order] = [Order] - 1
		WHERE
			[BudgetID] = @BudgetID AND
			[GroupTypeID] = @GroupTypeID AND
			[Order] > @Order
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN
		END
		FETCH NEXT FROM BudgetGroups INTO @Order, @BudgetID, @State, @GroupTypeID
	END
	CLOSE BudgetGroups
	DEALLOCATE BudgetGroups
END

GO