IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetTemplateWizardBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetTemplateWizardBrowse'
		DROP PROCEDURE [dbo].[pjm6BudgetTemplateWizardBrowse]
	END
GO

PRINT 'Creating procedure pjm6BudgetTemplateWizardBrowse'
GO

/******************************************************************************
**		File: pjm6BudgetTemplateWizardBrowse.sql
**		Name: pjm6BudgetTemplateWizardBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 20/08/2010 17:05:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		09.08.11	SYV				
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetTemplateWizardBrowse]
	@ProjectID TIdentifier = NULL
AS
	SET NOCOUNT ON
	
	DECLARE @TemplateClass TClass,
			@ProjectCurrencyCode TCode3,
			@ManageBudgetTemplates TBool,
			@Lang			TLanguage
			
	SET @TemplateClass = dbo.adfGetClassByName('Pjm5.BudgetTemplate')
	SET @ManageBudgetTemplates = dbo.adfHasAccessRightByName('ManageBudgetTemplates')
	
	IF @ProjectID IS NOT NULL
		SET @ProjectCurrencyCode = (SELECT [CurrencyCode] FROM [Project] WHERE [ID] = @ProjectID)

	SET @Lang = dbo.adfGetLanguage()
	
	IF @ManageBudgetTemplates = 1
	BEGIN
		SELECT
			@TemplateClass AS [Class],
			[Budget].[ID],
			[Budget].[FileAs],
			[Budget].[BudgetTypeID],
			ISNULL([BudgetTypeGlobal].[FileAs], [BudgetType].[FileAs]) AS [BudgetType],
			[Budget].[Comments]
		FROM
			[Budget]
		INNER JOIN [BudgetType]
			ON [Budget].[BudgetTypeID] = [BudgetType].[ID]
		LEFT OUTER JOIN [BudgetTypeGlobal] 
			ON ([BudgetType].[ID] = [BudgetTypeGlobal].[ID]
				AND [BudgetTypeGlobal].[Language] = @Lang) 
		WHERE
			[Budget].[State] = 4 AND (@ProjectID IS NULL OR (@ProjectID IS NOT NULL AND [Budget].[CurrencyCode] = @ProjectCurrencyCode)) 
			--AND @ManageBudgetTemplates = 1
	END

	RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetTemplateWizardBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetTemplateBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetTemplateBrowse'
		DROP PROCEDURE [dbo].[pjm6BudgetTemplateBrowse]
	END
GO

PRINT 'Creating procedure pjm6BudgetTemplateBrowse'
GO

/******************************************************************************
**		File: pjm6BudgetTemplateBrowse.sql
**		Name: pjm6BudgetTemplateBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetTemplateBrowse]
	@StateSelector int
AS
	SET NOCOUNT ON
	
	DECLARE @TemplateClass TClass
	SET @TemplateClass = dbo.adfGetClassByName('Pjm6.BudgetTemplate')

	
	SELECT
		@TemplateClass AS [Class],
		[Budget].[ID],
		[Budget].[State],
		[Budget].[Flag],
		[Budget].[FileAs],
		[Budget].[BudgetTypeID],
		[Budget].[CurrencyCode],
		[Budget].[WorkBudgetBottom] + [Budget].[ExpenseBudgetBottom] AS [BudgetBottom],
		[Budget].[WorkBudgetHigh] + [Budget].[ExpenseBudgetHigh] AS [BudgetHigh],
		[Budget].[Comments],
		[Budget].[Created],
		[Budget].[CreatedBy],
		[Budget].[Modified],
		[Budget].[ModifiedBy],
		[Budget].[Timestamp]
	FROM
		[Budget] 
	WHERE
		((@StateSelector = 0 AND [Budget].[State] IN (4,5)) OR (@StateSelector > 0 AND [Budget].[State] = (@StateSelector + 3)))
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetTemplateBrowse] TO PUBLIC
GO 