IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'Pjm6GetCurrentPeriod')
	BEGIN
		PRINT 'Dropping Procedure Pjm6GetCurrentPeriod'
		DROP  Procedure  Pjm6GetCurrentPeriod
	END
GO

PRINT 'Creating Procedure Pjm6GetCurrentPeriod'
GO


CREATE Procedure [dbo].[Pjm6GetCurrentPeriod]
	@Now TDate,
	@Flag TFlag,
	@PeriodStart TDate OUTPUT,
	@PeriodEnd TDate OUTPUT
AS
	DECLARE

		@Month TTinyIdentifier
		
	SET @Month = DATEPART(month, @Now)
		
	IF(@Flag = 2) --Months
	BEGIN
		SET @PeriodStart = CONVERT(DATETIME,CAST(year(@Now)*10000 + month(@Now)*100 + 1 AS CHAR(8)),110)
		SET @PeriodEnd = CONVERT(DATETIME,CAST(year(@Now)*10000 + month(@Now)*100 + DAY(DATEADD(d, -DAY(DATEADD(m,1,@Now)),DATEADD(m,1,@Now))) AS CHAR(8)),110)
	END
	ELSE IF(@Flag = 3) -- Quarters
	BEGIN
		IF(@Month < 4 ) -- 1 Quarter
		BEGIN
			SET @PeriodStart = CONVERT(DATETIME,CAST(year(@Now)*10000 + 101 AS CHAR(8)),110) -- 1 January
			SET @PeriodEnd = CONVERT(DATETIME,CAST(year(@Now)*10000 + 331 AS CHAR(8)),110) -- 31 March
		END
		ELSE IF(@Month < 7 ) -- 2 Quarter
		BEGIN
			SET @PeriodStart = CONVERT(DATETIME,CAST(year(@Now)*10000 + 401 AS CHAR(8)),110) -- 1 April
			SET @PeriodEnd = CONVERT(DATETIME,CAST(year(@Now)*10000 + 630 AS CHAR(8)),110) -- 30  June
		END
		ELSE IF(@Month < 10 ) -- 3 Quarter
		BEGIN
			SET @PeriodStart = CONVERT(DATETIME,CAST(year(@Now)*10000 + 701 AS CHAR(8)),110) -- 1 July
			SET @PeriodEnd = CONVERT(DATETIME,CAST(year(@Now)*10000 + 930 AS CHAR(8)),110) -- 30 September
		END
		ELSE -- 4 Quarter
		BEGIN
			SET @PeriodStart = CONVERT(DATETIME,CAST(year(@Now)*10000 + 1001 AS CHAR(8)),110) -- 1 October
			SET @PeriodEnd = CONVERT(DATETIME,CAST(year(@Now)*10000 + 1231 AS CHAR(8)),110) -- 21 December
		END
	END
	ELSE IF(@FLAG = 4) --HalfYears
	BEGIN
		IF(@Month < 7 ) -- 1 HalfYear
		BEGIN
			SET @PeriodStart = CONVERT(DATETIME,CAST(year(@Now)*10000 + 101 AS CHAR(8)),110) -- 1 January
			SET @PeriodEnd = CONVERT(DATETIME,CAST(year(@Now)*10000 + 630 AS CHAR(8)),110) -- 30 June
		END
		ELSE  -- 2 HalfYear
		BEGIN
			SET @PeriodStart = CONVERT(DATETIME,CAST(year(@Now)*10000 + 701 AS CHAR(8)),110) -- 1 July
			SET @PeriodEnd = CONVERT(DATETIME,CAST(year(@Now)*10000 + 1231 AS CHAR(8)),110) -- 31 December
		END
	END
	ELSE IF(@FLAG = 5) --Years	
	BEGIN
		SET @PeriodStart = CONVERT(DATETIME,CAST(year(@Now)*10000 + 101 AS CHAR(8)),110) -- 1 January
		SET @PeriodEnd = CONVERT(DATETIME,CAST(year(@Now)*10000 + 1231 AS CHAR(8)),110) -- 31 December
	END
	
RETURN 0
GO

--GRANT EXEC ON Pjm6GetCurrentPeriod TO PUBLIC
--GO
