 IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'pjm6EmployeeBudgetSupervisiorBrowse')
	BEGIN
		PRINT 'Dropping Procedure pjm6EmployeeBudgetSupervisiorBrowse'
		DROP  Procedure  pjm6EmployeeBudgetSupervisiorBrowse
	END

GO

PRINT 'Creating Procedure pjm6EmployeeBudgetSupervisiorBrowse'
GO
/******************************************************************************
**		File: 
**		Name: pjm6EmployeeBudgetSupervisiorBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure pjm6EmployeeBudgetSupervisiorBrowse
	@Own BIT = 0
AS
	SET NOCOUNT ON
	DECLARE @RightID int
	SET @RightID = dbo.adfGetRightID('CanBeBudgetSupervisior')

	IF @Own = 1
	BEGIN
		SELECT DISTINCT
			[Employee].[ID],
			[Employee].[Class],
			2 as [ImageIndex],
			[Employee].[State],
			[Employee].[FileAs],
			[Employee].[CompanyID],
			[Employee].[PositionID],
			(SELECT [FileAs] FROM [Position] WHERE [ID] = [Employee].[PositionID]) as [Position],
			(SELECT COALESCE([FileAs], [LegalName]) FROM [Company] WHERE [ID] = [Employee].[CompanyID]) as [Company],
			[Employee].[Created],
			[Employee].[CreatedBy],
			[Employee].[Modified],
			[Employee].[ModifiedBy],
			[Employee].[Timestamp]
		FROM
			[Employee]
			INNER JOIN [Company]
				ON ([Employee].[CompanyID] = [Company].[ID] AND [Company].[Own] = 1 AND [Company].[State]=1)
			INNER JOIN [AccessRight] 
				ON ([AccessRight].[RightID] = @RightID AND
						(
						[AccessRight].[TrusteeID] = [Employee].[UserID] OR
						[AccessRight].[TrusteeID] IN (SELECT [UserRole].[RoleID] FROM [UserRole] WHERE [UserRole].[UserID] = [Employee].[UserID])
						)
					)
		WHERE
			[Employee].[State] = 1
	END
	ELSE
	BEGIN
		SELECT DISTINCT
			[Employee].[ID],
			[Employee].[Class],
			2 as [ImageIndex],
			[Employee].[State],
			[Employee].[FileAs],
			[Employee].[CompanyID],
			[Employee].[PositionID],
			(SELECT [FileAs] FROM [Position] WHERE [ID] = [Employee].[PositionID]) as [Position],
			(SELECT COALESCE([FileAs], [LegalName]) FROM [Company] WHERE [ID] = [Employee].[CompanyID]) as [Company],
			[Employee].[Created],
			[Employee].[CreatedBy],
			[Employee].[Modified],
			[Employee].[ModifiedBy],
			[Employee].[Timestamp]
		FROM
			[Employee]
			INNER JOIN [Company]
				ON ([Employee].[CompanyID] = [Company].[ID] AND [Company].[State]=1)
			INNER JOIN [AccessRight] 
				ON ([AccessRight].[RightID] = @RightID AND
						(
						[AccessRight].[TrusteeID] = [Employee].[UserID] OR
						[AccessRight].[TrusteeID] IN (SELECT [UserRole].[RoleID] FROM [UserRole] WHERE [UserRole].[UserID] = [Employee].[UserID])
						)
					)
		WHERE
			[Employee].[State] = 1
	END
	RETURN 0
GO

GRANT EXEC ON pjm6EmployeeBudgetSupervisiorBrowse TO PUBLIC
GO
