IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalculationBrowseDraft]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalculationBrowseDraft'
		DROP PROCEDURE [dbo].[pjm5CalculationBrowseDraft]
	END
GO

PRINT 'Creating procedure pjm5CalculationBrowseDraft'
GO

/******************************************************************************
**		File: pjm5CalculationBrowseDraft.sql
**		Name: pjm5CalculationBrowseDraft
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 05/03/2005 11:14:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CalculationBrowseDraft]
	@TypeSelector INT
AS 
	SET NOCOUNT ON
	DECLARE
		@EmployeeID TIdentifier,
		@ViewAllProjects TBool,
		@language TLanguage
		
	SET @language = dbo.adfGetLanguage()
	SET @ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects'))
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()

	DECLARE
		@timeClass TClass,
		@expenseClass TClass,
		@phoneClass TClass,
		@requestClass TClass
	SELECT
		@timeClass = dbo.adfGetClassByName('Pjm5.TimeEntry'),
		@expenseClass = dbo.adfGetClassByName('Pjm5.Expense'),
		@phoneClass = dbo.adfGetClassByName('Pjm5.PhoneCall'),
		@requestClass = dbo.adfGetClassByName('Pjm5.ServiceRequest')

	SELECT
		[Calculation].[Class],
		[Calculation].[ID],
		[Calculation].[State],
		[Calculation].[Flag],
		[Calculation].[Date],
		[Calculation].[Number],
		[Calculation].[FileAs],
		[Calculation].[ProjectID],
		[Calculation].[DocumentClass],
		[Calculation].[PeriodStart],
		[Calculation].[PeriodEnd],
		[Calculation].[Comments],
		[Calculation].[Created],
		[Calculation].[CreatedBy],
		[Calculation].[Modified],
		[Calculation].[ModifiedBy],
		[Calculation].[Timestamp],
		[Calculation].[CurrencyCode],
		CASE 
			WHEN [Calculation].[DocumentClass] = @timeClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @expenseClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @phoneClass AND @language = 'ru' THEN ' '
			WHEN [Calculation].[DocumentClass] = @requestClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @timeClass AND @language = 'en' THEN 'Time'
			WHEN [Calculation].[DocumentClass] = @expenseClass AND @language = 'en' THEN 'Expenses'
			WHEN [Calculation].[DocumentClass] = @phoneClass AND @language = 'en' THEN 'Phone Calls'
			WHEN [Calculation].[DocumentClass] = @requestClass AND @language = 'en' THEN 'Orders'
			ELSE 'Unknown'
		END AS [CalculationType],
		[Project].[SupplierCompanyID],
		[Project].[CustomerCompanyID],	
		[Calculation].[VAT],
		[Calculation].[Total],
		[Calculation].[TotalWithVAT],
		[Calculation].[TotalWithVATPC] AS [ProjectTotal],
		[Project].[CurrencyCode] AS [ProjectCurrencyCode],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CostCenterID],
		[Company].[ManagerEmployeeID]
	FROM
		[Calculation]
		INNER JOIN [Project]
			ON [Project].[ID] = [Calculation].[ProjectID]
		LEFT OUTER JOIN [Company]
			ON [Project].[CustomerCompanyID] = [Company].[ID]
	WHERE
		(
			@TypeSelector = 0 OR
			@TypeSelector = 1 AND [Calculation].[DocumentClass] = @timeClass OR
			@TypeSelector = 2 AND [Calculation].[DocumentClass] = @expenseClass OR
			@TypeSelector = 3 AND [Calculation].[DocumentClass] = @phoneClass OR
			@TypeSelector = 4 AND [Calculation].[DocumentClass] = @requestClass
		) AND
		[Calculation].[State] = 1 AND
		(dbo.fnPjm5HasFinansDataAccess([Project].[ID], @EmployeeID, NULL, NULL) = 1)
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CalculationBrowseDraft] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalculationBrowseApproved]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalculationBrowseApproved'
		DROP PROCEDURE [dbo].[pjm5CalculationBrowseApproved]
	END
GO

PRINT 'Creating procedure pjm5CalculationBrowseApproved'
GO

/******************************************************************************
**		File: pjm5CalculationBrowseApproved.sql
**		Name: pjm5CalculationBrowseApproved
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 05/03/2005 11:14:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CalculationBrowseApproved]
	@TypeSelector INT,
	@DateSelector INT,
	@PeriodStart TDate,
	@PeriodEnd TDate
AS
	SET NOCOUNT ON
	DECLARE
		@EmployeeID TIdentifier,
		@ViewAllProjects TBool,
		@language TLanguage
		
	SET @language = dbo.adfGetLanguage()
	SELECT 
		@ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')),
		@EmployeeID = dbo.adfGetCurrentEmployeeID()

	DECLARE
		@timeClass TClass,
		@expenseClass TClass,
		@phoneClass TClass,
		@requestClass TClass
	SELECT
		@timeClass = dbo.adfGetClassByName('Pjm5.TimeEntry'),
		@expenseClass = dbo.adfGetClassByName('Pjm5.Expense'),
		@phoneClass = dbo.adfGetClassByName('Pjm5.PhoneCall'),
		@requestClass = dbo.adfGetClassByName('Pjm5.ServiceRequest')
		
	IF @DateSelector != 0
		EXEC BillingFilterPeriodGet @DateSelector, @PeriodStart OUTPUT, @PeriodEnd OUTPUT
	
	SELECT
		[Calculation].[Class],
		[Calculation].[ID],
		[Calculation].[State],
		[Calculation].[Flag],
		[Calculation].[Date],
		[Calculation].[Number],
		[Calculation].[FileAs],
		[Calculation].[ProjectID],
		[Calculation].[DocumentClass],
		[Calculation].[PeriodStart],
		[Calculation].[PeriodEnd],
		[Calculation].[Comments],
		[Calculation].[Created],
		[Calculation].[CreatedBy],
		[Calculation].[Modified],
		[Calculation].[ModifiedBy],
		[Calculation].[Timestamp],
		[Calculation].[CurrencyCode],
		CASE 
			WHEN [Calculation].[DocumentClass] = @timeClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @expenseClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @phoneClass AND @language = 'ru' THEN ' '
			WHEN [Calculation].[DocumentClass] = @requestClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @timeClass AND @language = 'en' THEN 'Time'
			WHEN [Calculation].[DocumentClass] = @expenseClass AND @language = 'en' THEN 'Expenses'
			WHEN [Calculation].[DocumentClass] = @phoneClass AND @language = 'en' THEN 'Phone Calls'
			WHEN [Calculation].[DocumentClass] = @requestClass AND @language = 'en' THEN 'Orders'
			ELSE 'Unknown'
		END AS [CalculationType],
		[Project].[SupplierCompanyID],
		[Project].[CustomerCompanyID],
		[Calculation].[VAT],
		[Calculation].[Total],
		[Calculation].[TotalWithVAT],
		[Calculation].[TotalWithVATPC] AS [ProjectTotal],
		[Project].[CurrencyCode] AS [ProjectCurrencyCode],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CostCenterID],
		[Company].[ManagerEmployeeID]
	FROM
		[Calculation]
		INNER JOIN [Project]
			ON [Project].[ID] = [Calculation].[ProjectID]
		LEFT OUTER JOIN [Company]
			ON [Project].[CustomerCompanyID] = [Company].[ID]
	WHERE
		(
			@DateSelector = 0 OR
			[Calculation].[Date] BETWEEN @PeriodStart AND @PeriodEnd 
		) AND
		(
			@TypeSelector = 0 OR
			@TypeSelector = 1 AND [Calculation].[DocumentClass] = @timeClass OR
			@TypeSelector = 2 AND [Calculation].[DocumentClass] = @expenseClass OR
			@TypeSelector = 3 AND [Calculation].[DocumentClass] = @phoneClass OR
			@TypeSelector = 4 AND [Calculation].[DocumentClass] = @requestClass
		) AND
		[Calculation].[State] = 2 AND
		(dbo.fnPjm5HasFinansDataAccess([Project].[ID], @EmployeeID, NULL, NULL) = 1)
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CalculationBrowseApproved] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalculationBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalculationBrowse'
		DROP PROCEDURE [dbo].[pjm5CalculationBrowse]
	END
GO

PRINT 'Creating procedure pjm5CalculationBrowse'
GO

/******************************************************************************
**		File: pjm5CalculationBrowse.sql
**		Name: pjm5CalculationBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 05/03/2005 11:14:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CalculationBrowse]
	@StateSelector INT,
	@TypeSelector INT,
	@DateSelector INT,
	@PeriodStart TDate,
	@PeriodEnd TDate
AS
	SET NOCOUNT ON
	DECLARE
		@EmployeeID TIdentifier,
		@ViewAllProjects TBool,
		@language TLanguage
		
	SET @language = dbo.adfGetLanguage()
	SELECT 
		@ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')),
		@EmployeeID = dbo.adfGetCurrentEmployeeID()

	DECLARE
		@timeClass TClass,
		@expenseClass TClass,
		@phoneClass TClass,
		@requestClass TClass
	SELECT
		@timeClass = dbo.adfGetClassByName('Pjm5.TimeEntry'),
		@expenseClass = dbo.adfGetClassByName('Pjm5.Expense'),
		@phoneClass = dbo.adfGetClassByName('Pjm5.PhoneCall'),
		@requestClass = dbo.adfGetClassByName('Pjm5.ServiceRequest')
		
	IF @DateSelector != 0
		EXEC BillingFilterPeriodGet @DateSelector, @PeriodStart OUTPUT, @PeriodEnd OUTPUT
	
	SELECT
		[Calculation].[Class],
		[Calculation].[ID],
		[Calculation].[State],
		[Calculation].[Flag],
		[Calculation].[Date],
		[Calculation].[Number],
		[Calculation].[FileAs],
		[Calculation].[ProjectID],
		[Calculation].[DocumentClass],
		[Calculation].[PeriodStart],
		[Calculation].[PeriodEnd],
		[Calculation].[Comments],
		[Calculation].[Created],
		[Calculation].[CreatedBy],
		[Calculation].[Modified],
		[Calculation].[ModifiedBy],
		[Calculation].[Timestamp],
		[Calculation].[CurrencyCode],
		CASE 
			WHEN [Calculation].[DocumentClass] = @timeClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @expenseClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @phoneClass AND @language = 'ru' THEN ' '
			WHEN [Calculation].[DocumentClass] = @requestClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @timeClass AND @language = 'en' THEN 'Time'
			WHEN [Calculation].[DocumentClass] = @expenseClass AND @language = 'en' THEN 'Expenses'
			WHEN [Calculation].[DocumentClass] = @phoneClass AND @language = 'en' THEN 'Phone Calls'
			WHEN [Calculation].[DocumentClass] = @requestClass AND @language = 'en' THEN 'Orders'
			ELSE 'Unknown'
		END AS [CalculationType],
		[Project].[SupplierCompanyID],
		[Project].[CustomerCompanyID],
		[Calculation].[VAT],
		[Calculation].[Total],
		[Calculation].[TotalWithVAT],
		[Calculation].[TotalWithVATPC] AS [ProjectTotal],
		[Project].[CurrencyCode] AS [ProjectCurrencyCode],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CostCenterID],
		[Company].[ManagerEmployeeID]
	FROM
		[Calculation]
		INNER JOIN [Project]
			ON [Project].[ID] = [Calculation].[ProjectID]
		LEFT OUTER JOIN [Company]
			ON [Project].[CustomerCompanyID] = [Company].[ID]
	WHERE
		(
			@DateSelector = 0 OR
			[Calculation].[Date] BETWEEN @PeriodStart AND @PeriodEnd 
		) AND
		(
			@TypeSelector = 0 OR
			@TypeSelector = 1 AND [Calculation].[DocumentClass] = @timeClass OR
			@TypeSelector = 2 AND [Calculation].[DocumentClass] = @expenseClass OR
			@TypeSelector = 3 AND [Calculation].[DocumentClass] = @phoneClass OR
			@TypeSelector = 4 AND [Calculation].[DocumentClass] = @requestClass
		) AND
		(
			(@StateSelector = 0) OR 
			(@StateSelector = 5 AND [Calculation].[State] != 4) OR
			(@StateSelector != 0 AND [Calculation].[State] = @StateSelector)
		) AND
		(dbo.fnPjm5HasFinansDataAccess([Project].[ID], @EmployeeID, NULL, NULL) = 1)
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CalculationBrowse] TO PUBLIC
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalculationBrowseByCompany]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalculationBrowseByCompany'
		DROP PROCEDURE [dbo].[pjm5CalculationBrowseByCompany]
	END
GO

PRINT 'Creating procedure pjm5CalculationBrowseByCompany'
GO

/******************************************************************************
**		File: pjm5CalculationBrowseByCompany.sql
**		Name: pjm5CalculationBrowseByCompany
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 05/03/2005 11:14:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CalculationBrowseByCompany]
	@CompanyID TIdentifier,
	@StateSelector INT,
	@TypeSelector INT,
	@DateSelector INT,
	@PeriodStart TDate,
	@PeriodEnd TDate
AS
	SET NOCOUNT ON
	DECLARE
		@EmployeeID TIdentifier,
		@ViewAllProjects TBool,
		@language TLanguage
		
	SET @language = dbo.adfGetLanguage()
	SELECT 
		@ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')),
		@EmployeeID = dbo.adfGetCurrentEmployeeID()

	DECLARE
		@timeClass TClass,
		@expenseClass TClass,
		@phoneClass TClass,
		@requestClass TClass
	SELECT
		@timeClass = dbo.adfGetClassByName('Pjm5.TimeEntry'),
		@expenseClass = dbo.adfGetClassByName('Pjm5.Expense'),
		@phoneClass = dbo.adfGetClassByName('Pjm5.PhoneCall'),
		@requestClass = dbo.adfGetClassByName('Pjm5.ServiceRequest')

	IF @DateSelector != 0
		EXEC BillingFilterPeriodGet @DateSelector, @PeriodStart OUTPUT, @PeriodEnd OUTPUT
		
	SELECT
		[Calculation].[Class],
		[Calculation].[ID],
		[Calculation].[State],
		[Calculation].[Flag],
		[Calculation].[Date],
		[Calculation].[Number],
		[Calculation].[FileAs],
		[Calculation].[ProjectID],
		[Calculation].[DocumentClass],
		[Calculation].[PeriodStart],
		[Calculation].[PeriodEnd],
		[Calculation].[Comments],
		[Calculation].[Created],
		[Calculation].[CreatedBy],
		[Calculation].[Modified],
		[Calculation].[ModifiedBy],
		[Calculation].[Timestamp],
		[Calculation].[CurrencyCode],
		CASE 
			WHEN [Calculation].[DocumentClass] = @timeClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @expenseClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @phoneClass AND @language = 'ru' THEN ' '
			WHEN [Calculation].[DocumentClass] = @requestClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @timeClass AND @language = 'en' THEN 'Time'
			WHEN [Calculation].[DocumentClass] = @expenseClass AND @language = 'en' THEN 'Expenses'
			WHEN [Calculation].[DocumentClass] = @phoneClass AND @language = 'en' THEN 'Phone Calls'
			WHEN [Calculation].[DocumentClass] = @requestClass AND @language = 'en' THEN 'Orders'
			ELSE 'Unknown'
		END AS [CalculationType],
		[Project].[SupplierCompanyID],
		[Project].[CustomerCompanyID],
		[Calculation].[VAT],
		[Calculation].[Total],
		[Calculation].[TotalWithVAT],
		[Calculation].[TotalWithVATPC] AS [ProjectTotal],
		[Project].[CurrencyCode] AS [ProjectCurrencyCode],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CostCenterID],
		[Company].[ManagerEmployeeID]
	FROM
		[Calculation]
		INNER JOIN [Project]
			ON [Project].[ID] = [Calculation].[ProjectID]
		LEFT OUTER JOIN [Company]
			ON [Project].[CustomerCompanyID] = [Company].[ID]
	WHERE
		(
			[Project].[SupplierCompanyID] = @CompanyID OR
			[Project].[CustomerCompanyID] = @CompanyID 
		)AND
		(
			@DateSelector = 0 OR
			[Calculation].[Date] BETWEEN @PeriodStart AND @PeriodEnd 
		) AND
		(
			@TypeSelector = 0 OR
			@TypeSelector = 1 AND [Calculation].[DocumentClass] = @timeClass OR
			@TypeSelector = 2 AND [Calculation].[DocumentClass] = @expenseClass OR
			@TypeSelector = 3 AND [Calculation].[DocumentClass] = @phoneClass OR
			@TypeSelector = 4 AND [Calculation].[DocumentClass] = @requestClass
		) AND
		(
			(@StateSelector = 0) OR 
			(@StateSelector = 5 AND [Calculation].[State] != 4) OR
			(@StateSelector != 0 AND [Calculation].[State] = @StateSelector)
		) AND
		(dbo.fnPjm5HasFinansDataAccess([Project].[ID], @EmployeeID, NULL, NULL) = 1)
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CalculationBrowseByCompany] TO PUBLIC
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalculationBrowseByProject]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalculationBrowseByProject'
		DROP PROCEDURE [dbo].[pjm5CalculationBrowseByProject]
	END
GO

PRINT 'Creating procedure pjm5CalculationBrowseByProject'
GO

/******************************************************************************
**		File: pjm5CalculationBrowseByProject.sql
**		Name: pjm5CalculationBrowseByProject
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 05/03/2005 11:14:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CalculationBrowseByProject]
	@ProjectID TIdentifier,
	@StateSelector INT,
	@TypeSelector INT,
	@DateSelector INT,
	@PeriodStart TDate,
	@PeriodEnd TDate
AS
	SET NOCOUNT ON
	DECLARE
		@EmployeeID TIdentifier,
		@ViewAllProjects TBool,
		@language TLanguage
		
	SET @language = dbo.adfGetLanguage()
	SELECT 
		@ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')),
		@EmployeeID = dbo.adfGetCurrentEmployeeID()

	DECLARE
		@timeClass TClass,
		@expenseClass TClass,
		@phoneClass TClass,
		@requestClass TClass
	SELECT
		@timeClass = dbo.adfGetClassByName('Pjm5.TimeEntry'),
		@expenseClass = dbo.adfGetClassByName('Pjm5.Expense'),
		@phoneClass = dbo.adfGetClassByName('Pjm5.PhoneCall'),
		@requestClass = dbo.adfGetClassByName('Pjm5.ServiceRequest')

	IF @DateSelector != 0
		EXEC BillingFilterPeriodGet @DateSelector, @PeriodStart OUTPUT, @PeriodEnd OUTPUT
		
	SELECT
		[Calculation].[Class],
		[Calculation].[ID],
		[Calculation].[State],
		[Calculation].[Flag],
		[Calculation].[Date],
		[Calculation].[Number],
		[Calculation].[FileAs],
		[Calculation].[ProjectID],
		[Calculation].[DocumentClass],
		[Calculation].[PeriodStart],
		[Calculation].[PeriodEnd],
		[Calculation].[Comments],
		[Calculation].[Created],
		[Calculation].[CreatedBy],
		[Calculation].[Modified],
		[Calculation].[ModifiedBy],
		[Calculation].[Timestamp],
		[Calculation].[CurrencyCode],
		CASE 
			WHEN [Calculation].[DocumentClass] = @timeClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @expenseClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @phoneClass AND @language = 'ru' THEN ' '
			WHEN [Calculation].[DocumentClass] = @requestClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @timeClass AND @language = 'en' THEN 'Time'
			WHEN [Calculation].[DocumentClass] = @expenseClass AND @language = 'en' THEN 'Expenses'
			WHEN [Calculation].[DocumentClass] = @phoneClass AND @language = 'en' THEN 'Phone Calls'
			WHEN [Calculation].[DocumentClass] = @requestClass AND @language = 'en' THEN 'Orders'
			ELSE 'Unknown'
		END AS [CalculationType],
		[Project].[SupplierCompanyID],
		[Project].[CustomerCompanyID],
		[Calculation].[VAT],
		[Calculation].[Total],
		[Calculation].[TotalWithVAT],
		[Calculation].[TotalWithVATPC] AS [ProjectTotal],
		[Project].[CurrencyCode] AS [ProjectCurrencyCode],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CostCenterID],
		[Company].[ManagerEmployeeID]
	FROM
		[Calculation]
		INNER JOIN [Project]
			ON [Project].[ID] = [Calculation].[ProjectID]
		LEFT OUTER JOIN [Company]
			ON [Project].[CustomerCompanyID] = [Company].[ID]
	WHERE
		[Project].[ID] = @ProjectID AND
		(
			@DateSelector = 0 OR
			[Calculation].[Date] BETWEEN @PeriodStart AND @PeriodEnd 
		) AND
		(
			@TypeSelector = 0 OR
			@TypeSelector = 1 AND [Calculation].[DocumentClass] = @timeClass OR
			@TypeSelector = 2 AND [Calculation].[DocumentClass] = @expenseClass OR
			@TypeSelector = 3 AND [Calculation].[DocumentClass] = @phoneClass OR
			@TypeSelector = 4 AND [Calculation].[DocumentClass] = @requestClass
		) AND
		(
			(@StateSelector = 0) OR 
			(@StateSelector = 5 AND [Calculation].[State] != 4) OR
			(@StateSelector != 0 AND [Calculation].[State] = @StateSelector)
		) AND
		(dbo.fnPjm5HasFinansDataAccess([Project].[ID], @EmployeeID, NULL, NULL) = 1)
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CalculationBrowseByProject] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalculationDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalculationDelete'
		DROP PROCEDURE [dbo].[pjm5CalculationDelete]
	END
GO

PRINT 'Creating procedure pjm5CalculationDelete'
GO

/******************************************************************************
**		File: pjm5CalculationDelete.sql
**		Name: pjm5CalculationDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 05/03/2005 11:14:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		28.06.10	KOV				    
**		02.04.12	PAM				  
*******************************************************************************/
CREATE PROCEDURE pjm5CalculationDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE
		@CalculationClass	TClass

	SET @CalculationClass = dbo.adfGetClassByName('Pjm5.Calculation')

	IF EXISTS(SELECT * FROM [SuperTimer] 
					WHERE [SuperTimer].[DocumentClass] = @CalculationClass AND [SuperTimer].[DocumentID] = @ID AND 
					([SuperTimer].[State] in (1,2) OR ([SuperTimer].[State] = 3 AND [SuperTimer].[Persistent] = 1)))
	BEGIN
		RAISERROR('#CannotDeleteDocumentWithActiveTimer', 18, -1)
		RETURN 1
	END
	BEGIN TRANSACTION

	--   ""  
	UPDATE
		c
	SET
		[State] = 2,
		[Modified] = DEFAULT,
		[ModifiedBy] = DEFAULT
	FROM [Calculation] c
	INNER JOIN [CalculationAdvance] ca
		ON c.[ID] = ca.[AdvanceCalculationID]
	WHERE
		ca.[CalculationID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	--    
	DELETE 
		[Attachment]
	WHERE
		[Attachment].[LinkDocumentClass] = @CalculationClass AND 
		[Attachment].[LinkDocumentID] = @ID AND
		[AttachmentTypeID] = 3
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

		
	DELETE FROM [CalculationLine] WHERE [CalculationID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [Calculation] WHERE [Calculation].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5CalculationDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalculationChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalculationChangeState'
		DROP PROCEDURE [dbo].[pjm5CalculationChangeState]
	END
GO

PRINT 'Creating procedure pjm5CalculationChangeState'
GO

/******************************************************************************
**		File: pjm5CalculationChangeState.sql
**		Name: pjm5CalculationChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 05/03/2005 11:14:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5CalculationChangeState
	@ID TIdentifier,
	@ToState TState
AS
	SET NOCOUNT ON
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass,
			@ProjectID TIdentifier,
			@Date TDate
	
	SELECT
		@Class = [Calculation].[Class],
		@FromState = [Calculation].[State],
		@ProjectID = [Calculation].[ProjectID],
		@Date = [Calculation].[Date]
	FROM
		[Calculation]
	WHERE
		[Calculation].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END

	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllCalculations')) = 0 AND
		dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	BEGIN TRANSACTION
	UPDATE
		[Calculation]
	SET
		[Calculation].[State] = @ToState,
		[Calculation].[Modified] = GETDATE(),
		[Calculation].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[Calculation].[ID] = @ID
	AND
		[Calculation].[State] = @FromState

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
		
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5CalculationChangeState TO PUBLIC
GO
