IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentLinesSelect]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentLinesSelect'
		DROP PROCEDURE [dbo].[pjm5DocumentLinesSelect]
	END
GO

PRINT 'Creating procedure pjm5DocumentLinesSelect'
GO

/******************************************************************************
**		File: pjm5DocumentLinesSelect.sql
**		Name: pjm5DocumentLinesSelect
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 05/03/2005 11:14:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		17.12.12	SOV				  UseVariousCurrency -
**									       
**		28.02.13	SOV				  IncludingRecordsOfSubprojects - 
**									        
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentLinesSelect]
	@ProjectID TIdentifier,
	@DocumentClass TClass,
	@PeriodStart TDate,
	@PeriodEnd TDate,
	--@FileAs TName = '',
	@Employee TIdentifier = NULL,
	@Category TName,
	@CurrencyCode TCode3,
	@Class TClass,
	@SentToApprove TBool = 0,
	@Task TIdentifier = NULL,
	@Service TIdentifier = NULL,
	@Contact TIdentifier = NULL,
	@ContactClass TClass = NULL,
	@Flag int = NULL,
	@JobID TIdentifier = NULL,
	@JobClass TClass = NULL,
	@DocumentID TIdentifier = NULL,
	@UseVariousCurrency bit = 0,
	@IncludingRecordsOfSubprojects bit = 0
AS
	SET NOCOUNT ON
	IF @Class = dbo.adfGetClassByName('Pjm5.Calculation')
		EXEC pjm5CalculationLinesSelect 
			@ProjectID,
			@DocumentClass,
			@PeriodStart,
			@PeriodEnd,
			@Employee,
			@Category,
			@CurrencyCode,
			@SentToApprove,
			@Task,
			@Service,
			@Contact,
			@ContactClass,
			@Flag,
			@JobID,
			@JobClass,
			@DocumentID,
			@UseVariousCurrency,
			@IncludingRecordsOfSubprojects
	ELSE
		EXEC pjm5FinanceLinesSelect
			@ProjectID,
			@DocumentClass,
			@PeriodStart,
			@PeriodEnd,
			--@FileAs,
			@Employee,
			@Category,
			@CurrencyCode,
			@Class,
			@SentToApprove,
			@Task,
			@Service,
			@Contact,
			@ContactClass,
			@Flag,
			@JobID,
			@JobClass
	RETURN 0
GO

GRANT EXECUTE ON [pjm5DocumentLinesSelect] TO PUBLIC
GO
