IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FinanceLinesSelect]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FinanceLinesSelect'
		DROP PROCEDURE [dbo].[pjm5FinanceLinesSelect]
	END
GO

PRINT 'Creating procedure pjm5FinanceLinesSelect'
GO

/******************************************************************************
**		File: pjm5FinanceLinesSelect.sql
**		Name: pjm5FinanceLinesSelect
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 05/03/2005 11:14:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FinanceLinesSelect]
	@ProjectID TIdentifier,
	@DocumentClass TClass,
	@PeriodStart TDate,
	@PeriodEnd TDate,
	--@FileAs TName,
	@Employee TIdentifier,
	@Category TName,
	@CurrencyCode TCode3,
	@Class TClass,
	@SentToApprove TBool,
	@Task TIdentifier = NULL,
	@Service TIdentifier = NULL,
	@Contact TIdentifier = NULL,
	@ContactClass TClass = NULL,
	@Flag int = NULL,
	@JobID TIdentifier = NULL,
	@JobClass TClass = NULL		
AS
	SET NOCOUNT ON
	DECLARE 
		--@value TVariant,
		@VATRate TPercent,
		@ApplyVAT TBool,
		@CalculationClass TClass
		
	SET @CalculationClass = dbo.adfGetClassByName('Pjm5.Calculation')
	SET @VATRate = 0
	SELECT @ApplyVAT = [Project].[ApplyVAT] FROM [Project] WHERE [Project].[ID] = @ProjectID
	IF @ApplyVAT = 1
	BEGIN
		SET @VATRate = dbo.fnPjm5GetVATRate()
	END
	
	SELECT
		@PeriodStart = CAST(CONVERT(varchar(8), @PeriodStart, 112) AS datetime),
		@PeriodEnd = DATEADD(day, 1, CAST(CONVERT(varchar(8), @PeriodEnd, 112) AS datetime))
		
	IF @DocumentClass = dbo.adfGetClassByName('Pjm5.TimeEntry')
		SELECT
			DISTINCT
			CAST(1 AS bit) AS [Selected],
			[TimeEntry].[State],
			[TimeEntry].[Class],
			[TimeEntry].[ID],
			[TimeEntry].[DocumentID],
			[TimeEntry].[DocumentClass],			
			[TimeEntry].[StartTime] AS [Date],
			[Employee].[ID] AS [EmployeeID],
			[Employee].[FileAs] AS [Employee],
			[TimeEntry].[FileAs],
			[TimeEntry].[BillableHour] AS [Amount],
			[TimeEntry].[Rate] AS [Price],
			CASE [Project].[RatesWithVAT]
				WHEN 1 THEN [TimeEntry].[Rate]
				ELSE [TimeEntry].[Rate] * (1 + @VATRate)
			END AS [PriceWithVAT],
			[TimeEntry].[Rate] * [TimeEntry].[BillableHour] AS [Sum],
			[Project].[RatesWithVAT] AS [VATIsIncluded],
			([TimeEntry].[Rate] * [TimeEntry].[BillableHour]) * @VATRate / (1 + [Project].[RatesWithVAT] * @VATRate) AS [VAT],
			ROUND([TimeEntry].[Rate] * [TimeEntry].[BillableHour], 2) -
				CASE [Project].[RatesWithVAT]
					WHEN 0 THEN 0
					ELSE ROUND(ROUND([TimeEntry].[Rate] * [TimeEntry].[BillableHour], 2) * @VATRate, 2)
				END AS [SumWithoutVAT],
			ROUND([TimeEntry].[Rate] * [TimeEntry].[BillableHour], 2) +
				CASE [Project].[RatesWithVAT]
					WHEN 0 THEN ROUND(ROUND([TimeEntry].[Rate] * [TimeEntry].[BillableHour], 2) * @VATRate, 2)
					ELSE 0
				END AS [SumWithVAT],
			[TimeEntry].[Comments],
			[Project].[CurrencyCode]
		FROM
			[vwTimeEntry] as [TimeEntry]
			INNER JOIN [Employee]
				ON [Employee].[ID] = [TimeEntry].[EmployeeID]
			INNER JOIN [Project]
				ON [Project].[ID] = [TimeEntry].[ProjectID]
			LEFT OUTER JOIN [DocumentContact]
				ON [TimeEntry].[Class] = [DocumentContact].[DocumentClass] 
					AND [TimeEntry].[ID] = [DocumentContact].[DocumentID]
		WHERE
			(
				@Task IS NULL OR
				[TimeEntry].[TaskID] = @Task
			) AND
			(
				@Flag IS NULL OR
				[TimeEntry].[Flag] = @Flag
			) AND
			(
				@Service IS NULL OR
				[TimeEntry].[DocumentID] = @Service
			) AND
			[TimeEntry].[ProjectID] = @ProjectID AND
			[TimeEntry].[StartTime] >= @PeriodStart AND 
			[TimeEntry].[StartTime] < @PeriodEnd AND
			[TimeEntry].[Billable] = 1 AND
			(
				[TimeEntry].[State] = 3 OR
				@SentToApprove = 1 AND [TimeEntry].[State] = 2 OR
				(
					[TimeEntry].[State] = 6 AND
					NOT EXISTS(
						SELECT * 
						FROM [Attachment] 
						WHERE 
							[LinkDocumentClass] IN (@Class, @CalculationClass) AND
							[DocumentClass] = [TimeEntry].[Class] AND 
							[DocumentID] = [TimeEntry].[ID] AND 
							[AttachmentTypeID] = 3
						) 
				)
			)AND
			(@Employee IS NULL OR [Employee].[ID] = @Employee) AND
			(
				@Category IS NULL OR 
				EXISTS (
					SELECT * 
					FROM
						[DocumentCategory]
						INNER JOIN [Category]
							ON ([DocumentCategory].[DocumentClass] = [Category].[DocumentClass] AND 
								[DocumentCategory].[CategoryID] = [Category].[ID])
					WHERE
						[DocumentCategory].[DocumentClass] = [TimeEntry].[Class] AND 
						[DocumentCategory].[DocumentID] = [TimeEntry].[ID] AND
						[Category].[FileAs] LIKE @Category
					)
			) AND
			(
				@JobID IS NULL OR
				[TimeEntry].[DocumentID] = @JobID AND [TimeEntry].[DocumentClass] = @JobClass
			) AND
			(
				@Contact IS NULL OR 
				([DocumentContact].[BusinessCardID] = @Contact AND [DocumentContact].[BusinessCardClass] = @ContactClass)
			)
			
	ELSE IF @DocumentClass = dbo.adfGetClassByName('Pjm5.Expense')
		SELECT
			DISTINCT
			CAST(1 AS bit) AS [Selected],
			[Expense].[State],
			[Expense].[Class],
			[Expense].[ID],
			[Expense].[DocumentID],
			[Expense].[DocumentClass],			
			[Expense].[Date],
			[Employee].[ID] AS [EmployeeID],
			[Employee].[FileAs] AS [Employee],
			[Expense].[FileAs],
			[Expense].[Amount],
			CASE 
				WHEN [VATIsIncluded] = 1 AND [Project].[ApplyVAT] = 0 AND [Expense].[Amount] != 0
					THEN ([Expense].[Amount] * [Expense].[Price] - [Expense].[VAT]) / [Expense].[Amount]
				WHEN [VATIsIncluded] = 1 AND [Project].[ApplyVAT] = 0 AND [Expense].[Amount] = 0
					THEN [Expense].[Price] / (1 + [Expense].[VATRate])
				ELSE [Expense].[Price]
			END AS [Price],
			CASE 
				WHEN [VATIsIncluded] = 1 AND [Project].[ApplyVAT] = 1
					THEN [Expense].[Price]

				WHEN [VATIsIncluded] = 1 AND [Project].[ApplyVAT] = 0 AND [Expense].[Amount] != 0
					THEN ([Expense].[Amount] * [Expense].[Price] - [Expense].[VAT]) / [Expense].[Amount]
				WHEN [VATIsIncluded] = 0 AND [Project].[ApplyVAT] = 1 AND [Expense].[Amount] != 0
					THEN ([Expense].[Amount] * [Expense].[Price] + [Expense].[VAT]) / [Expense].[Amount]
				WHEN [VATIsIncluded] = 0 AND [Project].[ApplyVAT] = 0
					THEN [Expense].[Price]
				ELSE [Expense].[Price] * (1 + [Expense].[VATRate])
			END AS [PriceWithVAT],
			[Expense].[Amount] * [Expense].[Price] AS [Sum],
			[Expense].[VATIsIncluded],
			CASE [Project].[ApplyVAT]
				WHEN 1 THEN [Expense].[VAT] 
				ELSE 0.0
			END AS [VAT],
			CASE
				WHEN [VATIsIncluded] = 1 
					THEN ([Expense].[Amount] * [Expense].[Price] - [Expense].[VAT])
				ELSE [Expense].[Amount] * [Expense].[Price]
			END AS [SumWithoutVAT],
			CASE
				WHEN [VATIsIncluded] = 1 
					THEN ([Expense].[Amount] * [Expense].[Price]) 
				ELSE ([Expense].[Amount] * [Expense].[Price] + [Expense].[VAT])
			END AS [SumWithVAT],
			[Expense].[Comments],
			[Expense].[FromCurrencyCode] AS [CurrencyCode]
		FROM
			[pjm5vwExpense] AS [Expense]
			INNER JOIN [Employee]
				ON [Employee].[ID] = [Expense].[EmployeeID]
			INNER JOIN [Project]
				ON [Project].[ID] = [Expense].[ProjectID]
			LEFT OUTER JOIN [DocumentContact]
				ON [Expense].[Class] = [DocumentContact].[DocumentClass] 
					AND [Expense].[ID] = [DocumentContact].[DocumentID]
		WHERE
			(
				@Task IS NULL OR
				[Expense].[TaskID] = @Task
			) AND
			(
				@Flag IS NULL OR
				[Expense].[Flag] = @Flag
			) AND
			[Expense].[ProjectID] = @ProjectID AND
			[Expense].[Date] >= @PeriodStart AND 
			[Expense].[Date] < @PeriodEnd AND
			[Expense].[Billable] = 1 AND
			(@CurrencyCode IS NULL OR [Expense].[FromCurrencyCode] = @CurrencyCode) AND
			(
				[Expense].[State] = 3 OR
				@SentToApprove = 1 AND [Expense].[State] = 2 OR
				(
					[Expense].[State] = 6 AND
					NOT EXISTS(
						SELECT * 
						FROM [Attachment] 
						WHERE 
							[LinkDocumentClass] IN (@Class, @CalculationClass) AND
							[DocumentClass] = [Expense].[Class] AND 
							[DocumentID] = [Expense].[ID] AND 
							[AttachmentTypeID] = 3
						) 
				)			
			) AND
			(@Employee IS NULL OR [Employee].[ID] = @Employee) AND
			(
				@Category IS NULL OR 
				EXISTS (
					SELECT * 
					FROM
						[DocumentCategory]
						INNER JOIN [Category]
							ON ([DocumentCategory].[DocumentClass] = [Category].[DocumentClass] AND 
								[DocumentCategory].[CategoryID] = [Category].[ID])
					WHERE
						[DocumentCategory].[DocumentClass] = [Expense].[Class] AND 
						[DocumentCategory].[DocumentID] = [Expense].[ID] AND
						[Category].[FileAs] LIKE @Category
					)
			) AND
			(
				@JobID IS NULL OR
				[Expense].[DocumentID] = @JobID AND [Expense].[DocumentClass] = @JobClass
			) AND
			(
				@Contact IS NULL OR 
				([DocumentContact].[BusinessCardID] = @Contact AND [DocumentContact].[BusinessCardClass] = @ContactClass)
			)

	ELSE IF @DocumentClass = dbo.adfGetClassByName('Pjm5.ServiceRequest')
		SELECT
			DISTINCT
			CAST(1 AS bit) AS [Selected],
			[ServiceRequest].[State],
			[ServiceRequest].[Class],
			[ServiceRequest].[ID],
			[ServiceRequest].[Date],
			[Employee].[ID] AS [EmployeeID],
			[Employee].[FileAs] AS [Employee],
			[ServiceRequest].[FileAs],
			1 AS [Amount],
			[ServiceRequest].[Total] AS [Price],
			CASE [Project].[ApplyVAT] 
				WHEN 1 THEN [ServiceRequest].[TotalWithVAT] 
				ELSE [ServiceRequest].[Total]
			END AS [PriceWithVAT],
			[ServiceRequest].[Total] AS [Sum],
			[ServiceRequest].[VATIsIncluded],
			CASE [Project].[ApplyVAT]
				WHEN 1 THEN [ServiceRequest].[VAT] 
				ELSE 0.0
			END AS [VAT],
			[ServiceRequest].[Total] AS [SumWithoutVAT],
			CASE [Project].[ApplyVAT]
				WHEN 1 THEN [ServiceRequest].[TotalWithVAT] 
				ELSE [ServiceRequest].[Total]
			END AS [SumWithVAT],
			[ServiceRequest].[Comments],
			[Project].[CurrencyCode]
		FROM
			[ServiceRequest]
			INNER JOIN [Employee]
				ON [Employee].[ID] = [ServiceRequest].[EmployeeID]
			INNER JOIN [Project]
				ON [Project].[ID] = [ServiceRequest].[ProjectID]
			LEFT OUTER JOIN [DocumentContact]
				ON [ServiceRequest].[class] = [DocumentContact].[DocumentClass] 
					AND [ServiceRequest].[ID] = [DocumentContact].[DocumentID]
		WHERE
			(
				@Flag IS NULL OR
				[ServiceRequest].[Flag] = @Flag
			) AND
			[ServiceRequest].[ProjectID] = @ProjectID AND
			[ServiceRequest].[Date] >= @PeriodStart AND 
			[ServiceRequest].[Date] < @PeriodEnd AND
			[ServiceRequest].[Billable] = 1 AND
			(
				[ServiceRequest].[State] = 4 OR
				@SentToApprove = 1 AND [ServiceRequest].[State] = 3 OR
				(
					[ServiceRequest].[State] = 5 AND
					NOT EXISTS(
						SELECT * 
						FROM [Attachment] 
						WHERE 
							[LinkDocumentClass] IN (@Class, @CalculationClass) AND
							[DocumentClass] = [ServiceRequest].[Class] AND 
							[DocumentID] = [ServiceRequest].[ID] AND 
							[AttachmentTypeID] = 3
						) 
				)			
			) AND
			(@Employee IS NULL OR [Employee].[ID] = @Employee) AND
			(
				@Category IS NULL OR 
				EXISTS (
					SELECT * 
					FROM
						[DocumentCategory]
						INNER JOIN [Category]
							ON ([DocumentCategory].[DocumentClass] = [Category].[DocumentClass] AND 
								[DocumentCategory].[CategoryID] = [Category].[ID])
					WHERE
						[DocumentCategory].[DocumentClass] = [ServiceRequest].[Class] AND 
						[DocumentCategory].[DocumentID] = [ServiceRequest].[ID] AND
						[Category].[FileAs] LIKE @Category
					)
			) AND
			(
				@Contact IS NULL OR 
				([DocumentContact].[BusinessCardID] = @Contact AND [DocumentContact].[BusinessCardClass] = @ContactClass)
			)
	RETURN 0
GO

GRANT EXECUTE ON [pjm5FinanceLinesSelect] TO PUBLIC
GO
