 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6DocumentCardCheckReadAccess]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6DocumentCardCheckReadAccess'
		DROP PROCEDURE [dbo].[pjm6DocumentCardCheckReadAccess]
	END
GO

PRINT 'Creating procedure pjm6DocumentCardCheckReadAccess'
GO

/******************************************************************************
**		File: pjm6DocumentCardCheckReadAccess.sql
**		Name: pjm6DocumentCardCheckReadAccess
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6DocumentCardCheckReadAccess]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @CurrentEmployeeID TIdentifier
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	IF NOT EXISTS (
		SELECT * 
			FROM 
				[TaskRequest]
				INNER JOIN [TaskRequestAssignment]
					ON [TaskRequestAssignment].[TaskRequestID] = [TaskRequest].[ID] AND
						[TaskRequestAssignment].[EmployeeID]=@CurrentEmployeeID
			WHERE 
				[TaskRequest].[DocumentCardID] = @ID AND
				[TaskRequest].[State] = 2
	)
	BEGIN
		DECLARE @UserID TIdentifier
		SET @UserID = dbo.adfGetCurrentUserID()
		
		DECLARE @FolderID TIdentifier
		SELECT 
			@FolderID = [DocumentCard].[FolderID] 
		FROM
			[DocumentCard]
		WHERE
			[DocumentCard].[ID] = @ID
		IF @FolderID > 0
		BEGIN
			IF dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'ReadItems') = 0
			BEGIN
				RAISERROR('#accessdenied', 18, -1)
				RETURN 1
			END
		END
	END

	RETURN 0
GO

GRANT EXECUTE ON pjm6DocumentCardCheckReadAccess TO PUBLIC
GO
