 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardCopy]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentCardCopy'
		DROP PROCEDURE [dbo].[pjm5DocumentCardCopy]
	END
GO

PRINT 'Creating procedure pjm5DocumentCardCopy'
GO

/******************************************************************************
**		File: pjm5DocumentCardCopy.sql
**		Name: pjm5DocumentCardCopy
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentCardCopy]
	@ID TIdentifier,
	@FolderID TIdentifier
AS
	SET NOCOUNT ON
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('AccessToPublicFolders')) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF NOT EXISTS(SELECT * FROM [Folder] WHERE [ID] = @FolderID)
	BEGIN
		RAISERROR('#folderisdeleted', 18, -1)
		RETURN 1
	END
	
	DECLARE 
		@UserID TIdentifier,
		@PrevFolderID TIdentifier,
		@DocumentItemID TIdentifier,
		@CreatedBy TIdentifier,
		@NewCardID TIdentifier,
		@NewID TIdentifier,
		@PrevState TState,
		@State TState,
		@CardClass TClass,
		@CardState TState,
		@PublicationControl TBool,
		@FolderPublication TBool,
		@CaseID TIdentifier,
		@CompanyID TIdentifier,
		@rv int

	SELECT
		@PublicationControl = [Folder].[PublicationControl],
		@CompanyID = [Folder].[CompanyID]
	FROM
		[Folder]
	WHERE
		[ID] = @FolderID
		
	
	SELECT 
		@PrevFolderID = [DocumentCard].[FolderID],
		@CreatedBy = [DocumentCard].[CreatedBy],
		@PrevState = [DocumentCard].[State],
		@CardClass = [DocumentCard].[Class],
		@DocumentItemID = [DocumentItem].[ID],
		@CaseID = [DocumentCard].[CaseID]
	FROM 
		[DocumentCard]
		LEFT OUTER JOIN [DocumentItem]
			ON [DocumentItem].[DocumentCardID] = [DocumentCard].[ID]
	WHERE
		[DocumentCard].[ID] = @ID

	SET @UserID = dbo.adfGetCurrentUserID()

	IF dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'CreateItems') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SET @State = dbo.adfwfGetInitialState('acb865ab-ae3c-429e-af10-d14d6a46363b')
	IF @State != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SET @CardState = dbo.adfwfGetInitialState('6cc877ce-4425-4e49-a3d5-76b01ae709ae')
	IF @CardState IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SET @FolderPublication = 1
	IF @PublicationControl = 1 AND @CaseID IS NULL
		SET @FolderPublication = dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'FolderPublication')

	BEGIN TRANSACTION
	INSERT INTO [DocumentCard] ([State], [Flag], [Date], [FileAs], [FolderID],
		[DocumentCardClassID],
		[DocumentCardID],
		[Number],
		[NumberIn],
		[DateIn],
		[NumberOut],
		[DateOut],
		[CompanyID],
		[ContactID],
		[CorrespondentCompanyID],
		[CorrespondentContactID],
		[DivisionID],
		[CardOwnerID],
		[CustodyPlaceID],
		[AppendixCount],
		[PageCount],
		[Copy],
		[StorePeriod],
		[Package],
		[CaseID],
		[Comments]) 
	SELECT 
		@CardState, 0, [DocumentCard].[Date], [DocumentCard].[FileAs], @FolderID,
		[DocumentCard].[DocumentCardClassID],
		[DocumentCard].[DocumentCardID],
		[DocumentCard].[Number],
		[DocumentCard].[NumberIn],
		[DocumentCard].[DateIn],
		[DocumentCard].[NumberOut],
		[DocumentCard].[DateOut],
		@CompanyID,
		[DocumentCard].[ContactID],
		[DocumentCard].[CorrespondentCompanyID],
		[DocumentCard].[CorrespondentContactID],
		[DocumentCard].[DivisionID],
		[DocumentCard].[CardOwnerID],
		[DocumentCard].[CustodyPlaceID],
		[DocumentCard].[AppendixCount],
		[DocumentCard].[PageCount],
		[DocumentCard].[Copy],
		[DocumentCard].[StorePeriod],
		[DocumentCard].[Package],
		[DocumentCard].[CaseID],
		[DocumentCard].[Comments]
	FROM
		[DocumentCard]
	WHERE
		[DocumentCard].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @NewCardID = SCOPE_IDENTITY()
	
	IF @CardState = 5 -- NOT VISIBLE
	BEGIN
		UPDATE 
			[DocumentCard]
		SET
			[State] = 1
		WHERE
			[ID] = @NewCardID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	IF @DocumentItemID IS NOT NULL
	BEGIN
		INSERT INTO [DocumentItem]
			([State], [Flag], [FileAs], [FileName], [Extension], [LatestVersion], [FolderID], [DocumentCardID])
		SELECT
			@State, 0, [FileAs], [FileName], [Extension], [LatestVersion], @FolderID, @NewCardID
		FROM
			[DocumentItem]
		WHERE
			[ID] = @DocumentItemID
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		SET @NewID = SCOPE_IDENTITY()
		
		INSERT INTO [DocumentVersion] ([DocumentItemID], [Version], [Extension], [Data]) 
		SELECT
			@NewID, [DocumentVersion].[Version], [DocumentVersion].[Extension], [DocumentVersion].[Data]
		FROM 
			[DocumentVersion]
		WHERE
			[DocumentVersion].[DocumentItemID] = @DocumentItemID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		IF @FolderPublication = 1
		BEGIN
			EXEC @rv = pjm5DocumentItemChangeStateInternal @NewID, 2
			IF @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		EXEC pjm5DocumentItemCreateNotification @NewID
	END
	COMMIT TRANSACTION

	EXEC pjm5DocumentCardGet @NewCardID
	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentCardCopy TO PUBLIC
GO

