IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentItemUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentItemUpdate'
		DROP PROCEDURE [dbo].[pjm5DocumentItemUpdate]
	END
GO

PRINT 'Creating procedure pjm5DocumentItemUpdate'
GO

/******************************************************************************
**		File: pjm5DocumentItemUpdate.sql
**		Name: pjm5DocumentItemUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		19.11.09	SYV				      
**									 
**		20.02.13	SAP				  OPENXML 
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentItemUpdate
	@Xml XML
AS
	SET NOCOUNT ON
	DECLARE		
		@ID TIdentifier,
		@FileName TName,
		@FileAs TName,
		@Extension TName,
		@CardOwnerID TIdentifier,
		@Comments TNotes,
		@FolderID TIdentifier

		
	SELECT
		@ID = T.c.value('ID[1]','int'),
		@FileName = T.c.value('FileName[1]','nvarchar(512)'),
		@FileAs = T.c.value('FileAs[1]','nvarchar(512)'),
		@Extension = T.c.value('Extension[1]','nvarchar(512)'),
		@CardOwnerID = T.c.value('CardOwnerID[1]','int'),
		@Comments = T.c.value('Comments[1]','nvarchar(max)')
	FROM
		@Xml.nodes('/pjm5DocumentItemGet/DocumentItem') AS T(c) 

	
	SELECT @FolderID=[FolderID] from [DocumentItem] where ID=@ID
	DECLARE @p3 int
	SET @p3=NULL
	EXEC pjm5DocumentItemCheckExisting @FolderID=@FolderID,@FileName=@FileName,@ID=@p3 output
	IF @p3 != @ID AND @p3 IS NOT NULL
	BEGIN
		RAISERROR('#fileexist', 18, -1)
		RETURN 1
	END
	
	IF UPPER(@Extension) != UPPER(RIGHT(@FileName, LEN(@Extension)))
	BEGIN
		RAISERROR('#wrongfileextension', 18, -1)
		RETURN 1
	END
	
	BEGIN TRANSACTION
	UPDATE
		[DocumentItem]
	SET
		[FileName] = @FileName,
		[FileAs] = @FileAs,
		[Modified] = DEFAULT,
		[ModifiedBy] = DEFAULT
	WHERE
		[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	UPDATE
		[DocumentCard]
	SET
		[FileAs] = @FileAs,
		[CardOwnerID] = @CardOwnerID,
		[Comments] = @Comments,
		[Modified] = DEFAULT,
		[ModifiedBy] = DEFAULT
	FROM
		[DocumentCard]
		INNER JOIN [DocumentItem]
			ON [DocumentItem].[DocumentCardID] = [DocumentCard].[ID]
	WHERE
		[DocumentItem].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	EXEC pjm5DocumentItemGet @ID
	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentItemUpdate TO PUBLIC
GO
 