IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'Export1C')
	BEGIN
		PRINT 'Dropping Procedure Export1C'
		DROP  Procedure  Export1C
	END

GO

PRINT 'Creating Procedure Export1C'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2010 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
-- Pd*Fd*, Pd*Id*, Fd*Id*, I*Sd*, S*Fd*, SI*, IF*, IP*, FP*   

	DATE		Author		Comments
	--------	------		----------------------------------------------------------
	21.01.10	SPV			     
	21.01.10	SPV			        
							     (PaymentCurrencyRateDate)
	21.01.10	SPV			    
	28.05.10	SPV			      
	09.08.10	SPV			   
	10.08.10	SPV			        
	10.12.10	SPV			      
	31.08.11    SAM                
	20.02.14	BAO			      
	13.03.14	BAO			    @Total, @TotalWithVAT, @VAT
							 -  
--------------------------------------------------------------------------------------*/
CREATE Procedure Export1C
	@SupplierID TIdentifier,
	@StartDate TDate,
	@EndDate TDate,
	@ExportFlag int
AS
	SET NOCOUNT ON
	
	DECLARE
		@InvoiceClass TClass,
		@StatementClass TClass,
		@FactureClass TClass,
		@PaymentClass TClass,
		@Value TVariant,
		@LastExportDate TDate,
		@LastExport TDate,
		@AdvanceFactureFlag TFlag,
		@DateTypeFlag TFlag,
		@InvoiceOnly TFlag,
		@UserID TIdentifier,
		@EmployeeClass TClass,
		@CompanyClass TClass,
		@NationalCurrencyCode TCode3,
		@val TVariant
		
		
	EXEC adfParameterGet 'NationalCurrency', 'CommonBusiness', @val OUTPUT	
	SET @NationalCurrencyCode = CAST(@val AS varchar(3))
	
	SET @AdvanceFactureFlag = (@ExportFlag / 10) % 10	-- 1*  0* -    -
	SET @DateTypeFlag = @ExportFlag % 10	-- 	0 -   , 1 -  
	SET @InvoiceOnly = @ExportFlag / 100	--  
	SET @InvoiceClass = dbo.adfGetClassByName('Pjm5.Invoice')
	SET @EmployeeClass = dbo.adfGetClassByName('Adf.Employee')
	SET @CompanyClass = dbo.adfGetClassByName('Adf.Company')
	SET @StatementClass = dbo.adfGetClassByName('Pjm5.Statement')
	SET @FactureClass = dbo.adfGetClassByName('Pjm5.Facture')
	SET @PaymentClass = dbo.adfGetClassByName('Adf.Payment')
	SET @UserID = dbo.adfGetCurrentUserID()
	
	-- ID Udf- " ".    	
	DECLARE @ServiceTypeClass TClass, @ServiceTypeUDF TIdentifier
	SET @ServiceTypeClass = dbo.adfGetClassByName('Pjm5.ServiceType')
	SELECT
		@ServiceTypeUDF = [Property].[ID]
	FROM
		[Property]
	WHERE
		[Property].[Class] = @ServiceTypeClass AND [Property].[Name] = ' '
	
	SET @LastExportDate = @StartDate
	SET @LastExport = GETDATE()
	
	--  
	DECLARE @Deprecated TABLE
	(
		[DocumentClass] TClass,
		[DocumentID] TIdentifier
	)
	INSERT INTO @Deprecated
	--     
	SELECT
		@InvoiceClass,
		[InvoiceID]
	FROM
	(
		SELECT [InvoiceLine].[InvoiceID]
		FROM [InvoiceLine]
		GROUP BY [InvoiceLine].[InvoiceID], [InvoiceLine].[VATRate]
	) as [Invoices]
	GROUP BY [InvoiceID] HAVING COUNT([InvoiceID]) > 1
	UNION
	SELECT
		@FactureClass,
		[FactureID]
	FROM
	(
		SELECT [FactureLine].[FactureID]
		FROM [FactureLine]
		GROUP BY [FactureLine].[FactureID], [FactureLine].[VATRate]
	) as [Factures]
	GROUP BY [FactureID] HAVING COUNT([FactureID]) > 1
	UNION
	SELECT
		@StatementClass,
		[StatementID]
	FROM
	(
		SELECT [StatementLine].[StatementID]
		FROM [StatementLine]
		GROUP BY [StatementLine].[StatementID], [StatementLine].[VATRate]
	) as [Statements]
	GROUP BY [StatementID] HAVING COUNT([StatementID]) > 1
	UNION
	--      
	SELECT
		@InvoiceClass,
		[Invoice].[ID]
	FROM
		[Invoice]
	WHERE
		[Invoice].[ExchangeBanned] = 1
	UNION
	SELECT
		@StatementClass,
		[Statement].[ID]
	FROM
		[Statement]
	WHERE
		[Statement].[ExchangeBanned] = 1
	UNION
	SELECT
		@FactureClass,
		[Facture].[ID]
	FROM
		[Facture]
	WHERE
		[Facture].[ExchangeBanned] = 1
	--    
	UNION
	SELECT
		@FactureClass,
		[Facture].[ID]
	FROM
		[Facture]
		INNER JOIN [Project]
			ON [Project].[ID] = [Facture].[ProjectID]
	WHERE
		[Project].[ContractDate] IS NULL AND
		[Project].[ContractNumber] IS NULL AND
		[Project].[ExchangeSystemName] IS NULL
	UNION
	SELECT
		@StatementClass,
		[Statement].[ID]
	FROM
		[Statement]
		INNER JOIN [Project]
			ON [Project].[ID] = [Statement].[ProjectID]
	WHERE
		[Project].[ContractDate] IS NULL AND
		[Project].[ContractNumber] IS NULL AND
		[Project].[ExchangeSystemName] IS NULL
	UNION
	SELECT
		@InvoiceClass,
		[Invoice].[ID]
	FROM
		[Invoice]
		INNER JOIN [Project]
			ON [Project].[ID] = [Invoice].[ProjectID]
	WHERE
		[Project].[ContractDate] IS NULL AND
		[Project].[ContractNumber] IS NULL AND
		[Project].[ExchangeSystemName] IS NULL
	

	--      
	DECLARE @FISP TABLE
	(
		[DocumentClass] TClass,
		[DocumentID] TIdentifier
	)
	DECLARE @FISPDistinct TABLE
	(
		[DocumentClass] TClass,
		[DocumentID] TIdentifier
	)

	--    
	DECLARE @StatementInvoice TABLE
	(
		[StatementID] TIdentifier,
		[InvoiceID] TIdentifier
	)
	--
	
	INSERT INTO @StatementInvoice
	SELECT
		[Statement].[ID],
		[Invoice].[ID]
	FROM
		[Invoice]
		INNER JOIN [Attachment]
			ON [Invoice].[Class] = [Attachment].[DocumentClass]
				AND [Invoice].[ID] = [Attachment].[DocumentID]
		INNER JOIN [Statement]
			ON [Statement].[Class] = [Attachment].[LinkDocumentClass]
				AND [Statement].[ID] = [Attachment].[LinkDocumentID]
	WHERE
	(
		[Statement].[Modified] > @LastExportDate AND @DateTypeFlag = 0 OR
		([Statement].[Date] BETWEEN @StartDate AND @EndDate) AND @DateTypeFlag = 1
	) AND [Invoice].[ID] NOT IN (SELECT [DocumentID] FROM @Deprecated WHERE [DocumentClass] = @InvoiceClass)
	UNION
	SELECT
		[Statement].[ID],
		[Invoice].[ID]
	FROM
		[Statement]
		INNER JOIN [Attachment]
			ON [Statement].[Class] = [Attachment].[DocumentClass]
				AND [Statement].[ID] = [Attachment].[DocumentID]
		INNER JOIN [Invoice]
			ON [Invoice].[Class] = [Attachment].[LinkDocumentClass]
				AND [Invoice].[ID] = [Attachment].[LinkDocumentID]
	WHERE
	(
		[Statement].[Modified] > @LastExportDate AND @DateTypeFlag = 0 OR
		([Statement].[Date] BETWEEN @StartDate AND @EndDate) AND @DateTypeFlag = 1
	) AND [Invoice].[ID] NOT IN (SELECT [DocumentID] FROM @Deprecated WHERE [DocumentClass] = @InvoiceClass)

--
	-- -  
	DECLARE @FactureStatement TABLE
	(
		[FactureID] TIdentifier,
		[StatementID] TIdentifier
	)
	
	DECLARE @Invoices TABLE
	(
		[InvoiceID] TIdentifier,
		[FactureID] TIdentifier
	)
	
	INSERT INTO @Invoices ([InvoiceID], [FactureID])
	SELECT 
		[Attachment].[LinkDocumentID],
		[Attachment].[DocumentID]
	FROM
		[Attachment]
		INNER JOIN [Facture]
			ON	[Attachment].[DocumentClass] = [Facture].[Class] AND
				[Attachment].[DocumentID] = [Facture].[ID] AND
				[Attachment].[LinkDocumentClass] = @InvoiceClass
	WHERE
		(
			[Facture].[Modified] > @LastExportDate AND @DateTypeFlag = 0 OR
			([Facture].[Date] BETWEEN @StartDate AND @EndDate) AND @DateTypeFlag = 1
		) AND
		[Attachment].[LinkDocumentID] NOT IN (SELECT [InvoiceID] FROM @Invoices)
	UNION
	SELECT 
		[Attachment].[DocumentID],
		[Attachment].[LinkDocumentID]
	FROM
		[Attachment]
		INNER JOIN [Facture]
			ON	[Attachment].[LinkDocumentClass] = [Facture].[Class] AND
				[Attachment].[LinkDocumentID] = [Facture].[ID] AND
				[Attachment].[DocumentClass] = @InvoiceClass
	WHERE
		(
			[Facture].[Modified] > @LastExportDate AND @DateTypeFlag = 0 OR
			([Facture].[Date] BETWEEN @StartDate AND @EndDate) AND @DateTypeFlag = 1
		) AND
		[Attachment].[DocumentID] NOT IN (SELECT [InvoiceID] FROM @Invoices)
		
	INSERT INTO @FactureStatement
	SELECT 
		[Invoices].[FactureID],
		[Attachment].[LinkDocumentID]
	FROM
		[Attachment]
		INNER JOIN @Invoices [Invoices]
			ON	[Invoices].[InvoiceID] = [Attachment].[DocumentID] AND
				[Attachment].[DocumentClass] = @InvoiceClass AND
				[Attachment].[LinkDocumentClass] = @StatementClass
	WHERE
		[Invoices].[FactureID] NOT IN (SELECT [FactureID] FROM @FactureStatement)
	UNION
	SELECT 
		[Invoices].[FactureID],
		[Attachment].[DocumentID]
	FROM
		[Attachment]
		INNER JOIN @Invoices [Invoices]
			ON	[Invoices].[InvoiceID] = [Attachment].[LinkDocumentID] AND
				[Attachment].[LinkDocumentClass] = @InvoiceClass AND
				[Attachment].[DocumentClass] = @StatementClass
	WHERE
		[Invoices].[FactureID] NOT IN (SELECT [FactureID] FROM @FactureStatement)
	--
	
	INSERT INTO @FactureStatement
	SELECT 
		[Facture].[ID] AS [FactureID],
		[Statement].[ID] AS [StatementID]
	FROM
		[Statement]
		INNER JOIN [Attachment]
			ON [Statement].[Class] = [Attachment].[DocumentClass]
				AND [Statement].[ID] = [Attachment].[DocumentID]
		INNER JOIN [Facture]
			ON [Facture].[Class] = [Attachment].[LinkDocumentClass]
				AND [Facture].[ID] = [Attachment].[LinkDocumentID]
	WHERE
		(
			[Facture].[Modified] > @LastExportDate AND @DateTypeFlag = 0 OR
			([Facture].[Date] BETWEEN @StartDate AND @EndDate) AND @DateTypeFlag = 1
		) AND
		[Facture].[ID] NOT IN (SELECT [FactureID] FROM @FactureStatement)
	UNION
	SELECT 
		[Facture].[ID] AS [FactureID],
		[Statement].[ID] AS [StatementID]
	FROM
		[Facture]
		INNER JOIN [Attachment]
			ON [Facture].[Class] = [Attachment].[DocumentClass]
				AND [Facture].[ID] = [Attachment].[DocumentID]
		INNER JOIN [Statement]
			ON [Statement].[Class] = [Attachment].[LinkDocumentClass]
				AND [Statement].[ID] = [Attachment].[LinkDocumentID]
	WHERE
		(
			[Facture].[Modified] > @LastExportDate AND @DateTypeFlag = 0 OR
			([Facture].[Date] BETWEEN @StartDate AND @EndDate) AND @DateTypeFlag = 1
		) AND
		[Facture].[ID] NOT IN (SELECT [FactureID] FROM @FactureStatement)

	--
	--  
	INSERT INTO @FISP ([DocumentID], [DocumentClass])
	SELECT
		[Invoice].[ID],
		@InvoiceClass
	FROM
		[Invoice]
	WHERE
		[Invoice].[ID] NOT IN 
		(
			SELECT [DocumentID] FROM @FISP WHERE [DocumentClass] = @InvoiceClass
		) AND
		(
			[Invoice].[Modified] > @LastExportDate AND @DateTypeFlag = 0 OR
			([Invoice].[Date] BETWEEN @StartDate AND @EndDate) AND @DateTypeFlag = 1
		) AND
		[Invoice].[ID] NOT IN (SELECT [DocumentID] FROM @Deprecated WHERE [DocumentClass] = @InvoiceClass) 

	--
	INSERT INTO @FISP ([DocumentID], [DocumentClass])
	SELECT
		[Facture].[ID],
		@FactureClass
	FROM
		[Facture]
	WHERE
		[Facture].[ID] NOT IN 
		(
			SELECT [DocumentID] FROM @FISP WHERE [DocumentClass] = @FactureClass
		) AND
		(
			[Facture].[Modified] > @LastExportDate AND @DateTypeFlag = 0 OR
			([Facture].[Date] BETWEEN @StartDate AND @EndDate) AND @DateTypeFlag = 1
		)
		AND
		[Facture].[ID] NOT IN (SELECT [DocumentID] FROM @Deprecated WHERE [DocumentClass] = @FactureClass) 

	--
	INSERT INTO @FISP ([DocumentID], [DocumentClass])
	SELECT
		[Statement].[ID],
		@StatementClass
	FROM
		[Statement]
	WHERE
		[Statement].[ID] NOT IN 
		(
			SELECT [DocumentID] FROM @FISP WHERE [DocumentClass] = @StatementClass
		) AND
		(
			[Statement].[Modified] > @LastExportDate AND @DateTypeFlag = 0 OR
			([Statement].[Date] BETWEEN @StartDate AND @EndDate) AND @DateTypeFlag = 1
		) AND
		[Statement].[ID] NOT IN (SELECT [DocumentID] FROM @Deprecated WHERE [DocumentClass] = @StatementClass) 
----------
	--   
	
	INSERT INTO @FISPDistinct([DocumentID], [DocumentClass])
	SELECT DISTINCT [DocumentID], [DocumentClass] FROM @FISP
	
	--------------------------- -------------------------------
	DECLARE @Del TABLE
	(
		[DocumentClass] TClass,
		[DocumentID] TIdentifier,
		[DocumentNumber] TName,
		[DocumentDate] TDate,
		[Date] TDate,
		[SupplierID] TIdentifier
	)

	INSERT INTO @Del
	SELECT 
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[Number],
		[Invoice].[Date],
		MAX([T].[Created]),
		[Project].[SupplierCompanyID]
	FROM
		[Invoice]
		INNER JOIN [Project]
			ON [Invoice].[ProjectID] = [Project].[ID] AND [Invoice].[State] IN (1, 3)
		INNER JOIN [Transition] [T]
			ON [Invoice].[Class] = [T].[Class] AND [Invoice].[ID] = [T].[DocumentID]
		INNER JOIN [TransitionTemplate] [TT]
			ON [TT].[ID] = [T].[TransitionTemplateID]
				AND [TT].[ToState] IN (1, 3) AND [TT].[FromState] IN (2, 5)
	WHERE
		[Invoice].[State] IN (1, 3) AND
		(
			[T].[Created] > @LastExportDate AND @DateTypeFlag = 0 OR
			[Invoice].[Date] BETWEEN @StartDate AND @EndDate AND @DateTypeFlag = 1
		)
	GROUP BY
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[Number],
		[Invoice].[Date],
		[Project].[SupplierCompanyID]	 

	INSERT INTO @Del
	SELECT 
		[Facture].[Class],
		[Facture].[ID],
		[Facture].[Number],
		[Facture].[Date],
		MAX([T].[Created]),
		[Project].[SupplierCompanyID]
	FROM
		[Facture]
		INNER JOIN [Project]
			ON [Facture].[ProjectID] = [Project].[ID] AND [Facture].[State] IN (1, 3)
		INNER JOIN [Transition] [T]
			ON [Facture].[Class] = [T].[Class] AND [Facture].[ID] = [T].[DocumentID]
		INNER JOIN [TransitionTemplate] [TT]
			ON [TT].[ID] = [T].[TransitionTemplateID]
				AND [TT].[ToState] IN (1, 3) AND [TT].[FromState] IN (2)
	WHERE
		[Facture].[State] IN (1, 3) AND
		(
			[T].[Created] > @LastExportDate AND @DateTypeFlag = 0 OR
			[Facture].[Date] BETWEEN @StartDate AND @EndDate AND @DateTypeFlag = 1
		)
	GROUP BY
		[Facture].[Class],
		[Facture].[ID],
		[Facture].[Number],
		[Facture].[Date],
		[Project].[SupplierCompanyID]	 

	INSERT INTO @Del
	SELECT 
		[Statement].[Class],
		[Statement].[ID],
		[Statement].[Number],
		[Statement].[Date],
		MAX([T].[Created]),
		[Project].[SupplierCompanyID]
	FROM
		[Statement]
		INNER JOIN [Project]
			ON [Statement].[ProjectID] = [Project].[ID] AND [Statement].[State] IN (1, 4)
		INNER JOIN [Transition] [T]
			ON [Statement].[Class] = [T].[Class] AND [Statement].[ID] = [T].[DocumentID]
		INNER JOIN [TransitionTemplate] [TT]
			ON [TT].[ID] = [T].[TransitionTemplateID]
				AND [TT].[ToState] IN (1, 4) AND [TT].[FromState] IN (2, 3)
	WHERE
		[Statement].[State] IN (1, 4) AND
		(
			[T].[Created] > @LastExportDate AND @DateTypeFlag = 0 OR
			[Statement].[Date] BETWEEN @StartDate AND @EndDate AND @DateTypeFlag = 1
		)
	GROUP BY
		[Statement].[Class],
		[Statement].[ID],
		[Statement].[Number],
		[Statement].[Date],
		[Project].[SupplierCompanyID]	 

	--------------------------------------------------------------------------------
	SELECT
		@StartDate as 'Period/@StartDate',
		@EndDate as 'Period/@EndDate',
		CASE @DateTypeFlag WHEN 1 THEN 0 ELSE 1 END as 'Period/@PeriodType',
		(
			SELECT
				[Company].[ID] as '@SupplierID',
				[Company].[FileAs] as '@Name',
				'' as '@SupplierType',
				[Company].[LegalName] as '@LegalName',
				dbo.fnPjm5AddressAsString([LegalAddress].[Street], [LegalAddress].[City],[LegalAddress].[Region],[LegalAddress].[PostalCode],[LegalAddress].[Country]) as '@LegalAddress',
				dbo.fnPjm5AddressAsString([PostalAddress].[Street], [PostalAddress].[City],[PostalAddress].[Region],[PostalAddress].[PostalCode],[PostalAddress].[Country]) as '@PostalAddress',
				[BasicPhone].[Phone] as '@BasePhone',
				[Fax].[Phone] as '@Fax',
				[Company].[LegalCode] as '@LegalCode',
				[Company].[KPP] as '@KPP',
				------------------------------Invoice
				(
					SELECT
						[Invoice].[ID] as '@ID',
						[Invoice].[State] as '@State',
						[Invoice].[Number] as '@Number',
						[Invoice].[Date] as '@Date',
						[Currency].[NumericCode] as '@CurrencyNumericCode',
						[Currency].[Code] as '@CurrencyCode',
						[Invoice].[CurrencyRate] as '@CurrencyRate',
						dbo.pjm6fnCurrencyGetRate([Invoice].[CurrencyCode], [Invoice].[Date], @NationalCurrencyCode) as '@NationalCurrencyRate',
						[Invoice].[Advance] as '@Advance',
						[Invoice].[DueDate] as '@EndDate',
						[Invoice].[BaseCurrencyRate] as '@BaseCurrencyRate',
						[Invoice].[Total] as '@Total',
						[Invoice].[TotalWithVAT] as '@TotalWithVAT',
						[Invoice].[VAT] as '@VAT',
						(SELECT TOP(1)[VATRate] FROM [InvoiceLine] WHERE [InvoiceID] = [Invoice].[ID]) as '@VATRate',
						CASE WHEN (SELECT TOP(1)[VATRate] FROM [InvoiceLine] WHERE [InvoiceID] = [Invoice].[ID]) > 0 THEN 1 ELSE 0 END as '@ApplyVAT',
						--[Project].[ApplyVAT] as '@ApplyVAT',
						CASE [Invoice].[PaymentCurrencyPoint] WHEN 0 THEN 'Payment' ELSE 'Invoice' END as '@PaymentCurrencyRateDate',
						[Invoice].[Modified] as '@Modified',
						-----------contract
						(
						SELECT
							[Project].[ID] as '@ContractID',
							[Project].[ContractNumber] as '@ContractNumber',
							dbo.fnMask ([Project].[ExchangeSystemName], [Project].[ContractNumber],
							    [Project].[ContractDate]) as '@ExchangeSystemName',
							[Project].[ContractDate] as '@ContractDate',
							[Project].[ContractEndDate] as '@ContractEndDate',
							[Currency].[Code] as '@CurrencyCode',
							[Currency].[NumericCode] as '@CurrencyNumericCode',
							[CostCenter].[ID] as '@CostCenterID',
							[CostCenter].[Code] as '@CostCenterCode',
							[CostCenter].[FileAs] as '@CodeCenterFileAs',
							CASE
								WHEN [Project].[CurrencyCode] != @NationalCurrencyCode THEN
									CASE
										WHEN ISNULL([ContractBankAccount].[CurrencyCode], [DefaultBankAccount].[CurrencyCode]) != @NationalCurrencyCode THEN 'INT'
										ELSE 'UE'
									END
								ELSE
									'NAT'
							END as '@CurrencyContractType',
							[Project].[InvoiceExpirationPeriod] as '@InvoiceExpirationPeriod',
							[Project].[InvoiceExpirationPeriodType] as '@InvoiceExpirationPeriodType',
							[Project].[IsConsignor] as '@IsConsignor',
							[Project].[ConsignorID] as '@ConsignorID',
							CASE [Project].[ConsignorClass] WHEN @EmployeeClass THEN 'Employee' WHEN @CompanyClass THEN 'Company' ELSE 'None' END as '@ConsignorType',
							[BusinessCard].[FileAs] as '@Consignor',
							[Project].[ConsignorContract] as '@ConsignorContract'
						 FROM
							[Project]
							LEFT OUTER JOIN [CostCenter]
								ON [Project].[CostCenterID] = [CostCenter].[ID]
							LEFT OUTER JOIN [Company]
								ON [Company].[ID] = [Project].[SupplierCompanyID]
							LEFT OUTER JOIN [BankAccount] [DefaultBankAccount]
								ON [DefaultBankAccount].[ID] = ISNULL([Company].[BankAccountID], -1)
							LEFT OUTER JOIN [BankAccount] [ContractBankAccount]
								ON [ContractBankAccount].[ID] = ISNULL([Project].[BankAccountID], -1)
							LEFT OUTER JOIN [Currency]
								ON [Currency].[Code] = [Project].[CurrencyCode]
							LEFT OUTER JOIN [BusinessCard]
								ON [BusinessCard].[Class] = [Project].[ConsignorClass] AND [BusinessCard].[ID] = [Project].[ConsignorID]
							WHERE [Project].[ID] = [Invoice].[ProjectID]
						 FOR XML PATH('Contract'), TYPE
						),
						---------------Bank account
						(
						SELECT
							[BankAccount].[ID] as '@BankAccountID',
							[BankAccount].[Account] as '@BankAccount',
							[BankAccount].[BankName] as '@Bank',
							[BankAccount].[City] as '@CityBank',
							[BankAccount].[IntermediaryAccount] as '@IntermediaryAccount',
							[BankAccount].[BankCode] as '@BankCode',
							[Currency].[Code] as '@CurrencyCode',
							[Currency].[NumericCode] as '@CurrencyNumericCode'
						FROM
							[BankAccount]
							INNER JOIN [Currency]
								ON [BankAccount].[CurrencyCode] = [Currency].[Code]							
						WHERE [BankAccount].[ID] = [Invoice].[SupplierBankAccountID]
						 FOR XML PATH('BankAccount'), TYPE
						),
						---------------Customer Bank account
						(
						SELECT
							[BankAccount].[ID] as '@BankAccountID',
							[BankAccount].[Account] as '@BankAccount',
							[BankAccount].[BankName] as '@Bank',
							[BankAccount].[City] as '@CityBank',
							[BankAccount].[IntermediaryAccount] as '@IntermediaryAccount',
							[BankAccount].[BankCode] as '@BankCode',
							[Currency].[Code] as '@CurrencyCode',
							[Currency].[NumericCode] as '@CurrencyNumericCode'
						 FROM
							[Company]
							INNER JOIN [BankAccount]
								ON [Company].[BankAccountID] = [BankAccount].[ID]
							INNER JOIN [Currency]
								ON [BankAccount].[CurrencyCode] = [Currency].[Code]
						WHERE
							[Invoice].[CustomerCompanyID] = [Company].[ID]
						 FOR XML PATH('ConsigneeBankAccount'), TYPE
						),
						-------------Customer
						(
							SELECT	
								[Company].[ID] as '@ID',
								[Company].[FileAs]  as '@Name',
								dbo.fnPjm6GetLegalFormType([Company].[LegalCode], ISNULL([LegalAddress].[Country], '')) as '@LegalFormType',
								[Company].[LegalName]  as '@LegalName',
								dbo.fnPjm5AddressAsString([LegalAddress].[Street], [LegalAddress].[City],[LegalAddress].[Region],[LegalAddress].[PostalCode],[LegalAddress].[Country])  as '@LegalAddress',
								dbo.fnPjm5AddressAsString([PostalAddress].[Street], [PostalAddress].[City],[PostalAddress].[Region],[PostalAddress].[PostalCode],[PostalAddress].[Country]) as '@PostAddress',
								[BasicPhone].[Phone] as '@Phone',
								[Fax].[Phone] as '@Fax',
								[Company].[LegalCode]  as '@LegalCode',
								[Company].[KPP] as '@KPP'
							FROM
								[Company]
								LEFT OUTER JOIN [Address] as [LegalAddress]
									ON [LegalAddress].[BusinessCardID] = [Company].[ID] AND 
										[LegalAddress].[BusinessCardClass] = [Company].[Class] AND
										[LegalAddress].[AddressTypeID] = 1
								LEFT OUTER JOIN [Address] as [PostalAddress]
									ON [PostalAddress].[BusinessCardID] = [Company].[ID] AND 
										[PostalAddress].[BusinessCardClass] = [Company].[Class] AND
										[PostalAddress].[AddressTypeID] = 5
								LEFT OUTER JOIN [Phone] as [BasicPhone]
									ON [BasicPhone].[BusinessCardID] = [Company].[ID] AND 
										[BasicPhone].[BusinessCardClass] = [Company].[Class] AND
										[BasicPhone].[PhoneTypeID] = 11
								LEFT OUTER JOIN [Phone] as [Fax]
									ON [Fax].[BusinessCardID] = [Company].[ID] AND 
										[Fax].[BusinessCardClass] = [Company].[Class] AND
										[Fax].[PhoneTypeID] = 8 
							WHERE [Company].[ID] = [Invoice].[CustomerCompanyID]
							FOR XML PATH('Customer'), TYPE
						),
						-------------Consignee
						(
							SELECT	
								[Company].[ID] as '@ID',
								[Company].[FileAs]  as '@Name',
								dbo.fnPjm6GetLegalFormType([Company].[LegalCode], ISNULL([LegalAddress].[Country], '')) as '@LegalFormType',
								[Company].[LegalName]  as '@LegalName',
								dbo.fnPjm5AddressAsString([LegalAddress].[Street], [LegalAddress].[City],[LegalAddress].[Region],[LegalAddress].[PostalCode],[LegalAddress].[Country])  as '@LegalAddress',
								dbo.fnPjm5AddressAsString([PostalAddress].[Street], [PostalAddress].[City],[PostalAddress].[Region],[PostalAddress].[PostalCode],[PostalAddress].[Country]) as '@PostAddress',
								[BasicPhone].[Phone] as '@Phone',
								[Fax].[Phone] as '@Fax',
								[Company].[LegalCode]  as '@LegalCode',
								[Company].[KPP] as '@KPP'
							FROM
								[Company]
								LEFT OUTER JOIN [Address] as [LegalAddress]
									ON [LegalAddress].[BusinessCardID] = [Company].[ID] AND 
										[LegalAddress].[BusinessCardClass] = [Company].[Class] AND
										[LegalAddress].[AddressTypeID] = 1
								LEFT OUTER JOIN [Address] as [PostalAddress]
									ON [PostalAddress].[BusinessCardID] = [Company].[ID] AND 
										[PostalAddress].[BusinessCardClass] = [Company].[Class] AND
										[PostalAddress].[AddressTypeID] = 5
								LEFT OUTER JOIN [Phone] as [BasicPhone]
									ON [BasicPhone].[BusinessCardID] = [Company].[ID] AND 
										[BasicPhone].[BusinessCardClass] = [Company].[Class] AND
										[BasicPhone].[PhoneTypeID] = 11
								LEFT OUTER JOIN [Phone] as [Fax]
									ON [Fax].[BusinessCardID] = [Company].[ID] AND 
										[Fax].[BusinessCardClass] = [Company].[Class] AND
										[Fax].[PhoneTypeID] = 8 
							WHERE [Company].[ID] = [Invoice].[CustomerCompanyID]
							FOR XML PATH('Consignee'), TYPE
						),
						------------Invoice Lines
						(
							SELECT
								[InvoiceLine].[ID] as '@ID',
								[ServiceType].[ID] as '@ServiceTypeID',
								[ServiceType].[FileAs] as '@ServiceType',
								[ServiceType].[Code] as '@ServiceTypeCode',
								CASE [PropertyValue].[Value] WHEN 'True' THEN 1 ELSE 0 END as '@LineTypeIncludeSKU',
								[Service].[ID] as '@ServiceID',
								[Service].[FileAs] as '@Service',
								[Service].[Code] as '@ServiceCode',
								[InvoiceLine].[Amount] as '@Amount',
								[InvoiceLine].[VATRate] as '@VATRate',
								[UOM].[FileAs] '@UOM',
								CASE 
								WHEN [InvoiceLine].[VATIsIncluded] = 1 AND [InvoiceLine].[Amount] != 0
									THEN ([InvoiceLine].[Price] * [InvoiceLine].[Amount] - [InvoiceLine].[VAT]) / [InvoiceLine].[Amount]
								ELSE [InvoiceLine].[Price]
								END  as '@Price',
								[InvoiceLine].[Amount] * 
									CASE 
										WHEN [InvoiceLine].[VATIsIncluded] = 1 AND [InvoiceLine].[Amount] != 0
											THEN ([InvoiceLine].[Price] * [InvoiceLine].[Amount] - [InvoiceLine].[VAT]) / [InvoiceLine].[Amount]
										ELSE [InvoiceLine].[Price]
									END  as '@Total',
								CASE 
									WHEN [InvoiceLine].[VATIsIncluded] = 0 AND [InvoiceLine].[Amount] != 0
										THEN ([InvoiceLine].[Price] * [InvoiceLine].[Amount] + [InvoiceLine].[VAT]) / [InvoiceLine].[Amount]
									ELSE [InvoiceLine].[Price]
								END  as '@PriceWithVAT',
								[InvoiceLine].[Amount] * 
								CASE 
									WHEN [InvoiceLine].[VATIsIncluded] = 0 AND [InvoiceLine].[Amount] != 0
										THEN ([InvoiceLine].[Price] * [InvoiceLine].[Amount] + [InvoiceLine].[VAT]) / [InvoiceLine].[Amount]
									ELSE [InvoiceLine].[Price]
								END as '@TotalWithVAT',
								[InvoiceLine].[VAT] as '@VAT',
								[InvoiceLine].[Description] as '@Description'
							FROM
								[InvoiceLine]
								LEFT OUTER JOIN [ServiceType]
									ON [InvoiceLine].[ServiceTypeID] = [ServiceType].[ID]
								LEFT OUTER JOIN [UOM]
									ON [InvoiceLine].[UOMID] = [UOM].[ID]
								LEFT OUTER JOIN [ServiceAssignment]
										ON [ServiceAssignment].[Class] = [InvoiceLine].[DocumentClass]
										AND [ServiceAssignment].[ID] = [InvoiceLine].[DocumentID]
								LEFT OUTER JOIN [Service]
										ON [Service].[ID] = [ServiceAssignment].[ServiceID]
								LEFT OUTER JOIN [PropertyValue]
									ON [PropertyValue].[DocumentClass] = [ServiceType].[Class] AND
									 [PropertyValue].[DocumentID] = [ServiceType].[ID] AND [PropertyValue].[PropertyID] = @ServiceTypeUDF
							WHERE
								[InvoiceLine].[InvoiceID] = [Invoice].[ID]
							FOR XML PATH('InvoiceLine'), TYPE
						),
						---------------------Payments
						(
						SELECT
							[Payment].[ID] as '@ID',
							[Payment].[Number] as '@Number',
							[Payment].[IncomingNumber] as '@SysNum',
							[Payment].[IncomingDate] as '@DatePorucheniya',
							[Payment].[Date] as '@Date',
							[Payment].[Value] as '@Sum'
						FROM
							[PaymentDetail]
							INNER JOIN [Payment]
								ON [PaymentDetail].[PaymentID] = [Payment].[ID]
						WHERE
							[PaymentDetail].[InvoiceID] = [Invoice].[ID]
						FOR XML PATH('Payment'), TYPE
						) as 'Payments'
					FROM
						[Invoice] 
						INNER JOIN [Project]
							ON [Project].[ID] = [Invoice].[ProjectID]
						INNER JOIN [Currency]
							ON [Currency].[Code] = [Invoice].[CurrencyCode]
						INNER JOIN @FISPDistinct [FISP]
							ON [FISP].[DocumentID] = [Invoice].[ID] AND [FISP].[DocumentClass] = @InvoiceClass
					WHERE
						[Invoice].[State] IN (2, 5) AND
						([Invoice].[SupplierCompanyID] = @SupplierID OR @SupplierID = 0 AND [Company].[Own] = 1)
					FOR XML PATH('Invoice'), TYPE
				) as 'Invoices',
				-----------------------------Statement
				(
					SELECT
						[Statement].[ID] as '@ID',
						[Statement].[State] as '@State',
						[Statement].[Date] as '@Date',
						[Statement].[Number] as '@Number',

						[Statement].[PeriodStart] as '@StartDate',
						[Statement].[PeriodEnd] as '@EndDate',
						[Currency].[Code] as '@CurrencyCode',
						[Currency].[NumericCode] as '@CurrencyNumericCode',
						[Statement].[CurrencyRate] as '@CurrencyRate',
						dbo.pjm6fnCurrencyGetRate([Statement].[CurrencyCode], [Statement].[Date], @NationalCurrencyCode) as '@NationalCurrencyRate',
						[Statement].[Total] as '@Total',
						[Statement].[TotalWithVAT] as '@NTotalWithVAT',
						[Statement].[VAT] as '@VAT',
						(SELECT TOP(1)[StatementLine].[VATRate] FROM [StatementLine] WHERE [StatementLine].[StatementID] = [Statement].[ID]) as '@VATRate',
						CASE WHEN (SELECT TOP(1) [StatementLine].[VATRate] FROM [StatementLine] WHERE [StatementLine].[StatementID] = [Statement].[ID]) > 0 THEN 1 ELSE 0 END as '@ApplyVAT',
						[Statement].[Modified] as '@Modified',
						-----------contract
						(
						SELECT
							[Project].[ID] as '@ContractID',
							[Project].[ContractNumber] as '@ContractNumber',
							dbo.fnMask ([Project].[ExchangeSystemName], [Project].[ContractNumber],
							    [Project].[ContractDate]) as '@ExchangeSystemName',
							[Project].[ContractDate] as '@ContractDate',
							[Project].[ContractEndDate] as '@ContractEndDate',
							[Currency].[Code] as '@CurrencyCode',
							[Currency].[NumericCode] as '@CurrencyNumericCode',
							[CostCenter].[ID] as '@CostCenterID',
							[CostCenter].[Code] as '@CostCenterCode',
							[CostCenter].[FileAs] as '@CodeCenterFileAs',
							CASE
								WHEN [Project].[CurrencyCode] != @NationalCurrencyCode THEN
									CASE
										WHEN ISNULL([ContractBankAccount].[CurrencyCode], [DefaultBankAccount].[CurrencyCode]) != @NationalCurrencyCode THEN 'INT'
										ELSE 'UE'
									END
								ELSE
									'NAT'
							END as '@CurrencyContractType',
							[Project].[InvoiceExpirationPeriod] as '@InvoiceExpirationPeriod',
							[Project].[InvoiceExpirationPeriodType] as '@InvoiceExpirationPeriodType',
							[Project].[IsConsignor] as '@IsConsignor',
							[Project].[ConsignorID] as '@ConsignorID',
							CASE [Project].[ConsignorClass] WHEN @EmployeeClass THEN 'Employee' WHEN @CompanyClass THEN 'Company' ELSE 'None' END as '@ConsignorType',
							[BusinessCard].[FileAs] as '@Consignor',
							[Project].[ConsignorContract] as '@ConsignorContract'
						FROM
							[Project]
							LEFT OUTER JOIN [CostCenter]
								ON [Project].[CostCenterID] = [CostCenter].[ID]
							LEFT OUTER JOIN [Company] 
								ON [Company].[ID] = [Project].[SupplierCompanyID]
							LEFT OUTER JOIN [BankAccount] [DefaultBankAccount]
								ON [DefaultBankAccount].[ID] = ISNULL([Company].[BankAccountID], -1)
							LEFT OUTER JOIN [BankAccount] [ContractBankAccount]
								ON [ContractBankAccount].[ID] = ISNULL([Project].[BankAccountID], -1)
							LEFT OUTER JOIN [Currency]
								ON [Currency].[Code] = [Project].[CurrencyCode]
							LEFT OUTER JOIN [BusinessCard]
								ON [BusinessCard].[Class] = [Project].[ConsignorClass] AND [BusinessCard].[ID] = [Project].[ConsignorID]
								
						WHERE [Project].[ID] = [Statement].[ProjectID]
						FOR XML PATH('Contract'), TYPE
						),
						---------------Bank account
						(
							SELECT
								[BankAccount].[ID] as '@BankAccountID',
								[BankAccount].[Account] as '@BankAccount',
								[BankAccount].[BankName] as '@Bank',
								[BankAccount].[City] as '@CityBank',
								[BankAccount].[IntermediaryAccount] as '@IntermediaryAccount',
								[BankAccount].[BankCode] as '@BankCode',
								[Currency].[Code] as '@CurrencyCode',
								[Currency].[NumericCode] as '@CurrencyNumericCode'
							FROM
								[Project]
								INNER JOIN [BankAccount]
									ON [BankAccount].[ID] = ISNULL([Project].[BankAccountID], [Company].[BankAccountID])
								INNER JOIN [Currency]
									ON [BankAccount].[CurrencyCode] = [Currency].[Code]	
								INNER JOIN [Company]
									ON [Project].[SupplierCompanyID] = @SupplierID
							WHERE
								[Statement].[SupplierCompanyID] = [Company].[ID]
								AND [Project].[ID] = [Statement].[ProjectID]
							FOR XML PATH('BankAccount'), TYPE
						),
						---------------Customer Bank account
						(
						SELECT
							[BankAccount].[ID] as '@BankAccountID',
							[BankAccount].[Account] as '@BankAccount',
							[BankAccount].[BankName] as '@Bank',
							[BankAccount].[City] as '@CityBank',
							[BankAccount].[IntermediaryAccount] as '@IntermediaryAccount',
							[BankAccount].[BankCode] as '@BankCode',
							[Currency].[Code] as '@CurrencyCode',
							[Currency].[NumericCode] as '@CurrencyNumericCode'
						 FROM
							[Company]
							INNER JOIN [BankAccount]
								ON [Company].[BankAccountID] = [BankAccount].[ID]
							INNER JOIN [Currency]
								ON [BankAccount].[CurrencyCode] = [Currency].[Code]
						WHERE
							[Statement].[CustomerCompanyID] = [Company].[ID]
						 FOR XML PATH('ConsigneeBankAccount'), TYPE
						),
						-------------Customer
						(
							SELECT	
								[Company].[ID] as '@ID',
								[Company].[FileAs]  as '@Name',
								dbo.fnPjm6GetLegalFormType([Company].[LegalCode], ISNULL([LegalAddress].[Country], '')) as '@LegalFormType',
								[Company].[LegalName]  as '@LegalName',
								dbo.fnPjm5AddressAsString([LegalAddress].[Street], [LegalAddress].[City],[LegalAddress].[Region],[LegalAddress].[PostalCode],[LegalAddress].[Country])  as '@LegalAddress',
								dbo.fnPjm5AddressAsString([PostalAddress].[Street], [PostalAddress].[City],[PostalAddress].[Region],[PostalAddress].[PostalCode],[PostalAddress].[Country]) as '@PostAddress',
								[BasicPhone].[Phone] as '@Phone',
								[Fax].[Phone] as '@Fax',
								[Company].[LegalCode]  as '@LegalCode',
								[Company].[KPP] as '@KPP'
							FROM
								[Company]
								LEFT OUTER JOIN [Address] as [LegalAddress]
									ON [LegalAddress].[BusinessCardID] = [Company].[ID] AND 
										[LegalAddress].[BusinessCardClass] = [Company].[Class] AND
										[LegalAddress].[AddressTypeID] = 1
								LEFT OUTER JOIN [Address] as [PostalAddress]
									ON [PostalAddress].[BusinessCardID] = [Company].[ID] AND 
										[PostalAddress].[BusinessCardClass] = [Company].[Class] AND
										[PostalAddress].[AddressTypeID] = 5
								LEFT OUTER JOIN [Phone] as [BasicPhone]
									ON [BasicPhone].[BusinessCardID] = [Company].[ID] AND 
										[BasicPhone].[BusinessCardClass] = [Company].[Class] AND
										[BasicPhone].[PhoneTypeID] = 11
								LEFT OUTER JOIN [Phone] as [Fax]
									ON [Fax].[BusinessCardID] = [Company].[ID] AND 
										[Fax].[BusinessCardClass] = [Company].[Class] AND
										[Fax].[PhoneTypeID] = 8 
							WHERE [Company].[ID] = [Statement].[CustomerCompanyID]
							FOR XML PATH('Customer'), TYPE
						),
						-------------Consignee
						(
							SELECT	
								[Company].[ID] as '@ID',
								[Company].[FileAs]  as '@Name',
								dbo.fnPjm6GetLegalFormType([Company].[LegalCode], ISNULL([LegalAddress].[Country], '')) as '@LegalFormType',
								[Company].[LegalName]  as '@LegalName',
								dbo.fnPjm5AddressAsString([LegalAddress].[Street], [LegalAddress].[City],[LegalAddress].[Region],[LegalAddress].[PostalCode],[LegalAddress].[Country])  as '@LegalAddress',
								dbo.fnPjm5AddressAsString([PostalAddress].[Street], [PostalAddress].[City],[PostalAddress].[Region],[PostalAddress].[PostalCode],[PostalAddress].[Country]) as '@PostAddress',
								[BasicPhone].[Phone] as '@Phone',
								[Fax].[Phone] as '@Fax',
								[Company].[LegalCode]  as '@LegalCode',
								[Company].[KPP] as '@KPP'
							FROM
								[Company]
								LEFT OUTER JOIN [Address] as [LegalAddress]
									ON [LegalAddress].[BusinessCardID] = [Company].[ID] AND 
										[LegalAddress].[BusinessCardClass] = [Company].[Class] AND
										[LegalAddress].[AddressTypeID] = 1
								LEFT OUTER JOIN [Address] as [PostalAddress]
									ON [PostalAddress].[BusinessCardID] = [Company].[ID] AND 
										[PostalAddress].[BusinessCardClass] = [Company].[Class] AND
										[PostalAddress].[AddressTypeID] = 5
								LEFT OUTER JOIN [Phone] as [BasicPhone]
									ON [BasicPhone].[BusinessCardID] = [Company].[ID] AND 
										[BasicPhone].[BusinessCardClass] = [Company].[Class] AND
										[BasicPhone].[PhoneTypeID] = 11
								LEFT OUTER JOIN [Phone] as [Fax]
									ON [Fax].[BusinessCardID] = [Company].[ID] AND 
										[Fax].[BusinessCardClass] = [Company].[Class] AND
										[Fax].[PhoneTypeID] = 8 
							WHERE [Company].[ID] = [Statement].[CustomerCompanyID]
							FOR XML PATH('Consignee'), TYPE
						),
						------------Statement Lines
						(
							SELECT
								[StatementLine].[ID] as '@ID',
								[ServiceType].[ID] as '@ServiceTypeID',
								[ServiceType].[FileAs] as '@ServiceType',
								[ServiceType].[Code] as '@ServiceTypeCode',
								CASE [PropertyValue].[Value] WHEN 'True' THEN 1 ELSE 0 END as '@LineTypeIncludeSKU',
								[Service].[ID] as '@ServiceID',
								[Service].[FileAs] as '@Service',
								[Service].[Code] as '@ServiceCode',
								[StatementLine].[Amount] as '@Amount',
								[StatementLine].[VATRate] as '@VATRate',
								[UOM].[FileAs] '@UOM',
								CASE 
								WHEN [StatementLine].[VATIsIncluded] = 1 AND [StatementLine].[Amount] != 0
									THEN ([StatementLine].[Price] * [StatementLine].[Amount] - [StatementLine].[VAT]) / [StatementLine].[Amount]
								ELSE [StatementLine].[Price] 
								END  as '@Price',
								[StatementLine].[Amount] * 	
									CASE 
										WHEN [StatementLine].[VATIsIncluded] = 1 AND [StatementLine].[Amount] != 0
											THEN ([StatementLine].[Price] * [StatementLine].[Amount] - [StatementLine].[VAT]) / [StatementLine].[Amount]
										ELSE [StatementLine].[Price]
									END  as '@Total',
								CASE 
									WHEN [StatementLine].[VATIsIncluded] = 0 AND [StatementLine].[Amount] != 0
										THEN ([StatementLine].[Price] * [StatementLine].[Amount] + [StatementLine].[VAT]) / [StatementLine].[Amount]
									ELSE [StatementLine].[Price]
								END  as '@PriceWithVAT',
								[StatementLine].[Amount] * 	
								CASE 
									WHEN [StatementLine].[VATIsIncluded] = 0 AND [StatementLine].[Amount] != 0
										THEN ([StatementLine].[Price] * [StatementLine].[Amount] + [StatementLine].[VAT]) / [StatementLine].[Amount]
									ELSE [StatementLine].[Price]
								END as '@TotalWithVAT',
								[StatementLine].[VAT] as '@VAT',
								[StatementLine].[Description] as '@Description'
							FROM
								[StatementLine]
								LEFT OUTER JOIN [ServiceType]
									ON [StatementLine].[ServiceTypeID] = [ServiceType].[ID]
								LEFT OUTER JOIN [UOM]
									ON [StatementLine].[UOMID] = [UOM].[ID]
								LEFT OUTER JOIN [ServiceAssignment]
										ON [ServiceAssignment].[Class] = [StatementLine].[DocumentClass]
										AND [ServiceAssignment].[ID] = [StatementLine].[DocumentID]
								LEFT OUTER JOIN [Service]
										ON [Service].[ID] = [ServiceAssignment].[ServiceID]
								LEFT OUTER JOIN [PropertyValue]
									ON [PropertyValue].[DocumentClass] = [ServiceType].[Class] AND
									 [PropertyValue].[DocumentID] = [ServiceType].[ID] AND [PropertyValue].[PropertyID] = @ServiceTypeUDF
							WHERE
								[StatementLine].[StatementID] = [Statement].[ID]
							FOR XML PATH('StatementLine'), TYPE
						),
						---------------------State Invoices
						(
							SELECT
								[Invoice].[ID] as '@ID',
								[Invoice].[Number] as '@Number',
								[Invoice].[Date] as '@Date',
								[Invoice].[Total] as '@Sum'
							FROM
								@StatementInvoice [SI]
								INNER JOIN [Invoice]
									ON [SI].[InvoiceID] = [Invoice].[ID] AND [Invoice].[Advance] = 1
							WHERE
								[SI].[StatementID] = [Statement].[ID]
							FOR XML PATH('AInvoice'), TYPE
						) as 'AInvoices',
						------------
						(
							SELECT
								[Invoice].[ID] as '@ID',
								[Invoice].[Number] as '@Number',
								[Invoice].[Date] as '@Date',
								[Invoice].[Total] as '@Sum'
							FROM
								@StatementInvoice [SI]
								INNER JOIN [Invoice]
									ON [SI].[InvoiceID] = [Invoice].[ID] AND [Invoice].[Advance] = 0
							WHERE
								[SI].[StatementID] = [Statement].[ID]
							FOR XML PATH('PInvoice'), TYPE
						) as 'PInvoices'
						
						-------------------------------
					FROM
						[Statement] 
						INNER JOIN [Project]
							ON [Project].[ID] = [Statement].[ProjectID]
						INNER JOIN [Currency]
							ON [Currency].[Code] = [Statement].[CurrencyCode]
						INNER JOIN @FISPDistinct [FISP]
							ON [FISP].[DocumentID] = [Statement].[ID] AND [FISP].[DocumentClass] = @StatementClass
					WHERE
						@InvoiceOnly = 0 AND
						([Statement].[SupplierCompanyID] = @SupplierID OR @SupplierID = 0 AND [Company].[Own] = 1)
						AND [Statement].[State] IN (2, 3)
					FOR XML PATH('Statement'), TYPE
				) as 'Statements',
				------------------------------Facture
				(
					SELECT
						[Facture].[ID] as '@ID',
						[Facture].[State] as '@State',
						[Facture].[Number] as '@Number',
						[Facture].[Date] as '@Date',
						ISNULL([Statement].[Number], '') as '@StatementNumber',
						ISNULL([Statement].[Date], '') as '@StatementDate',
						[Currency].[Code] as '@CurrencyCode',
						[Currency].[NumericCode] as '@CurrencyNumericCode',
						[Facture].[CurrencyRate] as '@CurrencyRate',
						dbo.pjm6fnCurrencyGetRate([Facture].[CurrencyCode], [Facture].[Date], @NationalCurrencyCode) as '@NationalCurrencyRate',
						[Facture].[Advance] as '@Advance',
						[Facture].[Total] as '@Total',
						[Facture].[TotalWithVAT] as '@TotalWithVAT',
						[Facture].[VAT] as '@VAT',
						--[Project].[ApplyVAT] as '@ApplyVAT',
						[Facture].[Sender] as '@Consignor',
						[Facture].[Recipient] as '@Consignee',
						(SELECT TOP(1)[FactureLine].[VATRate] FROM [FactureLine] WHERE [FactureLine].[FactureID] = [Facture].[ID]) as '@VATRate',
						CASE WHEN (SELECT TOP(1) [FactureLine].[VATRate] FROM [FactureLine] WHERE [FactureLine].[FactureID] = [Facture].[ID]) > 0 THEN 1 ELSE 0 END as '@ApplyVAT',
						[Facture].[Modified] as '@Modified',
						-----------contract
						(
						SELECT
							[Project].[ID] as '@ContractID',
							[Project].[ContractNumber] as '@ContractNumber',
							dbo.fnMask ([Project].[ExchangeSystemName], [Project].[ContractNumber],
							    [Project].[ContractDate]) as '@ExchangeSystemName',
							[Project].[ContractDate] as '@ContractDate',
							[Project].[ContractEndDate] as '@ContractEndDate',
							[Currency].[Code] as '@CurrencyCode',
							[Currency].[NumericCode] as '@CurrencyNumericCode',
							[CostCenter].[ID] as '@CostCenterID',
							[CostCenter].[Code] as '@CostCenterCode',
							[CostCenter].[FileAs] as '@CodeCenterFileAs',
							CASE
								WHEN [Project].[CurrencyCode] != @NationalCurrencyCode THEN
									CASE
										WHEN ISNULL([ContractBankAccount].[CurrencyCode], [DefaultBankAccount].[CurrencyCode]) != @NationalCurrencyCode THEN 'INT'
										ELSE 'UE'
									END
								ELSE
									'NAT'
							END as '@CurrencyContractType',
							[Project].[InvoiceExpirationPeriod] as '@InvoiceExpirationPeriod',
							[Project].[InvoiceExpirationPeriodType] as '@InvoiceExpirationPeriodType',
							[Project].[IsConsignor] as '@IsConsignor',
							[Project].[ConsignorID] as '@ConsignorID',
							CASE [Project].[ConsignorClass] WHEN @EmployeeClass THEN 'Employee' WHEN @CompanyClass THEN 'Company' ELSE 'None' END as '@ConsignorType',
							[BusinessCard].[FileAs] as '@Consignor',
							[Project].[ConsignorContract] as '@ConsignorContract'
						FROM
							[Project]
							LEFT OUTER JOIN [CostCenter]
								ON [CostCenter].[ID] = [Project].[CostCenterID]
							LEFT OUTER JOIN [Currency]
								ON [Currency].[Code] = [Project].[CurrencyCode]
							LEFT OUTER JOIN [Company]
								ON [Company].[ID] = [Project].[SupplierCompanyID]
							LEFT OUTER JOIN [BankAccount] [DefaultBankAccount]
								ON [DefaultBankAccount].[ID] = ISNULL([Company].[BankAccountID], -1)
							LEFT OUTER JOIN [BankAccount] [ContractBankAccount]
								ON [ContractBankAccount].[ID] = ISNULL([Project].[BankAccountID], -1)
							LEFT OUTER JOIN [BusinessCard]
								ON [BusinessCard].[Class] = [Project].[ConsignorClass] AND [BusinessCard].[ID] = [Project].[ConsignorID]
						WHERE [Project].[ID] = [Facture].[ProjectID]
						FOR XML PATH('Contract'), TYPE
						),
						---------------Bank account
						(
						SELECT
							[BankAccount].[ID] as '@BankAccountID',
							[BankAccount].[Account] as '@BankAccount',
							[BankAccount].[BankName] as '@Bank',
							[BankAccount].[City] as '@CityBank',
							[BankAccount].[IntermediaryAccount] as '@IntermediaryAccount',
							[BankAccount].[BankCode] as '@BankCode',
							[Currency].[Code] as '@CurrencyCode',
							[Currency].[NumericCode] as '@CurrencyNumericCode'
						FROM
							[Company]
							INNER JOIN [BankAccount]
								ON [Company].[BankAccountID] = [BankAccount].[ID]
							INNER JOIN [Currency]
								ON [BankAccount].[CurrencyCode] = [Currency].[Code]
						WHERE
							[Facture].[SupplierCompanyID] = [Company].[ID]
						 FOR XML PATH('BankAccount'), TYPE
						),
						---------------Customer Bank account
						(
						SELECT
							[BankAccount].[ID] as '@BankAccountID',
							[BankAccount].[Account] as '@BankAccount',
							[BankAccount].[BankName] as '@Bank',
							[BankAccount].[City] as '@CityBank',
							[BankAccount].[IntermediaryAccount] as '@IntermediaryAccount',
							[BankAccount].[BankCode] as '@BankCode',
							[Currency].[Code] as '@CurrencyCode',
							[Currency].[NumericCode] as '@CurrencyNumericCode'
						FROM
							[Company]
							INNER JOIN [BankAccount]
								ON [Company].[BankAccountID] = [BankAccount].[ID]
							INNER JOIN [Currency]
								ON [BankAccount].[CurrencyCode] = [Currency].[Code]
						WHERE
							[Facture].[CustomerCompanyID] = [Company].[ID]
						 FOR XML PATH('ConsigneeBankAccount'), TYPE
						),
						-------------Customer
						(
							SELECT	
								[Company].[ID] as '@ID',
								[Company].[FileAs]  as '@Name',
								dbo.fnPjm6GetLegalFormType([Company].[LegalCode], ISNULL([LegalAddress].[Country], '')) as '@LegalFormType',
								[Company].[LegalName]  as '@LegalName',
								dbo.fnPjm5AddressAsString([LegalAddress].[Street], [LegalAddress].[City],[LegalAddress].[Region],[LegalAddress].[PostalCode],[LegalAddress].[Country])  as '@LegalAddress',
								dbo.fnPjm5AddressAsString([PostalAddress].[Street], [PostalAddress].[City],[PostalAddress].[Region],[PostalAddress].[PostalCode],[PostalAddress].[Country]) as '@PostAddress',
								[BasicPhone].[Phone] as '@Phone',
								[Fax].[Phone] as '@Fax',
								[Company].[LegalCode]  as '@LegalCode',
								[Company].[KPP] as '@KPP'
							FROM
								[Company]
								LEFT OUTER JOIN [Address] as [LegalAddress]
									ON [LegalAddress].[BusinessCardID] = [Company].[ID] AND 
										[LegalAddress].[BusinessCardClass] = [Company].[Class] AND
										[LegalAddress].[AddressTypeID] = 1
								LEFT OUTER JOIN [Address] as [PostalAddress]
									ON [PostalAddress].[BusinessCardID] = [Company].[ID] AND 
										[PostalAddress].[BusinessCardClass] = [Company].[Class] AND
										[PostalAddress].[AddressTypeID] = 5
								LEFT OUTER JOIN [Phone] as [BasicPhone]
									ON [BasicPhone].[BusinessCardID] = [Company].[ID] AND 
										[BasicPhone].[BusinessCardClass] = [Company].[Class] AND
										[BasicPhone].[PhoneTypeID] = 11
								LEFT OUTER JOIN [Phone] as [Fax]
									ON [Fax].[BusinessCardID] = [Company].[ID] AND 
										[Fax].[BusinessCardClass] = [Company].[Class] AND
										[Fax].[PhoneTypeID] = 8 
							WHERE [Company].[ID] = [Facture].[CustomerCompanyID]
							FOR XML PATH('Customer'), TYPE
						),
						-------------Consignee
						(
							SELECT	
								[Company].[ID] as '@ID',
								[Company].[FileAs]  as '@Name',
								dbo.fnPjm6GetLegalFormType([Company].[LegalCode], ISNULL([LegalAddress].[Country], '')) as '@LegalFormType',
								[Company].[LegalName]  as '@LegalName',
								dbo.fnPjm5AddressAsString([LegalAddress].[Street], [LegalAddress].[City],[LegalAddress].[Region],[LegalAddress].[PostalCode],[LegalAddress].[Country])  as '@LegalAddress',
								dbo.fnPjm5AddressAsString([PostalAddress].[Street], [PostalAddress].[City],[PostalAddress].[Region],[PostalAddress].[PostalCode],[PostalAddress].[Country]) as '@PostAddress',
								[BasicPhone].[Phone] as '@Phone',
								[Fax].[Phone] as '@Fax',
								[Company].[LegalCode]  as '@LegalCode',
								[Company].[KPP] as '@KPP'
							FROM
								[Company]
								LEFT OUTER JOIN [Address] as [LegalAddress]
									ON [LegalAddress].[BusinessCardID] = [Company].[ID] AND 
										[LegalAddress].[BusinessCardClass] = [Company].[Class] AND
										[LegalAddress].[AddressTypeID] = 1
								LEFT OUTER JOIN [Address] as [PostalAddress]
									ON [PostalAddress].[BusinessCardID] = [Company].[ID] AND 
										[PostalAddress].[BusinessCardClass] = [Company].[Class] AND
										[PostalAddress].[AddressTypeID] = 5
								LEFT OUTER JOIN [Phone] as [BasicPhone]
									ON [BasicPhone].[BusinessCardID] = [Company].[ID] AND 
										[BasicPhone].[BusinessCardClass] = [Company].[Class] AND
										[BasicPhone].[PhoneTypeID] = 11
								LEFT OUTER JOIN [Phone] as [Fax]
									ON [Fax].[BusinessCardID] = [Company].[ID] AND 
										[Fax].[BusinessCardClass] = [Company].[Class] AND
										[Fax].[PhoneTypeID] = 8 
							WHERE [Company].[ID] = [Facture].[CustomerCompanyID]
							FOR XML PATH('Consignee'), TYPE
						),
						------------Facture Lines
						(
							SELECT
								[FactureLine].[ID] as '@ID',
								[ServiceType].[ID] as '@ServiceTypeID',
								[ServiceType].[FileAs] as '@ServiceType',
								[ServiceType].[Code] as '@ServiceTypeCode',
								[Service].[ID] as '@ServiceID',
								[Service].[FileAs] as '@Service',
								[Service].[Code] as '@ServiceCode',
								[FactureLine].[Amount] as '@Amount',
								[FactureLine].[VATRate] as '@VATRate',
								[UOM].[FileAs] '@UOM',
								CASE 
								WHEN [FactureLine].[VATIsIncluded] = 1 AND [FactureLine].[Amount] != 0
									THEN ([FactureLine].[Price] * [FactureLine].[Amount] - [FactureLine].[VAT]) / [FactureLine].[Amount]
								ELSE [FactureLine].[Price] 
								END  as '@Price',
								[FactureLine].[Amount] * 	
									CASE 
										WHEN [FactureLine].[VATIsIncluded] = 1 AND [FactureLine].[Amount] != 0
											THEN ([FactureLine].[Price] * [FactureLine].[Amount] - [FactureLine].[VAT]) / [FactureLine].[Amount]
										ELSE [FactureLine].[Price]
									END  as '@Total',
								CASE [Project].[FactureCurrency]
									WHEN 0 THEN [FactureLine].[ExcisePC]
									ELSE [FactureLine].[Excise]
									END as '@Excise',
								CASE 
									WHEN [FactureLine].[VATIsIncluded] = 0 AND [FactureLine].[Amount] != 0
										THEN ([FactureLine].[Price] * [FactureLine].[Amount] + [FactureLine].[VAT]) / [FactureLine].[Amount]
									ELSE [FactureLine].[Price]
								END  as '@PriceWithVAT',
								[FactureLine].[Amount] * 	
								CASE 
									WHEN [FactureLine].[VATIsIncluded] = 0 AND [FactureLine].[Amount] != 0
										THEN ([FactureLine].[Price] * [FactureLine].[Amount] + [FactureLine].[VAT]) / [FactureLine].[Amount]
									ELSE [FactureLine].[Price]
								END as '@TotalWithVAT',
								[FactureLine].[VAT] as '@VAT',
								[FactureLine].[Description] as '@Description',
								[FactureLine].[CustomDeclaration] as '@CustomDeclaration',
								[FactureLine].[Country] as '@ProducerCountry'
							FROM
								[FactureLine]
								INNER JOIN [Project]
									ON [Facture].[ProjectID] = [Project].[ID]
								LEFT OUTER JOIN [UOM]
									ON [UOM].[ID] = [FactureLine].[UOMID]
								LEFT OUTER JOIN [ServiceAssignment]
									ON [ServiceAssignment].[Class] = [FactureLine].[DocumentClass]
									AND [ServiceAssignment].[ID] = [FactureLine].[DocumentID]
								LEFT OUTER JOIN [Service]
									ON [Service].[ID] = [ServiceAssignment].[ServiceID]
								LEFT OUTER JOIN [ServiceType]
									ON [Service].[ServiceTypeID] = [ServiceType].[ID]
							WHERE
								[FactureLine].[FactureID] = [Facture].[ID]
							FOR XML PATH('FactureLine'), TYPE
						),
						---------------------Payments
						(
						SELECT
							[Payment].[ID] as '@ID',
							[Payment].[Number] as '@Number',
							[Payment].[IncomingNumber] as '@SysNum',
							[Payment].[Date] as '@Date',
							[Payment].[IncomingDate] as '@DatePorucheniya',
							[Payment].[Value] as '@Sum'
						FROM
							[Payment]
							INNER JOIN [FacturePayment]
								ON [FacturePayment].[FactureID] = [Facture].[ID] AND [FacturePayment].[PaymentID] = [Payment].[ID]
						FOR XML PATH('Payment'), TYPE
						) as 'Payments'
						--------------------------------
				FROM
					[Facture] 
					INNER JOIN [Project]
						ON [Project].[ID] = [Facture].[ProjectID]
							AND ([Facture].[Advance] = 0 OR @AdvanceFactureFlag = 1)
					INNER JOIN [Currency]
						ON [Currency].[Code] = [Facture].[CurrencyCode]
					INNER JOIN @FISPDistinct [FISP]
							ON [FISP].[DocumentID] = [Facture].[ID] AND [FISP].[DocumentClass] = @FactureClass
					LEFT OUTER JOIN @FactureStatement [FS]
						ON [Facture].ID = [FS].FactureID
					LEFT OUTER JOIN [Statement]
						ON ISNULL([FS].[StatementID], 0) = [Statement].[ID]
					WHERE
						@InvoiceOnly = 0 AND
						[Facture].[State] IN (2) AND
						([Facture].[SupplierCompanyID] = @SupplierID OR @SupplierID = 0 AND [Company].[Own] = 1) AND
						[Facture].[ID] NOT IN
						(
							SELECT
								[Facture].[ID]
							FROM
								[Facture]
								LEFT OUTER JOIN [FacturePayment]
									ON [Facture].[Advance] = 1 AND [FacturePayment].[FactureID] = [Facture].[ID]
							WHERE
								[Facture].[Advance] = 1
							GROUP BY
								[Facture].[ID]
							HAVING
								COUNT([FacturePayment].[FactureID]) <> 1
						)
					FOR XML PATH('Facture'), TYPE
				) as 'Factures',
				----------------------------Removed
				(
					SELECT
						(SELECT
							[RemovedDocument].[DocumentID] as '@DocumentID',
							[RemovedDocument].[DocumentNumber] as '@DocumentNumber',
							[RemovedDocument].[DocumentDate] as '@DocumentDate',
							[RemovedDocument].[Date] as '@Date'
						FROM
							@Del [RemovedDocument]
						WHERE
							[RemovedDocument].[DocumentClass] = @InvoiceClass AND [RemovedDocument].[SupplierID] = [Company].[ID] AND
							(
								[RemovedDocument].[Date] > @LastExportDate AND @DateTypeFlag = 0 OR
								[RemovedDocument].[DocumentDate] BETWEEN @StartDate AND @EndDate AND @DateTypeFlag = 1
							)
						FOR XML PATH('Invoice'), TYPE),
						(SELECT
							[RemovedDocument].[DocumentID] as '@DocumentID',
							[RemovedDocument].[DocumentNumber] as '@DocumentNumber',
							[RemovedDocument].[DocumentDate] as '@DocumentDate',
							[RemovedDocument].[Date] as '@Date'
						FROM
							@Del [RemovedDocument]
						WHERE
							[RemovedDocument].[DocumentClass] = @StatementClass AND [RemovedDocument].[SupplierID] = [Company].[ID] AND
							(
								[RemovedDocument].[Date] > @LastExportDate AND @DateTypeFlag = 0 OR
								[RemovedDocument].[DocumentDate] BETWEEN @StartDate AND @EndDate AND @DateTypeFlag = 1
							)
						FOR XML PATH('Statement'), TYPE),
						(SELECT
							[RemovedDocument].[DocumentID] as '@DocumentID',
							[RemovedDocument].[DocumentNumber] as '@DocumentNumber',
							[RemovedDocument].[DocumentDate] as '@DocumentDate',
							[RemovedDocument].[Date] as '@Date'
						FROM
							@Del [RemovedDocument]
						WHERE
							[RemovedDocument].[DocumentClass] = @FactureClass AND [RemovedDocument].[SupplierID] = [Company].[ID] AND
							(
								[RemovedDocument].[Date] > @LastExportDate AND @DateTypeFlag = 0 OR
								[RemovedDocument].[DocumentDate] BETWEEN @StartDate AND @EndDate AND @DateTypeFlag = 1
							)
						FOR XML PATH('Facture'), TYPE)
					FOR XML PATH(''),TYPE
				) as 'Removed'
			FROM
				[Company] 
				LEFT OUTER JOIN [Address] as [LegalAddress]
					ON [LegalAddress].[BusinessCardID] = [Company].[ID] AND 
						[LegalAddress].[BusinessCardClass] = [Company].[Class] AND
						[LegalAddress].[AddressTypeID] = 1
				LEFT OUTER JOIN [Address] as [PostalAddress]
					ON [PostalAddress].[BusinessCardID] = [Company].[ID] AND 
						[PostalAddress].[BusinessCardClass] = [Company].[Class] AND
						[PostalAddress].[AddressTypeID] = 5
				LEFT OUTER JOIN [Phone] as [BasicPhone]
					ON [BasicPhone].[BusinessCardID] = [Company].[ID] AND 
						[BasicPhone].[BusinessCardClass] = [Company].[Class] AND
						[BasicPhone].[PhoneTypeID] = 11
				LEFT OUTER JOIN [Phone] as [Fax]
					ON [Fax].[BusinessCardID] = [Company].[ID] AND 
						[Fax].[BusinessCardClass] = [Company].[Class] AND
						[Fax].[PhoneTypeID] = 8
			WHERE
				(
					(@SupplierID = 0  AND [Company].[Own] = 1) OR [Company].[ID] = @SupplierID
				)
			FOR XML PATH('Supplier'), TYPE
		) as 'Suppliers'
	FOR XML PATH('Documents')
	
	EXEC adfParameterGet 'LastExportDate', 'Pjm6', @Value = @Value OUTPUT
	SET @LastExportDate = CONVERT(datetime, @Value)
	
	IF @LastExportDate IS NULL AND @DateTypeFlag = 1
		SET @LastExportDate = CASE WHEN @EndDate > GETDATE() THEN GETDATE() ELSE @EndDate END
	IF @DateTypeFlag = 0
		SET @LastExportDate = GETDATE()
	
	DECLARE @ExportFinanceOnce TBool
	
	SELECT @ExportFinanceOnce = [ExportFinanceOnce] FROM [Company] WHERE [ID] = @SupplierID
	
	DECLARE
		@ExportType TIdentifier,
		@ExportItemID TIdentifier
	SET @ExportType = CASE @DateTypeFlag WHEN 0 THEN 2 ELSE 1 END
	EXEC pjm6CreateExportItem @SupplierID, @StartDate, @EndDate, @ExportType
	SET @ExportItemID = @@IDENTITY
		
	UPDATE
		[Facture]
	SET
		[Facture].[ExportItemID] = @ExportItemID,
		[Facture].[ExchangeBanned] = @ExportFinanceOnce 
	WHERE
		[Facture].[ID] IN (SELECT [DocumentID] FROM @FISP [FISP] WHERE [DocumentClass] = @FactureClass) AND
		[Facture].[State] IN (2)
		
	UPDATE
		[Invoice]
	SET
		[Invoice].[ExportItemID] = @ExportItemID,
		[Invoice].[ExchangeBanned] = @ExportFinanceOnce
	WHERE
		[Invoice].[ID] IN (SELECT [DocumentID] FROM @FISP [FISP] WHERE [DocumentClass] = @InvoiceClass) AND
		[Invoice].[State] IN (2, 5)
		
	UPDATE
		[Statement]
	SET
		[Statement].[ExportItemID] = @ExportItemID,
		[Statement].[ExchangeBanned] = @ExportFinanceOnce
	WHERE
		[Statement].[ID] IN (SELECT [DocumentID] FROM @FISP [FISP] WHERE [DocumentClass] = @StatementClass) AND
		[Statement].[State] IN (2, 3)
	
	EXEC adfParameterSet 'LastExportDate', 'Pjm6', @LastExportDate
	EXEC adfParameterSet 'LastExport', 'Pjm6', @LastExport
	
	RETURN 0
GO

GRANT EXEC ON Export1C TO PUBLIC
GO