IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderNotificationSettingsUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FolderNotificationSettingsUpdate'
		DROP PROCEDURE [dbo].[pjm5FolderNotificationSettingsUpdate]
	END
GO

PRINT 'Creating procedure pjm5FolderNotificationSettingsUpdate'
GO

/******************************************************************************
**		File: pjm5FolderNotificationSettingsUpdate.sql
**		Name: pjm5FolderNotificationSettingsUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FolderNotificationSettingsUpdate]
	@FolderID TIdentifier,
	@FolderSettings TBitMask,
	@CardSettings TBitMask,
	@FileSettings TBitMask,
	@ApplyToSubfolders	TBool
AS
	SET NOCOUNT ON
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()

	BEGIN TRANSACTION
	DELETE
		[FolderNotificationSettings]
	WHERE
		[FolderID] = @FolderID AND
		[TrusteeID] = @UserID
	IF @@error != 0	
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [FolderNotificationSettings] 
		([FolderID], [TrusteeID], [FolderSettings], [CardSettings], [FileSettings])
	VALUES 
		(@FolderID, @UserID, @FolderSettings, @CardSettings, @FileSettings)
	IF @@error != 0	
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF @ApplyToSubfolders = 1
	BEGIN
		;WITH [Folders] ([FolderID], [ID], [Level]) AS
		(
			SELECT [FolderID], [ID], 0 FROM [Folder] WHERE [FolderID] = @FolderID
			UNION ALL
			SELECT [Folder].[FolderID], [Folder].[ID], [Folders].[Level] + 1
			FROM
				[Folder]
				INNER JOIN [Folders]
					ON [Folders].[ID] = [Folder].[FolderID]
		)
		DELETE 
			[FolderNotificationSettings] 
		FROM 
			[FolderNotificationSettings]
			INNER JOIN [Folders]
				ON [Folders].[ID] = [FolderNotificationSettings].[FolderID]
				
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		;WITH [Folders] ([FolderID], [ID], [Level]) AS
		(
			SELECT [FolderID], [ID], 0 FROM [Folder] WHERE [FolderID] = @FolderID
			UNION ALL
			SELECT @FolderID, [Folder].[ID], [Folders].[Level] + 1
			FROM
				[Folder]
				INNER JOIN [Folders]
					ON [Folders].[ID] = [Folder].[FolderID]
		)
		INSERT INTO [FolderNotificationSettings] ([FolderID], [TrusteeID], [FolderSettings], [CardSettings], [FileSettings])
		SELECT
			[Folders].[ID], [FolderNotificationSettings].[TrusteeID], [FolderNotificationSettings].[FolderSettings], [FolderNotificationSettings].[CardSettings], [FolderNotificationSettings].[FileSettings] 
		FROM 
			[Folders]
			INNER JOIN [FolderNotificationSettings]
				ON [FolderNotificationSettings].[FolderID] = [Folders].[FolderID]
				
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON [pjm5FolderNotificationSettingsUpdate] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderNotificationSettingsGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FolderNotificationSettingsGet'
		DROP PROCEDURE [dbo].[pjm5FolderNotificationSettingsGet]
	END
GO

PRINT 'Creating procedure pjm5FolderNotificationSettingsGet'
GO

/******************************************************************************
**		File: pjm5FolderNotificationSettingsGet.sql
**		Name: pjm5FolderNotificationSettingsGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FolderNotificationSettingsGet]
	@FolderID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()

	SELECT
		[FolderID], 
		[TrusteeID], 
		[FolderSettings], 
		[CardSettings], 
		[FileSettings]
	FROM
		[FolderNotificationSettings]
	WHERE
		[FolderID] = @FolderID AND
		[TrusteeID] = @UserID

	RETURN 0
GO

GRANT EXECUTE ON [pjm5FolderNotificationSettingsGet] TO PUBLIC
GO
