IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'pjm6PaymentCheckExistanse')
	BEGIN
		PRINT 'Dropping Procedure pjm6PaymentCheckExistanse'
		DROP  Procedure  pjm6PaymentCheckExistanse
	END

GO

PRINT 'Creating Procedure pjm6PaymentCheckExistanse'
GO
/******************************************************************************
**		File: pjm6PaymentCheckExistanse.sql
**		Name: pjm6PaymentCheckExistanse
**		Desc: return details about payment (For Data Exchange Systems)
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		17.06.10	SPV				first version
**    
*******************************************************************************/
CREATE PROCEDURE pjm6PaymentCheckExistanse @Number TName, @Date TDate
AS
	SET NOCOUNT ON
	
	SELECT
		[Payment].[Value] as [Sum],
		[Company].[FileAs] as [Payer],
		[Payment].[PayerCompanyID],
		[Payment].[ID] as [PaymentID],
		[Payment].[State] 
	FROM
		[Payment]
		INNER JOIN [Company]
			ON [Company].[ID] = [Payment].[PayerCompanyID]
	WHERE
		[Payment].[Number] = @Number AND
		[Payment].[Date] = @Date AND
		[Payment].[State] IN (2, 3, 4)
GO

GRANT EXEC ON pjm6PaymentCheckExistanse TO PUBLIC
GO