IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6PaymentLineAppendByImport]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6PaymentLineAppendByImport'
		DROP PROCEDURE [dbo].[pjm6PaymentLineAppendByImport]
	END
GO

PRINT 'Creating procedure pjm6PaymentLineAppendByImport'
GO

/******************************************************************************
**		File: pjm6PaymentLineAppendByImport.sql
**		Name: pjm6PaymentLineAppendByImport
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 01/21/2005 17:11:09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6PaymentLineAppendByImport]
	@PaymentID TIdentifier,
	@InvoiceID TIdentifier,
	@PaymentValue TMoney,
	@PaymentVAT TMoney
AS
	SET NOCOUNT ON
	DECLARE
		@Value TMoney,
		@VAT TMoney,
		@InvoiceValue TMoney,
		@InvoiceVAT TMoney,
		@ProjectCurrencyCode TCode3,
		@PaymentCurrencyCode TCode3,
		@InvoiceCurrencyRate TMoney,
		@CurrencyRate TMoney,
		@InvoicePaymentCurrencyPoint TIdentifier,
		@rv int,
		@PValue TMoney,
		@PLinesValue TMoney,
		@PaymentDate TDate
		
	SELECT
		@InvoiceCurrencyRate = [Invoice].[CurrencyRate], -- CurrencyRate   
		@InvoicePaymentCurrencyPoint = [Invoice].[PaymentCurrencyPoint],
		@ProjectCurrencyCode = [Project].[CurrencyCode]
	FROM
		[Invoice]
		INNER JOIN [Project]
			ON [Project].[ID] = [Invoice].[ProjectID]
	WHERE
		[Invoice].[ID] = @InvoiceID

	SELECT @PaymentDate = [Date], @PaymentCurrencyCode = [CurrencyCode] FROM [Payment] WHERE [Payment].[ID] = @PaymentID

	
	SET @CurrencyRate = CASE @InvoicePaymentCurrencyPoint WHEN 1 THEN @InvoiceCurrencyRate ELSE
		dbo.fnCurrencyGetExactRate(@ProjectCurrencyCode, @PaymentCurrencyCode, @PaymentDate) END

	IF @CurrencyRate IS NULL
		RETURN

	IF @CurrencyRate < 0
		SET @CurrencyRate = @CurrencyRate
	
	SELECT
		@Value = CASE WHEN @CurrencyRate <= 0 THEN -1.0 * @PaymentValue * @CurrencyRate ELSE @PaymentValue / @CurrencyRate END,
		@VAT =  CASE WHEN @CurrencyRate <= 0 THEN -1.0 * @PaymentVAT * @CurrencyRate ELSE @PaymentVAT / @CurrencyRate END

	BEGIN TRANSACTION
	
	INSERT INTO [PaymentDetail]
	(
		[PaymentID],
		[InvoiceID],
		[PaymentValue],
		[PaymentVAT],
		[CurrencyRate],
		[Value],
		[VAT],
		[Description]
	)
	VALUES
	(
		@PaymentID,
		@InvoiceID,
		@PaymentValue,
		@PaymentVAT,
		@CurrencyRate,
		@Value,
		@VAT,
		''
	)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	
	SELECT
		@PLinesValue = SUM([PaymentDetail].[PaymentValue]),
		@PValue = [Payment].[Value]
	FROM
		[PaymentDetail]
		INNER JOIN [Payment]
			ON [PaymentDetail].[PaymentID] = [Payment].[ID]
	WHERE
		[PaymentDetail].[PaymentID] = @PaymentID AND
		[Payment].[State] = 2
	GROUP BY
		[Payment].[ID],
		[Payment].[Value],
		[Payment].[State]
	
		
	IF ROUND(@PLinesValue, 2) = ROUND(@PValue, 2)		
	BEGIN
		EXEC @rv = dbo.adfPaymentChangeState @PaymentID, 3
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm6PaymentLineAppendByImport TO PUBLIC
GO
 