 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BindInvoiceAndStatement]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BindInvoiceAndStatement'
		DROP PROCEDURE [dbo].[pjm6BindInvoiceAndStatement]
	END
GO

PRINT 'Creating procedure pjm6BindInvoiceAndStatement'
GO

/******************************************************************************
**		File: pjm6BindInvoiceAndStatement.sql
**		Name: pjm6BindInvoiceAndStatement
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.svintsov
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6BindInvoiceAndStatement]
	@InvoiceID TIdentifier,
	@StatementID TIdentifier,
	@CalculationID TIdentifier
AS
	DECLARE
		@StatementClass TClass,
		@InvoiceClass TClass,
		@CalculationClass TClass
	
	SELECT
		@StatementClass = dbo.adfGetClassByName('Pjm5.Statement'),
		@InvoiceClass = dbo.adfGetClassByName('Pjm5.Invoice'),
		@CalculationClass = dbo.adfGetClassByName('Pjm5.Calculation')
	
	IF (@InvoiceID IS NULL AND @StatementID IS NOT NULL AND @CalculationID IS NOT NULL)
	BEGIN
		SELECT
			@InvoiceID = [LinkDocumentID]
		FROM
			[Attachment]
		WHERE
			[LinkDocumentClass] = @InvoiceClass AND
			[DocumentClass] = @CalculationClass AND
			[DocumentID] = @CalculationID
			
	END
	ELSE IF (@InvoiceID IS NOT NULL AND @StatementID IS NULL AND @CalculationID IS NOT NULL)
	BEGIN
		SELECT
			@StatementID = [LinkDocumentID]
		FROM
			[Attachment]
		WHERE
			[LinkDocumentClass] = @StatementClass AND
			[DocumentClass] = @CalculationClass AND
			[DocumentID] = @CalculationID
	END
	ELSE
	BEGIN
		RETURN
	END

	DECLARE @Advance TBool
	SELECT @Advance = [Advance] FROM [Invoice] WHERE [ID] = @InvoiceID

		
	
	IF @StatementID IS NOT NULL AND @InvoiceID IS NOT NULL AND @Advance = 0 AND
		NOT EXISTS (
			SELECT [DocumentID] FROM [Attachment]
			WHERE [DocumentClass] = @InvoiceClass AND [LinkDocumentClass]= @StatementClass AND [DocumentID] = @InvoiceID AND [LinkDocumentID] = @StatementID
		)
	BEGIN
		INSERT INTO [Attachment] ([DocumentClass], [DocumentID], [Name], [LinkDocumentClass], [LinkDocumentID], [AttachmentTypeID]) VALUES
		(@InvoiceClass, @InvoiceID, '', @StatementClass, @StatementID, 2)

		INSERT INTO [Attachment] ([DocumentClass], [DocumentID], [Name], [LinkDocumentClass], [LinkDocumentID], [AttachmentTypeID]) VALUES
		(@StatementClass, @StatementID, '', @InvoiceClass, @InvoiceID, 2)
	END

	RETURN 0

GO

GRANT EXECUTE ON [pjm6BindInvoiceAndStatement] TO PUBLIC
GO

