IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceBrowseDraft]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5InvoiceBrowseDraft'
		DROP PROCEDURE [dbo].[pjm5InvoiceBrowseDraft]
	END
GO

PRINT 'Creating procedure pjm5InvoiceBrowseDraft'
GO

/******************************************************************************
**		File: pjm5InvoiceBrowseDraft.sql
**		Name: pjm5InvoiceBrowseDraft
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5InvoiceBrowseDraft]
AS
	SET NOCOUNT ON
	DECLARE
		@EmployeeID TIdentifier,
		@ViewAllProjects TBool,
		@BaseCurrencyCode TCode3,
		@value TVariant

	EXEC adfParameterGet @Name='BaseCurrency', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @BaseCurrencyCode = CAST(@value as varchar(3))
	SELECT 
		@ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')),
		@EmployeeID = dbo.adfGetCurrentEmployeeID()
		
	SELECT
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[State],
		[Invoice].[Flag],
		[WarningFlag].[WarningType],
		[Invoice].[Date],
		[Invoice].[Number],
		[Invoice].[FileAs],
		[Invoice].[ProjectID],
		[Project].[ProjectManagerEmployeeID],
		[Invoice].[CurrencyCode],
		[Invoice].[CurrencyRate],
		[Invoice].[BaseCurrencyRate],
		[Invoice].[SupplierCompanyID],
		[Invoice].[SupplierBankAccountID],
		[Invoice].[CustomerCompanyID],
		[Invoice].[Advance],
		[Invoice].[Total],
		[Invoice].[VAT],
		[Invoice].[TotalWithVAT],
		[Invoice].[TotalWithVATPC] AS [ProjectTotal],
		[Project].[CurrencyCode] AS [ProjectCurrencyCode],
		[Invoice].[TotalWithVATBC] AS [BaseTotal],
		@BaseCurrencyCode AS [BaseCurrencyCode],
		[Invoice].[Comments],
		[Invoice].[Created],
		[Invoice].[CreatedBy],
		[Invoice].[Modified],
		[Invoice].[ModifiedBy],
		[Invoice].[Timestamp],
		[Project].[CostCenterID],
		[Company].[ManagerEmployeeID],
		[Invoice].[ExchangeBanned]
	FROM
		[Invoice]
		INNER JOIN [Project]
			ON [Project].[ID] = [Invoice].[ProjectID]
		LEFT OUTER JOIN [Company]
			ON [Project].[CustomerCompanyID] = [Company].[ID]
		LEFT OUTER JOIN [WarningFlag]
			ON ([Invoice].[WarningFlagID] = [WarningFlag].[ID])
	WHERE
		[Invoice].[State] = 1 AND
		(dbo.fnPjm5HasFinansDataAccess([Project].[ID], @EmployeeID, NULL, NULL) = 1)
	RETURN 0
GO

GRANT EXECUTE ON [pjm5InvoiceBrowseDraft] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5InvoiceBrowse'
		DROP PROCEDURE [dbo].[pjm5InvoiceBrowse]
	END
GO

PRINT 'Creating procedure pjm5InvoiceBrowse'
GO

/******************************************************************************
**		File: pjm5InvoiceBrowse.sql
**		Name: pjm5InvoiceBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5InvoiceBrowse]
	@StateSelector INT,
	@DateSelector INT,
	@PeriodStart TDate,
	@PeriodEnd TDate
AS
	SET NOCOUNT ON
	DECLARE
		@EmployeeID TIdentifier,
		@ViewAllProjects TBool,
		@BaseCurrencyCode TCode3,
		@value TVariant,
		@today TDateTime

	EXEC adfParameterGet @Name='BaseCurrency', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @BaseCurrencyCode = CAST(@value as varchar(3))
	SELECT 
		@ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')),
		@EmployeeID = dbo.adfGetCurrentEmployeeID(),
		@today = GETDATE()
	
	IF @DateSelector != 0
		EXEC BillingFilterPeriodGet @DateSelector, @PeriodStart OUTPUT, @PeriodEnd OUTPUT
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	;
	WITH [AdvanceInvoices] ([InvoiceID], [AdvanceValue]) AS
	(
		SELECT
			[AdvanceInvoice].[InvoiceID],
			SUM([Invoice].[TotalWithVAT])
		FROM
			[AdvanceInvoice]
			INNER JOIN [Invoice]
				ON [AdvanceInvoice].[AdvanceInvoiceID] = [Invoice].[ID]
		GROUP BY
			[AdvanceInvoice].[InvoiceID]
	)
	SELECT
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[State],
		[Invoice].[Flag],
		[WarningFlag].[WarningType],
		[Invoice].[Date],
		[Invoice].[Number],
		[Invoice].[FileAs],
		[Invoice].[ProjectID],
		[Project].[ProjectManagerEmployeeID],
		[Invoice].[CurrencyCode],
		[Invoice].[CurrencyRate],
		[Invoice].[BaseCurrencyRate],
		[Invoice].[SupplierCompanyID],
		[Invoice].[SupplierBankAccountID],
		[Invoice].[CustomerCompanyID],
		[Invoice].[Advance],
		[Invoice].[Total],
		[Invoice].[VAT],
		[Invoice].[TotalWithVAT],
		[Invoice].[TotalWithVATPC] AS [ProjectTotal],
		[Project].[CurrencyCode] AS [ProjectCurrencyCode],
		[Invoice].[TotalWithVATBC] AS [BaseTotal],
		@BaseCurrencyCode AS [BaseCurrencyCode],
		[Invoice].[DueDate],
		CASE
			WHEN @Lang = 'en' THEN
				CASE
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 90 THEN 'more than 90 days overdue'
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 60 THEN '61-90 days overdue'
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 30 THEN '31-60 days overdue'
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 0 THEN '1-30 days overdue'
					ELSE ' waiting'
				END
			ELSE
				CASE
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 90 THEN ' 90  '
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 60 THEN '61-90  '
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 30 THEN '31-60  '
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 0 THEN '1-30  '
					ELSE ' '
				END
		END AS [OverDue],
		ISNULL([pjm5vwInvoicePayment].[PaymentValue], 0) AS [PaymentValue],
		[Invoice].[TotalWithVAT] - 
			ISNULL([pjm5vwInvoicePayment].[PaymentValue], 0) -
			ISNULL([AdvanceInvoices].[AdvanceValue], 0) AS [RemainValue],
		[Invoice].[Comments],
		[Invoice].[Created],
		[Invoice].[CreatedBy],
		[Invoice].[Modified],
		[Invoice].[ModifiedBy],
		[Invoice].[Timestamp],
		[Project].[CostCenterID],
		[Company].[ManagerEmployeeID],
		[Invoice].[ExchangeBanned]
	FROM
		[Invoice]
		INNER JOIN [Project]
			ON [Project].[ID] = [Invoice].[ProjectID]
		LEFT OUTER JOIN [Company]
			ON [Project].[CustomerCompanyID] = [Company].[ID]
		LEFT OUTER JOIN [pjm5vwInvoicePayment]
			ON [pjm5vwInvoicePayment].[InvoiceID] = [Invoice].[ID]
		LEFT OUTER JOIN [AdvanceInvoices]
			ON [AdvanceInvoices].[InvoiceID] = [Invoice].[ID]
		LEFT OUTER JOIN [WarningFlag]
			ON ([Invoice].[WarningFlagID] = [WarningFlag].[ID])
	WHERE
		(@DateSelector = 0 OR [Invoice].[Date] BETWEEN @PeriodStart AND @PeriodEnd) AND
		(
			@StateSelector = 0 OR 
			@StateSelector = 7 AND [Invoice].[State] != 3 OR
			@StateSelector = 1 AND [Invoice].[State] = 1 OR
			@StateSelector = 2 AND [Invoice].[State] = 2 OR
			@StateSelector = 3 AND [Invoice].[State] = 5 OR
			@StateSelector = 4 AND [Invoice].[State] = 3 OR
			@StateSelector = 5 AND [Invoice].[State] = 7 OR
			@StateSelector = 6 AND [Invoice].[State] = 6
		) AND
		(dbo.fnPjm5HasFinansDataAccess([Project].[ID], @EmployeeID, NULL, NULL) = 1)

	RETURN 0
GO

GRANT EXECUTE ON [pjm5InvoiceBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceBrowsePlan]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5InvoiceBrowsePlan'
		DROP PROCEDURE [dbo].[pjm5InvoiceBrowsePlan]
	END
GO

PRINT 'Creating procedure pjm5InvoiceBrowsePlan'
GO

/******************************************************************************
**		File: pjm5InvoiceBrowsePlan.sql
**		Name: pjm5InvoiceBrowsePlan
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		25.06.13	SAP				  "" --> " "
*******************************************************************************/
CREATE PROCEDURE [pjm5InvoiceBrowsePlan]
	@DateSelector INT,
	@PeriodEnd TDate
AS
	SET NOCOUNT ON
	DECLARE
		@PeriodStart TDate,
		@EmployeeID TIdentifier,
		@ViewAllProjects TBool,
		@BaseCurrencyCode TCode3,
		@value TVariant,
		@today TDateTime

	EXEC adfParameterGet @Name='BaseCurrency', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @BaseCurrencyCode = CAST(@value as varchar(3))
	SELECT 
		@ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')),
		@EmployeeID = dbo.adfGetCurrentEmployeeID(),
		@today = GETDATE()
		
	DECLARE @Date TDate
	SET @Date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS DATETIME)
	
	IF @DateSelector = 1 -- next 3 month
		SELECT
			@PeriodStart = DATEADD(month, 1, DATEADD(day, 1 - DATEPART(day, @Date), @Date)),
			@PeriodEnd = DATEADD(day, -1, DATEADD(month, 3, @PeriodStart))
	IF @DateSelector = 2
		SELECT			
			@PeriodEnd = CAST(CONVERT(varchar(8), @PeriodEnd, 112) AS datetime)
		
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[State],
		[Invoice].[Flag],
		[WarningFlag].[WarningType],
		[Invoice].[Date],
		[Invoice].[Number],
		[Invoice].[FileAs],
		[Invoice].[ProjectID],
		[Project].[ProjectManagerEmployeeID],
		[Invoice].[CurrencyCode],
		[Invoice].[CurrencyRate],
		[Invoice].[BaseCurrencyRate],
		[Invoice].[SupplierCompanyID],
		[Invoice].[SupplierBankAccountID],
		[Invoice].[CustomerCompanyID],
		[Invoice].[Advance],
		[Invoice].[Total],
		[Invoice].[VAT],
		[Invoice].[TotalWithVAT],
		[Invoice].[TotalWithVATPC] AS [ProjectTotal],
		[Project].[CurrencyCode] AS [ProjectCurrencyCode],
		[Invoice].[TotalWithVATBC] AS [BaseTotal],
		@BaseCurrencyCode AS [BaseCurrencyCode],
		[Invoice].[DueDate],
		CASE
			WHEN @Lang = 'en' THEN
				CASE
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 60 THEN '> 60 days overdue'
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 30 THEN '> 30 days overdue'
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 15 THEN '> 15 days overdue'
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 0 THEN 'overdue'
					ELSE ' waiting'
				END
			ELSE
				CASE
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 60 THEN '> 60  '
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 30 THEN '> 30  '
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 15 THEN '> 15  '
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 0 THEN ''
					ELSE ''
				END
		END AS [OverDue],
		[Invoice].[Comments],
		[Invoice].[Created],
		[Invoice].[CreatedBy],
		[Invoice].[Modified],
		[Invoice].[ModifiedBy],
		[Invoice].[Timestamp],
		[Project].[CostCenterID],
		[Company].[ManagerEmployeeID],
		[Invoice].[ExchangeBanned]
	FROM
		[Invoice]
		INNER JOIN [Project]
			ON [Project].[ID] = [Invoice].[ProjectID]
		LEFT OUTER JOIN [Company]
			ON [Project].[CustomerCompanyID] = [Company].[ID]
		LEFT OUTER JOIN [WarningFlag]
			ON ([Invoice].[WarningFlagID] = [WarningFlag].[ID])
	WHERE
		(@DateSelector = 0 OR [Invoice].[Date] <= @PeriodEnd) AND
		[Invoice].[State] = 6 AND
		(dbo.fnPjm5HasFinansDataAccess([Project].[ID], @EmployeeID, NULL, NULL) = 1)

	RETURN 0
GO

GRANT EXECUTE ON [pjm5InvoiceBrowsePlan] TO PUBLIC
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6InvoiceBrowseWithoutShipment]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6InvoiceBrowseWithoutShipment'
		DROP PROCEDURE [dbo].[pjm6InvoiceBrowseWithoutShipment]
	END
GO

PRINT 'Creating procedure pjm6InvoiceBrowseWithoutShipment'
GO

/******************************************************************************
**		File: pjm6InvoiceBrowseWithoutShipment.sql
**		Name: pjm6InvoiceBrowseWithoutShipment
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.svintsov
**		Date: 10/02/2010 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		12.02.10	SPV				 
**		16.08.13	SAP				      ""
*******************************************************************************/
CREATE PROCEDURE [pjm6InvoiceBrowseWithoutShipment]
AS
	SET NOCOUNT ON
	
	DECLARE
		@EmployeeID TIdentifier,
		@ViewAllProjects TBool,
		@BaseCurrencyCode TCode3,
		@value TVariant,
		@today TDateTime,
		@sortWaitingPeriod Char /*     */
		

	EXEC adfParameterGet @Name='BaseCurrency', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @BaseCurrencyCode = CAST(@value as varchar(3))
	SELECT 
		@ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')),
		@EmployeeID = dbo.adfGetCurrentEmployeeID(),
		@today = GETDATE()
		
	DECLARE @Date TDate
	SET @Date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS DATETIME)
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	
	DECLARE @InvoicePayments TABLE
	(
		[InvoiceID] TIdentifier,
		[Total] TMoney,
		[LastPaymentDate] TDate
	)
	
	DECLARE @InvoiceStatements TABLE
	(
		[InvoiceID] TIdentifier,
		[Total] TMoney
	)
	
	INSERT INTO @InvoicePayments
	SELECT
		[Invoice].[ID],
		ISNULL(SUM([PaymentDetail].[PaymentValue]), 0),
		MAX([Payment].[Date])
	FROM
		[Invoice]
		INNER JOIN [Project]
			ON [Project].[ID] = [Invoice].[ProjectID]
		INNER JOIN [PaymentDetail]
			ON [PaymentDetail].[InvoiceID] = [Invoice].[ID]
		INNER JOIN [Payment]
			ON [PaymentDetail].[PaymentID] = [Payment].[ID]
	WHERE
		[Invoice].[Advance] = 1 AND
		(dbo.fnPjm5HasFinansDataAccess([Project].[ID], @EmployeeID, NULL, NULL) = 1)
	GROUP BY
		[Invoice].[ID]
	
		
	INSERT INTO @InvoiceStatements
	SELECT
		[TEMP].[InvoiceID],
		SUM([TEMP].[Value])
	FROM
		(
			SELECT
				[InvoicePayments].[InvoiceID] as [InvoiceID],
				ISNULL([StatementAdvanceInvoice].[StatementPaymentValue], 0) *
					CASE WHEN [Statement].[State] IN (1, 2, 3) THEN 1 ELSE 0 END as [Value]
			FROM
				@InvoicePayments [InvoicePayments]
				LEFT OUTER JOIN [StatementAdvanceInvoice]
					ON [StatementAdvanceInvoice].[AdvanceInvoiceID] = [InvoicePayments].[InvoiceID]
				LEFT OUTER JOIN [Statement]
					ON [Statement].[ID] = [StatementAdvanceInvoice].[StatementID]
		) as [Temp]
	GROUP BY
		[TEMP].[InvoiceID]
	
		
	SELECT
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[State],
		[Invoice].[Flag],
		[WarningFlag].[WarningType],
		[Invoice].[Date],
		[Invoice].[Number],
		[Invoice].[FileAs],
		[Invoice].[ProjectID],
		[Project].[ProjectManagerEmployeeID],
		[Invoice].[CurrencyCode],
		[Invoice].[CurrencyRate],
		[Invoice].[BaseCurrencyRate],
		[Invoice].[SupplierCompanyID],
		[Invoice].[SupplierBankAccountID],
		[Invoice].[CustomerCompanyID],
		[Invoice].[Advance],
		[Invoice].[Total],
		[Invoice].[VAT],
		[Invoice].[TotalWithVAT],
		[Invoice].[TotalWithVATPC] AS [ProjectTotal],
		[Project].[CurrencyCode] AS [ProjectCurrencyCode],
		[Invoice].[TotalWithVATBC] AS [BaseTotal],
		@BaseCurrencyCode AS [BaseCurrencyCode],
		[Invoice].[Comments],
		[Invoice].[Created],
		[Invoice].[CreatedBy],
		[Invoice].[Modified],
		[Invoice].[ModifiedBy],
		[Invoice].[Timestamp],
		[Project].[CostCenterID],
		[Company].[ManagerEmployeeID],
		[InvoiceStatements].[Total] as [StatementsTotal],
		[InvoicePayments].[Total] as [PaymentValue],
		([Invoice].[TotalWithVAT] - [InvoiceStatements].[Total]) as [InvoiceNotCovered],
		([Invoice].[TotalWithVAT] - [InvoicePayments].[Total]) as [RemainValue],
		([InvoicePayments].[Total] - [InvoiceStatements].[Total]) as [PaymentNotCovered],
		--@sortWaitingPeriod AS [SortWaitingPeriod],
		CASE
			WHEN @Lang = 'en' THEN
				CASE
					WHEN DATEDIFF(day, [InvoicePayments].[LastPaymentDate], @today) > 90 THEN 'more than 90 days'
					WHEN DATEDIFF(day, [InvoicePayments].[LastPaymentDate], @today) > 60 THEN 'more 61 to 90 days'
					WHEN DATEDIFF(day, [InvoicePayments].[LastPaymentDate], @today) > 30 THEN 'more 31 to 60 days'
					ELSE 'until 30 days'
				END
			ELSE
				CASE
					WHEN DATEDIFF(day, [InvoicePayments].[LastPaymentDate], @today) > 90 THEN ' 90 '
					WHEN DATEDIFF(day, [InvoicePayments].[LastPaymentDate], @today) > 60 THEN ' 61  90 '
					WHEN DATEDIFF(day, [InvoicePayments].[LastPaymentDate], @today) > 30 THEN ' 31  60 '
					ELSE ' 30 '
				END
		END AS [WaitingPeriod],
		CASE
			WHEN DATEDIFF(day, [InvoicePayments].[LastPaymentDate], @today) > 90 THEN '4'
			WHEN DATEDIFF(day, [InvoicePayments].[LastPaymentDate], @today) > 60 THEN '3'
			WHEN DATEDIFF(day, [InvoicePayments].[LastPaymentDate], @today) > 30 THEN '2'
			ELSE '1'
		END AS [SortWaitingPeriod],
		[Invoice].[ExchangeBanned]
	FROM
		[Invoice]
		INNER JOIN [Project]
			ON [Project].[ID] = [Invoice].[ProjectID]
		INNER JOIN [Company]
			ON [Company].[ID] = [Project].[CustomerCompanyID]
		INNER JOIN @InvoicePayments [InvoicePayments]
			ON [Invoice].[ID] = [InvoicePayments].[InvoiceID]
		INNER JOIN @InvoiceStatements [InvoiceStatements]
			ON [Invoice].[ID] = [InvoiceStatements].[InvoiceID]
		LEFT OUTER JOIN [WarningFlag]
			ON ([Invoice].[WarningFlagID] = [WarningFlag].[ID])
	WHERE
		[Invoice].[State] NOT IN (3, 7) AND
		[InvoiceStatements].[Total] + 0.01 < [Invoice].[TotalWithVAT]
	ORDER BY 
		[SortWaitingPeriod]

	RETURN 0
GO

GRANT EXECUTE ON [pjm6InvoiceBrowseWithoutShipment] TO PUBLIC
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6InvoiceBrowseBadDebt]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6InvoiceBrowseBadDebt'
		DROP PROCEDURE [dbo].[pjm6InvoiceBrowseBadDebt]
	END
GO

PRINT 'Creating procedure pjm6InvoiceBrowseBadDebt'
GO

/******************************************************************************
**		File: pjm6InvoiceBrowseBadDebt.sql
**		Name: pjm6InvoiceBrowseBadDebt
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vadim.baranovskiy
**		Date: 01/21/2005 15:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6InvoiceBrowseBadDebt]

AS
	SET NOCOUNT ON
	DECLARE
		@EmployeeID TIdentifier,
		@ViewAllProjects TBool,
		@BaseCurrencyCode TCode3,
		@value TVariant,
		@today TDateTime

	EXEC adfParameterGet @Name='BaseCurrency', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @BaseCurrencyCode = CAST(@value as varchar(3))
	SELECT 
		@ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')),
		@EmployeeID = dbo.adfGetCurrentEmployeeID(),
		@today = GETDATE()
	
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	;
	WITH [AdvanceInvoices] ([InvoiceID], [AdvanceValue]) AS
	(
		SELECT
			[AdvanceInvoice].[InvoiceID],
			SUM([Invoice].[TotalWithVAT])
		FROM
			[AdvanceInvoice]
			INNER JOIN [Invoice]
				ON [AdvanceInvoice].[AdvanceInvoiceID] = [Invoice].[ID]
		GROUP BY
			[AdvanceInvoice].[InvoiceID]
	)
	SELECT
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[State],
		[Invoice].[Flag],
		[WarningFlag].[WarningType],
		[Invoice].[Date],
		[Invoice].[Number],
		[Invoice].[FileAs],
		[Invoice].[ProjectID],
		[Project].[ProjectManagerEmployeeID],
		[Invoice].[CurrencyCode],
		[Invoice].[CurrencyRate],
		[Invoice].[BaseCurrencyRate],
		[Invoice].[SupplierCompanyID],
		[Invoice].[SupplierBankAccountID],
		[Invoice].[CustomerCompanyID],
		[Invoice].[Advance],
		[Invoice].[Total],
		[Invoice].[VAT],
		[Invoice].[TotalWithVAT],
		[Invoice].[TotalWithVATPC] AS [ProjectTotal],
		[Project].[CurrencyCode] AS [ProjectCurrencyCode],
		[Invoice].[TotalWithVATBC] AS [BaseTotal],
		@BaseCurrencyCode AS [BaseCurrencyCode],
		[Invoice].[DueDate],
		CASE
			WHEN @Lang = 'en' THEN
				CASE
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 90 THEN 'more than 90 days overdue'
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 60 THEN '61-90 days overdue'
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 30 THEN '31-60 days overdue'
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 0 THEN '1-30 days overdue'
					ELSE ' waiting'
				END
			ELSE
				CASE
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 90 THEN ' 90  '
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 60 THEN '61-90  '
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 30 THEN '31-60  '
					WHEN DATEDIFF(day, [Invoice].[DueDate], @today) > 0 THEN '1-30  '
					ELSE ' '
				END
		END AS [OverDue],
		ISNULL([pjm5vwInvoicePayment].[PaymentValue], 0) AS [PaymentValue],
		[Invoice].[TotalWithVAT] - 
			ISNULL([pjm5vwInvoicePayment].[PaymentValue], 0) -
			ISNULL([AdvanceInvoices].[AdvanceValue], 0) AS [RemainValue],
		[Invoice].[Comments],
		[Invoice].[Created],
		[Invoice].[CreatedBy],
		[Invoice].[Modified],
		[Invoice].[ModifiedBy],
		[Invoice].[Timestamp],
		[Project].[CostCenterID],
		[Company].[ManagerEmployeeID],
		[Invoice].[ExchangeBanned]
	FROM
		[Invoice]
		INNER JOIN [Project]
			ON [Project].[ID] = [Invoice].[ProjectID]
		LEFT OUTER JOIN [Company]
			ON [Project].[CustomerCompanyID] = [Company].[ID]
		LEFT OUTER JOIN [pjm5vwInvoicePayment]
			ON [pjm5vwInvoicePayment].[InvoiceID] = [Invoice].[ID]
		LEFT OUTER JOIN [AdvanceInvoices]
			ON [AdvanceInvoices].[InvoiceID] = [Invoice].[ID]
		LEFT OUTER JOIN [WarningFlag]
			ON ([Invoice].[WarningFlagID] = [WarningFlag].[ID])
	WHERE [Invoice].[State] = 7 
		 AND
		(dbo.fnPjm5HasFinansDataAccess([Project].[ID], @EmployeeID, NULL, NULL) = 1)

	RETURN 0
GO

GRANT EXECUTE ON [pjm6InvoiceBrowseBadDebt] TO PUBLIC
GO