IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5GadgetIssueBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5GadgetIssueBrowse'
		DROP PROCEDURE [dbo].[pjm5GadgetIssueBrowse]
	END
GO

PRINT 'Creating procedure pjm5GadgetIssueBrowse'
GO

/******************************************************************************
**		File: pjm5GadgetIssueBrowse.sql
**		Name: pjm5GadgetIssueBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 14:40:18
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5GadgetIssueBrowse]
	@StateSelector INT,
	@UnreadOnly BIT
AS

	SET NOCOUNT ON

	DECLARE @IssueClass TClass,
			@UserID TIdentifier,
			@EmployeeID TIdentifier

	SET @IssueClass = dbo.adfGetClassByName('Pjm5.Issue')
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()

	SELECT 
		[I].[ProjectID], SUM(CASE WHEN [S].[Read] IS NULL OR [S].[Read] = 0 THEN 1 ELSE 0 END) as [Count]
	FROM
		[Issue] as [I] LEFT OUTER JOIN [DocumentUserState] as [S]
			ON ([I].[ID] = [S].[DocumentID] AND [S].[DocumentClass] = @IssueClass
				AND [S].[UserID] = @UserID)
		INNER JOIN [Project] as [P]
			ON ([I].[ProjectID] = [P].[ID] AND [P].[State] = 2)
	WHERE
		[I].[EmployeeID] = @EmployeeID
		AND [I].[State] = 3
	GROUP BY
		[I].[ProjectID]
		

	SELECT
		[I].[ID],
		[I].[ProjectID],
		[I].[FileAs],
		[I].[DueDate],
		CAST(ISNULL([S].[Read], 0) as BIT) as [Read]
	FROM
		[Issue] as [I] LEFT OUTER JOIN [DocumentUserState] as [S]
			ON ([I].[ID] = [S].[DocumentID] AND [S].[DocumentClass] = @IssueClass
				AND [S].[UserID] = @UserID)
		INNER JOIN [Project] as [P]
			ON ([I].[ProjectID] = [P].[ID] AND [P].[State] = 2)
	WHERE
		[I].[EmployeeID] = @EmployeeID
		AND [I].[State] = 3

		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5GadgetIssueBrowse] TO PUBLIC
GO
  