IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5IssueBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5IssueBrowse'
		DROP PROCEDURE [dbo].[pjm5IssueBrowse]
	END
GO

PRINT 'Creating procedure pjm5IssueBrowse'
GO

/******************************************************************************
**		File: pjm5IssueBrowse.sql
**		Name: pjm5IssueBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 14:40:18
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		23.08.10	MAN				   "  " 
**									   "  "
**		06.05.13	SAP				    
*******************************************************************************/
CREATE PROCEDURE [pjm5IssueBrowse]
	@StateSelector INT, --0 - , 1 - , 2 - , 3 - , 4 - , 5 - ,
						--6 - , 7 -  
	@EmployeeOnly BIT,
	@ProjectID INT
AS
	SET NOCOUNT ON
	
	DECLARE 
		@EmployeeID TIdentifier,
		@ViewAllFinance TBool,
		@userID int,
		@IssueClass TClass
	
	
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @ViewAllFinance = dbo.adfHasAccessRightByName('ViewAllFinance')
	SET	@userID = dbo.adfGetCurrentUserID()
	SET @IssueClass = dbo.adfGetClassByName('Pjm5.Issue')
	
	SELECT
		[Issue].[Class],
		[Issue].[ID],
		[Issue].[State],
		[Issue].[Flag],
		[Issue].[Number],
		[Issue].[FileAs],
		[Issue].[DuplicateOfIssueID],
		[Issue].[ProjectID],
		[Issue].[EmployeeID],
		[Issue].[SeverityID],
		[Issue].[PriorityID],
		[Issue].[DueDate],
		[Issue].[EndTime],
		[Issue].[ResolutionID],
		[Issue].[Resolution],
		[Issue].[SendStatusReport],
		[Issue].[WSSDocumentURL],
		[Issue].[UDF1],
		[Issue].[UDF2],
		[Issue].[UDF3],
		[Issue].[UDF4],
		[Issue].[Comments],
		[Issue].[Created],
		[Issue].[CreatedBy],
		[Issue].[Modified],
		[Issue].[ModifiedBy],
		[Issue].[Timestamp],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @EmployeeID
				THEN [Issue].[ActualBudget]
			ELSE -1
		END AS [ActualBudget],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @EmployeeID
				THEN [Issue].[Budget]
			ELSE -1
		END AS [Budget],
		[Issue].[ActualManHour],
		[Issue].[ManHour],
		CAST(ISNULL([DocumentUserState].[Read], 0) as bit) as [Read],
		[DocumentUserState].[ReadTime]
	FROM
		[Issue]
		INNER JOIN [Project] ON [Project].[ID] = [Issue].[ProjectID]
		LEFT OUTER JOIN [DocumentUserState]
			ON ([DocumentUserState].[UserID] = @userID AND 
				[DocumentUserState].[DocumentClass] = @IssueClass AND 
				[DocumentUserState].[DocumentID] = [Issue].[ID])
	WHERE
		(
			(@StateSelector = 0) OR 
			(@StateSelector = 1 AND [Issue].[State] = 3) OR
			(@StateSelector = 2 AND [Issue].[State] = 5) OR
			(@StateSelector = 3 AND [Issue].[State] = 4) OR
			(@StateSelector = 4 AND [Issue].[State] = 6) OR
			(@StateSelector = 5 AND [Issue].[State] = 1) OR
			(@StateSelector = 6 AND [Issue].[State] = 2) OR
			(@StateSelector = 7 AND [Issue].[State] <> 5) 
		)
		AND
		(
			@EmployeeOnly = 0 
		OR 
			(@EmployeeOnly != 0 AND [Issue].[EmployeeID] = @EmployeeID)	
		)
		AND 
		(
			(@ProjectID > 0 AND [Issue].[ProjectID] = @ProjectID)
			OR 
			(@ProjectID = -1 AND [Issue].[ProjectID] IN (SELECT [ProjectID] FROM [IssueProject] WHERE [UserID] = @userId) AND dbo.fnPjm5IsProjectMember([Issue].[ProjectID], @EmployeeID) = 1)
			OR
			(@ProjectID = -2 AND [Issue].[ProjectID] IN (SELECT [ID] FROM [Project]	WHERE
				[Project].[State] = 2 AND [Project].[SupportsRequestManagement] != 0
				AND
				([ProjectManagerEmployeeID] = @EmployeeID OR  
				dbo.fnPjm5IsProjectMember([Project].[ID], @EmployeeID) = 1 OR
				dbo.fnPjm5IsAssistant() = 1)))
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5IssueBrowse] TO PUBLIC
GO
 