IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5IssueCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5IssueCreate'
		DROP PROCEDURE [dbo].[pjm5IssueCreate]
	END
GO

PRINT 'Creating procedure pjm5IssueCreate'
GO

/******************************************************************************
**		File: pjm5IssueCreate.sql
**		Name: pjm5IssueCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 14:40:18
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5IssueCreate]
	@Number TCode,
	@FileAs TName,
	@DuplicateOfIssueID TIdentifier,
	@ProjectID TIdentifier,
	@EmployeeID TIdentifier,
	@SeverityID TIdentifier,
	@PriorityID TIdentifier,
	@DueDate TDate,
	@EndTime TDate,
	@ResolutionID TIdentifier,
	@Resolution TNotes,
	@SendStatusReport TBool,
	@WSSDocumentURL THref,
	@UDF1 TCode,
	@UDF2 TCode,
	@UDF3 TCode,
	@UDF4 TCode,
	@Comments TNotes,
	@ReminderState TState,
	@ReminderInterval TTimeSpan,
	@ManHour TCount,
	@Budget TMoney
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('1acd1e8f-3c88-43b1-81ac-0dcabc871562')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF @ProjectID IS NULL
	BEGIN
		RAISERROR('#projectnotspecified', 18, -1)
		RETURN 1
	END
	
	IF NOT EXISTS(SELECT * FROM [Project] WHERE [ID] = @ProjectID AND [SupportsRequestManagement] = 1)
	BEGIN
		RAISERROR('#doesnotsupportsrequestmanagement', 18, -1)
		RETURN 1
	END
	
	IF @EmployeeID IS NOT NULL
	BEGIN
		IF NOT EXISTS(SELECT * FROM [vwAssignment] WHERE [ProjectID] = @ProjectID AND [EmployeeID] = @EmployeeID AND [State]=1)
		BEGIN
			RAISERROR('#notassignedtospecifiedproject', 18, -1)
			RETURN 1
		END
	END
	
	BEGIN TRANSACTION
	
	IF NOT EXISTS(SELECT * FROM [DocumentIndex] WHERE [ProjectID] = @ProjectID)
	BEGIN
		INSERT INTO [DocumentIndex] ([ProjectID]) VALUES(@ProjectID)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	DECLARE @Index TCount, @Prefix TCode, @N varchar(10)
	
	UPDATE
		[DocumentIndex]
	SET
		@Index = [IssueIndex] + 1,
		[IssueIndex] = [IssueIndex] + 1
	WHERE
		[ProjectID] = @ProjectID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
		
	SELECT
		@Prefix = LEFT(UPPER([Number]), 8)
	FROM
		[Project] 
	WHERE
		[ID] = @ProjectID
		
	SET @N = CAST(@Index as varchar(10))
	
	SET @Number = @Prefix + REPLICATE('0', 8 - LEN(@N)) + @N
	
	INSERT INTO [Issue]
		([Flag], [State], [Number], [FileAs], [DuplicateOfIssueID], [ProjectID], [EmployeeID], [SeverityID], [PriorityID], [DueDate], [EndTime], [ResolutionID], [Resolution], [SendStatusReport], [WSSDocumentURL], [UDF1], [UDF2], [UDF3], [UDF4], [Comments], [ActualManHour], [ManHour], [ActualBudget], [Budget])
	VALUES
		(0, @State, @Number, @FileAs, @DuplicateOfIssueID, @ProjectID, @EmployeeID, @SeverityID, @PriorityID, @DueDate, @EndTime, @ResolutionID, @Resolution, @SendStatusReport, @WSSDocumentURL, @UDF1, @UDF2, @UDF3, @UDF4, @Comments, 0, ISNULL(@ManHour, 0), 0, ISNULL(@Budget, 0))
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()
	
	DECLARE @rv int		
	EXEC @rv = pjm7IssueReminderCreate @ID,
		@DueDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	EXEC @rv = pjm6IssueAutoAssign @ID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	COMMIT TRANSACTION

	EXEC pjm5IssueGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5IssueCreate TO PUBLIC
GO
 