IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmBudgetLineGroup')
	BEGIN
		PRINT 'Dropping Procedure lmBudgetLineGroup'
		DROP  Procedure  lmBudgetLineGroup
	END

GO

PRINT 'Creating Procedure lmBudgetLineGroup'
GO
/******************************************************************************
**		File: 
**		Name: lmBudgetLineGroup
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						----------- 
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmBudgetLineGroup
AS
	SET NOCOUNT ON

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[BudgetLineGroup].[ID],
		[BudgetLineGroup].[BudgetID],
		ISNULL([BudgetLineGroupGlobal].[FileAs], [BudgetLineGroup].[FileAs]) AS [FileAs],
		[BudgetLineGroup].[GroupTypeID],
		[BudgetLineGroup].[Order],
		[BudgetLineGroup].[State]
	FROM
		[BudgetLineGroup]
		LEFT OUTER JOIN [BudgetLineGroupGlobal] 
			ON ([BudgetLineGroup].[ID] = [BudgetLineGroupGlobal].[ID]
				AND [BudgetLineGroupGlobal].[Language] = @Lang)
	
	RETURN 0
GO

GRANT EXEC ON lmBudgetLineGroup TO PUBLIC
GO