﻿IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmBudgetTemplate')
	BEGIN
		PRINT 'Dropping Procedure lmBudgetTemplate'
		DROP  Procedure  lmBudgetTemplate
	END

GO

PRINT 'Creating Procedure lmBudgetTemplate'
GO
/******************************************************************************
**		File: 
**		Name: lmBudgetTemplate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		29.03.2011	PAM				Список шаблонов бюджета
**    
*******************************************************************************/
CREATE Procedure lmBudgetTemplate
AS
	SET NOCOUNT ON
	IF dbo.adfHasAccessRightByName('ManageBudgetTemplates') <> 1
		RETURN 0

	SELECT
		[Budget].[ID],
		[Budget].[FileAs] as [Name],
		[Budget].[State],
		[Budget].[CurrencyCode]
	FROM
		[Budget]
	WHERE
		[Budget].[State] IN (4, 5)
	
GO

GRANT EXEC ON lmBudgetTemplate TO PUBLIC
GO
 