 IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmEmployeeReportAccess')
	BEGIN
		PRINT 'Dropping Procedure lmEmployeeReportAccess'
		DROP  Procedure  lmEmployeeReportAccess
	END

GO

PRINT 'Creating Procedure lmEmployeeReportAccess'
GO
/******************************************************************************
**		File: 
**		Name: lmEmployeeReportAccess
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmEmployeeReportAccess
AS
	SET NOCOUNT ON

	DECLARE @Employee int
	SET @Employee = dbo.adfGetCurrentEmployeeID()

	IF (dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')) = 1 OR dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllEmployees')) = 1	)
	BEGIN		
		SELECT
			DISTINCT
			[Employee].[ID],
			[Employee].[FileAs] as [Name],
			[Employee].[CompanyID],
			[Employee].[State],
			[Employee].[UserID],
			[Company].[Own],
			[Employee].[Initials] as [Code],
			[Employee].[DivisionID],
			1 AS [Strong] 
		FROM
			[Employee] 
			INNER JOIN [Company]
				ON ([Employee].[CompanyID] = [Company].[ID])
		WHERE [Company].[State] = 1	AND [Company].[Own] = 1
	END
	ELSE
	BEGIN
		IF (dbo.adfHasAccessRight(dbo.adfGetRightID('ManageProject')) = 1)
		BEGIN
			SELECT
				DISTINCT
				[Employee].[ID],
				[Employee].[FileAs] AS [Name],
				[Employee].[CompanyID],
				[Employee].[State],
				[Employee].[UserID],
				1 AS [Own],
				[Employee].[Initials] AS [Code],
				[Employee].[DivisionID],
				1 AS [Strong] 
			FROM 
				[Employee]
				INNER JOIN [vwAssignment]
					ON [vwAssignment].[EmployeeID] = [Employee].[ID]
			WHERE
				[Employee].[ID] = @Employee OR
				[vwAssignment].[ProjectID] IN (	SELECT 
													[Project].[ID]
												FROM 
													[Project]
												WHERE 
													[Project].[ProjectManagerEmployeeID] = @Employee)
		END
		ELSE
		BEGIN
			SELECT
				DISTINCT
				[Employee].[ID],
				[Employee].[FileAs] as [Name],
				[Employee].[CompanyID],
				[Employee].[State],
				[Employee].[UserID],
				1 AS [Own],
				[Employee].[Initials] as [Code],
				[Employee].[DivisionID],
				1 AS [Strong] 
			FROM
				[Employee] 
			WHERE [Employee].ID = @Employee
		END
	END

	RETURN 0
GO

GRANT EXEC ON lmEmployeeReportAccess TO PUBLIC
GO