
 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6KickMailEmployeeToGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6KickMailEmployeeToGet'
		DROP PROCEDURE [dbo].[pjm6KickMailEmployeeToGet]
	END
GO

PRINT 'Creating procedure pjm6KickMailEmployeeToGet'
GO


CREATE PROCEDURE [pjm6KickMailEmployeeToGet] 
				@Class TClass,
				@ID TIdentifier
AS
	
SET NOCOUNT ON

	SELECT
	DISTINCT ([Employee].[ID]),
		[Employee].[FileAs],
		[Employee].[Class],
		[Employee].[State]
	FROM
		[vwEmployeeWithEP] as [Employee]
			INNER JOIN
			(
			SELECT 
				[ProjectManagerEmployeeID] as [EmployeeID]
			FROM
				[Project]
			WHERE
				[Project].[Class] =@Class
				AND [Project].[ID]= @ID

			UNION ALL
			
			SELECT 
				[Assignment].[EmployeeID]
			FROM
				[Task]
					INNER JOIN [TaskAssignment]
						ON [Task].[ID] = [TaskAssignment].[TaskID]
					INNER JOIN [vwAssignment] as [Assignment]
						ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
			WHERE
				[Task].[Class] =@Class
				AND [Task].[ID]= @ID

			UNION ALL

			SELECT
				[EmployeeID]
			FROM
				[TimeEntry]
			WHERE
				[TimeEntry].[Class] =@Class
				AND [TimeEntry].[ID]= @ID

			UNION ALL

			SELECT 
				[EmployeeID]
			FROM
				[Issue]
			WHERE
				[Issue].[Class] =@Class
				AND [Issue].[ID]= @ID
				
			UNION ALL
			
			SELECT
				[TaskRequestAssignment].[EmployeeID]
			FROM
				[TaskRequest]
						INNER JOIN [TaskRequestAssignment]
							ON [TaskRequestAssignment].[TaskRequestID] = [TaskRequest].[ID]
			WHERE
				[TaskRequest].[Class] = @Class
				AND [TaskRequest].[ID] = @ID
			
			UNION ALL
			
			SELECT
				[MeetingRequest].[OriginatorEmployeeID]
			FROM
				[MeetingRequest]
			WHERE
				[MeetingRequest].[Class] = @Class
				AND [MeetingRequest].[ID] = @ID
				
			UNION ALL
			
			SELECT
				[Attendee].[EmployeeID]
			FROM
				[MeetingRequest]
					INNER JOIN [Attendee]
						ON [Attendee].[MeetingRequestID] = [MeetingRequest].[ID]
			WHERE
				[MeetingRequest].[Class] = @Class
				AND [MeetingRequest].[ID] = @ID
			
			
			UNION ALL
			
			SELECT
				[EmployeeID]
			FROM
				[ServiceRequest]
			WHERE
				[ServiceRequest].[Class] = @Class
				AND [ServiceRequest].[ID] = @ID
			
			UNION ALL
			
			SELECT
				[ManagerEmployeeID]
			FROM
				[Company]
			WHERE
				[Company].[Class] = @Class
				AND [Company].[ID] = @ID

			UNION ALL
			
			SELECT
				[Company].[ManagerEmployeeID]
			FROM
				[Employee]
					INNER JOIN [Company]
						ON [Employee].[CompanyID] = [Company].[ID]
			WHERE
				[Employee].[Class] = @Class
				AND [Employee].[ID] = @ID
				
			UNION ALL
			
			SELECT
				[CardOwnerID]
			FROM
				[DocumentCard]
			WHERE
				[DocumentCard].[Class] = @Class
				AND [DocumentCard].[ID] = @ID
		) as [T]
			ON [T].[EmployeeID] = [Employee].[ID]
		WHERE [Employee].[UserID] != dbo.adfGetCurrentUserID()
		
RETURN 0
GO

GRANT EXECUTE ON [pjm6KickMailEmployeeToGet] TO PUBLIC
GO   