IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'NamedListBrowse')
	BEGIN
		PRINT 'Dropping Procedure NamedListBrowse'
		DROP  Procedure  NamedListBrowse
	END

GO

PRINT 'Creating Procedure NamedListBrowse'
GO
/******************************************************************************
**		File: 
**		Name: NamedListBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure NamedListBrowse
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[ID],
		[Name],
		[SortOrderAscending]
	FROM
		[NamedList]
	WHERE
		[ProjectID] = @ProjectID
		
	SELECT
		[NamedListID],
		[UDFIndex],
		[UDFCaption]
	FROM
		[NamedListBinding] INNER JOIN [NamedList]
			ON ([NamedListBinding].[NamedListID] = [NamedList].[ID])
	WHERE
		[NamedList].[ProjectID] = @ProjectID
		
	SELECT
		[NamedListID],
		[Code]
	FROM
		[NamedListEntry] INNER JOIN [NamedList]
			ON ([NamedListEntry].[NamedListID] = [NamedList].[ID])
	WHERE
		[NamedList].[ProjectID] = @ProjectID
	
	RETURN 0
GO

GRANT EXEC ON NamedListBrowse TO PUBLIC
GO
