﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7ContactBirthdayReminderCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7ContactBirthdayReminderCreate'
		DROP PROCEDURE [dbo].[pjm7ContactBirthdayReminderCreate]
	END
GO

PRINT 'Creating procedure pjm7ContactBirthdayReminderCreate'
GO

/******************************************************************************
**		File: pjm7ContactBirthdayReminderCreate.sql
**		Name: pjm7ContactBirthdayReminderCreate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Sergey Pelevin
**		Date: 11.12.13
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm7ContactBirthdayReminderCreate]
	@DocumentID TIdentifier,
	@ReminderEventTime TDateTime,
	@ReminderState TState,
	@ReminderInterval TTimeSpan
AS
	SET NOCOUNT ON
	
	DECLARE
		@CurrentUserID			TIdentifier,
		@DocumentClass			TClass,
		@ReminderDescription	TName,
		@Lang					TLanguage,
		@rv						int
	
	SET @Lang = dbo.adfGetLanguage()
	SELECT 
		@ReminderDescription = [Description] 
	FROM 
		[ReminderDescription] 
	WHERE 
		[Subtype] = 'CB'
		AND
		[Language] = @Lang
			
	SELECT
		@CurrentUserID = dbo.adfGetCurrentUserID(),
		@DocumentClass = dbo.adfGetClassByName('Adf.Employee')
		
	EXEC @rv = dbo.pjm7ReminderForUserCreate	@DocumentClass,
												@DocumentID,
												@CurrentUserID,
												'CB',
												@ReminderEventTime,
												@ReminderState,
												@ReminderInterval,
												@ReminderDescription,
												1
	RETURN @rv
GO

GRANT EXECUTE ON [pjm7ContactBirthdayReminderCreate] TO PUBLIC
GO     