﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7ReminderForUserByDocumentBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7ReminderForUserByDocumentBrowse'
		DROP PROCEDURE [dbo].[pjm7ReminderForUserByDocumentBrowse]
	END
GO

PRINT 'Creating procedure pjm7ReminderForUserByDocumentBrowse'
GO

/******************************************************************************
**		File: pjm7ReminderForUserByDocumentBrowse.sql
**		Name: pjm7ReminderForUserByDocumentBrowse
**		Desc: Процедура возвращает активные напоминания по документу для 
**				сотрудника
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 09.04.120 16:37:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE [pjm7ReminderForUserByDocumentBrowse]
@DocumentID		TIdentifier,
@DocumentClass	TClass,
@UserID			TIdentifier
AS
	SET NOCOUNT ON

	SELECT
		[Reminder].[ID],
		[Reminder].[DocumentClass],
		[Reminder].[DocumentID],
		[Reminder].[EventTime],
		[Reminder].[Subtype],
		[ReminderType].[IsTimeFormat],
		[UserReminder].[State],
		[UserReminder].[UserID],
		[UserReminder].[NextInterval],
		[UserReminder].[OriginalInterval],
		[UserReminder].[Description]
	FROM
		[Reminder]
		INNER JOIN [ReminderType]
			ON [ReminderType].[Subtype] = [Reminder].[Subtype]
		INNER JOIN [UserReminder]
			ON [UserReminder].[ReminderID] = [Reminder].[ID]
	WHERE
		[Reminder].[DocumentID] = @DocumentID
		AND
		[Reminder].[DocumentClass] = @DocumentClass
		AND
		[UserReminder].[UserID] = @UserID
		AND
		[UserReminder].[State] = 1
	ORDER BY
		DATEADD(minute, - [UserReminder].[OriginalInterval], [Reminder].[EventTime]) ASC
		

	RETURN 0
GO

GRANT EXECUTE ON [pjm7ReminderForUserByDocumentBrowse] TO PUBLIC
GO
