IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7ReminderForUserSnooze]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7ReminderForUserSnooze'
		DROP PROCEDURE [dbo].[pjm7ReminderForUserSnooze]
	END
GO

PRINT 'Creating procedure pjm7ReminderForUserSnooze'
GO

/******************************************************************************
**		File: pjm7ReminderForUserSnooze.sql
**		Name: pjm7ReminderForUserSnooze
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 02.05.2012 13:44:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm7ReminderForUserSnooze]
	@ReminderID TIdentifier,
	@Interval TTimeSpan
AS
	SET NOCOUNT ON
	
	DECLARE 
		@UserID TIdentifier,
		@ReminderSubtype TCode2
			
	SELECT 
		@UserID = dbo.adfGetCurrentUserID()
	
	IF @UserID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SELECT @ReminderSubtype = [Subtype] FROM [Reminder] WHERE [ID] = @ReminderID

	UPDATE [UserReminder]
	SET [NextInterval] = CASE
			WHEN @ReminderSubtype IN ('BC', 'MD', 'TD', 'UR', 'VA', 'VP','CB') THEN
				[OriginalInterval] + @Interval
			ELSE @Interval
		END
	WHERE
		[ReminderID] = @ReminderID AND [UserID] = @UserID
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm7ReminderForUserSnooze] TO PUBLIC
GO