IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7ReminderSettingsUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7ReminderSettingsUpdate'
		DROP PROCEDURE [dbo].[pjm7ReminderSettingsUpdate]
	END
GO

PRINT 'Creating procedure pjm7ReminderSettingsUpdate'
GO

/******************************************************************************
**		File: pjm7ReminderSettingsUpdate.sql
**		Name: pjm7ReminderSettingsUpdate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 02.05.2010 13:53:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm7ReminderSettingsUpdate]
	@Subtype TCode2,
	@InitialState TState,
	@InitialInterval TTimeSpan
AS
	SET NOCOUNT ON
	
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	
	IF NOT EXISTS (
		SELECT * FROM [ReminderSetting]
		WHERE [Subtype] = @Subtype AND [UserID] = @UserID
  	)
  	BEGIN
  		INSERT INTO [ReminderSetting] ([UserID], [Subtype],
  			[InitialState], [InitialInterval])
  		VALUES (@UserID, @Subtype, @InitialState, @InitialInterval)
  	END
  	ELSE
  	BEGIN
  		UPDATE [ReminderSetting]
  		SET
  			[InitialState] = @InitialState,
  			[InitialInterval] = @InitialInterval
  		WHERE
  			[Subtype] = @Subtype AND [UserID] = @UserID
  	END

	IF @Subtype='ES'
	BEGIN
		EXEC pjm7ReminderSettingsUpdate 'MS', @InitialState, @InitialInterval
	END  		
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm7ReminderSettingsUpdate] TO PUBLIC
GO   