/*==========================================================================*/
/* Function:         */
/*==========================================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fnPjm5CheckRuleDocumentConstraint]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[fnPjm5CheckRuleDocumentConstraint]
go

create function fnPjm5CheckRuleDocumentConstraint 
(@ContainerClass TClass, @ContainerID TIdentifier,
 @SubscriptionRuleID TIdentifier, @RuleEmployeeID TIdentifier)
returns bit
as
begin
	DECLARE @result bit
	SET @result = 0
	
	IF NOT EXISTS (
		SELECT *
		FROM [DocumentSubscriptionRule]
		WHERE
			[DocumentSubscriptionRule].[SubscriptionRuleID] = @SubscriptionRuleID
	) AND (EXISTS (
		SELECT
		[Project].[Class],
		[Project].[ID]
	FROM
		[Project]
	WHERE
		(
			[Project].[ProjectManagerEmployeeID] = @RuleEmployeeID OR
			dbo.fnPjm5IsProjectMember([Project].[ID], @RuleEmployeeID) = 1
		) AND
		([Project].[Class] = @ContainerClass AND [Project].[ID] = @ContainerID)
	))
	BEGIN
		SET @result = 1
	END
	ELSE IF EXISTS (
		SELECT *
		FROM [DocumentSubscriptionRule]
		WHERE
			[DocumentSubscriptionRule].[SubscriptionRuleID] = @SubscriptionRuleID AND
			[DocumentSubscriptionRule].[DocumentClass] = @ContainerClass AND
			[DocumentSubscriptionRule].[DocumentID] = @ContainerID
	)
	BEGIN
		SET @result = 1
	END
	
	RETURN @result
end
go

grant execute on [dbo].[fnPjm5CheckRuleDocumentConstraint] to [public]
go 