/*==============================================================*/
/* Database View:          */
/*==============================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwReminderMeetingRequest]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwReminderMeetingRequest]
go

create view pjm5vwReminderMeetingRequest
as
	SELECT
		[MeetingRequest].[Class] as [DocumentClass],
		[MeetingRequest].[ID] as [DocumentID],
		[Employee].[UserID] as [RecipientUserID],
		[MeetingRequest].[StartTime] as [EventTime]
	FROM
		[MeetingRequest]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [MeetingRequest].[OriginatorEmployeeID]
	WHERE
		[Employee].[UserID] IS NOT NULL
	UNION ALL
	SELECT
		[MeetingRequest].[Class] as [DocumentClass],
		[MeetingRequest].[ID] as [DocumentID],
		[Employee].[UserID] as [RecipientUserID],
		[MeetingRequest].[StartTime] as [EventTime]
	FROM
		[MeetingRequest] INNER JOIN [Attendee]
			ON [MeetingRequest].[ID] = [Attendee].[MeetingRequestID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [Attendee].[EmployeeID]
	WHERE
		[Employee].[UserID] IS NOT NULL
go

grant select on [dbo].[pjm5vwReminderMeetingRequest] to [public]
go 

/*==========================================================*/
/* Database View:                       */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwAppointMeetingRequest]') and OBJECTPROPERTY(id, N'IsView') = 1)
	drop view [dbo].[pjm5vwAppointMeetingRequest]
go

create view pjm5vwAppointMeetingRequest
as
	SELECT
		[MeetingRequest].[Class] as [DocumentClass],
		[MeetingRequest].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[MeetingRequest].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		[Employee].[UserID] as [Value],
		[MeetingRequest].[ModifiedBy] as [OwnerUserID]
	FROM
		[MeetingRequest]
		INNER JOIN [Attendee]
			ON ([MeetingRequest].[ID] = [Attendee].[MeetingRequestID])
		INNER JOIN [Employee]
			ON ([Attendee].[EmployeeID] = [Employee].[ID])
	WHERE
		[MeetingRequest].[State] IN (2, 3)
go

/*==========================================================*/
/* Database View:                              */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwCancelMeetingRequest]') and OBJECTPROPERTY(id, N'IsView') = 1)
	drop view [dbo].[pjm5vwCancelMeetingRequest]
go

create view pjm5vwCancelMeetingRequest
as
	SELECT
		[MeetingRequest].[Class] as [DocumentClass],
		[MeetingRequest].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[MeetingRequest].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		[Employee].[UserID] as [Value],
		[MeetingRequest].[ModifiedBy] as [OwnerUserID]
	FROM
		[MeetingRequest]
		INNER JOIN [Attendee]
			ON ([MeetingRequest].[ID] = [Attendee].[MeetingRequestID])
		INNER JOIN [Employee]
			ON ([Attendee].[EmployeeID] = [Employee].[ID])
	WHERE
		[MeetingRequest].[State] = 4
go
