/*==========================================================*/
/* Database View:                           */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwExecuteTask]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwExecuteTask]
go

create view pjm5vwExecuteTask
as
	SELECT
		[Task].[Class] as [DocumentClass],
		[Task].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Task].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[Task].[ModifiedBy] as [OwnerUserID]
	FROM
		[Task]
	WHERE
		[Task].[State] = 2
go

/*==========================================================*/
/* Database View:       */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwRecipientExecuteTask]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwRecipientExecuteTask]
go

create view pjm5vwRecipientExecuteTask
as
	SELECT
		[Task].[Class] as [DocumentClass],
		[Task].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Task].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID]
	FROM
		[Task]
		INNER JOIN [TaskAssignment]
			ON [TaskAssignment].[TaskID] = [Task].[ID]
		INNER JOIN [Assignment]
			ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
		INNER JOIN [AssignmentEntry]
			ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [AssignmentEntry].[EmployeeID]
	WHERE
		GETDATE() BETWEEN [AssignmentEntry].[ValidFrom] AND ISNULL([AssignmentEntry].[ValidTo], GETDATE())
		AND [Task].[State] != 7
go

/*==========================================================*/
/* Database View:                               */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwCancelTask]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwCancelTask]
go

create view pjm5vwCancelTask
as
	SELECT
		[Task].[Class] as [DocumentClass],
		[Task].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Task].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[Task].[ModifiedBy] as [OwnerUserID]
	FROM
		[Task]
	WHERE
		[Task].[State] = 6
go

/*==========================================================*/
/* Database View:           */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwRecipientCancelTask]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwRecipientCancelTask]
go

create view pjm5vwRecipientCancelTask
as
	SELECT
		[Task].[Class] as [DocumentClass],
		[Task].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Task].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID]
	FROM
		[Task]
		INNER JOIN [TaskAssignment]
			ON [TaskAssignment].[TaskID] = [Task].[ID]
		INNER JOIN [Assignment]
			ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
		INNER JOIN [AssignmentEntry]
			ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [AssignmentEntry].[EmployeeID]
	WHERE
		GETDATE() BETWEEN [AssignmentEntry].[ValidFrom] AND ISNULL([AssignmentEntry].[ValidTo], GETDATE())
		AND [Task].[State] != 7
go

/*==========================================================*/
/* Database View:                             */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwPostponeTask]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwPostponeTask]
go

create view pjm5vwPostponeTask
as
	SELECT
		[Task].[Class] as [DocumentClass],
		[Task].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Task].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[Task].[ModifiedBy] as [OwnerUserID]
	FROM
		[Task]
	WHERE
		[Task].[State] = 5
go

/*==========================================================*/
/* Database View:           */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwRecipientPostponeTask]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwRecipientPostponeTask]
go

create view pjm5vwRecipientPostponeTask
as
	SELECT
		[Task].[Class] as [DocumentClass],
		[Task].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Task].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID]
	FROM
		[Task]
		INNER JOIN [TaskAssignment]
			ON [TaskAssignment].[TaskID] = [Task].[ID]
		INNER JOIN [Assignment]
			ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
		INNER JOIN [AssignmentEntry]
			ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [AssignmentEntry].[EmployeeID]
	WHERE
		GETDATE() BETWEEN [AssignmentEntry].[ValidFrom] AND ISNULL([AssignmentEntry].[ValidTo], GETDATE())
		AND [Task].[State] != 7
go

/*==========================================================*/
/* Database View:               */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwAssignOnTask]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwAssignOnTask]
go

create view pjm5vwAssignOnTask
as
	SELECT
		[Task].[Class] as [DocumentClass],
		[Task].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Task].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		[Employee].[UserID] as [Value],
		[Task].[ModifiedBy] as [OwnerUserID]
	FROM
		[Task]
		INNER JOIN [TaskAssignment]
			ON [TaskAssignment].[TaskID] = [Task].[ID]
		INNER JOIN [Assignment]
			ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
		INNER JOIN [AssignmentEntry]
			ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [AssignmentEntry].[EmployeeID]
	WHERE
		GETDATE() BETWEEN [AssignmentEntry].[ValidFrom] AND ISNULL([AssignmentEntry].[ValidTo], GETDATE())
		AND [Task].[State] != 7
go

/*==========================================================*/
/* Database View:             */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwExclusionFromTask]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwExclusionFromTask]
go

create view pjm5vwExclusionFromTask
as
	SELECT
		[Task].[Class] as [DocumentClass],
		[Task].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Task].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		[Employee].[UserID] as [Value],
		[Task].[ModifiedBy] as [OwnerUserID]
	FROM
		[Task]
		INNER JOIN [TaskAssignment]
			ON [TaskAssignment].[TaskID] = [Task].[ID]
		INNER JOIN [Assignment]
			ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
		INNER JOIN [AssignmentEntry]
			ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [AssignmentEntry].[EmployeeID]
	WHERE
		GETDATE() BETWEEN [AssignmentEntry].[ValidFrom] AND ISNULL([AssignmentEntry].[ValidTo], GETDATE())
		AND [Task].[State] != 7
go

/*==========================================================*/
/* Database View:          */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwChangePercentTask]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwChangePercentTask]
go

create view pjm5vwChangePercentTask
as
	SELECT
		[Task].[Class] as [DocumentClass],
		[Task].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Task].[ProjectID] as [ContainerID],
		NULL as [UserID],
		CAST([Task].[PercentComplete]*100 as int) as [Value],
		[Task].[ModifiedBy] as [OwnerUserID]
	FROM
		[Task]
	WHERE
		[Task].[State] = 2 AND EXISTS
		(
			SELECT *		
			FROM [Transition]
			INNER JOIN [TransitionTemplate]
				ON [TransitionTemplate].[ID] = [Transition].[TransitionTemplateID]
			WHERE
				[Transition].[Class] = [Task].[Class] AND
				([TransitionTemplate].[FromState] = 2 AND
				 [TransitionTemplate].[ToState] = 2) AND
				[Transition].[ID] IN (
					SELECT TOP 1 [ID]
					FROM [Transition]
					WHERE [Class] = [Task].[Class] AND
					[DocumentID] = [Task].[ID]
					ORDER BY [Created] DESC
				)
		)
		
go

/*==========================================================*/
/* Database View:                             */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwCreateTask]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwCreateTask]
go

create view pjm5vwCreateTask
as
	SELECT
		[Task].[Class] as [DocumentClass],
		[Task].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Task].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[Task].[ModifiedBy] as [OwnerUserID]
	FROM
		[Task]
	WHERE
		[Task].[State] = 8
go

/*==============================================================*/
/* Database View:             */
/*==============================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwReminderTaskTS]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwReminderTaskTS]
go

create view pjm5vwReminderTaskTS
as
	SELECT
		[Task].[Class] as [DocumentClass],
		[Task].[ID] as [DocumentID],
		[Employee].[UserID] as [RecipientUserID],
		[Task].[StartDate] as [EventTime]
	FROM
		[Task]
		LEFT OUTER JOIN [TaskAssignment]
			ON [TaskAssignment].[TaskID] = [Task].[ID]
		LEFT OUTER JOIN [Assignment]
			ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
		LEFT OUTER JOIN [AssignmentEntry]
			ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
		LEFT OUTER JOIN [Employee]
			ON [AssignmentEntry].[EmployeeID] = [Employee].[ID]
go

grant select on [dbo].[pjm5vwReminderTaskTS] to [public]
go

/*=============================================================*/
/* Database View:             */
/*=============================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwReminderTaskTD]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwReminderTaskTD]
go

create view pjm5vwReminderTaskTD
as
	SELECT
		[Task].[Class] as [DocumentClass],
		[Task].[ID] as [DocumentID],
		[Employee].[UserID] as [RecipientUserID],
		[Task].[DueDate] as [EventTime]
	FROM
		[Task]
		LEFT OUTER JOIN [TaskAssignment]
			ON [TaskAssignment].[TaskID] = [Task].[ID]
		LEFT OUTER JOIN [Assignment]
			ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
		LEFT OUTER JOIN [AssignmentEntry]
			ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
		LEFT OUTER JOIN [Employee]
			ON [AssignmentEntry].[EmployeeID] = [Employee].[ID]
go

grant select on [dbo].[pjm5vwReminderTaskTD] to [public]
go