/*==========================================================*/
/* Database View:                          */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwCreateTaskRequest]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwCreateTaskRequest]
go

create view pjm5vwCreateTaskRequest
as
	SELECT
		[TaskRequest].[Class] as [DocumentClass],
		[TaskRequest].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[TaskRequest].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[TaskRequest].[ModifiedBy] as [OwnerUserID]
	FROM
		[TaskRequest]
	WHERE
		[TaskRequest].[State] = 1
go

/*==========================================================*/
/* Database View:                        */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwExecuteTaskRequest]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwExecuteTaskRequest]
go

create view pjm5vwExecuteTaskRequest
as
	SELECT
		[TaskRequest].[Class] as [DocumentClass],
		[TaskRequest].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[TaskRequest].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[TaskRequest].[ModifiedBy] as [OwnerUserID]
	FROM
		[TaskRequest]
	WHERE
		[TaskRequest].[State] = 3
go

/*==========================================================*/
/* Database View:            */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwAssignOnTaskRequest]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwAssignOnTaskRequest]
go

create view pjm5vwAssignOnTaskRequest
as
	SELECT
		[TaskRequest].[Class] as [DocumentClass],
		[TaskRequest].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[TaskRequest].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		[Employee].[UserID] as [Value],
		[TaskRequest].[ModifiedBy] as [OwnerUserID]
	FROM
		[TaskRequest]
		INNER JOIN [TaskRequestAssignment]
			ON [TaskRequest].[ID] = [TaskRequestAssignment].[TaskRequestID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [TaskRequestAssignment].[EmployeeID]
go

/*==========================================================*/
/* Database View:          */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwExclusionFromTaskRequest]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwExclusionFromTaskRequest]
go

create view pjm5vwExclusionFromTaskRequest
as
	SELECT
		[TaskRequest].[Class] as [DocumentClass],
		[TaskRequest].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[TaskRequest].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		[Employee].[UserID] as [Value],
		[TaskRequest].[ModifiedBy] as [OwnerUserID]
	FROM
		[TaskRequest]
		INNER JOIN [TaskRequestAssignment]
			ON [TaskRequest].[ID] = [TaskRequestAssignment].[TaskRequestID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [TaskRequestAssignment].[EmployeeID]
go

/*==========================================================*/
/* Database View:                            */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwCancelTaskRequest]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwCancelTaskRequest]
go

create view pjm5vwCancelTaskRequest
as
	SELECT
		[TaskRequest].[Class] as [DocumentClass],
		[TaskRequest].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[TaskRequest].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[TaskRequest].[ModifiedBy] as [OwnerUserID]
	FROM
		[TaskRequest]
	WHERE
		[TaskRequest].[State] = 4
go

/*==========================================================*/
/* Database View:        */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwRecipientCancelTaskRequest]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwRecipientCancelTaskRequest]
go

create view pjm5vwRecipientCancelTaskRequest
as
	SELECT
		[TaskRequest].[Class] as [DocumentClass],
		[TaskRequest].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[TaskRequest].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID]
	FROM
		[TaskRequest]
		INNER JOIN [TaskRequestAssignment]
			ON [TaskRequestAssignment].[TaskRequestID] = [TaskRequest].[ID]
		INNER JOIN [Employee]
			ON [TaskRequestAssignment].[EmployeeID] = [Employee].[ID]
go

/*=============================================================*/
/* Database View:         */
/*=============================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwReminderTaskRequestRS]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwReminderTaskRequestRS]
go

create view pjm5vwReminderTaskRequestRS
as
	SELECT
		[TaskRequest].[Class] as [DocumentClass],
		[TaskRequest].[ID] as [DocumentID],
		[Employee].[UserID] as [RecipientUserID],
		[TaskRequest].[StartTime] as [EventTime]
	FROM
		[TaskRequest]
		LEFT OUTER JOIN [TaskRequestAssignment]
			ON [TaskRequestAssignment].[TaskRequestID] = [TaskRequest].[ID]
		LEFT OUTER JOIN [Employee]
			ON [TaskRequestAssignment].[EmployeeID] = [Employee].[ID]
go

grant select on [dbo].[pjm5vwReminderTaskRequestRS] to [public]
go

/*=============================================================*/
/* Database View:          */
/*=============================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwReminderTaskRequestRD]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwReminderTaskRequestRD]
go

create view pjm5vwReminderTaskRequestRD
as
	SELECT
		[TaskRequest].[Class] as [DocumentClass],
		[TaskRequest].[ID] as [DocumentID],
		[Employee].[UserID] as [RecipientUserID],
		[TaskRequest].[DueTime] as [EventTime]
	FROM
		[TaskRequest]
		LEFT OUTER JOIN [TaskRequestAssignment]
			ON [TaskRequestAssignment].[TaskRequestID] = [TaskRequest].[ID]
		LEFT OUTER JOIN [Employee]
			ON [TaskRequestAssignment].[EmployeeID] = [Employee].[ID]
go

grant select on [dbo].[pjm5vwReminderTaskRequestRD] to [public]
go