IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'PjmSyncSelectContactItemsID')
	BEGIN
		PRINT 'Dropping Procedure PjmSyncSelectContactItemsID'
		DROP  Procedure  PjmSyncSelectContactItemsID
	END

GO

PRINT 'Creating Procedure PjmSyncSelectContactItemsID'
GO

--------------------------------------------------------------------------------------
CREATE Procedure PjmSyncSelectContactItemsID
	@DeviceID varchar(40)
	
AS
	SET NOCOUNT ON
	
	SELECT 
		[ItemID]	
	FROM 
		[ExternalLink]
		INNER JOIN [Company]
		ON [ExternalLink].[DocumentClass] = [Company].[Class] AND
			[ExternalLink].[DocumentID] = [Company].[ID]
	WHERE 
		[ExternalLink].[DeviceID] = @DeviceID
	
	UNION
	
	SELECT 
		[ItemID]	
	FROM 
		[ExternalLink]
		INNER JOIN [Employee]
		ON [ExternalLink].[DocumentClass] = [Employee].[Class] AND
			[ExternalLink].[DocumentID] = [Employee].[ID]
	WHERE 
		[ExternalLink].[DeviceID] = @DeviceID

	RETURN 0
GO

GRANT EXEC ON PjmSyncSelectContactItemsID TO PUBLIC
GO   