IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7EmployeeManagerAssistantBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7EmployeeManagerAssistantBrowse'
		DROP PROCEDURE [dbo].[pjm7EmployeeManagerAssistantBrowse]
	END
GO

PRINT 'Creating procedure pjm7EmployeeManagerAssistantBrowse'
GO

/******************************************************************************
**		File: EmployeeManagerAssistantBrowse.sql
**		Name: pjm7EmployeeManagerAssistantBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth:
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		27.06.13	SOV				   , 
**									     
*******************************************************************************/
CREATE PROCEDURE pjm7EmployeeManagerAssistantBrowse
	@Own BIT = 0
AS
	SET NOCOUNT ON
	DECLARE @RightID int
		
	SET @RightID = dbo.adfGetRightID('CanBeProjectManagerAssistant')

	IF (@Own = 1)
		SELECT DISTINCT
			[Employee].[ID],
			[Employee].[Class],
			2 as [ImageIndex],
			[Employee].[State],
			[Employee].[FileAs],
			[Employee].[CompanyID],
			[Employee].[PositionID],
			(SELECT [FileAs] FROM [Position] WHERE [ID] = [Employee].[PositionID]) as [Position],
			(SELECT COALESCE([FileAs], [LegalName]) FROM [Company] WHERE [ID] = [Employee].[CompanyID]) as [Company],
			[Employee].[Created],
			[Employee].[CreatedBy],
			[Employee].[Modified],
			[Employee].[ModifiedBy],
			[Employee].[Timestamp]
		FROM
			[Employee]
			INNER JOIN [Company]
				ON ([Employee].[CompanyID] = [Company].[ID] AND [Company].[Own] = 1 AND [Company].[State]=1)
			INNER JOIN [AccessRight] 
				ON ([AccessRight].[RightID] = @RightID AND
						(
						[AccessRight].[TrusteeID] = [Employee].[UserID] OR
						[AccessRight].[TrusteeID] IN (SELECT [UserRole].[RoleID] FROM [UserRole] WHERE [UserRole].[UserID] = [Employee].[UserID])
						)
					)
		WHERE
			[Employee].[State] = 1
	ELSE
		SELECT DISTINCT
			[Employee].[ID],
			[Employee].[Class],
			2 as [ImageIndex],
			[Employee].[State],
			[Employee].[FileAs],
			[Employee].[CompanyID],
			[Employee].[PositionID],
			(SELECT [FileAs] FROM [Position] WHERE [ID] = [Employee].[PositionID]) as [Position],
			(SELECT COALESCE([FileAs], [LegalName]) FROM [Company] WHERE [ID] = [Employee].[CompanyID]) as [Company],
			[Employee].[Created],
			[Employee].[CreatedBy],
			[Employee].[Modified],
			[Employee].[ModifiedBy],
			[Employee].[Timestamp]
		FROM
			[Employee]
			INNER JOIN [Company]
				ON ([Employee].[CompanyID] = [Company].[ID] AND [Company].[State]=1)
			INNER JOIN [AccessRight] 
				ON ([AccessRight].[RightID] = @RightID AND
						(
						[AccessRight].[TrusteeID] = [Employee].[UserID] OR
						[AccessRight].[TrusteeID] IN (SELECT [UserRole].[RoleID] FROM [UserRole] WHERE [UserRole].[UserID] = [Employee].[UserID])
						)
					)
		WHERE
			[Employee].[State] = 1
GO

GRANT EXECUTE ON [pjm7EmployeeManagerAssistantBrowse] TO PUBLIC
GO