IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ProjectBrowseForDialog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ProjectBrowseForDialog'
		DROP PROCEDURE [dbo].[pjm5ProjectBrowseForDialog]
	END
GO

PRINT 'Creating procedure pjm5ProjectBrowseForDialog'
GO

/******************************************************************************
**		File: pjm5ProjectBrowseForDialog.sql
**		Name: pjm5ProjectBrowseForDialog
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ProjectBrowseForDialog]
	@EmployeeID TIdentifier
AS
	SET NOCOUNT ON
	IF @EmployeeID IS NULL OR @EmployeeID <= 0
		SELECT @EmployeeID = dbo.adfGetCurrentEmployeeID()
		
	SELECT DISTINCT
		[Project].[Class],
		[Project].[ID],
		[Project].[State],
		[Project].[Flag],
		[Project].[Date],
		[Project].[Number],
		[Project].[FileAs],
		[Project].[ProjectTypeID],
		[Project].[SupplierCompanyID],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CustomerCompanyID],
		[Project].[CustomerFinanceManagerID],
		[Project].[ResponsiblePersonEmployeeID],
		[Project].[Created],
		[Project].[CreatedBy],
		[Project].[Modified],
		[Project].[ModifiedBy],
		[Project].[Timestamp],
		[Employee].[FileAs] AS [ManagerName],
		[Supplier].[FileAs] AS [SupplierName],
		[Customer].[FileAs] AS [CustomerName]
	FROM
		[Project]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [Project].[ProjectManagerEmployeeID]
		INNER JOIN [Company] AS [Supplier]
			ON [Supplier].[ID] = [Project].[SupplierCompanyID]
		LEFT OUTER JOIN [Company] AS [Customer]
			ON [Customer].[ID] = [Project].[CustomerCompanyID]
		
	WHERE
		[Project].[State] IN (2,4) AND
		EXISTS (SELECT [ID] FROM [vwAssignment] WHERE [ProjectID] = [Project].[ID] AND [EmployeeID] = @EmployeeID)

	RETURN 0
GO

GRANT EXECUTE ON [pjm5ProjectBrowseForDialog] TO PUBLIC
GO

 