 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ProjectGetInfo]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ProjectGetInfo'
		DROP PROCEDURE [dbo].[pjm5ProjectGetInfo]
	END
GO

PRINT 'Creating procedure pjm5ProjectGetInfo'
GO

/******************************************************************************
**		File: pjm5ProjectGetInfo.sql
**		Name: pjm5ProjectGetInfo
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		17.09.09	syv				  BankAccountID
**		24.03.11	SYV				 VATRate
**		04.02.13	SAP				  Color
**		19.04.13	SOV				  ID . -  . -
*******************************************************************************/
CREATE PROCEDURE [pjm5ProjectGetInfo]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE
		@HasTasks TBool,
		@HasTMServices TBool,
		@BankAccountID TIdentifier
		
	SET @HasTasks = 0
	IF EXISTS(SELECT * FROM [Task] WHERE [ProjectID] = @ID AND [State] = 2)
		SET @HasTasks = 1
		
	SET @HasTMServices = 0
	IF EXISTS(SELECT * FROM [ServiceAssignment] WHERE [ProjectID] = @ID AND [State] = 1 AND [PaymentTermID] = 3)
		SET @HasTMServices = 1
	
	SELECT
		@BankAccountID = [BankAccountID]
	FROM
		[Project]
	WHERE
		[ID] = @ID
	
	IF (@BankAccountID IS NULL)
	BEGIN
		SELECT
			@BankAccountID=[Company].[BankAccountID]
		FROM
			[Company], [Project]
		WHERE
			[Project].[ID] = @ID AND
			[Company].[ID] = [Project].[SupplierCompanyID]
	END

	DECLARE @ApplyVAT TBool,
			@VATRate TPercent,
			@value TVariant
	SET @VATRate = 0
	SELECT @ApplyVAT = [Project].[ApplyVAT] FROM [Project] WHERE [Project].[ID] = @ID
	IF @ApplyVAT = 1
	BEGIN
		EXEC adfParameterGet @Name='VATRate', @Group='CommonBusiness', @Value = @value OUTPUT
		SET @VATRate = ISNULL(CAST(@value as decimal(18,4)), 0)
	END
			
	SELECT
		[Project].[Class],
		[Project].[ID],
		[Project].[State],
		[Project].[Flag],
		[Project].[Date],
		[Project].[Number],
		[Project].[FileAs],
		[Project].[ProjectTypeID],
		[Project].[ProjectLanguageCode],
		[Project].[CurrencyCode],
		[Project].[Billable],
		[Project].[RoundingInterval],
		[Project].[RoundingMode],
		[Project].[ApplyVAT],
		[Project].[RatesWithVAT],
		[Project].[InvoiceExpirationPeriod],
		[Project].[InvoiceExpirationPeriodType],
		[Project].[WSSDocumentsURL],
		[Project].[ContractNumber],
		[Project].[ContractDate],
		[Project].[Comments],
		[Project].[Created],
		[Project].[CreatedBy],
		[Project].[Modified],
		[Project].[ModifiedBy],
		[Project].[Timestamp],
		[Project].[SupplierCompanyID],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CustomerCompanyID],
		[Project].[CustomerFinanceManagerID],
		[Project].[PaymentCurrencyPoint],
		[Project].[FactureCurrency],
		[Project].[Scale],
		[Project].[MsProjectID],
		@BankAccountID AS [BankAccountID],
		@HasTasks AS [HasTasks],
		@HasTMServices AS [HasTMServices],
		[PaymentPeriod].[InvoiceNextPaymentDate],
		[PaymentPeriod].[StatementNextPaymentDate],
		[PaymentPeriod].[CalculationNextPaymentDate],
		[Project].[ProjectLanguageCode],
		[Project].[CheckTaskWorkOverdraft],
		@VATRate AS [VATRate],
		[Project].[Color],
		[Project].[ManagerAssistantEmployeeID],
		[Project].[FinanceManagerEmployeeID]
	FROM
		[Project]
		INNER JOIN [PaymentPeriod]
			ON [PaymentPeriod].[ProjectID] = [Project].[ID]
	WHERE
		[Project].[ID] = @ID
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ProjectGetInfo] TO PUBLIC
GO
