IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ProjectTemplateBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ProjectTemplateBrowse'
		DROP PROCEDURE [dbo].[pjm5ProjectTemplateBrowse]
	END
GO

PRINT 'Creating procedure pjm5ProjectTemplateBrowse'
GO

/******************************************************************************
**		File: pjm5ProjectTemplateBrowse.sql
**		Name: pjm5ProjectTemplateBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		04.07.13	SOV				  ID    	
*******************************************************************************/
CREATE PROCEDURE [pjm5ProjectTemplateBrowse]
	@StateSelector int
AS
	SET NOCOUNT ON
	
	DECLARE @TemplateClass TClass
	SET @TemplateClass = dbo.adfGetClassByName('Pjm5.ProjectTemplate')

	
	SELECT
		@TemplateClass AS [Class],
		[Project].[ID],
		[Project].[State],
		[Project].[Flag],
		[Project].[Date],
		[Project].[Number],
		[Project].[FileAs],
		[Project].[ProjectTypeID],
		[Project].[SupplierCompanyID],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CustomerCompanyID],
		[Project].[CustomerFinanceManagerID],
		[Project].[ResponsiblePersonEmployeeID],
		[Project].[PriorityID],
		ISNULL([T].[EndDate], [Project].[Date]) AS [DueDate],
		[Project].[EndDate],
		[Project].[CurrencyCode],
		[Project].[CostCenterID],
		[Project].[Budget],
		T.[ManHour] AS [PlannedManHour],
		T.[Budget] AS [PlannedBudget],
		[Project].[Billable],
		[Project].[RoundingInterval],
		[Project].[RoundingMode],
		[Project].[ContractNumber],
		[Project].[ContractDate],
		[Project].[ContractEndDate],
		[Project].[ContractSubject],
		[Project].[ServiceLevelID],
		[Project].[ApplyVAT],
		[Project].[InvoiceExpirationPeriod],
		[Project].[InvoiceExpirationPeriodType],
		[Project].[Comments],
		[Project].[Created],
		[Project].[CreatedBy],
		[Project].[Modified],
		[Project].[ModifiedBy],
		[Project].[Timestamp],
		[Project].[PaymentCurrencyPoint],
		[Budget].[ID] AS [BudgetID],
		[Project].[ManagerAssistantEmployeeID],
		[Project].[FinanceManagerEmployeeID],
		[Project].[ResponsiblePersonEmployeeID]
	FROM
		[Project] 
		INNER JOIN [ProjectDetail]
			ON [ProjectDetail].[ID] = [Project].[ID]
		INNER JOIN [ProjectTemplate]
			ON [ProjectTemplate].[ID] = [Project].[ID]
		LEFT OUTER JOIN 
			(SELECT
				[Task].[ProjectID] AS [ProjectID],
				MAX([DueDate]) AS [EndDate],
				ISNULL(SUM([ManHour]), 0) / 60.0 AS [ManHour],
				(SELECT
					ISNULL(SUM([TaskAssignment].[Work] * [Assignment].[StandardRate]), 0) / 60.0
				FROM 
					[Task] t
					INNER JOIN [TaskAssignment]
						ON [TaskAssignment].[TaskID] = t.[ID]
					INNER JOIN [Assignment]
						ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
				WHERE 
					t.[State] = 7 AND
					[Assignment].[ProjectID] = [Task].[ProjectID]
				) AS [Budget]
			FROM 
				[Task]
			WHERE
				[Task].[State] = 7
			GROUP BY
				[Task].[ProjectID]
			) AS T
			ON ([Project].[ID] = [T].[ProjectID])
		LEFT JOIN [Budget]
			ON [DocumentID] = [Project].[ID]
	WHERE
		((@StateSelector = 0) OR ([Project].[State] = (@StateSelector + 4)))
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ProjectTemplateBrowse] TO PUBLIC
GO 


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ProjectTemplateBrowseByCategory]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ProjectTemplateBrowseByCategory'
		DROP PROCEDURE [dbo].[pjm5ProjectTemplateBrowseByCategory]
	END
GO

PRINT 'Creating procedure pjm5ProjectTemplateBrowseByCategory'
GO

/******************************************************************************
**		File: pjm5ProjectTemplateBrowseByCategory.sql
**		Name: pjm5ProjectTemplateBrowseByCategory
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ProjectTemplateBrowseByCategory]
	@StateSelector int
AS
	SET NOCOUNT ON
	
	DECLARE @TemplateClass TClass
	SET @TemplateClass = dbo.adfGetClassByName('Pjm5.ProjectTemplate')
	
		
	DECLARE @none nvarchar(6)
	IF dbo.adfGetLanguage() = 'ru'
		SET @none = '()'
	ELSE
		SET @none = '(none)'
	
	SELECT
		@TemplateClass AS [Class],
		[Project].[ID],
		[Project].[State],
		[Project].[Flag],
		[Project].[Date],
		[Project].[Number],
		[Project].[FileAs],
		[Project].[ProjectTypeID],
		[Project].[SupplierCompanyID],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CustomerCompanyID],
		[Project].[ResponsiblePersonEmployeeID],
		[Project].[PriorityID],
		[Project].[EndDate],
		[Project].[CurrencyCode],
		[Project].[CostCenterID],
		[Project].[Budget],
		T.[ManHour] AS [PlannedManHour],
		T.[Budget] AS [PlannedBudget],
		[Project].[Billable],
		[Project].[RoundingInterval],
		[Project].[RoundingMode],
		[Project].[ContractNumber],
		[Project].[ContractDate],
		[Project].[ContractEndDate],
		[Project].[ContractSubject],
		[Project].[ServiceLevelID],
		[Project].[ApplyVAT],
		[Project].[InvoiceExpirationPeriod],
		[Project].[InvoiceExpirationPeriodType],
		[Project].[Comments],
		[Project].[Created],
		[Project].[CreatedBy],
		[Project].[Modified],
		[Project].[ModifiedBy],
		[Project].[Timestamp],
		ISNULL([Category].[FileAs], @none) as [Category],
		[Project].[PaymentCurrencyPoint]
	FROM
		[Project]
		INNER JOIN [ProjectTemplate]
			ON [ProjectTemplate].[ID] = [Project].[ID]
		LEFT OUTER JOIN 
			(SELECT
				[Task].[ProjectID] AS [ProjectID],
				MAX([DueDate]) AS [EndDate],
				ISNULL(SUM([ManHour]), 0) / 60.0 AS [ManHour],
				(SELECT
					ISNULL(SUM([TaskAssignment].[Work] * [Assignment].[StandardRate]), 0) / 60.0
				FROM 
					[Task] t
					INNER JOIN [TaskAssignment]
						ON [TaskAssignment].[TaskID] = t.[ID]
					INNER JOIN [Assignment]
						ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
				WHERE 
					t.[State] = 7 AND
					[Assignment].[ProjectID] = [Task].[ProjectID]
				) AS [Budget]
			FROM 
				[Task]
			WHERE
				[Task].[State] = 7
			GROUP BY
				[Task].[ProjectID]
			) AS T
			ON ([Project].[ID] = [T].[ProjectID])
		LEFT OUTER JOIN [DocumentCategory]
			ON ([DocumentCategory].[DocumentClass] = @TemplateClass AND [Project].[ID] = [DocumentCategory].[DocumentID])
		LEFT OUTER JOIN [Category]
			ON ([DocumentCategory].[CategoryID] = [Category].[ID])
	WHERE
		((@StateSelector = 0) OR ([Project].[State] = (@StateSelector + 4)))
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ProjectTemplateBrowseByCategory] TO PUBLIC
GO 