IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetAvailableProjects]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetAvailableProjects'
		DROP FUNCTION [dbo].[fnPjm5GetAvailableProjects]
	END

GO

PRINT 'Creating function fnPjm5GetAvailableProjects'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetTaskListByAssignment
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetAvailableProjects()
RETURNS @Projects TABLE ([ID] INT PRIMARY KEY, [State] INT NOT NULL)
AS
BEGIN
	DECLARE @EmployeeID INT, @hasAccess BIT
	
	SET @hasAccess = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects'))
	IF @hasAccess = 1
		INSERT INTO @Projects ([ID], [State])
		SELECT
			[Project].[ID],
			[Project].[State]
		FROM
			[Project]
		WHERE
			[Project].[State] NOT IN (5, 6)
	ELSE
	BEGIN
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
		INSERT INTO @Projects ([ID], [State])
		SELECT DISTINCT
			[Project].[ID],
			[Project].[State]
		FROM
			[Project] INNER JOIN [vwAssignment]
				ON ([Project].[ID] = [vwAssignment].[ProjectID] AND 
					(([vwAssignment].[EmployeeID] = @EmployeeID AND
					[vwAssignment].[State] = 1) OR [Project].[ProjectManagerEmployeeID] = @EmployeeID))
		WHERE
			[Project].[State] = 2
		OR
			([Project].[State] IN (1, 3, 4) AND ([Project].[ProjectManagerEmployeeID] = @EmployeeID OR @hasAccess = 1))
	END	
	RETURN
END
	
GO

GRANT SELECT ON fnPjm5GetAvailableProjects TO PUBLIC
GO
 