IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'pjm5ApproveProjectTasks')
	BEGIN
		PRINT 'Dropping Procedure pjm5ApproveProjectTasks'
		DROP  Procedure  pjm5ApproveProjectTasks
	END

GO

PRINT 'Creating Procedure pjm5ApproveProjectTasks'
GO
/******************************************************************************
**		File: 
**		Name: pjm5ApproveProjectTasks
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**     ----------							-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure pjm5ApproveProjectTasks
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON
	
	IF EXISTS (
		SELECT [Project].[ID]
		FROM [Project]
				INNER JOIN [MsProject]
					ON [MsProject].[ID] = [Project].[MsProjectID]
		WHERE
			[Project].[ID] = @ProjectID)
	BEGIN
		UPDATE [Task]
		SET
			[State] = 2,
			[Modified] = DEFAULT,
			[ModifiedBy] = DEFAULT
		WHERE [Task].[ProjectID] = @ProjectID
	RETURN 0
	END
	
	DECLARE ProjectTasks CURSOR LOCAL FORWARD_ONLY READ_ONLY FOR
			SELECT [ID], [State] FROM [Task] WHERE [ProjectID] = @ProjectID
			
		OPEN ProjectTasks
		
		DECLARE @ID TIdentifier, @State TState, @Skip BIT, @rv int
		
		FETCH NEXT FROM ProjectTasks INTO @ID, @State
		WHILE @@FETCH_STATUS = 0
		BEGIN

			IF @State = 8 -- 
			BEGIN
				SET @Skip = 0			
				IF NOT EXISTS(SELECT * FROM [TaskAssignment] WHERE [TaskID] = @ID)
				BEGIN
					SET @Skip = 1
				END
				
				IF @Skip = 0 AND EXISTS(SELECT * FROM [TaskAssignment] INNER JOIN [vwAssignment] as [Assignment]
						ON ([TaskAssignment].[AssignmentID] = [Assignment].[ID])
					WHERE [TaskID] = @ID AND [Assignment].[EmployeeID] IS NULL)
				BEGIN
					SET @Skip = 1
				END
				
				IF @Skip = 0
				BEGIN
					UPDATE [Task]
					SET
						[State] = 2,
						[Modified] = DEFAULT,
						[ModifiedBy] = DEFAULT
					WHERE [Task].[ID] = @ID
					
					IF @@ERROR != 0 GOTO ERROR_HANDLER
				END		
				ELSE
				BEGIN
					UPDATE [Task]
					SET
						[Flag] = 4,
						[Modified] = DEFAULT,
						[ModifiedBy] = DEFAULT
					WHERE
						[ID] = @ID AND [Flag] = 0
				END	
				EXEC @rv = pjm6TaskBudgetUpdate @ID
				IF @rv != 0
					GOTO ERROR_HANDLER
			END
			FETCH NEXT FROM ProjectTasks INTO @ID, @State
			END

			CLOSE ProjectTasks
			DEALLOCATE ProjectTasks
			RETURN 0
		ERROR_HANDLER:
			CLOSE ProjectTasks
			DEALLOCATE ProjectTasks
			RETURN 1
GO

