IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportCompany')
	BEGIN
		PRINT 'Dropping Procedure ReportCompany'
		DROP  Procedure  ReportCompany
	END

GO

PRINT 'Creating Procedure ReportCompany'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportCompany
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE
		@UserID			TIdentifier,
		@UserName		TName
		
	SET @UserID = dbo.adfGetCurrentUserID()
		
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID
		
	SELECT
		[Company].[LegalName],
		[Company].[FileAs],
		[Company].[LegalCode],
		[Company].[KPP],
		[Company].[FoundationDate],
		[Company].[Own],
		[Company].[State],
		[BankAccount].[BankName],
		[BankAccount].[City],
		[BankAccount].[BankCode],
		[BankAccount].[CurrencyCode],
		[BankAccount].[Account],
		[BankAccount].[IntermediaryAccount],
		[BankAccount].[AdditionalAccounts],
		[ExecutiveEmployee].[FileAs] AS [ExecutiveEmployee],
		[AccountantEmployee].[FileAs] AS [AccountanEmployee],
		[ManagerEmployee].[FileAs] AS [ManagerEmployee],
		[CompanySize].[FileAs] AS [CompanySize],
		[CompanyTurnover].[FileAs] AS [CompanyTurnover],
		dbo.fnPjm5GetContactList([Company].[ID], [Company].[Class]) AS [Contacts],
		dbo.fnPjm5GetCategoryList([Company].[ID], [Company].[Class]) AS [Categories],
		dbo.fnPjm5GetIndustryBranchList([Company].[ID]) AS [IndustryBranchList],
		dbo.fnPjm5AddressAsString([FactAddress].[Street],[FactAddress].[City],[FactAddress].[Region],[FactAddress].[PostalCode],[FactAddress].[Country]) AS [FactAddress],
		dbo.fnPjm5AddressAsString([LegalAddress].[Street],[LegalAddress].[City],[LegalAddress].[Region],[LegalAddress].[PostalCode],[LegalAddress].[Country]) AS [LegalAddress],
		dbo.fnPjm5GetPhoneList([Company].[ID], [Company].[Class]) AS [Phonelist],
		dbo.fnPjm5GetAttachmentList([Company].[ID], [Company].[Class]) AS [AttachmentList],
		@UserName AS [UserName]		
	FROM
		[Company]
			LEFT OUTER JOIN [BankAccount]
				ON [Company].[BankAccountID] = [BankAccount].[ID]
			LEFT OUTER JOIN [Employee] AS [ExecutiveEmployee]
				ON [Company].[ExecutiveEmployeeID] = [ExecutiveEmployee].[ID]
			LEFT OUTER JOIN [Employee] AS [AccountantEmployee]
				ON [Company].[AccountantEmployeeID] = [AccountantEmployee].[ID]
			LEFT OUTER JOIN [Employee] AS [ManagerEmployee]
				ON [Company].[ManagerEmployeeID] = [ManagerEmployee].[ID]
			LEFT OUTER JOIN [CompanySize]
				ON [Company].[CompanySizeID] = [CompanySize].[ID]
			LEFT OUTER JOIN [CompanyTurnover]
				ON [Company].[CompanyTurnoverID] = [CompanyTurnover].[ID]
			LEFT OUTER JOIN [BusinessCard]
				ON [Company].[ID] = [BusinessCard].[ID]	AND
				[Company].[Class] = [BusinessCard].[Class]
			LEFT OUTER JOIN [Address] AS [FactAddress]
				ON [BusinessCard].[ID] = [FactAddress].[BusinessCardID]	AND
				[BusinessCard].[Class] = [FactAddress].[BusinessCardClass] AND
				[FactAddress].[AddressTypeID] = 3
			LEFT OUTER JOIN [Address] AS [LegalAddress]
				ON [BusinessCard].[ID] = [LegalAddress].[BusinessCardID]	AND
				[BusinessCard].[Class] = [LegalAddress].[BusinessCardClass] AND
				[LegalAddress].[AddressTypeID] = 1							
	WHERE	
		[Company].[ID] = @ID
	
	SELECT
		1 AS [Table],
		NULL AS [EmployeeName],
		NULL AS [Position],
		[Company].[Comments] AS [Text]
	FROM
		[Company]
	WHERE
		[Company].[ID] = @ID
	UNION ALL	
	SELECT
		2,
		[Employee].[FileAs],
		[Position].[FileAs],
		dbo.fnPjm5GetPhoneList([Employee].[ID], [Employee].[Class])		
	FROM
		[Employee]
			LEFT OUTER JOIN [Position]
				ON [Employee].[PositionID] = [Position].[ID]
	WHERE
		[Employee].[CompanyID] = @ID
	
			
		
	
RETURN 0
GO

GRANT EXEC ON ReportCompany TO PUBLIC

GO
