IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportMRE')
	BEGIN
		PRINT 'Dropping Procedure ReportMRE'
		DROP  Procedure  ReportMRE
	END

GO

PRINT 'Creating Procedure ReportMRE'
GO
--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/

CREATE Procedure ReportMRE
	@Date			TDateTime,
	@DateSelector	int,
	@CompanyID		TIdentifier,
	@DivisionSelector int,
	@DivisionID		TIdentifier
AS
	SET NOCOUNT ON
	
	IF @DivisionID IS NULL AND @DivisionSelector=2 
	BEGIN
		RAISERROR('#DivisionIsNotSelected', 16, -1)
		RETURN 1
	END
	
	DECLARE
		@PeriodStart	TDateTime,
		@PeriodEnd		TDateTime,
		@DayCount		int,
		@TodayDate		datetime,
		@LastSymbol		char(8)	
	
	SET @TodayDate = CAST(CONVERT(varchar(8), GETDATE(), 112) AS DATETIME)	
	SET @DayCount = DATEPART(day, GETDATE())
	SET @PeriodStart = CASE	@DateSelector
		WHEN 0 THEN CAST(CONVERT(varchar(8), DATEADD(day, 1-@DayCount, GETDATE()), 112) AS datetime)
		WHEN 1 THEN CAST(CONVERT(varchar(8), DATEADD(month, -1, DATEADD(day, 1-@DayCount, GETDATE())), 112) AS datetime)
		ELSE CAST(CONVERT(varchar(8), @Date, 112) AS datetime)
	END
	SET @PeriodEnd = CASE @DateSelector
		WHEN 0 THEN DATEADD(day, 1, @TodayDate)
		ELSE DATEADD(month, 1, @PeriodStart)		
	END	
	DECLARE
		@t	table(
			[ID]		int,
			[Name]		varchar(256),
			[Logged]	int,
			[Day01]		decimal(18,2),
			[Day02]		decimal(18,2),
			[Day03]		decimal(18,2),
			[Day04]		decimal(18,2),
			[Day05]		decimal(18,2),
			[Day06]		decimal(18,2),
			[Day07]		decimal(18,2),
			[Day08]		decimal(18,2),
			[Day09]		decimal(18,2),
			[Day10]		decimal(18,2),
			[Day11]		decimal(18,2),
			[Day12]		decimal(18,2),
			[Day13]		decimal(18,2),
			[Day14]		decimal(18,2),
			[Day15]		decimal(18,2),
			[Day16]		decimal(18,2),
			[Day17]		decimal(18,2),
			[Day18]		decimal(18,2),
			[Day19]		decimal(18,2),
			[Day20]		decimal(18,2),
			[Day21]		decimal(18,2),
			[Day22]		decimal(18,2),
			[Day23]		decimal(18,2),
			[Day24]		decimal(18,2),
			[Day25]		decimal(18,2),
			[Day26]		decimal(18,2),
			[Day27]		decimal(18,2),
			[Day28]		decimal(18,2),
			[Day29]		decimal(18,2),
			[Day30]		decimal(18,2),
			[Day31]		decimal(18,2),
			[Approved]	decimal(18,2),
			[Calculation]	decimal(18,2)
		)

	INSERT INTO @t(
		[ID],
		[Name],
		[Logged],
		[Day01],
		[Day02],
		[Day03],
		[Day04],
		[Day05],
		[Day06],
		[Day07],
		[Day08],
		[Day09],
		[Day10],
		[Day11],
		[Day12],
		[Day13],
		[Day14],
		[Day15],
		[Day16],
		[Day17],
		[Day18],
		[Day19],
		[Day20],
		[Day21],
		[Day22],
		[Day23],
		[Day24],
		[Day25],
		[Day26],
		[Day27],
		[Day28],
		[Day29],
		[Day30],
		[Day31],
		[Approved],
		[Calculation]
	)
	SELECT
		[Employee].[ID],
		[Employee].[FileAs],
		CASE
			WHEN COUNT([TimeEntry].[ID]) > 0 THEN 1
			ELSE 1
		END,
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= @PeriodStart AND [TimeEntry].[StartTime] < DATEADD(day, 1, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 1, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 2, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 2, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 3, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 3, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 4, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 4, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 5, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 5, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 6, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 6, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 7, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 7, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 8, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 8, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 9, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 9, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 10, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 10, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 11, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 11, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 12, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 12, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 13, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 13, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 14, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 14, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 15, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 15, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 16, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 16, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 17, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 17, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 18, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 18, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 19, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 19, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 20, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 20, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 21, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 21, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 22, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 22, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 23, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 23, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 24, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 24, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 25, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 25, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 26, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 26, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 27, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 27, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 28, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 28, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 29, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 29, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 30, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [TimeEntry].[StartTime] >= DATEADD(day, 30, @PeriodStart) AND [TimeEntry].[StartTime] < DATEADD(day, 31, @PeriodStart) THEN [RoundedDuration] / 60.0
			ELSE NULL
		END),
		SUM(CASE 
			WHEN [TimeEntry].[State]in(3,6) THEN [TimeEntry].[RoundedDuration] / 60.0
			ELSE 0 
		END),
		SUM(CASE 
			WHEN [TimeEntry].[State]in(3,6) THEN [TimeEntry].[BillableDuration] * [TimeEntry].[Billable] / 60.0
			ELSE 0 
		END)			
	FROM
		[Employee]
			INNER JOIN [Company] 
				ON [Employee].[CompanyID] = [Company].[ID]
			LEFT OUTER JOIN [Division] 
				ON [Employee].[DivisionID] = [Division].[ID]
			LEFT OUTER JOIN	[vwTimeEntry] as [TimeEntry]
				ON ([Employee].[ID] = [TimeEntry].[EmployeeID])AND
				   ([TimeEntry].[StartTime] >= @PeriodStart AND [TimeEntry].[StartTime] < @PeriodEnd) AND
				    [TimeEntry].[State] in (2,3,6)		
				   
	WHERE
		([Employee].[CompanyID] = @CompanyID OR @CompanyID IS NULL) AND
		[Employee].[State] = 1 AND [Company].[Own] = 1 AND [Company].[State] = 1
		AND
		(
			@DivisionSelector = 0 OR 
			(@DivisionSelector = 1 AND [Employee].[DivisionID] IS NULL) OR
			(@DivisionSelector = 2 AND (@DivisionID IS NULL  OR [Employee].[DivisionID] = @DivisionID ))
		)
		
		
	GROUP BY
		[Employee].[ID],
		[Employee].[FileAs]
	ORDER BY
		[Employee].[FileAs]

	
	EXECUTE ReportMREHeader @PeriodStart, @PeriodEnd, @CompanyID, @DivisionID, @DivisionSelector

	SELECT
		[ID],
		[Name],
		[Logged],
		[Day01],
		[Day02],
		[Day03],
		[Day04],
		[Day05],
		[Day06],
		[Day07],
		[Day08],
		[Day09],
		[Day10],
		[Day11],
		[Day12],
		[Day13],
		[Day14],
		[Day15],
		[Day16],
		[Day17],
		[Day18],
		[Day19],
		[Day20],
		[Day21],
		[Day22],
		[Day23],
		[Day24],
		[Day25],
		[Day26],
		[Day27],
		[Day28],
		[Day29],
		[Day30],
		[Day31],
		CASE
			WHEN DATEADD(day, 28, @PeriodStart) < DATEADD(month, 1, @PeriodStart) THEN 1
			ELSE 0
		END AS [Present29],
		CASE
			WHEN DATEADD(day, 29, @PeriodStart) < DATEADD(month, 1, @PeriodStart) THEN 1
			ELSE 0
		END AS [Present30],
		CASE
			WHEN DATEADD(day, 30, @PeriodStart) < DATEADD(month, 1, @PeriodStart) THEN 1
			ELSE 0
		END AS [Present31],
		ISNULL([Approved], 0) AS [Approved],
		ISNULL([Calculation], 0) AS [Calculation]	
	FROM
		@t

RETURN 0
GO

GRANT EXEC ON ReportMRE TO PUBLIC

GO
