IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportRevenueDynamicsByServiceTypeHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportRevenueDynamicsByServiceTypeHeader'
		DROP  Procedure  ReportRevenueDynamicsByServiceTypeHeader
	END

GO

PRINT 'Creating Procedure ReportRevenueDynamicsByServiceTypeHeader'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/ 
CREATE PROCEDURE [dbo].[ReportRevenueDynamicsByServiceTypeHeader]
       @CompanyID TIdentifier,
       @CurrencySelector int,
       @CostCenterID TIdentifier,
	   @CostCenterSelector int,
       @ServiceTypeSelector int,
       @InvoiceSelector int,
       @DateSelector int,
       @PeriodStart  TDate OUTPUT,
       @PeriodEnd TDate OUTPUT

AS

   SET NOCOUNT ON

   DECLARE
          @CompanyName TName,	
          @Value TVariant,
          @CostCenterName TName,
          @ServiceIncludedName TName,
          @InvoiceState TName,
          @UserName TName,
          @UserID TIdentifier

   SET @CompanyName = '()'
   SET @CostCenterName  = '()'

   IF (@CostCenterSelector=1 AND @CostCenterID IS NULL)
       SET @CostCenterName = '( )'
   
   SELECT 
         @CompanyName = [Company].[FileAs]
   FROM
         [Company]
   WHERE 
         [Company].[ID] = @CompanyID
   
   IF @CurrencySelector = 0
      EXEC adfParameterGet 'BaseCurrency', 'CommonBusiness', @Value OUTPUT
   
   IF @CurrencySelector = 1
      EXEC adfParameterGet 'NationalCurrency', 'CommonBusiness', @Value OUTPUT
   
   SELECT 
         @CostCenterName = [CostCenter].[FileAs]
   FROM
         [CostCenter]
   WHERE 
         ([CostCenter].[ID] = @CostCenterID) AND (@CostCenterSelector = 1)


   SET @ServiceIncludedName = CASE @ServiceTypeSelector
                                   WHEN 0 THEN '    '
                                   WHEN 1 THEN ' '
                                   WHEN 2 THEN '  '
                              END
   IF @InvoiceSelector=0
           SET @InvoiceState = '  '
   ELSE
           SET @InvoiceState = '  '

   IF @DateSelector = 0
   BEGIN
      SET @PeriodStart = CAST(YEAR(GetDate())-1 as char(4))
      SET @PeriodEnd = CAST(YEAR(GetDate()) as char(4))
   END

   IF @DateSelector = 1
   BEGIN
      SET @PeriodStart = CAST(YEAR(GetDate())-2 as char(4))
      SET @PeriodEnd = CAST(YEAR(GetDate())-1 as char(4))
   END

   IF @DateSelector = 2
     SET @PeriodStart = CAST(YEAR(@PeriodEnd)-1 as char(4))

   SET @UserID = dbo.adfGetCurrentUserID()
	
   SELECT
         @UserName = [Trustee].[DisplayName]
   FROM 
         [Trustee]
   WHERE 
         [Trustee].[ID] = @UserID
   
   SELECT
         @CompanyName  AS [CompanyName],
         CAST(@Value AS nvarchar(32)) AS [CurrencyCode],
         @CostCenterName AS [CostCenterName],
         @ServiceIncludedName AS [SeriveIncludedName],
         @InvoiceState AS [InvoiceState],
         @PeriodStart AS [PeriodStart],
         @PeriodEnd AS [PeriodEnd],
         @UserName AS [UserName]
RETURN 0
GO

GRANT EXEC ON ReportRevenueDynamicsByServiceTypeHeader TO PUBLIC

GO
