IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportTask')
	BEGIN
		PRINT 'Dropping Procedure ReportTask'
		DROP  Procedure  ReportTask
	END

GO

PRINT 'Creating Procedure ReportTask'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportTask
	@ID TIdentifier
AS

	SET NOCOUNT ON
	DECLARE
		@UserID			TIdentifier,
		@UserName		TName,
		@WorkTime		TCount,
		@val			TVariant
		
	SET @UserID = dbo.adfGetCurrentUserID()
	
	EXEC adfParameterGet @Name='WorkTime', @Group='Pjm5', @Value = @val OUTPUT
	SET @WorkTime = CAST(@val as int)
	
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID
		
	SELECT
		[Task].[FileAs],
		[Task].[State],
		[Task].[Duration] * @WorkTime/60 AS [Duration],
		[Task].[StartDate],
		[Task].[DueDate],
		[Task].[EndDate],
		dbo.fnPjm5GetAssignmentListByTask([Task].[ID]) AS [AssignmentList],
		[Project].[FileAs] AS [ProjectName],
		[Project].[Number] AS [ProjectCode],
		[Priority].[FileAs] AS [Priority],
		[Task].[PercentComplete] * 100 AS [Percent],
 		[Task].[Milestone],
		dbo.fnPjm5GetContactList([Task].[ID], [Task].[Class]) AS [Contacts],
		dbo.fnPjm5GetCategoryList([Task].[ID], [Task].[Class]) AS [Categories],
		dbo.fnPjm5GetAttachmentList([Task].[ID], [Task].[Class]) AS [AttachmentList],
		@UserName AS [UserName]	
	FROM
		[Task]
		LEFT OUTER JOIN [Project]
			ON [Task].[ProjectID] = [Project].[ID]	
		LEFT OUTER JOIN [Priority]
			ON [Task].[PriorityID] = [Priority].[ID]	
	WHERE
		[Task].[ID] = @ID	
		
	
	SELECT
		1 AS [Table],
		[Task].[Comments] AS [Taxt],
		NULL AS [Date],
		NULL AS [DisplayName]		
	FROM
		[Task]
	WHERE
		[Task].[ID] = @ID		
		
	UNION ALL
	SELECT
		2,
		[Note].[Text],
		[Note].[Created],
		[Trustee].[DisplayName]
	FROM
		[Task]
		INNER JOIN [Note]
			ON [Task].[ID] = [Note].[DocumentID] AND
			   [Task].[Class] = [Note].[DocumentClass]
		INNER JOIN [Trustee]
			ON ([Note].[CreatedBy] = [Trustee].[ID])
	WHERE
		[Task].[ID] = @ID 
	ORDER BY 
		3 ASC		


GO

GRANT EXEC ON ReportTask TO PUBLIC

GO
