IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportWREHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportWREHeader'
		DROP  Procedure  ReportWREHeader
	END

GO

PRINT 'Creating Procedure ReportWREHeader'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportWREHeader
	@CompanyID		int,
	@WeekStart	    Tdatetime,
	@NextDate		Tdatetime,
	@DivisionID		TIdentifier,
	@DivisionSelector		int
	

AS
	SET NOCOUNT ON
	SET DATEFIRST 7
	DECLARE
		@UserID			TIdentifier,
		@UserName		TName,
		@CompanyName	TName,
		@DivisionName	TName,
		@value			TVariant,
		@WorkTime		decimal(18,2)
		
	EXEC adfParameterGet 'WorkTime', 'Pjm5', @value OUTPUT  
	SET @WorkTime = CAST(@value AS decimal(18,2))
	SET @WorkTime = @WorkTime / 60.00		
						
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @CompanyName = '()'
	SET @DivisionName = CASE @DivisionSelector
         WHEN 0 THEN '()'
         WHEN 1 THEN ' '
         WHEN 2 THEN '()'
  	END
	
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID
		
	SELECT
		@CompanyName = [Company].[FileAs]
	FROM
		[Company]
	WHERE
		[Company].[ID] = @CompanyID
	
	SELECT
	@DivisionName = [Division].[FileAs]

	FROM
		[Division]
	WHERE
		[Division].[ID] = @DivisionID		
	
	SELECT
		@CompanyName AS [CompanyName],
		@DivisionName AS [DivisionName],
		@WeekStart AS [WeekStart],
		DATEADD(second, -1, DATEADD(week, 1, @WeekStart)) AS [WeekEnd],
		@UserName AS [UserName],
		dbo.fnPjm5GetWorkingDays(@WeekStart, DATEADD(second, -1, @NextDate)) AS [WorkingDays],
		@WorkTime AS [WorkTime]
	

RETURN 0
GO

GRANT EXEC ON ReportWREHeader TO PUBLIC

GO
