SET QUOTED_IDENTIFIER ON
GO 

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalendarResourceUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalendarResourceUpdate'
		DROP PROCEDURE [dbo].[pjm5CalendarResourceUpdate]
	END
GO

PRINT 'Creating procedure pjm5CalendarResourceUpdate'
GO

/******************************************************************************
**		File: CalendarEmployeeUpdate.sql
**		Name: pjm5CalendarResourceUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/15/2006 16:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CalendarResourceUpdate]
	@Xml XML
AS
	DECLARE @UserID TIdentifier, @doc xml
	
	SET NOCOUNT ON

	SET @doc = @Xml

	SET @UserID = dbo.adfGetCurrentUserID()
		
	BEGIN TRANSACTION
	
	DELETE [CalendarResource] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [CalendarResource] ([UserID], [ResourceID])
	SELECT
		@UserID,
		T.c.value('(.)[1]', 'int')
	FROM
		@doc.nodes('/Resources/ID') T(c)
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
		
	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON [pjm5CalendarResourceUpdate] TO PUBLIC
GO
