IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceBrowseSelectorDialog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceBrowseSelectorDialog'
		DROP PROCEDURE [dbo].[pjm5ServiceBrowseSelectorDialog]
	END
GO

PRINT 'Creating procedure pjm5ServiceBrowseSelectorDialog'
GO

/******************************************************************************
**		File: ServiceBrowseSelectorDialog.sql
**		Name: pjm5ServiceBrowseSelectorDialog
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/18/2005 20:56:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		22.07.10	SYV				      
**		31.03.14	BAO				   
**									 
**		01.04.14	BAO				   
**									 
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceBrowseSelectorDialog]
	@Code varchar(256),
	@FileAs varchar(256),
	@PaymentTermID TIdentifier,
	@ServiceTypeID TIdentifier,
	@ProjectID TIdentifier,
	@Assigned bit,
	@IncludingRecordsOfSubprojects bit = 0
AS
	SET NOCOUNT ON

	IF @ProjectID IS NULL
	BEGIN
		RETURN 0
	END

	DECLARE
		@CurrencyCode TCode,
		@ApplyVAT TBool,
		@VATRate TAmount,
		@value TVariant
	SET @VATRate = 0
	SELECT @ApplyVAT = [Project].[ApplyVAT] FROM [Project] WHERE [Project].[ID] = @ProjectID
	IF @ApplyVAT = 1
	BEGIN
		EXEC adfParameterGet @Name='VATRate', @Group='CommonBusiness', @Value = @value OUTPUT
		SET @VATRate = ISNULL(CAST(@value as decimal(18,4)), 0)
	END

	SELECT @CurrencyCode = [CurrencyCode] FROM [Project] WHERE [ID] = @ProjectID

	--      
	DECLARE @subprojectsTable TABLE 
	(
		[Class] TClass,
		[ID] TIdentifier,
		[State] TState,
		[Flag] TFlag,
		[Date] TDate,
		[Number] TCode,
		[FileAs] TName,
		[ProjectTypeID] TIdentifier,
		[SupplierCompanyID] TIdentifier,
		[ProjectManagerEmployeeID] TIdentifier,
		[CustomerCompanyID] TIdentifier,
		[CustomerFinanceManagerID] TIdentifier,
		[ResponsiblePersonEmployeeID] TIdentifier,
		[PriorityID] TIdentifier,
		[DueDate] TDate,
		[EndDate] TDate,
		[CurrencyCode] TCode3,
		[CostCenterID] TIdentifier,
		[ManHour] TCount,
		[Budget] TMoney,
		[PlannedManHour] TCount,
		[PlannedBudget] TMoney,
		[Billable] TBool,
		[RoundingInterval] TCount,
		[RoundingMode] TIdentifier,
		[ContractNumber] TCode,
		[ContractDate] TDate,
		[ContractEndDate] TDate,
		[ContractSubject] TName,
		[ServiceLevelID] TIdentifier,
		[ApplyVAT] TBool,
		[InvoiceExpirationPeriod] TCount,
		[InvoiceExpirationPeriodType] TIdentifier,
		[Comments] TNotes,
		[Created] TSysDateTime,
		[CreatedBy] TUserID,
		[Modified] TSysDateTime,
		[ModifiedBy] TUserID,
		[ExchangeSystemName] TName,
		[Timestamp] varbinary(MAX),
		[PercentComplete] TPercent,
		[PC] INT,
		[PaymentCurrencyPoint] TIdentifier,
		[IsConsignor] TBool,
		[Consignor] TName,
		[ConsignorContract] TName,
		[ParentProjectID] INT,
		[ManagerAssistantEmployeeID] TIdentifier,
		[FinanceManagerEmployeeID] TIdentifier
	);

	--     
	INSERT INTO @subprojectsTable exec pjm6SubProjectBrowse @ParentProjectID=@ProjectID,@StateSelector=2,
		@CanCreateCalculation = 1

	IF @Assigned = 0
	BEGIN
		SELECT
			[Service].[Class],
			[Service].[ID],
			[Service].[State],
			[Service].[Flag],
			[Project].[Number] as [ProjectNumber],
			[Service].[Code],
			[Service].[FileAs],
			[Service].[PaymentTermID],
			[DocumentGlobal].[FileAs] AS [PaymentTerm],
--			CAST(NULL AS int) AS [Amount],
--			CASE [Service].[VATIsIncluded]
--				WHEN 0 THEN [ServicePrice].[Price]
--				ELSE [ServicePrice].[Price] / (1 + @VATRate)
--			END AS [Price],
--			CASE [Service].[VATIsIncluded]
--				WHEN 0 THEN [ServicePrice].[Price] * (1 + @VATRate)
--				ELSE [ServicePrice].[Price]
--			END AS [PriceWithVAT],
			[Service].[Created],
			[Service].[CreatedBy],
			[Service].[Modified],
			[Service].[ModifiedBy],
			[Service].[Timestamp]
		FROM
			[Service]
			LEFT OUTER JOIN [ServicePrice]
				ON ([Service].[ID] = [ServicePrice].[ServiceID] AND
					[ServicePrice].[CurrencyCode] = @CurrencyCode)
			LEFT OUTER JOIN [PaymentTerm]
				ON [PaymentTerm].[ID] = [Service].[PaymentTermID]
			LEFT OUTER JOIN [DocumentGlobal]
				ON ([PaymentTerm].[Class] = [DocumentGlobal].[Class] AND
					[PaymentTerm].[ID] = [DocumentGlobal].[ID] AND
					[DocumentGlobal].[Language] = dbo.adfGetLanguage())	
			INNER JOIN [Project]
				ON [Project].[ID] = @ProjectID		
		WHERE
			([Service].[State] = 1) AND
			(@Code IS NULL OR [Service].[Code] LIKE @Code) AND
			(@FileAs IS NULL OR [Service].[FileAs] LIKE @FileAs) AND
			(@PaymentTermID IS NULL OR [PaymentTerm].[ID] = @PaymentTermID) AND
			(@ServiceTypeID IS NULL OR [Service].[ServiceTypeID] = @ServiceTypeID)
	END
	ELSE
	BEGIN
		SELECT
			[ServiceAssignment].[Class],
			[ServiceAssignment].[ID],
			[ServiceAssignment].[State],
			[ServiceAssignment].[Flag],
			[Project].[Number] as [ProjectNumber],
			[Service].[Code],
			[ServiceAssignment].[FileAs],
			[Service].[PaymentTermID],
			[DocumentGlobal].[FileAs] AS [PaymentTerm],
--			1.0 AS [Amount],
--			CASE [ServiceAssignment].[VATIsIncluded]
--				WHEN 0 THEN [ServiceAssignment].[Price]
--				ELSE [ServiceAssignment].[Price] / (1 + @VATRate)
--			END AS [Price],
--			CASE [ServiceAssignment].[VATIsIncluded]
--				WHEN 0 THEN [ServiceAssignment].[Price] * (1 + @VATRate)
--				ELSE [ServiceAssignment].[Price]
--			END AS [PriceWithVAT],
			[ServiceAssignment].[Created],
			[ServiceAssignment].[CreatedBy],
			[ServiceAssignment].[Modified],
			[ServiceAssignment].[ModifiedBy],
			[ServiceAssignment].[Timestamp]
		FROM
			[ServiceAssignment]
			INNER JOIN [Service] 
				ON [Service].[ID] = [ServiceAssignment].[ServiceID]
			LEFT OUTER JOIN [PaymentTerm]
				ON [PaymentTerm].[ID] = [Service].[PaymentTermID]
			LEFT OUTER JOIN [DocumentGlobal]
				ON ([PaymentTerm].[Class] = [DocumentGlobal].[Class] AND
					[PaymentTerm].[ID] = [DocumentGlobal].[ID] AND
					[DocumentGlobal].[Language] = dbo.adfGetLanguage())	
			INNER JOIN [Project]
				ON [Project].[ID] = [ServiceAssignment].[ProjectID]
		WHERE
			[ServiceAssignment].[State] IN (1, 6) AND
			(@Code IS NULL OR [Service].[Code] LIKE @Code) AND
			(@FileAs IS NULL OR [Service].[FileAs] LIKE @FileAs) AND
			(@PaymentTermID IS NULL OR [PaymentTerm].[ID] = @PaymentTermID) AND
			(@ServiceTypeID IS NULL OR [ServiceAssignment].[ServiceTypeID] = @ServiceTypeID)
		AND
			(
				(
					@IncludingRecordsOfSubprojects = 1 AND 
					[ServiceAssignment].[ProjectID] IN (SELECT [ID] FROM @subprojectsTable)
				) OR
				(
					[ServiceAssignment].[ProjectID] = @ProjectID
				)
			)
		
	END		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ServiceBrowseSelectorDialog] TO PUBLIC
GO
  