IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6NextPaymentDateGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6NextPaymentDateGet'
		DROP PROCEDURE [dbo].[pjm6NextPaymentDateGet]
	END
GO

PRINT 'Creating procedure pjm6NextPaymentDateGet'
GO

/******************************************************************************
**		File: pjm6NextPaymentDateGet.sql
**		Name: pjm6NextPaymentDateGet
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: yuriy.soldatkin
**		Date: 09.09.09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6NextPaymentDateGet]
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT 
		[StatementNextPaymentDate],
		[InvoiceNextPaymentDate] 
	FROM 
		[PaymentPeriod] 
	WHERE 
		[ProjectID]=@ProjectID

	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm6NextPaymentDateGet] TO PUBLIC
GO  