IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceRequestMyNext7DaysBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceRequestMyNext7DaysBrowse'
		DROP PROCEDURE [dbo].[pjm5ServiceRequestMyNext7DaysBrowse]
	END
GO

PRINT 'Creating procedure pjm5ServiceRequestMyNext7DaysBrowse'
GO

/******************************************************************************
**		File: pjm5ServiceRequestMyNext7DaysBrowse.sql
**		Name: pjm5ServiceRequestMyNext7DaysBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 08/02/2005 14:07:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceRequestMyNext7DaysBrowse]
AS
	SET NOCOUNT ON
	
	DECLARE
		@PeriodStart TDateTime,
		@PeriodEnd TDateTime,
		@CurrentEmployeeID TIdentifier
	
	SET @CurrentEmployeeID =  dbo.adfGetCurrentEmployeeID()
	DECLARE @ViewAllFinance TBool
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SELECT
		@PeriodStart = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime),
		@PeriodEnd = DATEADD(day, 7, @PeriodStart)
	
	SELECT
		[ServiceRequest].[Class],
		[ServiceRequest].[ID],
		[ServiceRequest].[ProjectID],
		[ServiceRequest].[EmployeeID],
		[ServiceRequest].[PriorityID],
		[ServiceRequest].[State],
		[ServiceRequest].[Flag],
		[ServiceRequest].[Date],
		[ServiceRequest].[Number],
		[ServiceRequest].[FileAs],
		[ServiceRequest].[Description],
		[ServiceRequest].[StartDate],
		[ServiceRequest].[DueDate],
		[ServiceRequest].[Billable],
		[ServiceRequest].[VATIsIncluded],
		[ServiceRequest].[Comments],
		[ServiceRequest].[Created],
		[ServiceRequest].[CreatedBy],
		[ServiceRequest].[Modified],
		[ServiceRequest].[ModifiedBy],
		[ServiceRequest].[Timestamp],
		[Project].[SupplierCompanyID],
		[Project].[CustomerCompanyID],
		[Project].[CurrencyCode] AS [CurrencyCode],
		[Project].[CurrencyCode] AS [ProjectCurrencyCode],
		[ServiceRequest].[ManHour],
		[ServiceRequest].[ActualManHour],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
				THEN [ServiceRequest].[ActualBudget]
			ELSE -1
		END AS [ActualBudget]
	FROM
		[ServiceRequest]
		INNER JOIN [Project]
			ON [Project].[ID] = [ServiceRequest].[ProjectID]
	WHERE
		([ServiceRequest].[State] IN (2, 3))
		AND
		(
		[ServiceRequest].[DueDate] IS NULL OR
		([ServiceRequest].[DueDate] >= @PeriodStart AND	[ServiceRequest].[DueDate] < @PeriodEnd)
		)
		AND		
		[ServiceRequest].[EmployeeID] = @CurrentEmployeeID
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ServiceRequestMyNext7DaysBrowse] TO PUBLIC
GO 