IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskAssignmentRemainingUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6TaskAssignmentRemainingUpdate'
		DROP PROCEDURE [dbo].[pjm6TaskAssignmentRemainingUpdate]
	END
GO

PRINT 'Creating procedure pjm6TaskAssignmentRemainingUpdate'
GO


CREATE PROCEDURE pjm6TaskAssignmentRemainingUpdate
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE 
		@RemainingWork TAmount,
		@RemainingOvertimeWork TAmount
		
	SELECT
		@RemainingWork = [RemainingWork] - [TimeEntry].[Duration],
		@RemainingOvertimeWork =
			CASE 
				WHEN [Task].[MsTaskID] IS NOT NULL AND [TimeEntry].[Overtime] = 1
					THEN [RemainingOvertimeWork] - [TimeEntry].[Duration] 
				ELSE [RemainingOvertimeWork] 
			END
	FROM
		[TaskAssignment]
			INNER JOIN [Task]
				ON [Task].[ID] = [TaskAssignment].[TaskID]
			INNER JOIN [TimeEntry]
				ON [Task].[ID] = [TimeEntry].[TaskID] AND
					[TaskAssignment].[AssignmentID] =[TimeEntry].[AssignmentID]
	WHERE
		[TimeEntry].[ID] = @ID

	UPDATE [TaskAssignment]
	SET 
		[RemainingWork] = CASE WHEN @RemainingWork < 0 THEN 0 ELSE @RemainingWork END,
		[RemainingOvertimeWork] =CASE WHEN @RemainingOvertimeWork < 0 THEN 0 ELSE @RemainingOvertimeWork END
	FROM	
		[TaskAssignment]
		INNER JOIN [TimeEntry]
			ON [TaskAssignment].[TaskID] = [TimeEntry].[TaskID] AND
				[TaskAssignment].[AssignmentID] = [TimeEntry].[AssignmentID]
	WHERE 
		[TimeEntry].[ID] = @ID					
	
	IF @@ERROR != 0
		RETURN 1

RETURN 0
GO
GRANT EXECUTE ON pjm6TaskAssignmentRemainingUpdate TO PUBLIC
GO
 