IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[Pjm5GetNextWorkDayPeriod]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure Pjm5GetNextWorkDayPeriod'
		DROP PROCEDURE [dbo].[Pjm5GetNextWorkDayPeriod]
	END
GO

PRINT 'Creating procedure Pjm5GetNextWorkDayPeriod'
GO

/******************************************************************************
**		File: Pjm5GetNextWorkDayPeriod.sql
**		Name: Pjm5GetNextWorkDayPeriod
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 15/01/2010
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [Pjm5GetNextWorkDayPeriod]
	@Date datetime,
	@StartTime datetime OUTPUT,
	@EndTime datetime OUTPUT
AS
BEGIN
	DECLARE @WorkTimeStart		int,
			@WorkTimeEnd		int,
			@varStart1			TVariant,
			@varStart2			TVariant,
			@varTimeEnd1		TVariant,
			@varTimeEnd2			TVariant,
			@WorkDateTimeEnd	datetime,
			--@StartTime			datetime,
			--@EndTime			datetime,
			@WorkWeek			TVariant,
			@daymask			int

	EXEC adfParameterGet @Name='WorkTimeStart1', @Group='Pjm5', @Value = @varStart1 OUTPUT
	EXEC adfParameterGet @Name='WorkTimeStart2', @Group='Pjm5', @Value = @varStart2 OUTPUT
	EXEC adfParameterGet @Name='WorkTimeEnd1', @Group='Pjm5', @Value = @varTimeEnd1 OUTPUT
	EXEC adfParameterGet @Name='WorkTimeEnd2', @Group='Pjm5', @Value = @varTimeEnd2 OUTPUT
	SET @WorkTimeStart = CAST(ISNULL(@varStart1, @varStart2) as int)
	SET @WorkTimeEnd = CAST(ISNULL(@varTimeEnd2, @varTimeEnd1) as int)

	SELECT @WorkWeek = Value FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Name]='WorkDaysOfWeek' AND [Group]='Pjm5'
	SET @daymask = CAST(@WorkWeek as int)

	SET @WorkDateTimeEnd = DateAdd(minute,@WorkTimeEnd, CAST(CONVERT(varchar(8), @Date, 112) AS DATETIME))
	IF(@WorkDateTimeEnd > @Date and dbo.fnPjm5IsWorkingDayByMask(@Date, @daymask) = 1)
	BEGIN
		SET @StartTime = DateAdd(minute,@WorkTimeStart, CAST(CONVERT(varchar(8), @Date, 112) AS DATETIME))
	END
	ELSE
	BEGIN
		DECLARE @find		bit,
				@curdate	datetime
		SET @curdate = DateAdd(minute,@WorkTimeStart, CAST(CONVERT(varchar(8), @Date, 112) AS DATETIME))
		SET @find = 0
		WHILE (@find = 0)
		BEGIN
			SET @curdate = DATEADD(day, 1, @curdate)
			IF (dbo.fnPjm5IsWorkingDayByMask(@curdate, @daymask) = 1)
			BEGIN
				SET @StartTime = @curdate
				SET @find = 1
			END
		END
	END

	DECLARE @findEndDate		bit,
			@enddate			datetime
	SET @findEndDate = 0
	SET @enddate = DateAdd(minute,@WorkTimeEnd, CAST(CONVERT(varchar(8), @StartTime, 112) AS DATETIME))
	WHILE (@findEndDate = 0)
	BEGIN
		SET @enddate = DATEADD(day, 1, @enddate)
		IF (dbo.fnPjm5IsWorkingDayByMask(@enddate, @daymask) = 1)
		BEGIN
			SET @EndTime = @enddate
			SET @findEndDate = 1
		END
	END
	select @StartTime, @EndTime
	RETURN 0
END
GO

GRANT EXECUTE ON [Pjm5GetNextWorkDayPeriod] TO PUBLIC
GO