IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[TaskRequestBrowseSelectorDialog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure TaskRequestBrowseSelectorDialog.'
		DROP PROCEDURE [dbo].[TaskRequestBrowseSelectorDialog]
	END
GO

PRINT 'Creating procedure TaskRequestBrowseSelectorDialog.'
GO

SET QUOTED_IDENTIFIER ON
GO

/******************************************************************************
**		File: TaskRequestBrowseSelectorDialog.sql
**		Name: TaskRequestBrowseSelectorDialog
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [TaskRequestBrowseSelectorDialog]
	@EmployeeID TIdentifier,
	@ProjectID TIdentifier,
	@State TIdentifier,
	@View int
AS
	SET NOCOUNT ON
	
	DECLARE @StateClass TClass
	
	SET @StateClass = dbo.adfGetClassByName('Pjm5.TaskRequest')
	
	IF (@EmployeeID = 0)
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SELECT DISTINCT
		[TaskRequest].[ID],
		[TaskRequest].[State],
		[TaskRequest].[ProjectID],
		[TaskRequest].[FileAs],
		[TaskRequest].[StartTime],
		[TaskRequest].[DueTime],
		[Supervisor].[FileAs] as [Supervisor]
	FROM
		[TaskRequest]
		LEFT OUTER JOIN [Employee] [Supervisor]
			ON [Supervisor].[ID] = [TaskRequest].[SupervisorEmployeeID]
		LEFT OUTER JOIN [TaskRequestAssignment]
			ON [TaskRequestAssignment].[TaskRequestID] = [TaskRequest].[ID] AND [TaskRequestAssignment].[EmployeeID] = @EmployeeID
		INNER JOIN dbo.fnPjm6GetAvailableProjectsForTimeEntryGet(@EmployeeID, @ProjectID) AS [Project]
			ON [Project].[ID] = [TaskRequest].[ProjectID]
		LEFT OUTER JOIN [Employee] [Creator]
			ON [Creator].[UserID] = [TaskRequest].[CreatedBy]
	WHERE
		[TaskRequest].[State] IN (2) AND
		[TaskRequest].[DocumentCardID] IS NULL AND 
		(
			[TaskRequest].[ProjectID] = @ProjectID OR
			@ProjectID IN (0, -1, -2, -3, -4)
			
		) AND
		(
			--  
			@View = 0 OR 
			--   
			(@View = 1 AND [TaskRequestAssignment].[EmployeeID] = @EmployeeID) OR 
			--   
			(@View = 2 AND [TaskRequest].[SupervisorEmployeeID] = @EmployeeID) OR
			--  
			(@View = 3 AND [Creator].[ID] = @EmployeeID)
		)

	
	RETURN 0
GO

GRANT EXECUTE ON [TaskRequestBrowseSelectorDialog] TO PUBLIC
GO

