IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[TaskRequestBrowseSelectorDialogCalculation]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure TaskRequestBrowseSelectorDialogCalculation.'
		DROP PROCEDURE [dbo].[TaskRequestBrowseSelectorDialogCalculation]
	END
GO

PRINT 'Creating procedure TaskRequestBrowseSelectorDialogCalculation.'
GO

SET QUOTED_IDENTIFIER ON
GO

/******************************************************************************
**		File: TaskRequestBrowseSelectorDialog.sql
**		Name: TaskRequestBrowseSelectorDialog
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [TaskRequestBrowseSelectorDialogCalculation]
	@EmployeeID TIdentifier,
	@ProjectID TIdentifier,
	@State TIdentifier,
	@View int
AS
	SET NOCOUNT ON
	
	DECLARE @StateClass TClass
	
	SET @StateClass = dbo.adfGetClassByName('Pjm5.TaskRequest')
	
	IF (@EmployeeID = 0)
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	DECLARE
		@BudgetLineWork Table([ID] TIdentifier,[DocumentID] TIdentifier)

	IF (@State = 6)
	BEGIN
		SELECT
			[TaskRequest].[ID],
			[TaskRequest].[State],
			[TaskRequest].[ProjectID],
			[TaskRequest].[FileAs],
			[TaskRequest].[StartTime],
			[TaskRequest].[DueTime],
			[TaskRequest].[SupervisorAssignmentID] as [Supervisor]
		FROM
			[TaskRequest]
			LEFT JOIN [BudgetLineExpense]
				ON [BudgetLineExpense].[DocumentID] = [TaskRequest].[ID]
			LEFT JOIN [BudgetLineWork]
				ON [BudgetLineWork].[DocumentID] = [TaskRequest].[ID]
		WHERE
			[TaskRequest].[State] = 6 AND
			[TaskRequest].[ProjectID] = @ProjectID AND
			[BudgetLineWork].[DocumentID] IS NULL AND [BudgetLineExpense].[DocumentID] IS NULL
	END
	ELSE
	BEGIN
	SELECT DISTINCT
		[TaskRequest].[ID],
		[TaskRequest].[State],
		[TaskRequest].[ProjectID],
		[TaskRequest].[FileAs],
		[TaskRequest].[StartTime],
		[TaskRequest].[DueTime],
		[Supervisor].[FileAs] as [Supervisor]
	FROM
		[TaskRequest]
		LEFT OUTER JOIN [Employee] [Supervisor]
			ON [Supervisor].[ID] = [TaskRequest].[SupervisorEmployeeID]
		LEFT OUTER JOIN [TaskRequestAssignment]
			ON [TaskRequestAssignment].[TaskRequestID] = [TaskRequest].[ID] AND [TaskRequestAssignment].[EmployeeID] = @EmployeeID
		INNER JOIN dbo.fnPjm6GetAvailableProjectsForTimeEntryGet(@EmployeeID, @ProjectID) AS [Project]
			ON [Project].[ID] = [TaskRequest].[ProjectID]
		LEFT OUTER JOIN [Employee] [Creator]
			ON [Creator].[UserID] = [TaskRequest].[CreatedBy]
			LEFT JOIN [BudgetLineWork]
				ON [BudgetLineWork].[DocumentID] = [TaskRequest].[ID]
			LEFT JOIN [BudgetLineExpense]
				ON [BudgetLineExpense].[DocumentID] = [TaskRequest].[ID]
	WHERE
		[TaskRequest].[State] IN (2, 3, 4, 5) AND
		[TaskRequest].[DocumentCardID] IS NULL AND 
			[BudgetLineWork].[DocumentID] IS NULL AND [BudgetLineExpense].[DocumentID] IS NULL AND
		(
			[TaskRequest].[ProjectID] = @ProjectID OR
			@ProjectID IN (0, -1, -2, -3, -4)
			
		) AND
		(
			-- все доступные
			@View = 0 OR 
			-- все где участник
			(@View = 1 AND [TaskRequestAssignment].[EmployeeID] = @EmployeeID) OR 
			-- все где супервайзер
			(@View = 2 AND [TaskRequest].[SupervisorEmployeeID] = @EmployeeID) OR
			-- все созданные
			(@View = 3 AND [Creator].[ID] = @EmployeeID)
		)AND
		(
			[TaskRequest].[State] = @State OR	-- только указанного состояния
			@State = 0 -- все доступные состояния
		)
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [TaskRequestBrowseSelectorDialogCalculation] TO PUBLIC
GO

