IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskRequestUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskRequestUpdate'
		DROP PROCEDURE [dbo].[pjm5TaskRequestUpdate]
	END
GO

PRINT 'Creating procedure pjm5TaskRequestUpdate'
GO

/******************************************************************************
**		File: pjm5TaskRequestUpdate.sql
**		Name: pjm5TaskRequestUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/21/2006 18:26:20
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.07.10	MAN				 ,     .
**		21.03.13	MAB				  OPENXML
**		01.07.13	SOV				    ,  ,  
**									  
*******************************************************************************/
CREATE PROCEDURE pjm5TaskRequestUpdate
	@Xml XML
AS
	DECLARE 	
		@ID						TIdentifier,
		@FileAs					TName,
		@ProjectID				TIdentifier,
		@PriorityID				TIdentifier,
		@DueTime				TDateTime,
		@StartTime				TDateTime,
		@SendStatusReport		TBool,
		@TaskRequestStatusID	TIdentifier,
		@PercentComplete		int,
		@Comments				TNotes,
		@CurrentUserID			TIdentifier,
		@CurrentEmployeeID		TIdentifier,
		@RecurrenceID			TIdentifier,
		@ReminderState			TState,
		@ReminderInterval		TTimeSpan,
		@DocumentCardID			TIdentifier,
		@EmployeeID				TIdentifier,
		@SupervisorEmployeeID	TIdentifier,
		@EndTime				TDateTime,
		@Resolution				TNotes,
		@DocumentEditAccess		TBool,
		@ManageAllTaskRequest	TBool,
		@ManHour				TCount,
		@Budget					TMoney,
		@AssignmentID			TIdentifier,
		@SupervisorAssignmentID	TIdentifier

	SET @ManageAllTaskRequest = dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllTaskRequest'))
	
	DECLARE -- RECURRENCE
		@RStartDate TDate, 
		@REndDate TDate, 
		@RRecurrenceType TIdentifier, 
		@ROccurrences TCount,
		@RInterval TCount, 
		@RDayOfWeekMask TIdentifier, 
		@RInstance TIdentifier, 
		@RMonthOfYear TCount, 
		@RDayOfMonth TCount,
		@Recurrence TBool,
		@Class TClass,
		@State TState,
		@Creator TIdentifier
	
	SET NOCOUNT ON
	
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()

	SELECT
		@DocumentCardID			= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/DocumentCardID)[1]','int'),
		@ID						= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/ID)[1]','int'),
		@FileAs					= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/FileAs)[1]','nvarchar(256)'),
		@ProjectID				= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/ProjectID)[1]','int'),
		@EmployeeID				= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/EmployeeID)[1]','int'),
		@AssignmentID			= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/AssignmentID)[1]','int'),
		@SupervisorEmployeeID	= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/SupervisorEmployeeID)[1]','int'),
		@SupervisorAssignmentID	= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/SupervisorAssignmentID)[1]','int'),
		@PriorityID				= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/PriorityID)[1]','int'),
		@PercentComplete		= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/PercentComplete)[1]','int'),
		@DueTime				= CAST(@Xml.value('(/pjm5TaskRequestGet/TaskRequest/DueTime)[1]','varchar(19)') as datetime),
		@StartTime				= CAST(@Xml.value('(/pjm5TaskRequestGet/TaskRequest/StartTime)[1]','varchar(19)') as datetime),
		@EndTime				= CAST(@Xml.value('(/pjm5TaskRequestGet/TaskRequest/EndTime)[1]','varchar(19)') as datetime),
		@SendStatusReport		= (CASE @Xml.value('(/pjm5TaskRequestGet/TaskRequest/SendStatusReport)[1]','varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@TaskRequestStatusID	= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/TaskRequestStatusID)[1]','int'),
		@RecurrenceID			= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/RecurrencePatternID)[1]','int'),
		@Resolution				= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/Resolution)[1]','nvarchar(max)'),
		@DocumentEditAccess		= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/DocumentEditAccess)[1]','bit'),
		@Comments				= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/Comments)[1]','nvarchar(max)'),
		@ReminderState			= (CASE @Xml.value('(/pjm5TaskRequestGet/TaskRequest/ReminderState)[1]','varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@ReminderInterval		= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/ReminderInterval)[1]','int'),
		@ManHour				= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/ManHour)[1]','int'),
		@Budget					= @Xml.value('(/pjm5TaskRequestGet/TaskRequest/Budget)[1]','decimal(18,4)')
	
	IF @ProjectID IS NOT NULL 
	BEGIN 
		IF	(
				(	
					SELECT 
						COUNT(*)
					FROM 
						@Xml.nodes('/pjm5TaskRequestGet/TaskRequestAssignment') AS T(c)
				) !=	(
							SELECT 
								COUNT(*) AS Expr1
							FROM 
								[vwAssignment]
							WHERE 
							(
								[ProjectID] = @ProjectID
							) AND 
							((
								[State] = 1 AND
								[EmployeeID] IN	(	
													SELECT 
														T.c.value('EmployeeID[1]','int')
													FROM 
														@Xml.nodes('/pjm5TaskRequestGet/TaskRequestAssignment') AS T(c)
												)
							) OR
							(
								[State] = 3 AND
								[ID] IN	(	
											SELECT 
												T.c.value('AssignmentID[1]','int')
											FROM 
												@Xml.nodes('/pjm5TaskRequestGet/TaskRequestAssignment') AS T(c)
									)
							))
				)
			)
		BEGIN 
			RAISERROR ('#notassignedtospecifiedproject', 18, - 1) 
			RETURN 1 
		END 
	END

	IF EXISTS
	(
		SELECT *
		FROM
			[TaskRequest]
		WHERE
			[TaskRequest].[ID] = @ID AND
			@ManageAllTaskRequest <> 1 AND
			[CreatedBy] <> @CurrentUserID AND
			dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) <> 1 AND
			--   
			(
				ISNULL([EmployeeID], 0) <> ISNULL(@EmployeeID, 0) OR
				ISNULL([PercentComplete], 0) <> ISNULL(@PercentComplete, 0) AND
				ISNULL(@SupervisorEmployeeID, 0) <> @CurrentEmployeeID AND			
				ISNULL(@EmployeeID, 0) <> @CurrentEmployeeID
			)
	)
	BEGIN
		RAISERROR('#NotEnoughPermissionsForUpdate', 18, -1)
		RETURN 1
	END

	SELECT
		@State = [State],
		@Class = [Class],
		@Creator = [CreatedBy]
	FROM
		[TaskRequest]
	WHERE
		[ID] = @ID

	IF @State = 2 AND NOT EXISTS(SELECT * FROM @Xml.nodes('/pjm5TaskRequestGet/TaskRequestAssignment') AS List(XmlTable))
	BEGIN
		RAISERROR('#taskrequestisnotassigned', 18, -1)
		RETURN 0
	END

	SET @Recurrence = 0
	IF (SELECT @Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/ID)[1]', 'int')) IS NOT NULL
	BEGIN
		SET @Recurrence = 1
		SELECT
			@RStartDate			= @Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/StartDate)[1]','varchar(19)'),
			@REndDate			= @Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/EndDate)[1]','varchar(19)'), 
			@RRecurrenceType	= @Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/RecurrenceType)[1]','int'), 
			@ROccurrences		= @Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/Occurrences)[1]','int'),
			@RInterval			= @Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/Interval)[1]','int'), 
			@RDayOfWeekMask		= @Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/DayOfWeekMask)[1]','int'), 
			@RInstance			= @Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/Instance)[1]','int'), 
			@RMonthOfYear		= @Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/MonthOfYear)[1]','int'), 
			@RDayOfMonth		= @Xml.value('(/pjm5TaskRequestGet/RecurrencePattern/DayOfMonth)[1]','int')
	END
	
	IF @DueTime IS NULL AND @Recurrence = 1
		SET @DueTime = @RStartDate
	ELSE IF @DueTime IS NOT NULL AND @Recurrence = 1
	BEGIN	
		IF CAST(CONVERT(varchar(8), @DueTime, 112) AS datetime) < @RStartDate
			SET @RStartDate = CAST(CONVERT(varchar(8), @DueTime, 112) AS datetime)
	END

	BEGIN TRANSACTION

	IF @State IN (1, 2, 6)
	BEGIN
		IF @Recurrence = 0 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE [Document] SET [RecurrencePatternID] = NULL WHERE [Class] = @Class AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NULL
		BEGIN
			INSERT INTO [RecurrencePattern]
				([StartDate], [EndDate], [RecurrenceType], [Occurrences],
				[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
			VALUES
				(@RStartDate, @REndDate, @RRecurrenceType, @ROccurrences,
				@RInterval, @RDayOfWeekMask, @RInstance, @RMonthOfYear, @RDayOfMonth)
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			SET @RecurrenceID = SCOPE_IDENTITY()
			
			UPDATE [Document] SET [RecurrencePatternID] = @RecurrenceID WHERE [Class] = @Class AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE
				[RecurrencePattern]
			SET
				[StartDate] = @RStartDate, 
				[EndDate] = @REndDate, 
				[RecurrenceType] = @RRecurrenceType, 
				[Occurrences] = @ROccurrences,
				[Interval] = @RInterval, 
				[DayOfWeekMask] = @RDayOfWeekMask, 
				[Instance] = @RInstance, 
				[MonthOfYear] = @RMonthOfYear, 
				[DayOfMonth] = @RDayOfMonth
			WHERE
				[ID] = @RecurrenceID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END

	IF @State IN (1, 2, 4, 6) AND
		(
		@ManageAllTaskRequest = 1 OR
		@Creator = @CurrentUserID OR 
		@SupervisorEmployeeID = @CurrentEmployeeID OR
		dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 1
		)
	BEGIN
		UPDATE [TaskRequest]
		SET
			[TaskRequest].[FileAs] = @FileAs,
			[TaskRequest].[DocumentCardID] = @DocumentCardID,
			[TaskRequest].[ProjectID] = @ProjectID,
			[TaskRequest].[EmployeeID] =	(CASE @State
												WHEN  6 THEN
													NULL
												ELSE
													@EmployeeID	
											END),
			[TaskRequest].[AssignmentID] =	(CASE @State
												WHEN 6 THEN
													@AssignmentID
												ELSE
													NULL
											END),
			[TaskRequest].[SupervisorEmployeeID] =	(CASE @State
														WHEN  6 THEN
															NULL
														ELSE
															@SupervisorEmployeeID	
													END),
			[TaskRequest].[SupervisorAssignmentID] = (CASE @State
														WHEN  6 THEN
															@SupervisorAssignmentID
														ELSE
															NULL	
													END),
			[TaskRequest].[PriorityID] = @PriorityID,
			[TaskRequest].[DueTime] = @DueTime,
			[TaskRequest].[StartTime] = @StartTime,
			[TaskRequest].[EndTime] = @EndTime,
			[TaskRequest].[SendStatusReport] = @SendStatusReport,
			[TaskRequest].[TaskRequestStatusID] = @TaskRequestStatusID,
			[TaskRequest].[PercentComplete] = CAST(@PercentComplete as decimal(5, 2)) / CAST(100 as decimal(5, 2)),
			[TaskRequest].[Resolution] = @Resolution,
			[TaskRequest].[DocumentEditAccess] = @DocumentEditAccess,
			[TaskRequest].[Comments] = @Comments,
			[TaskRequest].[Modified] = DEFAULT,
			[TaskRequest].[ModifiedBy] = DEFAULT,
			[TaskRequest].[ManHour] = ISNULL(@ManHour, 0),
			[TaskRequest].[Budget] = ISNULL(@Budget, 0)
		WHERE
			[TaskRequest].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	
		DELETE 
			[TaskRequestAssignment]
		FROM
			[TaskRequestAssignment]
		WHERE 
			[TaskRequestID] = @ID AND
			(
			(NOT EXISTS	(	SELECT *
							FROM @Xml.nodes('/pjm5TaskRequestGet/TaskRequestAssignment') AS T(c)
							WHERE T.c.value('EmployeeID[1]','int') = [TaskRequestAssignment].[EmployeeID]
						) AND @State != 6) OR
			(NOT EXISTS	(	SELECT *
							FROM @Xml.nodes('/pjm5TaskRequestGet/TaskRequestAssignment') AS T(c)
							WHERE T.c.value('AssignmentID[1]','int') = [TaskRequestAssignment].[AssignmentID]
						) AND @State = 6)	
						)	
	
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		DELETE 
			[TaskRequestAssignmentResponse]
		FROM
			[TaskRequestAssignmentResponse]
		WHERE 
			[TaskRequestID] = @ID AND
			NOT EXISTS	(	SELECT *
							FROM @Xml.nodes('/pjm5TaskRequestGet/TaskRequestAssignment') AS T(c) 
							WHERE T.c.value('EmployeeID[1]','int') = [TaskRequestAssignmentResponse].[EmployeeID]
						)	
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	
		IF @State = 6
		BEGIN
			INSERT INTO [TaskRequestAssignment]
				([TaskRequestID], [AssignmentID])
			SELECT
				@ID, 
				T.c.value('AssignmentID[1]','int')
			FROM
				@Xml.nodes('/pjm5TaskRequestGet/TaskRequestAssignment') AS T(c)
			WHERE
				NOT EXISTS	(	SELECT *
								FROM 
									[TaskRequestAssignment]
								WHERE 
									[TaskRequestAssignment].[TaskRequestID] = @ID AND
									T.c.value('AssignmentID[1]','int') = [TaskRequestAssignment].[AssignmentID]
							)
		END
		ELSE
		BEGIN
		INSERT INTO [TaskRequestAssignment]([TaskRequestID], [EmployeeID])
		SELECT
			@ID, 
			T.c.value('EmployeeID[1]','int')
		FROM
			@Xml.nodes('/pjm5TaskRequestGet/TaskRequestAssignment') AS T(c)
		WHERE
			NOT EXISTS	(	SELECT *
							FROM 
								[TaskRequestAssignment]
							WHERE 
								[TaskRequestAssignment].[TaskRequestID] = @ID AND
								T.c.value('EmployeeID[1]','int') = [TaskRequestAssignment].[EmployeeID]
						)
		END

		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		DECLARE @OriginatorEmployeeID TIdentifier

		IF @State != 6
		BEGIN
		SET @OriginatorEmployeeID = (SELECT [ID] FROM [Employee] WHERE [UserID] = (SELECT [CreatedBy] FROM [TaskRequest] WHERE ID = @ID))
		IF @OriginatorEmployeeID IS NOT NULL
		BEGIN
			IF EXISTS	(	SELECT @ID, T.c.value('EmployeeID[1]','int')
							FROM @Xml.nodes('/pjm5TaskRequestGet/TaskRequestAssignment') AS T(c)
							WHERE T.c.value('EmployeeID[1]','int') = @OriginatorEmployeeID
						)
			BEGIN
				UPDATE [TaskRequestAssignment] 
				SET [Accepted] = 1  
				WHERE 
					[TaskRequestID] = @ID AND 
					[EmployeeID] = @OriginatorEmployeeID 
			END
		END
		END
			
	END
	ELSE IF @State = 2
	BEGIN
		UPDATE [TaskRequest]
		SET
			[TaskRequest].[PriorityID] = @PriorityID,
			[TaskRequest].[TaskRequestStatusID] = @TaskRequestStatusID,
			[TaskRequest].[PercentComplete] = CAST(@PercentComplete as decimal(5, 2)) / CAST(100 as decimal(5, 2)),
			[TaskRequest].[EndTime] = @EndTime,
			[TaskRequest].[Resolution] = @Resolution,
			[TaskRequest].[DocumentEditAccess] = @DocumentEditAccess,
			[TaskRequest].[Modified] = DEFAULT,
			[TaskRequest].[ModifiedBy] = DEFAULT,
			[TaskRequest].[ManHour] = ISNULL(@ManHour, 0),
			[TaskRequest].[Budget] = ISNULL(@Budget, 0)
		WHERE
			[TaskRequest].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	ELSE IF @State = 5
	BEGIN
		ROLLBACK TRANSACTION
		RAISERROR('#TransitionTemplateCouldNotBeFound', 18, -1)
		RETURN 1
	END
	ELSE 
	BEGIN
		ROLLBACK TRANSACTION
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	DECLARE @rv int		
	EXEC @rv = pjm7TaskRequestReminderCreate @ID,
		@DueTime, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	COMMIT TRANSACTION	

	EXEC pjm5TaskRequestGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5TaskRequestUpdate TO PUBLIC
GO
 