IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[lmTaskRequest]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure lmTaskRequest'
		DROP PROCEDURE [dbo].[lmTaskRequest]
	END
GO

PRINT 'Creating procedure lmTaskRequest'
GO

/******************************************************************************
**		File: pjm6lmTaskRequest.sql
**		Name: lmTaskRequest
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: SPV
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [lmTaskRequest]
AS
	SET NOCOUNT ON

	DECLARE @EmployeeID TIdentifier,
		@TaskRequestManager int

	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @TaskRequestManager = dbo.adfHasAccessRightByName('ManageAllTaskRequest')
		
	SELECT
		[TaskRequest].[ID],
		[TaskRequest].[State],
		[TaskRequest].[FileAs] AS [Name],
		[TaskRequest].[ProjectID]
	FROM
		[TaskRequest]
		LEFT OUTER JOIN [TaskRequestAssignment]
			ON  [TaskRequestAssignment].[TaskRequestID] = [TaskRequest].[ID]
	WHERE
		[TaskRequest].[State] IN (2, 3) AND
		[TaskRequest].[DocumentCardID] IS NULL AND
		(
			@TaskRequestManager = 1 OR
			[TaskRequest].[SupervisorEmployeeID] = @EmployeeID OR
			[TaskRequestAssignment].[EmployeeID] = @EmployeeID
		)
	
	RETURN 0
GO

GRANT EXECUTE ON [lmTaskRequest] TO PUBLIC
GO
 