IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimeEntryChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimeEntryChangeState'
		DROP PROCEDURE [dbo].[pjm5TimeEntryChangeState]
	END
GO

PRINT 'Creating procedure pjm5TimeEntryChangeState'
GO

/******************************************************************************
**		File: pjm5TimeEntryChangeState.sql
**		Name: pjm5TimeEntryChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		06.10.09	syv				   pjm6AssignmentCheckBudgetOverdraft
**		01.12.09	syv				   @OriginatorUserID 
**									 UserID  EXECUTE AS OWNER
**		26.01.10	syv				    
**									Assignment,     
**		14.05.10	SYV				  pjm6DismissEventsOnObject
**									 pjm7AllDocumentReminderDismiss   
**		31.05.10	SYV				   pjm6DismissEventsOnObject
**									 pjm7AllDocumentReminderDismiss  state 2
**		12.08.10	SYV				      5  1   
**		24.08.10	SYV				  pjm6DismissEventsOnObject .. 
**									   
**		01.10.10	SYV				Approver     
**		22.10.10	SYV				 ,     
**		01.12.10	SYV				 Rate     1, 2, 5
**		01.04.13	SOV				. -     
*******************************************************************************/
CREATE PROCEDURE pjm5TimeEntryChangeState
	@ID TIdentifier,
	@ToState TState,
	@OriginatorUserID TIdentifier = NULL
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass,
			@ProjectID TIdentifier,
			@DocumentClass TClass,
			@DocumentID TIdentifier,
			@TaskID TIdentifier,
			@EmployeeID TIdentifier,
			@DivisionID TIdentifier,
			@TimeEntryRate TMoney,
			@AssignmentID TIdentifier,
			@ActivityTypeID TIdentifier,
			@ActivityTypeIsMandatory bit,
			@var sql_variant,
			@rv int,
			@RecurrenceID TIdentifier,
			@StartTime TDatetime,
			@CurrentDate TDatetime,
			@FileAs TName,
			@Duration TCount,
			@Billable TBool,
			@Overtime TBool,
			@Color TColor,
			@Comments TNotes,
			@ServiceAssignmentID TIdentifier,
			@TaskAssignmentState TState,
			@result TBool,
			@OldAssignmentID TIdentifier,
			@IsAssignmentDeactivate TBool
			
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [TimeEntry].[Class],
		@FromState = [TimeEntry].[State],
		@ProjectID = [TimeEntry].[ProjectID],
		@DocumentClass = [TimeEntry].[DocumentClass],
		@DocumentID = [TimeEntry].[DocumentID],
		@EmployeeID = [TimeEntry].[EmployeeID],
		@DivisionID = [Employee].[DivisionID],
		@AssignmentID = dbo.fnPjm5GetProjectAssignment([TimeEntry].[ProjectID], [TimeEntry].[EmployeeID]),
		@TimeEntryRate = [TimeEntry].[Rate],
		@ActivityTypeID = [TimeEntry].[ActivityTypeID],
		@RecurrenceID  = [Document].[RecurrencePatternID],
		@StartTime = [TimeEntry].[StartTime],
		@CurrentDate = GETDATE(),
		@FileAs  = [TimeEntry].[FileAs],
		@TaskID = [TimeEntry].[TaskID],
		@Duration = [TimeEntry].[Duration],
		@Billable = [TimeEntry].[Billable],
		@Overtime = [TimeEntry].[Overtime],
		@Color = [TimeEntry].[Color],
		@Comments = [TimeEntry].[Comments],
		@TaskAssignmentState = [TaskAssignment].[State],
		@OldAssignmentID = [TimeEntry].[AssignmentID]
	FROM
		[TimeEntry]
		INNER JOIN [Document]
			ON [Document].[Class] = [TimeEntry].[Class] AND [Document].[ID] = [TimeEntry].[ID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [TimeEntry].[EmployeeID]
		LEFT JOIN [vwAssignment]
			ON [TimeEntry].[AssignmentID] = [vwAssignment].[ID] AND
				[TimeEntry].[ProjectID] = [vwAssignment].[ProjectID]
		LEFT OUTER JOIN [TaskAssignment]
			ON [TaskAssignment].[AssignmentID] = [TimeEntry].[AssignmentID]
			AND [TaskAssignment].[TaskID] = [TimeEntry].[TaskID]
	WHERE
		[TimeEntry].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	--  
	IF @ProjectID IS NULL
	BEGIN
		RAISERROR('#TimeEntryProjectIsNull', 18, -1)
		RETURN 1
	END
	
	SET @IsAssignmentDeactivate	= 0
	
	IF(@TaskID IS NULL
			AND 
			EXISTS (SELECT 
						* 
					FROM 
						[Assignment]
						INNER JOIN [TimeEntry]
							ON [Assignment].[ID] = [TimeEntry].[AssignmentID]	
					WHERE
						[TimeEntry].[ID] = @ID
						AND [TimeEntry].[Created] <= [Assignment].[Modified]
						AND [Assignment].[State] = 2)
			)
	BEGIN
			SET @AssignmentID = @OldAssignmentID
			SET @IsAssignmentDeactivate	= 1
	END
	
	--  assignment
	IF @AssignmentID IS NULL AND @ToState != 4 AND @IsAssignmentDeactivate = 0
	BEGIN
		RAISERROR('#TimeEntryAssignmentIDIsNull', 18, -1)
		RETURN 1
	END
	
	-- taskassignment
	IF @TaskAssignmentState IS NOT NULL AND @TaskAssignmentState = 2
	BEGIN
		RAISERROR('#TimeEntryTaskAssignmentStateIsDeactivated', 18, -1)
		RETURN 1
	END
	
	 --     
	EXEC adfParameterGet 'ActivityTypeIsMandatory', 'Pjm5', @var OUTPUT
	IF @var IS NULL
		SET @ActivityTypeIsMandatory = 1
	ELSE
		SET @ActivityTypeIsMandatory = CAST(@var as BIT)

	IF @ActivityTypeID IS NULL AND @ActivityTypeIsMandatory = 1
	BEGIN
		SET @ActivityTypeID = dbo.fnPjm5GetDefaultActivity(@ProjectID, @EmployeeID)
	END
	
	IF @ActivityTypeID IS NULL AND @ActivityTypeIsMandatory = 1
	BEGIN
		RAISERROR('#activitytypecannotbenull', 18, -1)
		RETURN 1
	END
	
	IF EXISTS
	(SELECT * FROM [TimeEntry] 
				INNER JOIN [Project]
					ON [Project].[ID] = [TimeEntry].[ProjectID]
		WHERE 
			[TimeEntry].[ID] = @ID AND
			[Project].[MsProjectID] IS NOT NULL AND
			[TimeEntry].[TaskID] IS NULL)
			
	BEGIN
		RAISERROR('#taskmustexistformsproject', 18, -1)
		RETURN 1
	END
	
	DECLARE 
		@CurrentEmployeeID TIdentifier,
		@projectManager TBool,
		@projectManagerAssistant TBool,
		@approver TBool,
		@assistant TBool
		
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @projectManager = dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID)
	SET @projectManagerAssistant = dbo.fnPjm7IsManagerAssistant(@ProjectID, @CurrentEmployeeID)
	SET @approver = dbo.fnPjm5IsProjectApprover(@ProjectID, @CurrentEmployeeID)
	SET @assistant = dbo.fnPjm5IsAssistant()
	
	IF @ToState IN (3, 4, 5) AND
		@projectManager = 0 AND
		@projectManagerAssistant = 0 AND
		@approver = 0 AND
		@assistant = 0
	BEGIN
		RAISERROR('#TimeEntryChangeStateFailed', 18, -1)
		RETURN 1
	END
	ELSE
	BEGIN
		IF (
				(@FromState = 1 AND @ToState = 2) OR 
				(@FromState = 2 AND @ToState = 1) OR
				(@FromState = 5 AND @ToState = 1)
			) AND
			@CurrentEmployeeID != @EmployeeID AND
			@projectManager = 0 AND
			@projectManagerAssistant = 0 AND
			@approver = 0 AND
			@assistant = 0 AND
			dbo.fnPjm5IsProjectAdministrator(@ProjectID, @CurrentEmployeeID) = 0
		BEGIN
			RAISERROR('#TimeEntryChangeStateFailed', 18, -1)
			RETURN 1
		END
		ELSE IF NOT (
				(@FromState = 2 AND @ToState = 3) OR 
				(@FromState = 3 AND @ToState = 5)
			) AND
			NOT (
				(@FromState = 1 AND @ToState = 2) OR 
				(@FromState = 2 AND @ToState = 1) OR
				(@FromState = 5 AND @ToState = 1)
			) AND
			@CurrentEmployeeID != @EmployeeID AND 
			@projectManager = 0 AND
			@assistant = 0 AND
			@projectManagerAssistant = 0 AND
			@approver = 0
		BEGIN
			RAISERROR('#TimeEntryChangeStateFailed', 18, -1)
			RETURN 1
		END
	END
	
	IF @ToState = 2 AND @TaskID IS NOT NULL
		EXEC @result = pjm6AssignmentCheckBudgetOverdraft @TaskID, @AssignmentID, @ID, NULL
	IF @result = 1
		RETURN 1
	
	IF (@DocumentID IS NOT NULL 
		AND @DocumentClass IS NOT NULL
		AND NOT EXISTS(SELECT TOP(1) [ID] FROM [Document] WHERE [Class] = @DocumentClass AND [ID] = @DocumentID))
	BEGIN
		RAISERROR('#CannotRetrieveDeletedDocument', 18, -1)
		RETURN 1
	END
	
	IF @ToState IN (1, 2, 5)
	BEGIN
		SET @TimeEntryRate = dbo.fnPjm5GetEmployeeRate(@EmployeeID, @ProjectID, @Overtime, CASE @DocumentClass WHEN dbo.adfGetClassByName('Pjm5.ServiceAssignment') THEN @DocumentID ELSE NULL END, 1)
	END
	
	BEGIN TRANSACTION
	IF @ToState = 3
	BEGIN
		IF @OriginatorUserID IS NULL
		BEGIN
			UPDATE [TimeEntry]
			SET
				[TimeEntry].[DivisionID] = @DivisionID,
				[TimeEntry].[AssignmentID] = @AssignmentID,
				[TimeEntry].[ActivityTypeID] = @ActivityTypeID,
				[TimeEntry].[State] = @ToState,
				[TimeEntry].[Modified] = DEFAULT,
				[TimeEntry].[ModifiedBy] = DEFAULT
			FROM 
				[TimeEntry]
			WHERE
				[TimeEntry].[ID] = @ID
			AND
				[TimeEntry].[State] = @FromState

			IF @@ERROR != 0
			BEGIN
				RAISERROR('#TimeEntryChangeStateFailed', 18, -1)
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE
		BEGIN
			UPDATE [TimeEntry]
			SET
				[TimeEntry].[DivisionID] = @DivisionID,
				[TimeEntry].[AssignmentID] = @AssignmentID,
				[TimeEntry].[ActivityTypeID] = @ActivityTypeID,
				[TimeEntry].[State] = @ToState,
				[TimeEntry].[Modified] = DEFAULT,
				[TimeEntry].[ModifiedBy] = @OriginatorUserID
			FROM 
				[TimeEntry]
			WHERE
				[TimeEntry].[ID] = @ID
			AND
				[TimeEntry].[State] = @FromState

			IF @@ERROR != 0
			BEGIN
				RAISERROR('#TimeEntryChangeStateFailed', 18, -1)
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END
	ELSE IF @ToState IN (1, 2, 5)
	BEGIN
		IF @OriginatorUserID IS NULL
		BEGIN	
			UPDATE [TimeEntry]
			SET
				[TimeEntry].[ActivityTypeID] = @ActivityTypeID,
				[TimeEntry].[State] = @ToState,
				[TimeEntry].[Modified] = DEFAULT,
				[TimeEntry].[ModifiedBy] = DEFAULT,
				[TimeEntry].[Rate] = @TimeEntryRate
			WHERE
				[TimeEntry].[ID] = @ID
			AND
				[TimeEntry].[State] = @FromState

			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE
		BEGIN	
			UPDATE [TimeEntry]
			SET
				[TimeEntry].[ActivityTypeID] = @ActivityTypeID,
				[TimeEntry].[State] = @ToState,
				[TimeEntry].[Modified] = DEFAULT,
				[TimeEntry].[ModifiedBy] = @OriginatorUserID,
				[TimeEntry].[Rate] = @TimeEntryRate
			WHERE
				[TimeEntry].[ID] = @ID
			AND
				[TimeEntry].[State] = @FromState

			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END	
	ELSE
	BEGIN
		IF @OriginatorUserID IS NULL
		BEGIN	
			UPDATE [TimeEntry]
			SET
				[TimeEntry].[ActivityTypeID] = @ActivityTypeID,
				[TimeEntry].[State] = @ToState,
				[TimeEntry].[Modified] = DEFAULT,
				[TimeEntry].[ModifiedBy] = DEFAULT
			WHERE
				[TimeEntry].[ID] = @ID
			AND
				[TimeEntry].[State] = @FromState

			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE
		BEGIN	
			UPDATE [TimeEntry]
			SET
				[TimeEntry].[ActivityTypeID] = @ActivityTypeID,
				[TimeEntry].[State] = @ToState,
				[TimeEntry].[Modified] = DEFAULT,
				[TimeEntry].[ModifiedBy] = @OriginatorUserID
			WHERE
				[TimeEntry].[ID] = @ID
			AND
				[TimeEntry].[State] = @FromState

			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END	
	
	-- RECURENCE
	IF @FromState = 1 AND @ToState = 2 AND
		@RecurrenceID IS NOT NULL
	BEGIN
		DECLARE @NewDate TDateTime
		SET @NewDate = dbo.fnPjm5RecurrenceGetNextDateTime(@RecurrenceID, @StartTime, @CurrentDate)
		
		IF ISNULL(@NewDate, @StartTime) > @StartTime
		BEGIN
			EXEC @rv = pjm5TimeEntryCreateRecurrence @ID, 
				@FileAs, 
				@ActivityTypeID, 
				@EmployeeID,
				@ProjectID, 
				@TaskID,
				@NewDate, 
				@Duration, 
				@Billable, 
				@Overtime, 
				@Color,
				@Comments,
				@DocumentID,
				@DocumentClass,
				@RecurrenceID

			IF @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			DECLARE @Occurrences TCount
			SELECT @Occurrences = [Occurrences] FROM [RecurrencePattern] WHERE [ID] = @RecurrenceID
			IF ISNULL(@Occurrences, 0) > 0
			BEGIN
				UPDATE
					[RecurrencePattern]
				SET
					[Occurrences] = @Occurrences - 1
				WHERE
					[ID] = @RecurrenceID
				IF @@ERROR != 0
				BEGIN
					ROLLBACK TRANSACTION
					RETURN 1
				END
			END
		END
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	EXEC @rv = pjm6TaskPercentUpdate @TaskID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF (@ToState = 2 OR @ToState = 3 OR @ToState = 4 OR @ToState = 6)
	BEGIN			
		EXEC @rv = pjm7AllDocumentReminderDismiss @Class, @ID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END	
	
	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON pjm5TimeEntryChangeState TO PUBLIC
GO
 