IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimeEntryCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimeEntryCreate'
		DROP PROCEDURE [dbo].[pjm5TimeEntryCreate]
	END
GO

PRINT 'Creating procedure pjm5TimeEntryCreate'
GO

/******************************************************************************
**		File: pjm5TimeEntryCreate.sql
**		Name: pjm5TimeEntryCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		02.03.12	PAM				   " "
**		12.03.13	SAP				  BillableHour
**		13.03.13	MAB				  OPENXXML
**		26.08.13	SOV				      " "
*******************************************************************************/
CREATE PROCEDURE [pjm5TimeEntryCreate]
	@Xml	XML
AS
	DECLARE 
		@State TState,
		@ID TIdentifier,
		@FileAs TName,
		@ActivityTypeID TIdentifier,
		@ProjectID TIdentifier,
		@DocumentClass TClass,
		@DocumentID TIdentifier,
		@TaskID TIdentifier,
		@StartTime TDateTime,
		@Duration TCount,
		--@RoundedDuration TCount,
		@Billable TBool,
		--@BillableDuration TCount,
		@BillableHour decimal(18,2),
		@Overtime TBool,
		@Rate TMoney,
		@Comments TNotes,
		@EmployeeID TIdentifier,
		@Color TColor,
		@rv int,
		@RecurrenceID TIdentifier,
		@ReminderState TBool,
		@ReminderInterval TTimeSpan,
		@RemainingWork TAmount,
		@RemainingOvertimeWork TAmount,
		@BillableIsModified	TBool
	
	SET NOCOUNT ON

	SELECT
		@FileAs					= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/FileAs)[1]','nvarchar(256)'),	 
		@ActivityTypeID			= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/ActivityTypeID)[1]','int'), 
		@ProjectID				= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/ProjectID)[1]','int'), 
		@DocumentClass			= dbo.adfGetClassByName(@Xml.value('(/pjm5TimeEntryGet/TimeEntry/DocumentClass)[1]','varchar(32)')),
		@DocumentID				= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/DocumentID)[1]','int'),
		@TaskID					= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/TaskID)[1]','int'), 
		@StartTime				= CAST(@Xml.value('(/pjm5TimeEntryGet/TimeEntry/StartTime)[1]','varchar(19)') as datetime), 
		@Duration				= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/Duration)[1]','nvarchar(256)'),
		--@RoundedDuration = [XmlTable].[RoundedDuration],
		@Billable				= CASE WHEN @Xml.value('(/pjm5TimeEntryGet/TimeEntry/Billable)[1]','varchar(5)') = 'false' THEN 0 ELSE 1 END, 
		--@BillableDuration = [XmlTable].[BillableDuration], 
		@Overtime				= CASE WHEN @Xml.value('(/pjm5TimeEntryGet/TimeEntry/Overtime)[1]','varchar(5)') = 'false' THEN 0 ELSE 1 END, 
		@BillableHour			= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/BillableHour)[1]','decimal(18,4)'),
		@Comments				= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/Comments)[1]','nvarchar(max)'),
		@EmployeeID				= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/EmployeeID)[1]','int'),
		@Color					= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/Color)[1]','int'),
		@ReminderState			= CASE WHEN @Xml.value('(/pjm5TimeEntryGet/TimeEntry/ReminderState	)[1]','varchar(5)') = 'false' THEN 0 ELSE 1 END,
		@ReminderInterval		= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/ReminderInterval)[1]','int'),
		@RemainingWork			= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/RemainingWork)[1]','decimal(18,4)'),
		@RemainingOvertimeWork	= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/RemainingOvertimeWork)[1]','decimal(18,4)'),
		@BillableIsModified		= @Xml.value('(/pjm5TimeEntryGet/TimeEntry/BillableIsModified)[1]','bit')
		
	IF @EmployeeID IS NULL
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()

	--     " "
	DECLARE
		@AppSyncCalendars	TBool,
		@value				TVariant,
		@SyncTimeEntry		TBool,
		@LocalNowDateTime	TDate

	EXEC adfParameterGet @Name='ExchangeSyncCalendars', @Group='Pjm6', @Value = @value OUTPUT
	SET @AppSyncCalendars = CAST(@value as bit)
	SET @SyncTimeEntry = 0
	SET @LocalNowDateTime = dbo.fnPjm7GetLocalDate()
 
	IF @AppSyncCalendars = 1 AND @StartTime > @LocalNowDateTime
	BEGIN
		DECLARE
			@UserSyncCalendars	bit,
			@TimeEntryUserID	TIdentifier

		SELECT @TimeEntryUserID = [UserID] FROM [Employee] WHERE [ID] = @EmployeeID 	

		SELECT @value = [Value] FROM [UserParameter] WHERE [Name] = 'SyncExchangeCalendar' AND [UserID] = @TimeEntryUserID
		SET @UserSyncCalendars = ISNULL(CAST(@value AS bit), 0)

		IF @UserSyncCalendars = 1
		BEGIN
			DECLARE
				@UserSyncEntriesInFuture	int

			SELECT @value = [Value] FROM [UserParameter] WHERE [Name] = 'SyncExchangeCalendarEntriesInFuture' AND [UserID] = @TimeEntryUserID
			SET @UserSyncEntriesInFuture = ISNULL(CAST(@value AS int), 1)

			SET @SyncTimeEntry = 
				(CASE
					WHEN @UserSyncEntriesInFuture = 0 THEN 1
					WHEN @UserSyncEntriesInFuture = 1 THEN 0
					WHEN @UserSyncEntriesInFuture = 2  THEN dbo.fnPjm6ExchangeSyncActivityTypeEntry(@ActivityTypeID, @TimeEntryUserID)
				END)
		END
	END

	BEGIN TRANSACTION

	DECLARE
		@RStartDate TDatetime, 
		@REndDate TDatetime, 
		@RRecurrenceType TIdentifier, 
		@ROccurrences TCount,
		@RInterval TCount, 
		@RDayOfWeekMask TIdentifier, 
		@RInstance TIdentifier, 
		@RMonthOfYear TCount, 
		@RDayOfMonth TCount

	SELECT
		@RStartDate			= CAST(@Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/StartDate)[1]','varchar(19)') as datetime),
		@REndDate			= CAST(@Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/EndDate)[1]','varchar(19)') as datetime),
		@RRecurrenceType	= @Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/RecurrenceType)[1]','int'),
		@ROccurrences		= @Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/Occurrences)[1]','int'),
		@RInterval			= @Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/Interval)[1]','int'),
		@RDayOfWeekMask		= @Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/DayOfWeekMask)[1]','int'),
		@RInstance			= @Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/Instance)[1]','int'),
		@RMonthOfYear		= @Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/MonthOfYear)[1]','int'),
		@RDayOfMonth		= @Xml.value('(/pjm5TimeEntryGet/RecurrencePattern/DayOfMonth)[1]','int')

	IF @RRecurrenceType IS NOT NULL
	BEGIN
		INSERT INTO [RecurrencePattern]
			([StartDate], [EndDate], [RecurrenceType], [Occurrences],
			[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
		VALUES
			(@RStartDate, @REndDate, @RRecurrenceType, @ROccurrences,
			@RInterval, @RDayOfWeekMask, @RInstance, @RMonthOfYear, @RDayOfMonth)
		
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		SET @RecurrenceID = SCOPE_IDENTITY()
	END
	
	IF @DocumentID IS NULL SET @DocumentClass = NULL

	EXEC @rv = pjm5TimeEntryCreateInternal @ID OUTPUT, 
		@FileAs, 
		@ActivityTypeID, 
		@EmployeeID,
		@ProjectID,
		@DocumentClass,
		@DocumentID,
		@TaskID,
		@StartTime, 
		@Duration, 
		@Billable,
		@BillableHour,
		@Overtime, 
		@Color,
		@Comments,
		@RecurrenceID

	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF (@BillableIsModified = 1)
	BEGIN
		UPDATE [EntryAmount]
		SET 
			[Modified] = GETDATE(),
			[ModifiedBy] = dbo.adfGetCurrentUserID()
		WHERE
			[EntryAmount].[ID] = @ID

		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	DECLARE @TimeEntryClass TClass
	SET @TimeEntryClass = dbo.adfGetClassByName('Pjm5.TimeEntry')

	IF @RecurrenceID IS NOT NULL
	BEGIN
		UPDATE
			[Document]
		SET
			[RecurrencePatternID] = @RecurrenceID
		WHERE
			[Class] = @TimeEntryClass AND [ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	EXEC @rv = pjm7TimeEntryReminderCreate @ID,
		@StartTime, @ReminderState,	@ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	EXEC @rv = pjm6TaskPercentUpdate @TaskID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	IF @SyncTimeEntry = 1
	BEGIN
		EXEC @rv = pjm7ExchangeSyncStateUpdate @ID, @TimeEntryClass, @SyncTimeEntry, @EmployeeID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

	END

	COMMIT TRANSACTION
	EXEC pjm6TimeEntryGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5TimeEntryCreate TO PUBLIC
GO
 