IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5UOMBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5UOMBrowse'
		DROP PROCEDURE [dbo].[pjm5UOMBrowse]
	END
GO

PRINT 'Creating procedure pjm5UOMBrowse'
GO

/******************************************************************************
**		File: pjm5UOMBrowse.sql
**		Name: pjm5UOMBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5UOMBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[UOM].[Class],
		[UOM].[ID],
		[UOM].[State],
		[UOM].[Flag],
		[UOM].[Code],
		[UOM].[FileAs],
		[UOM].[Comments],
		[UOM].[Created],
		[UOM].[CreatedBy],
		[UOM].[Modified],
		[UOM].[ModifiedBy],
		[UOM].[Timestamp],
		[UOM].[NumericCode]
	FROM
		[UOM]
	WHERE
		(
			(@StateSelector = 0) OR 
			(@StateSelector = 1 AND [UOM].[State] IN (1, 100)) OR
			(@StateSelector = 2 AND [UOM].[State] = 2)
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5UOMBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5UOMGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5UOMGet'
		DROP PROCEDURE [dbo].[pjm5UOMGet]
	END
GO

PRINT 'Creating procedure pjm5UOMGet'
GO

/******************************************************************************
**		File: pjm5UOMGet.sql
**		Name: pjm5UOMGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5UOMGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[UOM].[Class],
		[UOM].[ID],
		[UOM].[State],
		[UOM].[Flag],
		[UOM].[Code],
		[UOM].[FileAs],
		[UOM].[Comments],
		[UOM].[Created],
		[UOM].[CreatedBy],
		[UOM].[Modified],
		[UOM].[ModifiedBy],
		[UOM].[Timestamp],
		[UOM].[NumericCode]
	FROM
		[UOM]
	WHERE
		[UOM].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm5UOMGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5UOMCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5UOMCreate'
		DROP PROCEDURE [dbo].[pjm5UOMCreate]
	END
GO

PRINT 'Creating procedure pjm5UOMCreate'
GO

/******************************************************************************
**		File: pjm5UOMCreate.sql
**		Name: pjm5UOMCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5UOMCreate]
	@Code TCode,
	@FileAs TName,
	@Comments TNotes,
	@NumericCode TCode3
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('eb97ca65-56dd-4934-b41c-7e7a00ef2832')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [UOM]
		([Flag], [State], [Code], [FileAs], [Comments], [NumericCode])
	VALUES
		(0, @State, @Code, @FileAs, @Comments, @NumericCode)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC pjm5UOMGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5UOMCreate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5UOMUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5UOMUpdate'
		DROP PROCEDURE [dbo].[pjm5UOMUpdate]
	END
GO

PRINT 'Creating procedure pjm5UOMUpdate'
GO

/******************************************************************************
**		File: pjm5UOMUpdate.sql
**		Name: pjm5UOMUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5UOMUpdate
	@ID TIdentifier,
	@Code TCode,
	@FileAs TName,
	@Comments TNotes,
	@NumericCode TCode3
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[UOM]
	SET
		[UOM].[Code] = @Code,
		[UOM].[FileAs] = @FileAs,
		[UOM].[Comments] = @Comments,
		[UOM].[Modified] = GETDATE(),
		[UOM].[ModifiedBy] = dbo.adfGetCurrentUserID(),
		[UOM].[NumericCode] = @NumericCode
	WHERE
		[UOM].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC pjm5UOMGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5UOMUpdate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5UOMDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5UOMDelete'
		DROP PROCEDURE [dbo].[pjm5UOMDelete]
	END
GO

PRINT 'Creating procedure pjm5UOMDelete'
GO

/******************************************************************************
**		File: pjm5UOMDelete.sql
**		Name: pjm5UOMDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5UOMDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [UOM] WHERE [UOM].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5UOMDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5UOMChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5UOMChangeState'
		DROP PROCEDURE [dbo].[pjm5UOMChangeState]
	END
GO

PRINT 'Creating procedure pjm5UOMChangeState'
GO

/******************************************************************************
**		File: pjm5UOMChangeState.sql
**		Name: pjm5UOMChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		31.01.12	ASA				     
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5UOMChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [UOM].[Class],
		@FromState = [UOM].[State]
	FROM
		[UOM]
	WHERE
		[UOM].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[UOM]
	SET
		[UOM].[State] = @ToState,
		[UOM].[Modified] = GETDATE(),
		[UOM].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[UOM].[ID] = @ID
	AND
		[UOM].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5UOMChangeState TO PUBLIC
GO
